#!/bin/sh
#
# ư
#
#  args
#   $1: (none)/stop

[ "X${X7DBG}" = "Xon" ] && set -x

. /etc/ibsbat/ibs.subr

CMDBAT=`basename $0`
LOCKFILE=/var/lock/${CMDBAT}.lock

WGET=/tmp/wget10
WGETGZ=/mnt/usr/BACKUP/wget10.gz

NKF="nkf -j --unix"

# temporary file
OUTPUT0=/tmp/addcon.res0
# convert file
OUTPUT=/tmp/addcon.res
# server response file
SVRESF=/tmp/addcon.sv
# addcon result file
RESULTF=/tmp/addcon.result

AWKF=/etc/ibsbat/addcon/addcon.awk
DEFAULTURLF=/etc/ibsbat/addcon/default_url

AUTHF=/tmp/auth.txt
POSTF=/tmp/add.post
# 2006.04.05 signal sended file
DEBUG_ADDCON_INFO=/tmp/debug_addcon_info

WANIF=eth0
# 2006.04.16
# 2006.07.05
WANIFCFG_FIX=/etc/sysconfig/network-scripts/ifcfg-eth0
WANIFCFG=/etc/sysconfig/network-scripts/ifcfg-eth0.scas
WANIFCFGBAK=/etc/sysconfig/network-scripts/__ifcfg-eth0.bak
WANNETWORK=/etc/sysconfig/network

# 2006.05.13
# եˡ顼ʸ
# pppoe: pppoe³顼
ADDCON_ERR=/tmp/addcon.err

#------------
TIMEOUT=30
DNSTIMEOUT=10

#ADDOPT="--no-http-keep-alive -nv"
ADDOPT="--no-http-keep-alive"
AGENT="M-CAS/1.0"
ADDHEAD="Content-Type: application/x-www-form-urlencoded"

EAST_URL="http://add-con.mcas/"
WEST_URL="http://add-con.mcas.bb.fletsnet.com/"
DEFURL="http://add-con.mcas/"

# 2006.04.16
DHCPCD_INFO=/etc/dhcpc/dhcpcd-eth0.info

# V6ɬפ
SOHOCAS_NEED6=no

PPP_TOP=/etc/ppp
PAPSECRET=${PPP_TOP}/pap-secrets
CHAPSECRET=${PPP_TOP}/chap-secrets

#2006.04.20
# 0: success
# 1: error
# 2: no proc
ADDCON_COMPLETE=1
svjudge_cmd=/home/ibsuser/public_html/Admin/Sys_setup/Router/auto_serv_check.cgi

# 2006.07.13
DHCPC_COMP=/tmp/scas_west_dhcpc_complete

echo "" > /tmp/addcon.log


addcon_syslog()
{
	#2006.04.18
	logger -p kern.info -t $CMDBAT "tmp## ${1}"
	echo "${1}" >> /tmp/addcon.log
}

addcon_syslog0()
{
	#2006.04.18
	#logger -p kern.info -t $CMDBAT "autoconf## ${1}"
	logger -p local1.info -t $CMDBAT "autoconf## ${1}"
	echo "${1}" >> /tmp/addcon.log
}

addcon_syslog_sys()
{
	#logger -p kern.info -t $CMDBAT "System## ${1}"
	logger -p local1.info -t $CMDBAT "System## ${1}"
	echo "${1}" >> /tmp/addcon.log
}

create_auth()
{
	_comp_code=""
	_serv_code=""
	_cont_code=""
	_cust_id=""
	_term_id=`ip link show ${WANIF} | awk 'NR==2{printf"%s\n",toupper($2)}'|sed -e 's/://g'`

	# 2006.04.06 ǸβԤϤʤ
	echo -n "CompanyCode=${_comp_code}&ServiceCode=${_serv_code}&ControlCode=${_cont_code}&CustomerID=${cust_id}&TerminalID=${_term_id}"  > ${POSTF}
}

setup_sub_net46()
{
	#˼ѤߤΤᡢʤ¹
	url_update=`cat ${OUTPUT} | awk 'BEGIN{FS="="}/url_update=/{printf"%s",$2}'`
	url_update_cas=`cat ${OUTPUT} | awk 'BEGIN{FS="="}/url_update_cas=/{printf"%s",$2}'`

	check_iptell_type
	_type=$?

	if [ "X${url_update}" != "X" ]; then
		addcon_syslog "url_update is ${url_update}"
		SOHOCAS_NEED6=no
	elif [ "X${url_update_cas}" != "X" -a "${_type}" = "6" ]; then
		addcon_syslog "url_update_cas is ${url_update_cas}"
		SOHOCAS_NEED6=yes
	elif [ "X${url_update_cas}" != "X" -a "${_type}" = "7" ]; then
		addcon_syslog "url_update_cas is ${url_update_cas}"
		SOHOCAS_NEED6=yes
	else
		addcon_syslog "Both update_url and update_url_cas is null."
		SOHOCAS_NEED6=no
	fi

	if [ ${SOHOCAS_NEED6} = "yes" ]; then
		cp -p /etc/ibsbat/addcon/network.v6 /etc/sysconfig/network
		echo "IPV6INIT=yes" >> ${WANIFCFG}
	else
		cp -p /etc/ibsbat/addcon/network.v4 /etc/sysconfig/network
		echo "IPV6INIT=no" >> ${WANIFCFG}
	fi
}
setup_network_east()
{
	_gateway=`cat ${OUTPUT} | awk 'BEGIN{FS="="}/gateway=/{printf"%s",$2}'`

	cp -p /etc/ibsbat/addcon/network.v4 ${WANNETWORK}
	echo "IPV6INIT=no" >> ${WANIFCFG}
	#echo "GATEWAY=$_gateway" >> ${WANNETWORK}
	echo "GATEWAYDEV=eth0" >> ${WANNETWORK}
	#2006.04.06 pppoe.batǤϡȤʤ
	#echo "GATEWAY=0.0.0.0" >> ${WANNETWORK}
}

setup_eth0_east()
{
	addcon_syslog "east eth0 setup"

	_cas_ip_addr=`cat ${OUTPUT} | awk 'BEGIN{FS="="}/ip_addr/{printf"%s",$2}'`
	_cas_netmask0=`cat ${OUTPUT} | awk 'BEGIN{FS="="}/netmask/{printf"%s",$2}'`
	#_cas_netmask=`ipcalc -m ${_cas_ip_addr}/${_cas_netmask0}`
	eval `ipcalc -m ${_cas_ip_addr}/${_cas_netmask0}`
	_cas_gateway=`cat ${OUTPUT} | awk 'BEGIN{FS="="}/gateway/{printf"%s",$2}'`
	#_cas_broadcast=`ipcalc -b ${_cas_ip_addr}/${_cas_netmask}`
	# 2006.06.11
	#eval `ipcalc -b ${_cas_ip_addr}/${NETMASK}`
	eval `ipcalc -b ${_cas_ip_addr}/${_cas_netmask0}`

	ifdown eth0
	if [ $? != 0 ]; then
		addcon_syslog "already eth0 down."
		#return 1
	fi

	if [ -f "${WANIFCFG}" ]; then
		mv "${WANIFCFG}" "${WANIFCFGBAK}"
	fi

	echo "DEVICE=eth0" > ${WANIFCFG}
	echo "BOOTPROTO=none" >> ${WANIFCFG}
	echo "IPADDR=${_cas_ip_addr}" >> ${WANIFCFG}
	#echo "NETMASK=${_cas_netmask}" >> ${WANIFCFG}
	echo "NETMASK=${NETMASK}" >> ${WANIFCFG}
	#echo "BROADCAST=${_cas_broadcast}" >> ${WANIFCFG}
	echo "BROADCAST=${BROADCAST}" >> ${WANIFCFG}
	echo "ONBOOT=yes" >> ${WANIFCFG}
	echo "ALLMULTI=yes" >> ${WANIFCFG}

	#network
	setup_network_east
	# 2006.04.16 
	ifup ${WANIFCFG}
	return 0
}

####################
# $1: ip
# $2: mask
# 2006.04.23 ʥ뤬ɬפ
access_conf_edit()
{
	_conf_f=/usr/local/apache/conf/access.conf
	if [ -f ${_conf_f} ]; then
		mv ${_conf_f} ${_conf_f}.1
		cat ${_conf_f}.1 |\
			awk -v ip=${1} -v mask=${2} '{ where = match($0, "#ibs-soho-wan"); if ( where ) {printf"allow from %s/%s  #ibs-soho-wan\n",ip,mask} else { printf"%s\n",$0}}' > ${_conf_f}

		/usr/local/apachectl graceful
	fi
	return 0
}

# 2006.05.01 wancfg.bat⥳뤹
setup_eth0_west_after_dhcp()
{
	_fname=setup_eth0_west0_after_dhcp
	addcon_syslog "$_fname:west eth0 setup"
	unset IPADDR NETMASK
	if [ ! -f ${DHCPCD_INFO} ]; then
		addcon_syslog "${DHCPCD_INFO} file not found."
		return 1
	fi

  # ɤ߹
	. ${DHCPCD_INFO}
	if [ ! -n "${IPADDR}" -o ! -n "${NETMASK}" ]; then
		addcon_syslog "IPADDR[${IPADDR}] or NETMASK[${NETMASK}] is null. "
		return 1
	fi

	access_conf_edit "${IPADDR}" "${NETMASK}"

	return 0
}

setup_eth0_west()
{
	_fname=setup_eth0_west
	addcon_syslog "$_fname: west eth0 setup"
	return 0
}

addcon_setup_eth0_west()
{
	echo "DEVICE=eth0" > ${WANIFCFG}
	echo "BOOTPROTO=dhcp" >> ${WANIFCFG}
	#2006.04.13
	#echo "DHCPARGS=\"-R\"" >> ${WANIFCFG}
	#2006.04.14
	#echo "DHCPARGS=\"-t 10 -R\"" >> ${WANIFCFG}
	echo "DHCPCDARGS=\"-t 10 -R\"" >> ${WANIFCFG}
	echo "ALLMULTI=yes" >> ${WANIFCFG}
	echo "NETWORKING_IPV6=yes" >> ${WANIFCFG}
	echo "IPV6INIT=yes" >> ${WANIFCFG}

	# 2006.07.13 ټʤ
	if [ -f "${DHCPC_COMP}" ]; then
	addcon_syslog "already dhcp ifup ${WANIFCFG}"
	_rc=0
	else
	#ifup eth0
	#2006.04.17
	addcon_syslog "ifdown ${WANIFCFG}. waiting..."
	addcon_syslog "ip route flush"
	ip route flush dev eth0
	ifdown ${WANIFCFG}
	sleep 2

	# 2006.08.11 LAN¦IPv6RAػߤFLUSH
	sysctl -w net.ipv6.conf.eth1.accept_ra=0
	ip -f inet6 addr flush dev eth1

	#2006.05.13
	ifconfig eth0 up
	addcon_syslog "ifup ${WANIFCFG}"
	ifup ${WANIFCFG}
	_rc=$?
	fi

	# 2006.04.15
	# ˡallmultiν롩
	if [ $_rc = 0 ]; then
		led_alarm_off
		ip link set eth0 allmulti on

		if [ -f ${DHCPCD_INFO} ]; then
			unset IPADDR DNS GATEWAY
			. ${DHCPCD_INFO}
			if [ -n "${GATEWAY}" -a -n "${DNS}" ]; then
				addcon_syslog "Setting route to ${GATEWAY}"
				ip route add default via ${GATEWAY}

				addcon_syslog "Setting resolv.conf: ${DNS}"
				#echo "nameserver ${DNS}" > /etc/resolv.conf
				echo "${DNS}" | awk -F"," '{ for ( i=1; i<=NF; i = i + 1 ) printf"nameserver %s\n",$i}' > /etc/resolv.conf
				addcon_syslog_sys "DHCPμޤ"
				# 2006.07.13 DHCP
				touch ${DHCPC_COMP}
			else
				if [ ! -n "${GATEWAY}" ]; then
					addcon_syslog_sys "DHCPФGATEWAYǤޤ"
				fi
				if [ ! -n "${DNS}" ]; then
					addcon_syslog_sys "DHCPФDNSǤޤ"
				fi
				addcon_syslog "No setting route to gateway."
			fi
		else
			addcon_syslog "Not found ${DHCPCD_INFO}"
		fi
	else
		addcon_syslog "ifup ${WANIFCFG} error."
		addcon_syslog_sys "DHCPФαޤ"
		led_alarm_on
	fi

	return $?
}

# 2006.07.05 IP
addcon_setup_eth0_west_ip()
{
	ip link set eth0 allmulti on
	return 0
}

remove_eth0()
{
	#2006.04.16
	#ifdown eth0
	ifdown ${WANIFCFG}
	if [ -f "${WANIFCFGBAK}" ];then
		mv -f "${WANIFCFGBAK}" "${WANIFCFG}"
	else
		#dhcpξ
		echo "DEVICE=eth0" > ${WANIFCFG}
		echo "ONBOOT=yes" >> ${WANIFCFG}
		echo "BOOTPROTO=dhcp" >> ${WANIFCFG}
		# 2006.04.14
		#echo "DHCPARGS=\"-R\""  >> ${WANIFCFG}
		echo "DHCPCDARGS=\"-R\""  >> ${WANIFCFG}
		echo "ALLMULTI=yes" >> ${WANIFCFG}
	fi
	return 0
}

# 2006.04.08
#  $1: east/west
addcon_param_check()
{
	_strrc=0
	_chkstr=`cat ${OUTPUT} | awk 'BEGIN{FS="="}/sipsv_addr=/{printf"%s",$2}'`
	if [ -z "${_chkstr}" -o ${#_chkstr} -gt 64 ]; then
		_strrc=1
		addcon_syslog "sipsv_addr is \"${_chkstr}\". string error."
	fi

	_chkstr=`cat ${OUTPUT} | awk 'BEGIN{FS="="}/sipsv_port=/{printf"%s",$2}'`
	if [ -z "${_chkstr}" -o ${#_chkstr} -gt 5 -o ${_chkstr} -gt 65535 ]; then
		_strrc=1
		addcon_syslog "sipsv_port is \"${_chkstr}\". string error."
	fi

	_chkstr=`cat ${OUTPUT} | awk 'BEGIN{FS="="}/regsv_addr=/{printf"%s",$2}'`
	if [ -z "${_chkstr}" -o ${#_chkstr} -gt 64 ]; then
		_strrc=1
		addcon_syslog "regsv_addr is \"${_chkstr}\". string error."
	fi

	_chkstr=`cat ${OUTPUT} | awk 'BEGIN{FS="="}/regsv_port=/{printf"%s",$2}'`
	if [ -z "${_chkstr}" -o ${#_chkstr} -gt 5 -o ${_chkstr} -gt 65535 ]; then
		_strrc=1
		addcon_syslog "regsv_port is \"${_chkstr}\". string error."
	fi

	_chkstr=`cat ${OUTPUT} | awk 'BEGIN{FS="="}/username=/{printf"%s",$2}'`
	if [ ${#_chkstr} -gt 32 ]; then
		#_strrc=1
		addcon_syslog "username is \"${_chkstr}\". string error."
	fi
	

	_chkstr=`cat ${OUTPUT} | awk 'BEGIN{FS="="}/password=/{printf"%s",$2}'`
	if [ ${#_chkstr} -gt 32 ]; then
		#_strrc=1
		addcon_syslog "password is \"${_chkstr}\". string error."
	fi

	_chkstr=`cat ${OUTPUT} | awk 'BEGIN{FS="="}/ip_tel_num=/{printf"%s",$2}'`
	if [ ${#_chkstr} -lt 9 -o ${#_chkstr} -gt 32 ]; then
		#_strrc=1
		addcon_syslog "ip_tel_num is \"${_chkstr}\". string error."
	fi

	_addnum=1
	while [ $_addnum -le 31 ]; do
		_chkstr=`cat ${OUTPUT} | awk -v telnum=$_addnum 'BEGIN{numstr="ip_tel_num" telnum; FS="="}{ aaa=match($1,numstr); if ( aaa ) printf"%s",$2}'`
		if [ ${#_chkstr} -lt 9 -o ${#_chkstr} -gt 32 ]; then
			_strrc=1
			addcon_syslog "ip_tel_num${_addnum} is \"${_chkstr}\"."
		fi
		_addnum=$(( $_addnum + 1 ))
	done

	_chkstr=`cat ${OUTPUT} | awk 'BEGIN{FS="="}/area_code=/{printf"%s",$2}'`
	if [ ${#_chkstr} -lt 2 -o ${#_chkstr} -gt 6 ]; then
		#_strrc=1
		addcon_syslog "area_code is \"${_chkstr}\". string error."
	fi

	_chkstr=`cat ${OUTPUT} | awk 'BEGIN{FS="="}/url_update=/{printf"%s",$2}'`
	if [ -z "${_chkstr}" -o ${#_chkstr} -gt 128 ]; then
		#_strrc=1
		addcon_syslog "url_update is \"${_chkstr}\"."
	fi

	_chkstr=`cat ${OUTPUT} | awk 'BEGIN{FS="="}/url_update_cas=/{printf"%s",$2}'`
	if [ -z "${_chkstr}" -o ${#_chkstr} -gt 128 ]; then
		#_strrc=1
		addcon_syslog "url_update_cas is \"${_chkstr}\"."
	fi


	if [ "X$1" = "Xeast" ]; then
		_chkstr=`cat ${OUTPUT} | awk 'BEGIN{FS="="}/ip_addr=/{printf"%s",$2}'`
		if [ ${#_chkstr} -lt 7 -o ${#_chkstr} -gt 15 ]; then
			_strrc=1
			addcon_syslog "ip_addr is \"${_chkstr}\"."
		fi

		_chkstr=`cat ${OUTPUT} | awk 'BEGIN{FS="="}/netmask=/{printf"%s",$2}'`
		if [ -z "${_chkstr}" -o ${#_chkstr} -gt 2 -o ${_chkstr} -lt 1 -o ${_chkstr} -gt 32 ]; then
			_strrc=1
			addcon_syslog "netmask is \"${_chkstr}\"."
		fi

		_chkstr=`cat ${OUTPUT} | awk 'BEGIN{FS="="}/gateway=/{printf"%s",$2}'`
		if [ ${#_chkstr} -gt 15 ]; then
			_strrc=1
			addcon_syslog "gateway is \"${_chkstr}\"."
		fi
		
		_chkstr=`cat ${OUTPUT} | awk 'BEGIN{FS="="}/dest_nw_addr=/{printf"%s",$2}'`
		if [ ${#_chkstr} -gt 664 ]; then
			#_strrc=1
			addcon_syslog "dest_nw_addr is \"${_chkstr}\"."
		fi
	fi
}

# 2006.05.14
addcon_sverr()
{
	#_svres=`cat ${SVRESF} | awk -F: 'NR==2{printf"%s\n",$1}'`
	#_svres_str=`cat ${SVRESF} | awk -F: 'NR==2{printf"%s\n",$2}'`
	local _svres=
	_svres=`grep "Resolving" ${SVRESF} | grep "failed" `
	if [ $? = 0 ]; then
		addcon_syslog0 "DNS³顼"
	fi
	_svres=`grep "Connecting" ${SVRESF} | grep "failed" | grep "refused" `
	if [ $? = 0 ]; then
		addcon_syslog0 "ưꥵ³顼(HTTP)"
	fi
	#addcon_syslog0 "Х顼: ${_svres} ${svres_str}"
}
# 2006.05.14
check_bind()
{
	addcon_syslog "reset bind."
	iptables -D scas -o eth0 -p tcp --dport 53 -j ACCEPT
	iptables -D scas -o eth0 -p udp --dport 53 -j ACCEPT
	iptables -D scas -i eth0 -p tcp --sport 53 -j ACCEPT
	iptables -D scas -i eth0 -p udp --sport 53 -j ACCEPT

	iptables -I scas -o eth0 -p tcp --dport 53 -j ACCEPT
	iptables -I scas -o eth0 -p udp --dport 53 -j ACCEPT
	iptables -I scas -i eth0 -p tcp --sport 53 -j ACCEPT
	iptables -I scas -i eth0 -p udp --sport 53 -j ACCEPT
}

start_addcon()
{
	_fname=start_addcon
	#check_iptell_type
	#_type=$?
	#if [ $_type != 5 -a $_type != 6 -a $_type != 7 ]; then
	#	addcon_syslog "ip_tel type is not soho-cas"
	#	return 1
	#fi

	addcon_syslog "$_fname: start"
	_inet64=$1
	_addopt="${ADDOPT}"
	
	case ${_inet64} in
		-6)
			_addopt="${_addopt} --inet6-only"
			;;
		-4)
			_addopt="${_addopt} --inet4-only"
			;;
		*)
			;;
	esac

	if [ "X$2" != "X" ]; then
		_url=$2
	elif [ -f "${DEFAULTURLF}" ]; then
		_url=`cat ${DEFAULTURLF}`
	else
		_url=$DEFURL
	fi
	# 2006.05.14 DNSå
	check_bind
	create_auth
	${WGET} -S --timeout=${TIMEOUT} --dns-timeout=${DNSTIMEOUT} -O ${OUTPUT0} ${_addopt} --post-file="${POSTF}" --user-agent=${AGENT} --header="${ADDHEAD}" ${_url} 2> ${SVRESF}
	
	RETVAL=$?
	
	if [ $RETVAL = "0" ]; then
		addcon_syslog0 "ưޤ"
		if [ -f ${OUTPUT0} ]; then
			cat ${OUTPUT0} | ${NKF} > ${OUTPUT}
			_cas_result=`cat ${OUTPUT} | awk 'BEGIN{FS="="}/ResultCode/{printf"%s",$2}'`
			# 2006.04.08
			addcon_param_check

			case $_cas_result in
				0000)
					#cat ${OUTPUT} | awk -f ${AWKF} > ${RESULTF}
					cat ${OUTPUT0} | ${NKF} > ${RESULTF}
					addcon_syslog0 "ư"
					# 2006.04.20
					ADDCON_COMPLETE=0
					;;
				0001)
					addcon_syslog0 "ưꥵФΥ顼[ꥯȥեޥåȥ顼]"
					;;
				0002)
					addcon_syslog0 "ưꥵФΥ顼[桼ֹ ̤Ͽ]"
					;;
				0003)
					addcon_syslog0 "ưꥵФΥ顼[ȼҥ ̤Ͽ]"
					;;
				1101)
					addcon_syslog0 "ưꥵФΥ顼[ ̤Ͽ]"
					;;
				9990)
					addcon_syslog0 "ưꥵФΥ顼[꥽]"
					;;
				9991)
					addcon_syslog0 "ưꥵФΥ顼[ǧڥ顼]"
					;;
				9999)
					addcon_syslog0 "ưꥵФΥ顼[а۾]"
					;;
				*)
					addcon_syslog0 "ưꥵФΥ顼[̤ΤΥ]"
					;;
			esac
		fi
	else
		if [ -f ${SVRESF} ]; then
			# 2006.05.14
			addcon_sverr
		fi
		addcon_syslog0 "ưǤޤ"
	fi
	return ${RETVAL}
}


create_conf()
{
	cp /dev/null $PAPSECRET
	cp /dev/null $CHAPSECRET

	for i in ${PPP_TOP}/pppoe_e.conf; do
		_certify=`cat ${i} |grep "^#certification"` > /dev/null 2>&1
		if [ "$_certify" = "#certification=pap" ]; then
			cat $i | awk 'BEGIN{FS="=";}/^USER/{printf"%s  * ",$2;}/#password/{printf"%s\n",$2;}'  >> $PAPSECRET;
		fi
		if [ "$_certify" = "#certification=chap" ]; then
			cat $i | awk 'BEGIN{FS="=";}/^USER/{printf"%s  * ",$2;}/#password/{printf"%s\n",$2;}'  >> $CHAPSECRET;
		fi

	done
	chmod 600 ${PAPSECRET} ${CHAPSECRET}
}

# 2006.04.03 sumi
#  $1: backup/restore
resolv_conf()
{
	__args=$1
	case $__args in
		backup)
			if [ -f /etc/resolv.conf ]; then
				mv /etc/resolv.conf /etc/__addcon_resolv.conf
			fi
			addcon_syslog "backup resolv.conf"
			;;
		restore)
			if [ -f /etc/resolv.conf ]; then
				rm -f /etc/resolv.conf
				mv -f /etc/__addcon_resolv.conf /etc/resolv.conf
			fi
			addcon_syslog "restore resolv.conf"
			;;
		*)
			;;
	esac
}

# 2006.04.05
start_pppoe_east()
{
	_sec=`date +%s`
	_sec_limit=$(( ${_sec} + 900 ))
	_max_count=27
	addcon_syslog "start pppoe: sec:${_sec} limit:${_sec_limit}  remcount:${_max_count}"

	_rc=1
	while [ $_sec -le $_sec_limit ]; do
		adsl-start ${PPP_TOP}/pppoe_e.conf
		if [ $? != 0 ]; then
			addcon_syslog "pppoe connect retry"
			_sec=`date +%s`
			_max_count=$(( $_max_count - 1 ))
			addcon_syslog "pppoe connect retry: sec:${_sec} remcount:${_max_count}"
			if [ $_max_count = 0 ]; then
				addcon_syslog "pppoe connect max count over. break."
				break
			fi
		else
			addcon_syslog "pppoe connect success."
			_rc=0
			break
		fi
	done
	#2006.05.13
	if [ "X$_rc" = "X1" ]; then
		echo "pppoe" > ${ADDCON_ERR}
	fi
	return $_rc
}

start_scas_east()
{
	_rc=1
	resolv_conf backup
	#pppoe start
	create_conf
	start_pppoe_east
	if [ $? = 0 ]; then
		addcon_syslog "Waiting pppoe session."
		sleep 4
		addcon_syslog0 "PPPoE³ޤ(ưꥵ)"
		start_addcon -4 $EAST_URL
		_rc=$?
	else
		addcon_syslog "pppoe connect error."
		addcon_syslog0 "PPPoE³˼Ԥޤ(ưꥵ)"
		led_alarm_on
	fi
	adsl-stop ${PPP_TOP}/pppoe_e.conf
	resolv_conf restore

	if [ "$_rc" = 0 ]; then
		setup_eth0_east
	else
		addcon_syslog "addcon failure. Do not setup wan interface."
	fi
	return $_rc
}

start_scas_west()
{
	_rc=1
	# 2006.04.19
	_loopcount=3

	resolv_conf backup
	#dhcp start
	#dhcpcd -R -n eth0
	# 2006.04.10
	while [ 1 ]; do
		addcon_setup_eth0_west
		if [ $? = 0 ]; then
			addcon_syslog "Wait IPv6 setting..."
			sleep 4
			# dhcp(ɥ󤬼ԤǤͭ)
			setup_eth0_west_after_dhcp

			# 2006.08.10 test
			check_ipv6_global

			addcon_syslog "`ifconfig eth0`"
			start_addcon -6 $WEST_URL
			_rc=$?
			break
		else
			addcon_syslog "dhcp client setup error."
		fi
		# 2006.04.19
		_loopcount=$(( $_loopcount - 1 ))
		if [ $_loopcount = 0 ]; then
			break
		fi
	done
	# 2006.04.09
	#remove_eth0
	resolv_conf restore

	if [ "$_rc" = 0 ]; then
		setup_eth0_west
	else
		addcon_syslog "addcon failure. Do not setup wan interface."
	fi
	return $_rc
}
# 2006.07.05 IP
start_scas_west_ip()
{
	_rc=1
	_loopcount=20

	while [ 1 ]; do
		addcon_setup_eth0_west_ip
		if [ $? = 0 ]; then
			addcon_syslog "Wait IPv6 setting..."
			sleep 4

			# 2006.08.10 test
			check_ipv6_global
			# 2006.08.11
			if [ $? != 0 ]; then
				retry_rs_ipv6
			fi

			addcon_syslog "`ifconfig eth0`"
			start_addcon -6 $WEST_URL
			_rc=$?
			if [ "X$_rc" = "X0" ]; then
				break
			fi
		else
			addcon_syslog "dhcp client setup error."
		fi
		_loopcount=$(( $_loopcount - 1 ))
		if [ $_loopcount = 0 ]; then
			break
		fi
		addcon_syslog0 "˼Ԥޤ(ưꥵ)"
		addcon_syslog0 "ĤƻԲ:${_loopcount}(ưꥵ)"
		addcon_syslog0 "10ø˺ƻԤޤ(ưꥵ)"
		sleep 10
	done

	if [ "$_rc" = 0 ]; then
		setup_eth0_west
	else
		addcon_syslog "addcon failure. Do not setup wan interface."
	fi
	return $_rc
}
# 2006.08.11
retry_rs_ipv6()
{
	addcon_syslog "IPv6 rs sending retrying..."
	addcon_setup_eth0_west_ip
	#ifconfig eth0 down
	sysctl -w net.ipv6.conf.eth0.accept_ra=1
	#ifconfig eth0 up
	if [ -x /mnt/usr/BACKUP/rtsol ]; then
		/mnt/usr/BACKUP/rtsol eth0
	else
		addcon_syslog "Not found rtsol"
	fi
	sleep 4
}
# 2006.08.10
check_ipv6_global()
{
	local _rc=
	local _scope=
	_scope=`ip -f inet6 addr show dev eth0 | grep scope |grep global`
	if [ -z "$_scope" ]; then
		addcon_syslog0 "IPv6(Х)ɥ쥹Ǥޤ"
		_rc=1
	else
		addcon_syslog0 "IPv6(Х)ɥ쥹ޤ(${_scope})"
		_rc=0
	fi
	return $_rc
}

check_wget()
{
	case $1 in
		start)
			if [ -f ${WGETGZ} ]; then
				gunzip -c ${WGETGZ} > ${WGET}
				chmod 755 ${WGET}
			else
				WGET=wget
			fi
			;;
		stop)
			rm -f ${WGET}
			;;
		*)
			;;
	esac
}

# 2006.04.05 sumi
remove_addcon_file()
{
	[ -n "${OUTPUT0}" ] && rm -f ${OUTPUT0}
	[ -n "${OUTPUT}" ]  && rm -f ${OUTPUT}
	[ -n "${SVRESF}" ]  && rm -f ${SVRESF}
	[ -n "${RESULTF}" ] && rm -f ${RESULTF}
	[ -n "${DEBUG_ADDCON_INFO}" ] && rm -f ${DEBUG_ADDCON_INFO}
	return 0
}

################################
ln -s $0 ${LOCKFILE}
if [ $? != 0 ]; then
	addcon_syslog "Already executing $CMDBAT"
	exit 1
fi
trap "rm -f ${LOCKFILE}" EXIT


# 2006.05.01
case ${1} in
	access_conf)
		# dhcpaccess.conf
		setup_eth0_west_after_dhcp
		RETVAL=$?
		exit $RETVAL
		;;
	stop)
		remove_addcon_file
		exit 0
		;;
	*) ;;
esac

#####
check_wget start
#check_iptell_type
check_wanstate_type
_type=$?

# 2006.05.13
if [ -f "${ADDCON_ERR}" ]; then
	addcon_syslog "addcon error result: `cat ${ADDCON_ERR}`"
	exit 0
fi

case $_type in
	5)
		addcon_syslog "VoIP type is SOHO-CAS(EAST). Start addcon."
		addcon_syslog0 "ưꥵФؤ³򳫻Ϥޤ"
		start_scas_east
		RETVAL=$?
		;;
	# 2006.06.30 DHCPȸIPʬ
#	6|7)
	6)
		addcon_syslog "VoIP type is SOHO-CAS(WEST). Start addcon."
		addcon_syslog0 "ưꥵФؤ³򳫻Ϥޤ"
		start_scas_west
		RETVAL=$?
		;;
	# 2006.06.30 IP
	7)
		addcon_syslog "VoIP type is SOHO-CAS(WEST). Start addcon."
		addcon_syslog0 "ưꥵФؤ³򳫻Ϥޤ"
		start_scas_west_ip
		RETVAL=$?
		;;
	*)
		addcon_syslog "VoIP type is not SOHO-CAS. Do not nead addcon."
		RETVAL=1
		ADDCON_COMPLETE=2
		;;
esac
check_wget stop

addcon_syslog "result:${ADDCON_COMPLETE}"
case ${ADDCON_COMPLETE} in
	0)
		$svjudge_cmd "ok"
		;;
	1)
		$svjudge_cmd "ng"
		;;
	2|*)
		$svjudge_cmd "other"
		;;
esac

exit $RETVAL
