#!/bin/sh
#
# ưåץǡȥ󥿥եå
# 2006.03.27 S4
#
CMDBAT=`basename $0`
AUTOUP_FILE=${TOP}/etc/ibsbat/Router/ipaddress_of_wan/autoup.txt
IPTEL_FILE=${TOP}/etc/ibsbat/Router/ipaddress_of_wan/ip_tell.txt
AUTOUP_LOCKCMD=${TOP}/etc/ibsbat/autouplockf_sub.bat
HOSTS_LOCKCMD=${TOP}/etc/ibsbat/hostslockf_sub.bat
WINFO_AUTOUP=${TOP}/tmp/autoup_conn
WINFO_HOSTS=${TOP}/tmp/voip_conn

SERV_PID=/var/log/ibs/ibsproc_service.pid
SVJUDGE_FILE=/tmp/auto_serv_check.txt

# 2006.07.22
PPP_TOP=/etc/ppp
PAPSECRET=${PPP_TOP}/pap-secrets
CHAPSECRET=${PPP_TOP}/chap-secrets

. /etc/ibsbat/ibs.subr

ifcheck_syslog()
{
	logger -p kern.info -t $CMDBAT $1
}
ifcheck_syslog_debug()
{
	logger -p kern.debug -t $CMDBAT $1
}

ifcheck()
{
	[ -f ${AUTOUP_FILE} ] || return 1

	_type=`sed -n '1p' ${AUTOUP_FILE}`
	_autoup2=`sed -n '2p' ${AUTOUP_FILE}`

	if [ "$_type" = "#no" ]; then
		ifcheck_syslog "autoup not use."
		return 1
	elif [ "$_type" != "#0" -a "$_type" != "#1" -a "$_type" != "#2" -a "$_type" != "#3" -a "$_type" != "#4" -a "$_type" != "#lan" -a "$_type" != "#wan" -a "$_type" != "#ctu_ip" -a "$_type" != "#ctu_dhcp" -a "$_type" != "#scas_west_dhcp" -a "$_type" != "#scas_west_ip" -a "$_type" != "#scas_east" ]; then
		ifcheck_syslog "autoup interface is illegal."
		return 1
	fi
	if [ "X$_autoup2" = "X" ]; then
		ifcheck_syslog "autoup interface is not set."
		return 1
	else
		_ipaddr=`echo "$_autoup2" | awk '{printf"%s\n",$1}'`
		_name=`echo "$_autoup2" | awk '{printf"%s\n",$2}'`
	fi

	if [ "X$_name" != "Xibs-autoup" ]; then
		ifcheck_syslog "autoup entry is illegal."
		return 1
	fi
	ifcheck_syslog "autoup interface is ok."
	return 0
}

# 2006.07.18
# ưС󥢥åפ³Υåե̾¸롣
# ǻ˻
vup_session_f=/tmp/vup_session_entry
vup_realif_f=/tmp/vup_realif_f
vup_servname_f=/tmp/vup_servname_f
vup_servip_f=/tmp/vup_servip_f
vup_tmp_f=/tmp/vup_tmp_entry
# 2006.07.13
# $1: pppoeȥ(0-4)
ifcheck_scas_flets_check()
{
	local n_ifname=$1
	local _pidfile=/var/run/pppoe${n_ifname}.conf-adsl.pid.pppd
	if [ -f "$_pidfile" ]; then
		local _pid=`cat $_pidfile`
		kill -0 "$_pid"
		if [ $? = 0 ]; then
			# ³Ѥ
			return 0
		else
			# ̤³
			return 1
		fi
	else
		# ̤³
		return 1
	fi
}

# SCAS FLETS PPPoEȥ³
# $1: pppoeȥ
ifcheck_scas_flets_setup()
{
	local _fletspppoe=/etc/ppp/pppoe${1}.conf
	local _rc=

	ifcheck_syslog "ifcheck_scas_flets_setup: $1"
	if [ -f ${_fletspppoe} ]; then
		adsl-start ${_fletspppoe}
		_rc=$?
	fi
	return $_rc
}

# 2006.07.13
#  SCASfletsؤ³
# $1: ip
# $2: port
IFCHECK_TEST_CMD=/mnt/usr/BACKUP/ibscheck_test
ifcheck_ppp()
{
	local _fentry=
	local _flets=
	local _fip=
	local _fif=
	local _rc=
	# 2006.07.22
	local _nofent=
	local _tmpent=

	ifcheck_syslog "ifcheck_ppp $1 $2 $3"

#	${IFCHECK_TEST_CMD} -p 1 -t 5 -r 0 -v 0 -i 10.0.0.1
	# ޤϡ4
	if [ -f /etc/ppp/pppoe4.conf ]; then
#		_flets=`grep entry_name /etc/ppp/pppoe4.conf`
		_flets=`grep USER= /etc/ppp/pppoe4.conf`
#		if [ "X${_flets}" = "X#entry_name=flets" ]; then
		if [ "X${_flets}" = "XUSER='guest@flets'" ]; then
			_fentry=4
		fi
	else
		_nofent=4
	fi
	if [ "X$_fentry" = "X" ]; then
		for i in 0 1 2 3; do
			if [ -f /etc/ppp/pppoe${i}.conf ]; then
#				_flets=`grep entry_name /etc/ppp/pppoe${i}.conf`
				_flets=`grep USER= /etc/ppp/pppoe${i}.conf`
#				if [ "X${_flets}" = "X#entry_name=flets" ]; then
				if [ "X${_flets}" = "XUSER='guest@flets'" ]; then
					_fentry=${i}
					break
				fi
			else
				_nofent=${i}
			fi
		done
	fi

	if [ "X$_fentry" != "X" ]; then
		# FletsΥȥ꤬ͭ
		ifcheck_scas_flets_check "$_fentry"
		if [ $? != 0 ]; then
			# ̤³
			ifcheck_syslog "Flets entry($_fentry) not connected. connecting..."
			ifcheck_scas_flets_setup "$_fentry"
			_rc=$?
			if [ $_rc = 0 ]; then
				ifcheck_syslog "Flets entry($_fentry) connected."
				# ѤIPɥ쥹
				_fip=`adsl-status /etc/ppp/pppoe${_fentry}.conf | grep "inet addr" `
				_fip=`echo $_fip | awk '{printf"%s\n", $2}' | awk -F":" '{printf"%s\n",$2}'`
				${IFCHECK_TEST_CMD} -p 1 -t 5 -r 0 -v 0 -i ${_fip}
				_fif=`adsl-status /etc/ppp/pppoe${_fentry}.conf | sed -n '2p'`
				_fif=`echo $_fif | awk '{printf"%s\n",$1}'`
				ifcheck_syslog "Flets entry($_fentry) sending ip:${_fip} if:${_fif}"
				echo "/etc/ppp/pppoe${_fentry}.conf" > $vup_session_f
			fi
		else
			# ³Ѥ
			ifcheck_syslog "Flets entry($_fentry) already connected."
			# ѤIPɥ쥹
			_fip=`adsl-status /etc/ppp/pppoe${_fentry}.conf | grep "inet addr" `
			_fip=`echo $_fip | awk '{printf"%s\n", $2}' | awk -F":" '{printf"%s\n",$2}'`
			${IFCHECK_TEST_CMD} -p 1 -t 5 -r 0 -v 0 -i ${_fip}
			_fif=`adsl-status /etc/ppp/pppoe${_fentry}.conf | sed -n '2p'`
			_fif=`echo $_fif | awk '{printf"%s\n",$1}'`
			ifcheck_syslog "Flets entry($_fentry) sending ip:${_fip} if:${_fif}"
			_rc=0
		fi
	else
	#Ǥ̵
		# ȥ˶ͭ
		if [ "X$_nofent" != "X" ]; then
			ifcheck_syslog "Idle entry exist($_nofent)."
			# ե̵ȥѤ
			_tmpent=$_nofent
		else
		# ȥ˶̵
			# PPPå˶ͭ뤫
			for i in 4 3 2 1 0; do
				ifcheck_scas_flets_check ${i}
				if [ $? != 0 ]; then
					_tmpent=${i}
					break
				fi
			done

			if [ "X$_tmpent" = "X" ]; then
			#(ȥ5)
				ifcheck_syslog "Not idle entry. Disconnect entry4"
				_tmpent=4
				adsl-stop /etc/ppp/pppoe4.conf
				sleep 20
				# Ǥȥ¸
				mv /etc/ppp/pppoe${_tmpent}.conf /etc/ppp/pppoe_tmp.conf
				echo "/etc/ppp/pppoe${_tmpent}.conf" > ${vup_tmp_f}
			fi
		fi

#		ifcheck_ppp_flets_connect $_nofent
		ifcheck_ppp_flets_connect $_tmpent
		if [ $? = 0 ]; then
		# ѤIPɥ쥹
			_fip=`adsl-status ${flets_conf} | grep "inet addr" `
			_fip=`echo $_fip | awk '{printf"%s\n", $2}' | awk -F":" '{printf"%s\n",$2}'`
			${IFCHECK_TEST_CMD} -p 1 -t 5 -r 0 -v 0 -i ${_fip}
			_fif=`adsl-status ${flets_conf} | sed -n '2p'`
			_fif=`echo $_fif | awk '{printf"%s\n",$1}'`
			ifcheck_syslog "Flets entry sending ip:${_fip} if:${_fif}"
			echo "${flets_conf}" > $vup_session_f
			ifcheck_ppp_dns_route $_tmpent $_fif
			_rc=0
		else
			ifcheck_syslog "Idle entry cannot connect"
			_rc=1
		fi
	fi

	if [ "X$_rc" != "X0" ]; then
		#顼ޥ
		ifcheck_syslog "ifcheck_ppp connect error."
		${IFCHECK_TEST_CMD} -p 1 -t 7 -r 0
	else
		#³Ǥˡ롼ꤹ
		ifcheck_syslog "ifcheck_ppp  waiting ppp setup"
		sleep 10
		ifcheck_syslog "ifcheck_ppp  set route to server"
		if [ -n "$_fif" ]; then
			# 2006.07.21
			ifcheck_syslog "ifcheck_ppp add dns entry"
			/bin/sh /etc/ibsbat/dns/dnslookup2.bat add $_fif $1
			echo "$_fif $1" > /tmp/autoup_ifcheck_dns_entry
			echo "$_fif" > ${vup_realif_f}
			echo "$1"    > ${vup_servname_f}
			# 2006.07.22
			ifcheck_ppp_filter dns $_fif

			local _sip=`dig $1 A IN |grep -v "^;" |grep $1 | awk '{printf"%s\n",$5}'`
			if [ -n "$_sip" ]; then
				route add $_sip dev ${_fif}
				echo "$_sip" > ${vup_servip_f}
				# 2006.07.21
				ifcheck_ppp_filter serv $_fif $_sip
			fi
		else
			ifcheck_syslog "_fif not set"
		fi
	fi
	return $_rc
}
# 2006.07.21
# $1: dns/serv
# $2: realif
# $3: dl server ip
ifcheck_ppp_filter()
{
	local _ipt=/sbin/iptables
	local _realif=$2
	local _servip=$3

	$_ipt -N autoup
	if [ $? != 0 ]; then
		$_ipt -t filter -F autoup
	fi

	if [ "X$1" = "Xdns" ]; then
		$_ipt -I INPUT  -i $_realif -j autoup
		$_ipt -I OUTPUT -o $_realif -j autoup
		$_ipt -I autoup -o $_realif -p udp --dport 53 -j ACCEPT
		$_ipt -I autoup -o $_realif -p tcp --dport 53 -j ACCEPT
		$_ipt -I autoup -i $_realif -p udp --sport 53 -j ACCEPT
		$_ipt -I autoup -i $_realif -p tcp --sport 53 -j ACCEPT
	else
		$_ipt -I autoup -o $_realif -p udp --dport 53 -j ACCEPT
		$_ipt -I autoup -o $_realif -p tcp --dport 53 -j ACCEPT
		$_ipt -I autoup -o $_realif -p udp -d $_servip -j ACCEPT
		$_ipt -I autoup -o $_realif -p tcp -d $_servip -j ACCEPT
		$_ipt -I autoup -i $_realif -p udp --sport 53 -j ACCEPT
		$_ipt -I autoup -i $_realif -p tcp --sport 53 -j ACCEPT
		$_ipt -I autoup -i $_realif -p udp -s $_servip -j ACCEPT
		$_ipt -I autoup -i $_realif -p tcp -s $_servip -j ACCEPT
	fi

}
ifcheck_ppp_filter_del()
{
	local _ipt=/sbin/iptables
	local _realif=
	if [ -f "${vup_realif_f}" ]; then
		_realif=`cat ${vup_realif_f}`
	fi

	$_ipt -F autoup
	if [ -n "$_realif" ]; then
		$_ipt -D INPUT  -i $_realif -j autoup
		$_ipt -D OUTPUT -o $_realif -j autoup
	fi
	$_ipt -X autoup
}

# 2006.07.22
# $1: entry
# $2: realif
ifcheck_ppp_dns_route()
{
	local _entry=$1
	local _realif=$2
	local _dns_list=
	local _dns_add=
	local _maxcount=20

	while [ ! -f /etc/ppp/resolv_${_realif}.conf  -a $_maxcount -gt 0 ]; do
		_maxcount=$(( $_maxcount - 1 ))
		sleep 2
	done

	_dns_list=`cat /etc/ppp/resolv_${_realif}.conf`
	for _dns_add in $_dns_list; do
		_dns_add=${_dns_add##nameserver}
		if [ -n "$_dns_add" ]; then
			route add $_dns_add dev ${_realif}
		fi
	done
}

# 2006.07.22
# ȥե˶ͭ³
# $1: entry
flets_org_f=/etc/ppp/pppoe_flets.org
flets_conf=/etc/ppp/pppoe_flets.conf
ifcheck_ppp_flets_connect()
{
	local _ent=$1
	local _rc=1
	[ ! -f ${flets_org_f} ] && return 1
	cat ${flets_org_f} | awk -v _ppp=${_ent} '/DEVICE=/{printf"DEVICE=ppp%s\n",_ppp}!/DEVICE=/{printf"%s\n",$0}' > ${flets_conf}

	for i in $flets_conf; do
		_certify=`cat ${i} |grep "^#certification"` > /dev/null 2>&1
		if [ "$_certify" = "#certification=pap" ]; then
			cat $i | awk 'BEGIN{FS="=";}/^USER/{printf"%s  * ",$2;}/#password/{printf"%s\n",$2;}'  >> $PAPSECRET;
		fi
		if [ "$_certify" = "#certification=chap" ]; then
			cat $i | awk 'BEGIN{FS="=";}/^USER/{printf"%s  * ",$2;}/#password/{printf"%s\n",$2;}'  >> $CHAPSECRET;
		fi

	done

	adsl-start ${flets_conf}
	if [ $? = 0 ]; then
		ifcheck_syslog "${flets_conf} connected"
		_rc=0
	else
		ifcheck_syslog "${flets_conf} connect error"
		_rc=1
	fi
	return $_rc
}

# 2006.07.18
# 
ifcheck_dlcomp()
{
	if [ -f "$vup_session_f" ]; then
		local _pppent=`cat ${vup_session_f}`
		if [ -n "$_pppent" ]; then
			ifcheck_syslog "Flets entry disconnecting $_pppent"
			adsl-stop $_pppent
			# 2006.07.21
			sleep 10
		fi
		rm -f $vup_session_f
	fi
	local _dns_entry=
	if [ -f /tmp/autoup_ifcheck_dns_entry ]; then
		_dns_entry=`cat /tmp/autoup_ifcheck_dns_entry`
		/bin/sh /etc/ibsbat/dns/dnslookup2.bat del ${_dns_entry}
		rm -f /tmp/autoup_ifcheck_dns_entry
	fi

	# 2006.07.21
	ifcheck_ppp_filter_del

	# 2006.07.22 Ū³ѹͭä
	if [ -f ${vup_tmp_f} ]; then
		local _ppp_ent=`cat ${vup_tmp_f}`
		ifcheck_syslog "Session resume"
		#mv /etc/ppp/pppoe_tmp.conf /etc/ppp/pppoe4.conf
		#adsl-start /etc/ppp/pppoe4.conf
		mv /etc/ppp/pppoe_tmp.conf ${_ppp_ent}
		adsl-start ${_ppp_ent}
		rm -f ${vup_tmp_f}
	fi
	return 0
}

ifcheck_ibswan()
{
	local ip=`grep ibswan /etc/hosts|awk '{printf"%s\n",$1}'`
	if [ -n "${ip}" ]; then
		ifcheck_syslog "ibswan ok. ip:${ip}"
		return 0
	else
		ifcheck_syslog "ibswan not found."
		return 1
	fi
}

wan_ifcheck()
{
	[ -f ${IPTEL_FILE} ] || return 1

	check_iptell_type
	__type=$?

	case $__type in
		1)
			ifcheck_syslog "voip is pppoe."
			ifcheck_ibswan
			_rc=$?
			;;
		2)
			ifcheck_syslog "voip is fix."
			ifcheck_ibswan
			_rc=$?
			;;
		4)
			ifcheck_syslog "voip is ecas."
			ifcheck_ibswan
			_rc=$?
			;;
		5)
			ifcheck_syslog "voip is scas_east."
			ifcheck_ibswan
			_rc=$?
			;;
		6)
			ifcheck_syslog "voip is scas_west_dhcp."
			ifcheck_ibswan
			_rc=$?
			;;
		7)
			ifcheck_syslog "voip is scas_est_ipoe."
			ifcheck_ibswan
			_rc=$?
			;;
		*)
			return 1
			;;
	esac
	return $_rc
}

RETVAL=1

case $CMDBAT in
	autoup_ifcheck.bat)
		# 2006.07.13 ³׵б
		# ͭä(setup)ϡ³׵
		if [ "X$1" = "Xsetup" ]; then
			# ³׵
			ifcheck_syslog "autoup interface setup"
			ifcheck_ppp $2 $3
		elif [ "X$1" = "Xdlcomp" ]; then
			ifcheck_syslog "autoup interface disconnect"
			ifcheck_dlcomp
		else
			ifcheck
		fi
		RETVAL=$?
		;;
	wan_ifcheck.bat)
		wan_ifcheck
		RETVAL=$?
		#if [ $RETVAL = 0 -a -f ${SERV_PID} ]; then
		# 2006.05.13
		#if [ $RETVAL = 0 -a -f ${SERV_PID} -a -f ${SVJUDGE_FILE} ]; then
		# 2006.05.14
		if [ -f ${SERV_PID} -a -f ${SVJUDGE_FILE} ]; then
			ifcheck_syslog "send signal SIGHUP to `cat ${SERV_PID}`"
			kill -HUP `cat ${SERV_PID}`
		fi
		;;
	*)
		RETVAL=1
		;;
esac
exit $RETVAL
