#!/bin/sh
#
# WANꥹץ
#
# 2006.04.22 ƥ
#
#

_DBGON=
[ -f /tmp/dbgecho ] && _DBGON=1

[ "X${X7DBG}" = "Xon" ] && set -x

. /etc/ibsbat/ibs.subr
. /etc/rc.conf

CMDBAT=`basename $0`

prog=wancfg.bat
SUBSYS=/var/lock/subsys/wancfg
LOCKFILE=/var/lock/subsys/wancfg.lock

WAN_STATE=/etc/ibsbat/Router/ipaddress_of_wan/wan_state.txt
IP_TELL=/etc/ibsbat/Router/ipaddress_of_wan/ip_tell.txt

ADDCON=/etc/ibsbat/addcon/addcon.bat
IFCFG_ETH0=/etc/sysconfig/network-scripts/ifcfg-eth0
IFCFG_ETH0_SCAS=/etc/sysconfig/network-scripts/ifcfg-eth0.scas

DHCPC_INFO=/etc/dhcpc/dhcpcd-eth0.info

NAMED_LOCK=${TOP}/etc/named.ibs-soho.lock
NAMED_LOCK_SYM=${TOP}/etc/named.ibs-soho.lock.sym
LOCK_SLEEP=1
LOCK_TOUT=30

SERV_PID=/var/log/ibs/ibsproc_service.pid
SVJUDGE_FILE=/tmp/auto_serv_check.txt

# 2006.04.25
# 0: success
# 1: error
# 2: no proc
svjudge_cmd=/home/ibsuser/public_html/Admin/Sys_setup/Router/auto_serv_check.cgi

DBGECHO()
{
	[ ! -z $_DBGON ] && echo "$1"
}

wancfg_syslog()
{
	logger -p kern.info -t $CMDBAT "${1}"
}
wancfg_syslog0()
{
	logger -p local1.info -t $CMDBAT "System## ${1}"
}

named_lock()
{
	local RETRY=0
	until ln -s ${NAMED_LOCK} ${NAMED_LOCK_SYM} 2>&- ; do
		wancfg_syslog "named_lock: other proc locked!!"
		if [ "$RETRY" -gt "${LOCK_TOUT}" ] ; then
			rm -f ${NAMED_LOCK_SYM}
			wancfg_syslog "named_lock: time out!!"
			return 1
		fi
		RETRY=$(( $RETRY + 1 ))
		sleep ${LOCK_SLEEP}
	done
	wancfg_syslog "named_lock."
	return 0
}

named_unlock()
{
	rm -f ${NAMED_LOCK_SYM}
	wancfg_syslog "named_unlock."
	return 0
}

resolv_conf_local()
{
	if [ -f /etc/ibsbat/namedb/resolv.conf ]; then
		cp -f /etc/ibsbat/namedb/resolv.conf.org /etc/resolv.conf
	else
		echo "nameserver 127.0.0.1" > /etc/resolv.conf
	fi
}

named_edit()
{
	local _forwarders=$1
	local _nconf=

	wancfg_syslog "named_edit add.(${1})"
	resolv_conf_local
	if [ -f /etc/named.conf ]; then
		_nconf=/etc/named.conf
	else
		_nconf=/etc/ibsbat/namedb/named.conf
	fi

	named_lock
	cat $_nconf| \
	awk -v fwds=$_forwarders '/.*#ibs-forward/{printf"  %s  #ibs-forward\n",fwds}!/.*#ibs-forward/{print}' > /etc/named.conf.1
	mv /etc/named.conf.1 /etc/named.conf
	if [ -x /etc/rc.d/init.d/named ]; then
		/etc/rc.d/init.d/named restart
	fi
	named_unlock
}

config_hosts()
{
	_conf_f=/etc/hosts
	if [ -f ${_conf_f} ]; then
		mv ${_conf_f} ${_conf_f}.1
		cat ${_conf_f}.1 | sort | uniq | \
			sed -e '/#ibsold/d' -e 's:^#ibsnew[ 	]*::' > ${_conf_f}

		grep ibswan ${_conf_f} > /dev/null 2>&1
		if [ $? = 0 ]; then
			mv ${_conf_f} ${_conf_f}.1
			grep -v ibswan ${_conf_f}.1 > ${_conf_f}
			wancfg_syslog "config_hosts ibswan delete."
		else
			wancfg_syslog "config_hosts ibswan not found."
		fi
	else
		wancfg_syslog "config_hosts hosts not found."
	fi
}
# 2006.07.18
#  $1: IPADDR
config_autoup()
{
	local _autoup_f=/etc/ibsbat/Router/ipaddress_of_wan/autoup.txt
	if [ -f $_autoup_f ]; then
		_type=`sed -n '1p' ${_autoup_f}`
		#󥿥ե
		wancfg_syslog "autoup entry:${_type}"
		echo "$_type" > ${_autoup_f}
		echo "$1 ibs-autoup" >> ${_autoup_f}
		return 0
	else
		return 1
	fi
}

wancfg_addcon()
{
##############################
#%%1600
	if [ -x ${ADDCON} ]; then
		${ADDCON}
		send_signal_up
	fi
}

wancfg_eth0()
{
	if [ -f ${WAN_STATE} ]; then
		. ${WAN_STATE}
		if [ "X$wan_set_info" = "Xpppoe" ]; then
			rm -f ${IFCFG_ETH0}
		fi
	else
		echo "Not found ${WAN_STATE}"
	fi
#
# 2006.04.09
	check_wanstate_type
	_wanstate=$?
# west_dhcpǤʤ
	if [ -f ${IFCFG_ETH0} -a $_wanstate != 6 ]; then
		rm -f ${IFCFG_ETH0}.ibs-soho.invalid

		unset DEVICE IPADDR NETMASK BROADCAST
		. ${IFCFG_ETH0}
		if [ -n "${DEVICE}" -o -n "${IPADDR}" -o -n "${NETMASK}" -o -n "${BROADCAST}" ]; then
			/sbin/ifconfig ${DEVICE} ${IPADDR} netmask ${NETMASK} broadcast ${BROADCAST}
		else
			echo "DEIVCE or IPADDR or NETMASK or BROADCAST is null"
		fi

		config_hosts
		echo "${IPADDR}   ibswan" >> /etc/hosts
		wancfg_syslog "wancfg eth0 ibswan set.(${IPADDR})"
	else
		wancfg_syslog "Not found ${IFCFG_ETH0} or WAN type error."
	fi
}

# 2006.05.01
FWMARK_VOIP=0x20
RT_TABLE_SCAS=2
# 2006.06.09
# IPADDRꤵƤ뤳
# $1: east/west_dhcp/west_ipop
scas_voip_gw_set()
{
	local ADF=/tmp/addcon.result
	if [ -f /tmp/addcon.result ]; then
		eval `grep gateway ${ADF}`
		eval `grep sipsv_port ${ADF}`
		eval `grep regsv_port ${ADF}`
		eval `grep rtpport1 ${ADF}`
		eval `grep rtpport2 ${ADF}`
		# 2006.06.10
		eval `grep ip_addr ${ADF}`
		eval `grep netmask ${ADF}`
	else
		wancfg_syslog "Not found ${ADF}"
		return 1
	fi

	# 2006.06.09
	#scas_east_gw_reset
	scas_voip_gw_reset

	iptables -t mangle -N scas
	# 2006.06.10
	#iptables -t mangle -I OUTPUT -o eth0 -j scas
	iptables -t mangle -I OUTPUT -s ${ip_addr} -j scas

	# 2006.06.09
	#local scas_iptables="iptables -t mangle -I scas -o eth0"
	#local scas_iptables="iptables -t mangle -I OUTPUT -o eth0"
	local scas_iptables="iptables -t mangle -I scas"

	#iptables -t mangle -I scas -o eth0 -p udp --sport ${sipsv_port} -j MARK --set-mark $FWMARK_VOIP
	#iptables -t mangle -I scas -o eth0 -p tcp --sport ${sipsv_port} -j MARK --set-mark $FWMARK_VOIP
	#iptables -t mangle -I OUTPUT -p udp -s ${IPADDR} --dport ${sipsv_port} -j MARK --set-mark $FWMARK_VOIP
	#iptables -t mangle -I OUTPUT -p tcp -s ${IPADDR} --dport ${sipsv_port} -j MARK --set-mark $FWMARK_VOIP
	${scas_iptables} -p udp --dport ${sipsv_port} -j MARK --set-mark $FWMARK_VOIP
	${scas_iptables} -p tcp --dport ${sipsv_port} -j MARK --set-mark $FWMARK_VOIP
	if [ "X$sipsv_port" != "Xregsv_port" ]; then
	#iptables -t mangle -I scas -o eth0 -p udp --sport ${regsv_port} -j MARK --set-mark $FWMARK_VOIP
	#iptables -t mangle -I scas -o eth0 -p tcp --sport ${regsv_port} -j MARK --set-mark $FWMARK_VOIP
	#iptables -t mangle -I OUTPUT -p udp -s ${IPADDR} --dport ${regsv_port} -j MARK --set-mark $FWMARK_VOIP
	#iptables -t mangle -I OUTPUT -p tcp -s ${IPADDR} --dport ${regsv_port} -j MARK --set-mark $FWMARK_VOIP
	${scas_iptables} -p udp --dport ${regsv_port} -j MARK --set-mark $FWMARK_VOIP
	${scas_iptables} -p tcp --dport ${regsv_port} -j MARK --set-mark $FWMARK_VOIP
	fi

	#iptables -t mangle -I OUTPUT -p udp -s ${IPADDR} --sport ${rtpport1}:${rtpport2} -j MARK --set-mark $FWMARK_VOIP
	#iptables -t mangle -I OUTPUT -p tcp -s ${IPADDR} --sport ${rtpport1}:${rtpport2} -j MARK --set-mark $FWMARK_VOIP
	${scas_iptables} -p udp --sport ${rtpport1}:${rtpport2} -j MARK --set-mark $FWMARK_VOIP
	${scas_iptables} -p tcp --sport ${rtpport1}:${rtpport2} -j MARK --set-mark $FWMARK_VOIP

	ip rule del fwmark $FWMARK_VOIP table ${RT_TABLE_SCAS}
	ip rule add fwmark $FWMARK_VOIP table ${RT_TABLE_SCAS}

	ip route flush table ${RT_TABLE_SCAS}

	# 2006.06.09 eth0ǤϤʤviaѤ
	# ؿ
#	ip route del default table ${RT_TABLE_SCAS}
#	# ǥեGWȤơeth0
##	ip route add default via ${gateway} table ${RT_TABLE_SCAS}
#	ip route add default dev eth0 table ${RT_TABLE_SCAS}
	if [ "X$1" = "Xeast" ]; then
		scas_voip_gw_set_east $ip_addr $gateway $netmask
	fi
	if [ "X$1" = "Xwest_dhcp" ]; then
		scas_voip_gw_set_west_dhcp
	fi
	if [ "X$1" = "Xwest_ipoe" ]; then
		scas_voip_gw_set_west_ipoe
	fi

	ip route flush cache
	return 0
}
scas_voip_gw_reset()
{
	# 2006.06.10
	#iptables -t mangle -D OUTPUT -o eth0 -j scas
	iptables -t mangle -D OUTPUT -s ${IPADDR} -j scas

	iptables -t mangle -F scas
	ip rule del fwmark $FWMARK_VOIP table ${RT_TABLE_SCAS}
	# 2006.06.09
	#ip route del default table ${RT_TABLE_SCAS}
	ip route flush table ${RT_TABLE_SCAS}
}

# 2006.07.18
# SCAS ΥФؤΥ롼Ȥ
#  IPɥ쥹ȥݡֹMARK
scas_update_gw_set_east()
{
	local scas_iptables="iptables -t mangle -I scas"
	local upd_port=
	local upd_ip=
	if [ -f /tmp/addcon.result ]; then
		eval `grep url_update_cas /tmp/addcon.result`
		wancfg_syslog "${url_update_cas}"

		if [ -n "${url_update_cas}" ]; then
			local tmp1=${url_update_cas#http://}
			local tmp2=${tmp1%%\/*}
			upd_port=${tmp2##*:}
			upd_ip=${tmp2%%:*}
		fi
		if [ -n "${upd_port}" -a -n "${upd_ip}" ]; then
			${scas_iptables} -p tcp -d ${upd_ip} --dport ${upd_port} -j MARK --set-mark $FWMARK_VOIP
			${scas_iptables} -p udp -d ${upd_ip} --dport ${upd_port} -j MARK --set-mark $FWMARK_VOIP
		fi
	fi
}

# 2006.06.09
# $1: ip_addr
# $2: gateway
# $3: netmask
scas_voip_gw_set_east()
{
	# 2006.06.10
	if [ -z "${1}" -o -z "${2}" -o -z "${3}" ]; then
		wancfg_syslog0 "ưˤIPɥ쥹GATEWAYɥ쥹NETMASKΤɤ줫ͤǤ"
		return 0
	fi

	ip route del default table ${RT_TABLE_SCAS}
	# ǥեGWȤơeth0
	# 2006.06.09 eth0ǤϤʤviaѤ
	ip route add default via ${2} table ${RT_TABLE_SCAS}
	# 2006.06.10 Ʊ쥵֥ͥåѤ
	local lannet=`ipcalc -n ${1}/${3} | awk 'BEGIN{ FS="=";}{printf"%s\n",$2}'`
	ip route add ${lannet}/${3} dev eth0 table ${RT_TABLE_SCAS}

	# 2006.07.18
	scas_update_gw_set_east
}
# 2006.06.09
scas_voip_gw_set_west_dhcp()
{
	unset IPADDR DNS GATEWAY
	if [ -f "${DHCPC_INFO}" ]; then
		wancfg_syslog "Found ${DHCPC_INFO}"
		. ${DHCPC_INFO}
	else
		wancfg_syslog0 "DHCPˤͭޤ"
		return 0
	fi
	if [ -z "${GATEWAY}" ]; then
		wancfg_syslog0 "DHCPˤGATEWAYͭޤ"
		return 0
	fi

	ip route del default table ${RT_TABLE_SCAS}
	# ǥեGWȤơeth0
	# 2006.06.09 eth0ǤϤʤviaѤ
	ip route add default via ${GATEWAY} table ${RT_TABLE_SCAS}
}
# 2006.06.09
scas_voip_gw_set_west_ipoe()
{
	local _deftbl=/etc/ibsbat/Router/routing/default_route.txt
	if [ -f "$_deftbl" ]; then
	  . ${_deftbl}
	fi
	if [ -z "$default_route_ipaddress" ]; then
		wancfg_syslog0 "ǥեȥȥꤵƤޤ"
		return 0
	fi
	ip route del default table ${RT_TABLE_SCAS}
	# ǥեGWȤơeth0
	# 2006.06.09 eth0ǤϤʤviaѤ
	ip route add default via ${default_route_ipaddress} table ${RT_TABLE_SCAS}
}

#IPɥ쥹
wancfg_east_ipoe()
{
	if [ -f ${IFCFG_ETH0_SCAS} ]; then
		# 2006.05.10
		#rm -f /etc/sysconfig/network-scripts/ifcfg-eth0.ibs-soho.invalid
		. ${IFCFG_ETH0_SCAS}
		if [ -n "${DEVICE}" -o -n "${IPADDR}" -o -n "${NETMASK}" -o -n "${BROADCAST}" ]; then
			/sbin/ifconfig ${DEVICE} ${IPADDR} netmask ${NETMASK} broadcast ${BROADCAST}
			# 2006.05.15
			wancfg_ipcheck eth0
			config_hosts
			echo "${IPADDR}   ibswan" >> /etc/hosts
			wancfg_syslog "east_ipoe ibswan set.(${IPADDR})"

			# 2006.07.18
			local _atype=
			check_autoup_type
			_atype=$?
			if [ "X$_atype" = "X5" ]; then
				config_autoup ${IPADDR}
			fi
		fi
	fi
}

# 2006.05.15
# $1: i/f (eth0/ppp0-4)
wancfg_ipcheck()
{
	local _rc=
	local lanip=
	local lanmask=
	local wanip=
	local wanmask=

	local lanip0=`ip -f inet addr show dev eth1 | sed -n '2p' | awk '{printf"%s\n",$2}'`
	if [ -n "$lanip0" ]; then
		lanip=${lanip0%\/*}
		lanmask=${lanip0##*\/}
	fi
	local wanip0=`ip -f inet addr show dev $1 | sed -n '2p' | awk '{printf"%s\n",$2}'`
	if [ -n "$wanip0" ]; then
		wanip=${wanip0%\/*}
		wanmask=${wanip0##*\/}
	fi

	if [ ! -n "$lanip" -o ! -n "$wanip" ]; then
		wancfg_syslog0 "WAN¦ޤLAN¦IPɥ쥹󤬼Ǥޤ(WAN:[${wanip}] LAN:[${lanip}])"
		return 0
	fi

	if [ "X${lanip}" = "X${wanip}" ]; then
		wancfg_syslog0 "WAN¦IPɥ쥹LAN¦IPɥ쥹ƱǤ"
		_rc=1
	else
		_rc=0
	fi

	if [ ! -n "$lanmask" -o ! -n "$wanmask" ]; then
		wancfg_syslog0 "WAN¦ޤLAN¦Υͥåȥޥ󤬼Ǥޤ(WAN:[${wanmask}] LAN:[${lanmask}])"
		return 0
	fi
	local lanprefix=`ipcalc -p ${lanip}/${lanmask} | awk 'BEGIN{ FS="=";}{printf"%s\n",$2}'`
	local wanprefix=`ipcalc -p ${wanip}/${wanmask} | awk 'BEGIN{ FS="=";}{printf"%s\n",$2}'`
	if [ -n "$lanprefix" -a -n "$wanprefix" ]; then
		if [ $lanprefix -ge $wanprefix ]; then
			cmpprefix=$wanprefix
		else
			cmpprefix=$lanprefix
		fi
		local lannet=`ipcalc -n ${lanip}/${cmpprefix} | awk 'BEGIN{ FS="=";}{printf"%s\n",$2}'`
		local wannet=`ipcalc -n ${wanip}/${cmpprefix} | awk 'BEGIN{ FS="=";}{printf"%s\n",$2}'`
		if [ -n "$lannet" -a -n "$wannet" ]; then
			if [ "X$lannet" = "X$wannet" ]; then
				wancfg_syslog0 "WAN¦LAN¦Υ֥ͥåȤפƤ뤫Υ֥ͥåȤ˴ޤޤޤƤޤ(WAN:${wanip}/${wanmask}  LAN:${lanip}/${lanmask})"
				_rc=1
			else
				_rc=0
			fi
		else
			wancfg_syslog0 "WAN¦ޤLAN¦Υ֥ͥåȾ󤬼Ǥޤ(WAN:[${wannet}] LAN:[${lannet}])"
		fi
	else
		wancfg_syslog0 "WAN¦ޤLAN¦Υͥåȥץեå󤬼Ǥޤ(WAN:[${wanprefix}] LAN:[${lanprefix}])"
		_rc=0
	fi
	return $_rc
}

#DHCPCѻIPɥ쥹
# 2006.05.13
# $1: (wan ip)
wancfg_dhcpc_ipcheck()
{
	local lanip=`ip -f inet addr show dev eth1 | sed -n '2p' | awk '{printf"%s\n",$2}'`
	lanip=${lanip%\/*}
	if [ "X${1}" = "X${lanip}" ]; then
		wancfg_syslog0 "DHCPǼIPɥ쥹LAN¦IPɥ쥹ƱǤ"
		return 1
	else
		return 0
	fi
}
wancfg_dhcpc()
{
	unset IPADDR DNS

	wancfg_syslog "wancfg_dhcpc"
	if [ -f "${DHCPC_INFO}" ]; then
		wancfg_syslog "Found ${DHCPC_INFO}"
		. ${DHCPC_INFO}
	else
		wancfg_syslog "Not found ${DHCPC_INFO}"
		IPADDR=`ip -f inet addr show dev eth0 | sed -n '2p' | awk '{printf"%s\n",$2}'`
		IPADDR=${IPADDR%\/*}
	fi
	# 2006.05.13
	#wancfg_dhcpc_ipcheck ${IPADDR}
	wancfg_ipcheck eth0
	if [ $? = 1 ]; then
		return 1
	fi
	if [ -n "${IPADDR}" ]; then
		config_hosts
		echo "${IPADDR}   ibswan" >> /etc/hosts
		wancfg_syslog "wancfg_dhcpc ibswan set.(${IPADDR})"
		local _dns=
		if [ -n "$DNS" ]; then
			_dns=`echo ${DNS} | sed -e 's/,/;/' -e 's/$/;/'`
			named_edit "$_dns"
		fi
		# 2006.07.25
		config_autoup ${IPADDR}

		# 2006.05.12
		/etc/ibsbat/voip_sig.bat up
		/etc/ibsbat/auto_sig.bat up
	else
		wancfg_syslog "wancfg_dhcpc eth0 not setup."
	fi

	return 0
}
# 2006.07.05 IP
wancfg_west_ip()
{
	unset IPADDR
	if [ -f ${IFCFG_ETH0} ]; then
		. ${IFCFG_ETH0}
		if [ -n "${DEVICE}" -o -n "${IPADDR}" -o -n "${NETMASK}" -o -n "${BROADCAST}" ]; then
			wancfg_ipcheck eth0
		else
			wancfg_syslog "west_ip error.[DEVICE:${DEVICE} IPADDR:${IPADDR} NETMASK:${NETMASK} BROADCAST:${BROADCAST}]"
			IPADDR=`ip -f inet addr show dev eth0 | sed -n '2p' | awk '{printf"%s\n",$2}'`
			IPADDR=${IPADDR%\/*}
		fi
	else
		wancfg_syslog "west_ip Not found ${IFCFG_ETH0}"
		IPADDR=`ip -f inet addr show dev eth0 | sed -n '2p' | awk '{printf"%s\n",$2}'`
		IPADDR=${IPADDR%\/*}
	fi
	config_hosts
	echo "${IPADDR}   ibswan" >> /etc/hosts
	wancfg_syslog "west_ip ibswan set.(${IPADDR})"

	return 0
}
# 2006.05.01
wancfg_dhcp_restart()
{
	wancfg_syslog0 "DHCPƼޤ"
	if [ -f /var/run/dhcpcd-eth0.pid -a -x /sbin/dhcpcd ]; then
		wancfg_syslog "dhcpcd proc found. send SIGHUP signal."
		/sbin/dhcpcd -k
	else
		wancfg_syslog "dhcpcd proc not found."
	fi
	rm -f /etc/dhcpc/dhcpcd-eth0.cache
	rm -f /etc/dhcpc/dhcpcd-eth0.info*

	local _maxcount=20
	while [ -f /var/run/dhcpcd-eth0.pid -a $_maxcount -gt 0 ]; do
		_maxcount=$(( $_maxcount - 1 ))
		sleep 1
	done
	if [ $_maxcount = 0 ]; then
		wancfg_syslog "dhcpcd proc could not kill. retry."
		/sbin/dhcpcd -k
		sleep 1
	fi
	/sbin/dhcpcd -t 10 -R
	_dhcpc_rc=$?
	sleep 1
	if [ "X$_dhcpc_rc" = "X0" ]; then
		wancfg_dhcpc
		[ -x ${ADDCON} ] && ${ADDCON} access_conf
		return 0
	else
		wancfg_syslog0 "DHCPκƼ˼Ԥޤ"
		return 1
	fi
}

wancfg_dns()
{
#%%2000
	if [ -f /etc/ibsbat/dns.bat ]; then
		/bin/sh /etc/ibsbat/dns.bat boot
	fi
}

wancfg_pppoe()
{
#%%2100
	if [ -f /etc/ibsbat/pppoe.bat ]; then
		/bin/sh /etc/ibsbat/pppoe.bat boot
	fi

#%%2200
	if [ -f /etc/ibsbat/filter.bat -a ! -f /tmp/init_pushd_boot ]; then
		/bin/sh /etc/ibsbat/filter.bat boot
	fi
# nat
	if [ -f /etc/ibsbat/nat.bat ]; then
		/bin/sh /etc/ibsbat/nat.bat boot
	fi
# routing
	if [ -f /etc/ibsbat/routing.bat -a ! -f /tmp/init_pushd_boot ]; then
		/bin/sh /etc/ibsbat/routing.bat boot
	fi
}

wancfg_pppoe2()
{
#%%2300
## 2006.03.26 NFS
	if [ -f /etc/ibsbat/pppoe.bat ]; then
		/bin/sh /etc/ibsbat/pppoe.bat boot2
	fi

	if [ -f /etc/rc.d/init.d/adsl ]; then
		/etc/rc.d/init.d/adsl start
	fi
}

#
# $1: start/stop
wancfg_ntpd()
{
#%%2600
	if [ "X${ntpd}" = "XYES" ]; then 
		if [ -f /etc/rc.d/init.d/ntpd ]; then
			/etc/rc.d/init.d/ntpd $1
		fi
	fi
}

wancfg_ibsmail()
{
#%%2900
	sh /etc/ibsbat/ibsmail.bat
}

send_signal_up()
{
	local __chkname=send_signal_up
	local _add_rc=0

	if [ -f /tmp/Web_state.txt ]; then
		local __svcomp=`cat /tmp/Web_state.txt`
		[ "X$__svcomp" = "Xserv=2" ] || return 1
	else
		return 1
	fi
	[ -f "${SVJUDGE_FILE}" ] || return 1
	echo "Send signal"
	if [ -f "${SERV_PID}" ]; then
		_pid=`cat ${SERV_PID}`
		__sig="SIGHUP"
		if [ "X$_pid" != "X" ]; then
			kill -${__sig} $_pid
			logger -p kern.info -t $__chkname "send signal ${__sig} service pid."
			__add_rc=0
		else
			__add_rc=1
		fi
	else
		logger -p kern.info -t $__chkname "service pid nod found."
		__add_rc=1
	fi
	return $__add_rc
}

ETH0LINK=/proc/ibs/ibs_ethlink
wancr_check()
{
	local wancr=0
	wancfg_syslog "Check wan link..."
	ifconfig eth0 up
	if [ -f "$ETH0LINK" ]; then
		wancr=`cat $ETH0LINK`
	fi
	[ "X$wancr" = "X1" ]  && return 0 || return 1
}
wansetup_check_west()
{
	local _eth0=`ip -f inet addr show dev eth0 | sed -n '2p' | awk '{printf"%s\n",$2}'`
	if [ ! -n "${_eth0}" ]; then
		return 0
	else
		return 1
	fi
}
##############################
# S3ޤǤν
wancfg_toS3()
{
	wancfg_eth0
	wancfg_dns
	wancfg_pppoe
	wancfg_pppoe2

}
wancfg_scas_east()
{
	local _vtype=0
	local _atype=0

	check_iptell_type
	_vtype=$?
	check_autoup_type
	_atype=$?

	if [ "X$_vtype" = "X5" -o "X$_atype" = "X5" ]; then
		wancfg_addcon
		# 2006.04.17
		if [ -f /tmp/addcon.result ]; then
			initlog -n ibsnet03pppoe -s "addcon setup complete"
		fi

		wancfg_east_ipoe
		# 2006.05.01
		scas_voip_gw_set east
	fi


	wancfg_pppoe
	wancfg_pppoe2
	wancfg_dns
	# 2006.04.26
	if [ "X$_vtype" = "X5" -o "X$_atype" = "X5" ]; then
		if [ -f /etc/ibsbat/filter/scasfilter.bat ]; then
			/etc/ibsbat/filter/scasfilter.bat
		fi
		# 2006.06.09
		scas_voip_gw_set east
	fi
}
wancfg_scas_west_dhcp()
{
	wancfg_addcon
	wancfg_pppoe
	wancfg_dhcpc
	wancfg_dns
	# 2006.06.09
	scas_voip_gw_set west_dhcp
}
wancfg_scas_west_ipoe()
{
	# 2006.08.11
	rm -f /tmp/west_ip_wancfg_done

	# 2006.07.05 I/F塢ɥ»
	wancfg_pppoe
	wancfg_dns
	wancfg_addcon
	# 2006.07.05 IP
	wancfg_west_ip
	# 2006.06.09
	scas_voip_gw_set west_ipoe

	# 2006.08.11
	touch /tmp/west_ip_wancfg_done
}
####################
start()
{
	local _wtype=0
	local _ptype=0
	#VoIP
	#check_iptell_type
	#_vtype=$?

	# ip
	check_wanstate_type
	_wtype=$?

#	case "$_vtype" in
	case "$_wtype" in
		#|1|2|3|4)
		0|1|2|4)
	# ޤ̤
			#check_wanstate_type pppoe
			#_ptype=$?
			#if [ "X$_ptype" = "X1" ]; then
				wancfg_toS3
			#fi
	# 2006.04.25 ӥȽǥե
			$svjudge_cmd "other"
			if [ $? = 0 ]; then
				send_signal_up
			fi
			if [ "X$_wtype" = "X2" -o "X$_wtype" = "X4" ]; then
				wancfg_ipcheck eth0
			fi
			;;
		5)
	# SOHO-CAS
			wancfg_scas_east
			;;
		6)
	# SOHO-CAS(dhcp)
			wancfg_scas_west_dhcp
			;;
		7)
	# SOHO-CAS(IP)
			wancfg_scas_west_ipoe
			wancfg_ipcheck eth0
			;;
		*)
	# 2006.04.25 ӥȽǥե
			$svjudge_cmd "other"
			if [ $? = 0 ]; then
				send_signal_up
			fi
			;;
	esac

#  wancfg_ntpd start
	wancfg_ibsmail
	return 0
}

stop()
{
#  wancfg_ntpd stop
	return 0
}

wancfg_check()
{
	wancr_check
	if [ $? != 0 ]; then
		wancfg_syslog "wan link down."
		return 0
	else
		wancfg_syslog "wan link up."
	fi
	#check_iptell_type
	# 2006.08.11
	check_wanstate_type
	local _vtype=$?
	case "$_vtype" in
	1|2|3|4);;
	5);;
	6)
		wancfg_scas_west_dhcp
		;;
	7)
		wancfg_scas_west_ipoe
		;;
	*);;
	esac
}

####################
wancfg_syslog "exec."
ln -s $0 ${LOCKFILE}
if [ $? != 0 ]; then
	wancfg_syslog "Already executing $CMDBAT"
	exit 2
fi
trap "rm -f ${LOCKFILE}" EXIT

case $CMDBAT in
	dhcpcd.bat)
		wancfg_dhcp_restart
		exit $?
		;;
	*);;
esac

case "$1" in
	start)
		echo -n "Starting ${prog}... "
		start
		RETVAL=$?
		[ $RETVAL -eq 0 ] && touch ${SUBSYS}
		echo "done."
		;;
	stop)
		echo -n "Shutdown ${prog}... "
		[ -f ${SUBSYS} ] && rm -f ${SUBSYS}
		stop
		RETVAL=$?
		echo "done."
		;;
	restart)
		stop
		start
		;;
	test)
		#scas_voip_gw_set
		wancfg_ipcheck eth0
		;;
	ibscron)
		wancfg_check
		;;
	wancfg_dhcpc)	# 2006.05.08
		wancfg_dhcpc
		[ -x ${ADDCON} ] && ${ADDCON} access_conf
		;;
	wancfg_ipcheck)	# 2006.05.15
		wancfg_ipcheck eth0
		;;
	*)
		echo $"Usage: $0 {start|stop}"
		exit 1
		;;
esac
exit $RETVAL
