#!/bin/sh

[ "X${X7DBG}" = "Xon" ] && set -x

FILTER_BAT_VERSION=2004032701

# 2006.06.30
. /etc/ibsbat/ibs.subr

#DEBUG=1
IPTABLES=/sbin/iptables

#TOP=/home/ibsuser/work/filter
#IBSBAT=${TOP}/filter
TOP=/etc/ibsbat/Router/filtering
IBSBAT=/etc/ibsbat/filter

WAN_STATE=${TOP}/../ipaddress_of_wan/wan_state.txt

FTBL=${TOP}/filtering_table.txt
PPPF=${TOP}/filtering_set_pppoe.txt
LANF=${TOP}/filtering_set_lan.txt
WANF=${TOP}/filtering_set_wan.txt
DHCPF=${TOP}/filtering_set_dhcp.txt

FTBL_AWK=${IBSBAT}/ftbl.awk
FTBLPPPOE_AWK=${IBSBAT}/ftblpppoe.awk
FTBLLAN_AWK=${IBSBAT}/ftbllan.awk
FTBLWAN_AWK=${IBSBAT}/ftblwan.awk
FTBLDHCP_AWK=${IBSBAT}/ftbldhcp.awk

FTBL_ENTRY=${IBSBAT}/ftbl_entry
FTBL_START=${IBSBAT}/ftbl_start

LANIF=eth1
WANIF=eth0
N_TO_REAL_PREFIX=/var/run/ntoreal.

#
# ƥեå
#
filter_flush()
{
	${IPTABLES} -t filter -F
	${IPTABLES} -t filter -X
	${IPTABLES} -t nat -F
	${IPTABLES} -t nat -X
}

#
# ǥե
# ǥեȥݥꥷ
#
filter_default() {
	${IPTABLES} -P FORWARD ACCEPT
	${IPTABLES} -P INPUT   ACCEPT
	${IPTABLES} -P OUTPUT  ACCEPT

	${IPTABLES} -A INPUT -i lo -j ACCEPT
	${IPTABLES} -A OUTPUT -o lo -j ACCEPT

}

#
# $1: -A/-D/-I
# $2: ifname (ppp0/ppp1....)
# $3: lan ifname (eth1)
#
filter_establish() {
	_ifname=$2
	_lanifname=$3

	${IPTABLES} $1 FORWARD -m state --state ESTABLISHED,RELATED -j ACCEPT -i $_ifname -o ${LANIF}
	${IPTABLES} $1 FORWARD -m state --state NEW,ESTABLISHED -j ACCEPT -i ${LANIF} -o $_ifname
}

#
# $1: target (ACCEPT/DROP)
# $2: ifname (ppp0/ppp1/ppp2...)
#
filter_del_pppoe() {
	_target=$1
	_ifname=$2

	#INPUT
	_ent=`${IPTABLES} -L INPUT -n --line-numbers -v|grep $_target|grep "^[0-9]" |grep "$_ifname"| awk 'NR==1{printf"%s ",$1}'`
	while [ ! -z $_ent ]; do
		${IPTABLES} -D INPUT $_ent
		echo "INPUT:$_ent delete"
		_ent=`${IPTABLES} -L INPUT -n --line-numbers -v|grep $_target|grep "^[0-9]" |grep "$_ifname"| awk 'NR==1{printf"%s ",$1}'`
	done

	#OUTPUT
	_ent=`${IPTABLES} -L OUTPUT -n --line-numbers -v|grep $_target|grep "^[0-9]" |grep "$_ifname"| awk 'NR==1{printf"%s ",$1}'`
	while [ ! -z $_ent ]; do
		${IPTABLES} -D OUTPUT $_ent
		echo "OUTPUT:$_ent delete"
		_ent=`${IPTABLES} -L OUTPUT -n --line-numbers -v|grep $_target|grep "^[0-9]" |grep "$_ifname"| awk 'NR==1{printf"%s ",$1}'`
	done

	#FORWARD
	_ent=`${IPTABLES} -L FORWARD -n --line-numbers -v|grep $_target|grep "^[0-9]" |grep "$_ifname"| awk 'NR==1{printf"%s ",$1}'`
	while [ ! -z $_ent ]; do
		${IPTABLES} -D FORWARD $_ent
		echo "FORWARD:$_ent delete"
		_ent=`${IPTABLES} -L FORWARD -n --line-numbers -v|grep $_target|grep "^[0-9]" |grep "$_ifname"| awk 'NR==1{printf"%s ",$1}'`
	done
	
}


filter_lan_set() {
	filter_del_pppoe ACCEPT ${LANIF}
	filter_del_pppoe DROP ${LANIF}
	filter_del_pppoe LOG ${LANIF}
	if [ -f ${IBSBAT}/iptables_lan.sh ]; then
		sh ${IBSBAT}/iptables_lan.sh ${FTBL_ENTRY} ${LANIF}
	fi

	# LAN I/FIPϡINPUT/OUTPUTϥե륿ػ
	if [ -f /etc/sysconfig/network-scripts/ifcfg-eth1 ]; then
		. /etc/sysconfig/network-scripts/ifcfg-eth1
	fi

	if [ -z "${IPADDR}" -o -z "${NETMASK}" ]; then
		return 0
	fi
	eval `/bin/ipcalc --network ${IPADDR} ${NETMASK}`
	eval `/bin/ipcalc --prefix  ${IPADDR} ${NETMASK}`
	${IPTABLES} -I INPUT  -i ${LANIF} -s ${NETWORK}/${PREFIX} -j ACCEPT
	${IPTABLES} -I OUTPUT -o ${LANIF} -d ${NETWORK}/${PREFIX} -j ACCEPT
}


filter_create_conf() {
	cat ${FTBL}  | awk -f ${FTBL_AWK}       > ${FTBL_ENTRY}
	cat ${PPPF}  | awk -f ${FTBLPPPOE_AWK}  > ${FTBL_START}
	cat ${LANF}  | awk -f ${FTBLLAN_AWK}    >> ${FTBL_START}
	cat ${WANF}  | awk -f ${FTBLWAN_AWK}    >> ${FTBL_START}
	cat ${DHCPF} | awk -f ${FTBLDHCP_AWK}   >> ${FTBL_START}
}


filter_pppoe_set()
{
	_filter_bat=${IBSBAT}/iptables_${1}.sh
	if [ -z "${2}" ]; then
		_ntoreal_f="${N_TO_REAL_PREFIX}${1}"
		if [ -f "$_ntoreal_f" ]; then
			_real_if=`cat "$_ntoreal_f"`
		else
			#_real_if="${1}"
			_real_if=""
		fi
	else
		_real_if="${2}"
	fi
	if [ -f $_filter_bat -a ! -z "$_real_if" ]; then

		filter_del_pppoe ACCEPT $_real_if
		filter_del_pppoe DROP $_real_if
		filter_del_pppoe LOG $_real_if

		sh $_filter_bat ${FTBL_ENTRY} ${_real_if}
		#filter_establish -I ${_real_if} ${LANIF}
		filter_establish -A ${_real_if} ${LANIF}

		# 2004.04.06
		# shut off
		filter_wan_packet_shut $_real_if off

	fi
}

filter_wan_set()
{
	_filter_bat=${IBSBAT}/iptables_${1}.sh
	if [ -f $_filter_bat ]; then
		# 2005.02.27 S2
		filter_del_pppoe ACCEPT eth0
		filter_del_pppoe DROP eth0
		filter_del_pppoe LOG eth0

		sh $_filter_bat ${FTBL_ENTRY} ${WANIF}
		#filter_establish -I ${WANIF} ${LANIF}
		filter_establish -A ${WANIF} ${LANIF}
	fi
}

#
# ֡Ȼwan¦shut
filter_wan_default_set()
{
	local _count=
	WAN_LIST="ppp0 ppp1 ppp2 ppp3 ppp4"
	for i in $WAN_LIST; do
		${IPTABLES} -N shut_${i}
		# 2006.05.14
		_count=100
		while [ $_count -gt 0 ]; do
			${IPTABLES} -D FORWARD -i ${i} -j shut_${i}
			if [ $? != 0 ]; then break; fi
			_count=$(( $_count - 1 ))
		done
		_count=100
		while [ $_count -gt 0 ]; do
			${IPTABLES} -D FORWARD -o ${i} -j shut_${i}
			if [ $? != 0 ]; then break; fi
			_count=$(( $_count - 1 ))
		done
		${IPTABLES} -I FORWARD -i ${i} -j shut_${i}
		${IPTABLES} -I FORWARD -o ${i} -j shut_${i}

		filter_wan_packet_shut ${i} on
	done
}
#
# $1: real ifname
# $2: on/off
filter_wan_packet_shut()
{
	_real_ifname=$1
	_spec=$2
	if [ -z "$_real_ifname" -o -z "$_spec" ]; then
		retun 1
	fi
	case $_real_ifname in
		ppp0|ppp1|ppp2|ppp3|ppp4)
			;;
		*)
			_real_ifname=""
			;;
	esac
	if [ -z "$_real_ifname" ]; then
		return 1
	fi

	case $_spec in
		on)
			_spec=-I
			;;
		off)
			_spec=-D
			;;
		*)
			return 1
			;;
	esac

	#2006.05.14
	${IPTABLES} -F shut_${_real_ifname}

	${IPTABLES} $_spec shut_${_real_ifname} -i ${_real_ifname} -j DROP
	${IPTABLES} $_spec shut_${_real_ifname} -o ${_real_ifname} -j DROP
	return 0
}

########################################
# Main
#
# $1: (none)/flush/ppp[0-4]/wan/dhcp/eth0/boot/conf
#
[ ! -z "${DEBUG}" ] && filter_flush

_check_f=0
for i in ${FTBL} ${LANF} ${PPPF} ${WANF} ${DHCPF} ${FTBL_AWK} ${FTBLPPPOE_AWK} ${FTBLLAN_AWK} ${FTBLWAN_AWK} ${FTBLDHCP_AWK}; do
	if [ ! -f "$i" ]; then
		echo "${i} not found."
		_check_f=1
	fi
done
if [ "$_check_f" = 1 ]; then
	echo "File error."
	exit 1
fi

case $1 in
	flush)
		[ "$1" = "flush" ] && filter_flush
		;;
	ppp0|ppp1|ppp2|ppp3|ppp4)
		filter_pppoe_set $1 $2
		;;
	wan)
		filter_wan_set $1
		;;
	dhcp)
		_filter_bat=${IBSBAT}/iptables_${1}.sh
		if [ -f $_filter_bat ]; then
			sh $_filter_bat ${FTBL_ENTRY} ${WANIF}
			#filter_establish -I ${WANIF} ${LANIF}
			filter_establish -A ${WANIF} ${LANIF}
		fi
		;;
	conf)
		filter_create_conf
		;;
	boot)
		filter_create_conf
		filter_lan_set
		# 2004.04.06
		filter_wan_default_set
		# 2006.05.14
		check_wanstate_type
		_wtype=$?
		if [ "X$_wtype" = "X2" -o "X$_wtype" = "X4" ]; then
			filter_wan_set wan
		fi
		;;
	debug)
		filter_create_conf
		filter_default

		IFLIST="ppp0 ppp1 ppp2 ppp3 ppp4"
		for i in ${IFLIST}; do
			filter_del_pppoe ACCEPT ${i}
			filter_del_pppoe DROP ${i}
			filter_del_pppoe LOG ${i}

			_filter_bat=${IBSBAT}/iptables_${i}.sh
			if [ -f $_filter_bat ]; then
				sh $_filter_bat ${FTBL_ENTRY} ${i}
				#filter_establish -I ${i} ${LANIF}
				filter_establish -A ${i} ${LANIF}
			fi
		done
		filter_lan_set
		;;
	shut_on)
		filter_wan_packet_shut $2 on
		;;
	shut_off)
		filter_wan_packet_shut $2 off
		;;
	*)
		filter_create_conf
		# 2006.05.14
		check_wanstate_type pppoe
		_ptype=$?
		check_wanstate_type
		_wtype=$?
		if [ "X${_ptype}" = "X1" ]; then
			IFLIST="ppp0 ppp1 ppp2 ppp3 ppp4"
			for i in ${IFLILST}; do
				filter_pppoe_set $i
			done
		fi
		if [ "X${_wtype}" = "X2" -o "X${_wtype}" = "X4" ]; then
				filter_wan_set wan
		fi
		;;
esac
