#
# 2004.03.11
#
BEGIN{
 ORGFS=FS;
 FTBL="/etc/ibsbat/Router/filtering/filtering_table.txt";
 LANF="/etc/ibsbat/Router/filtering/filtering_set_lan.txt";
 PPPF="/etc/ibsbat/Router/filtering/filtering_set_pppoe.txt";
# FTBL="/home/ibsuser/work/filter/filtering_table.txt";
# LANF="/home/ibsuser/work/filter/filtering_set_lan.txt";
# PPPF="/home/ibsuser/work/filter/filtering_set_pppoe.txt";

 printf"#FS:%s:\n",FS;
 FS="=";
 record=1;

 printf"#!/bin/sh\n#\n";
 printf"IPTABLES=/sbin/iptables\n";

 printf"\nfilter_flush(){\n";
 printf" ${IPTABLES} -t filter -F\n";
 printf" ${IPTABLES} -t filter -X\n";
 printf" ${IPTABLES} -t nat -F\n";
 printf" ${IPTABLES} -t nat -X\n";

 printf" ${IPTABLES} -P FORWARD ACCEPT\n";
 printf" ${IPTABLES} -P INPUT   ACCEPT\n";
 printf" ${IPTABLES} -P OUTPUT  ACCEPT\n";
 printf"}\n";

}

function f_func_start(rn, no)
{
  if ( length(no) ) {
    printf"f_no_%03d()\n{\n",no;
    return 1;
  }
  return 0;
}

function f_func_end()
{
  printf"\n}\n";
}

function f_new_entry(rn)
{
  entry[rn] = "";
}

function f_no(rn, no)
{
  if ( length(no) ) {
    dummy = sprintf("  #%03d\n  iptables ",no);
    entry[rn] = entry[rn] dummy "";
    return 1;
  }
  return 0;
}

function f_direct(rn, direc)
{
#  if ( direc == "in" )  entry[rn] = entry[rn]  "-A INPUT -i $1 ";
#  if ( direc == "out" ) entry[rn] = entry[rn]  "-A OUTPUT -o $1 ";
  if ( direc == "in" )  entry[rn] = entry[rn]  "-A scas -i $1 ";
  if ( direc == "out" ) entry[rn] = entry[rn]  "-A scas -o $1 ";
}

function f_and_or(rn, action)
{
  if ( action == "and" ) return 1;
  if ( action == "or" ) return 0;
}

function f_dst_ip(rn, ip, mask)
{
  if ( ! length(ip) ) return 0;
  if ( ! length(mask) ) return 0;

  if ( ip > 0 && mask > 0 ) {
    dummy = sprintf("-d %s/%s ",ip,mask);
    entry[rn] = entry[rn]  dummy "";
    return 1;
  }
  else return 0;
  
}
function f_dst_port(rn, drange, start_end)
{
#  printf"dst_port::%d::drange:%s\n",rn, drange;
  if ( ! length(drange) ) return 0;
  if ( ! length(start_end) ) return 0;

  if ( start_end > 0 ) {
    split(start_end, port, " ");
  }

  if ( drange == "equal" ) {
    dummy = sprintf("--dport %s ",port[1]);
    entry[rn] = entry[rn]  dummy "";
  }
  if ( drange == "small" ) {
    dummy = sprintf("--dport :%s ",port[1]);
    entry[rn] = entry[rn]  dummy "";
  }
  if ( drange == "large" ) {
    dummy = sprintf("--dport %s: ", port[1]);
    entry[rn] = entry[rn]  dummy "";
  }
  if ( drange == "range" ) {
    dummy = sprintf("--dport %s:%s ", port[1], port[2]);
    entry[rn] = entry[rn] dummy;
#    printf("f_dst_port:drange is range:%s  entry:%s\n",dummy,entry[rn]);
  }

#  printf"dst_port::%s::%s\n",entry[rn], drange;
}
function f_src_ip(rn, ip, mask)
{
  if ( ! length(ip) ) return 0;
  if ( ! length(mask) ) return 0;

  if ( ip > 0 && mask > 0 ) {
    dummy = sprintf("-s %s/%s ",ip,mask);
    entry[rn] = entry[rn]  dummy "";
    return 1;
  }
  else return 0;
  
}
function f_src_port(rn, range, start_end)
{
  if ( ! length(range) ) return 0;
  if ( ! length(start_end) ) return 0;

  if ( start_end > 0 ) {
    split(start_end, port, " ");
  }

  if ( range == "equal" ) {
    dummy = sprintf("--sport %s ",port[1]);
    entry[rn] = entry[rn]  dummy "";
  }
  if ( range == "small" ) {
    dummy = sprintf("--sport :%s ",port[1]);
    entry[rn] = entry[rn]  dummy "";
  }
  if ( range == "large" ) {
    dummy = sprintf("--sport %s: ", port[1]);
    entry[rn] = entry[rn]  dummy "";
  }
  if ( range == "range" ) {
    dummy = sprintf("--sport %s:%s ", port[1], port[2]);
    entry[rn] = entry[rn]  dummy "";
  }
}

function f_proto(rn, proto,appoint)
{
  if ( proto == "tcp"  ) entry[rn] = entry[rn]  "-p tcp ";
  if ( proto == "udp"  ) entry[rn] = entry[rn]  "-p udp ";
  if ( proto == "icmp" ) entry[rn] = entry[rn]  "-p icmp ";
  if ( proto == "other" ) {
    if ( appoint > 0 ) {
      dummy = sprintf("-p %s ",appoint);
      entry[rn] = entry[rn]  dummy "";
    }
  }
}

function f_tcp_flag(rn, urg, ack, psh, rst, syn)
{
  if ( (urg > 0) || (ack > 0) || (psh > 0) || (rst > 0) || (syn > 0) ) {
    entry[rn] = entry[rn]  "--tcp-flags ";
  }
  if ( urg == "on" ) entry[rn] = entry[rn]  "URG,";
  if ( ack == "on" ) entry[rn] = entry[rn]  "ACK,";
  if ( psh == "on" ) entry[rn] = entry[rn]  "PSH,";
  if ( rst == "on" ) entry[rn] = entry[rn]  "RST,";
  if ( syn == "on" ) entry[rn] = entry[rn]  "SYN,";
}

function f_action(rn, action)
{
#  if ( action == "on" )  entry[rn] = entry[rn]  "-j ACCEPT ";
#  if ( action == "off" ) entry[rn] = entry[rn]  "-j DROP ";
  if ( action == "on" )  printf"-j DROP ";
  if ( action == "off" ) printf"-j ACCEPT ";
}

function f_log(rn, llog)
{
  if ( llog > 0 ) {
#    entry[rn] = entry[rn]  "-j LOG ";
    printf"-j LOG --log-level info --log-prefix 'filter: '";
  }
}

function f_newline(rn)
{
  entry[rn] += "\n";
}

function f_output_entry(rn)
{
#  for ( i in f_array ) {
#    if ( i != "index" )
#    printf"%s ",f_array[rn,i];
#  }
#  printf"\n";
  printf"%s", entry[rn];
}

/^pppoe_index/{ \
	print $NF;\
	line1 = $0;\
	getline line2;\
	print $NF;\
	getline line3;\
	print $NF;\
	printf"1:%s 2:%s 3:%s\n",line1,line2,line3;\
}
/^_index/{
  record = record + 1;
  printf"aaaa:%d\n",record;
  while( getline tmp > 0  ) {
    if ( tmp ~ /^index/ )  next;
    printf"%s: %s ", $0, tmp;
    if ( tmp ~ /filtering_table_number/ ) {
	printf"** YES **\n";
    }
    else {
	printf"** NO **\n";
    }
  }

#   print"bbbb\n";
#   while ( getline tmp < PPPF > 0 ) {
#      printf"%s: %s\n", $0, tmp;
#   }
}
/^index/{
#  printf"aaaa:%d\n",record;
  f_array[record, $1]=$2;
  while( (getline) > 0  && ( $0  !~ /^index/ ) ) {
#    print"***while:: ";
    if ( $0 ~ /^$/ )  {printf"#*** %s: exit\n",$0;break;}
#    printf"record:%d: %s\n", record, tmp;
    if ( $1 ~ /^filtering_table_number/ ) { f_array[record, $1]=$2; }
    if ( $1 ~ /^filtering_direction/ ) { f_array[record, $1]=$2; }
    if ( $1 ~ /^filtering_action/ ) { f_array[record, $1]=$2; }
    if ( $1 ~ /^filtering_dst_ipaddress/ ) {
      f_array[record, $1]=$2;
      if ( $2 > 0 ) f_array[record, "dst"] = "on";
    }
    if ( $1 ~ /^filtering_dst_subnetmask/ ) { f_array[record, $1]=$2; }
    if ( $1 ~ /^filtering_dst_range/ ) { f_array[record, $1]=$2; }
    if ( $1 ~ /^filtering_dst_port/ ) {
      f_array[record, $1]=$2;
      if ( $2 > 0 ) f_array[record, "dst"] = "on";
    }
    if ( $1 ~ /^filtering_src_ipaddress/ ) {
      f_array[record, $1]=$2;
      if ( $2 > 0 ) f_array[record, "src"] = "on";
    }
    if ( $1 ~ /^filtering_src_subnetmask/ ) { f_array[record, $1]=$2; }
    if ( $1 ~ /^filtering_src_range/ ) { f_array[record, $1]=$2; }
    if ( $1 ~ /^filtering_src_port/ ) {
      f_array[record, $1]=$2;
      if ( $2 > 0 ) f_array[record, "src"] = "on";
    }
    if ( $1 ~ /^filtering_and_or/ ) { f_array[record, $1]=$2; }
    if ( $1 ~ /^filtering_protocol/ ) { f_array[record, $1]=$2; }
    if ( $1 ~ /^filtering_appoint_protocol/ ) { f_array[record, $1]=$2; }
    if ( $1 ~ /^filtering_tcp_flag_urg/ ) { f_array[record, $1]=$2; }
    if ( $1 ~ /^filtering_tcp_flag_ack/ ) { f_array[record, $1]=$2; }
    if ( $1 ~ /^filtering_tcp_flag_psh/ ) { f_array[record, $1]=$2; }
    if ( $1 ~ /^filtering_tcp_flag_rst/ ) { f_array[record, $1]=$2; }
    if ( $1 ~ /^filtering_tcp_flag_syn_fin/ ) { f_array[record, $1]=$2; }
    if ( $1 ~ /^filtering_log/ ) { f_array[record, $1]=$2; }
  }
  record = record + 1;
}
/index=1/{
  printf"#ccccc:\n";
}
{
 printf"#none:%s\n", $0;
}

END0{
#  for ( i=0; i < record; i++ ) {
#    for( (r, j) in f_array ) {
#  if ( str in f_array ) {
#      printf("f_array[%d, %s]:%s\n",r, j, f_array[r, j]);
#      printf("f_array[%s]:%s\n",str, f_array[str]);
#      if ( j == "filtering_table_number" ) f_no(f_array[0,j]);
#    }
#  }


  printf"#SUBSEP:%s\n",SUBSEP;
  for ( str in f_array ) {
    split( str, tmparray, SUBSEP );
    i = tmparray[1];
    j = tmparray[2];
    printf("#f_array[%d, %s]:%s\n",i, j, f_array[i,j]);
  }

  printf("#f_array[%d, %s]:%s\n",1, "filtering_dst_ipaddress", f_array[1,"filtering_dst_ipaddress"]);
  printf("#f_array[%d, %s]:%s\n",2, "filtering_dst_ipaddress", f_array[2,"filtering_dst_ipaddress"]);

}

END{
  printf"#SUBSEP:%s\n",SUBSEP;
  for ( num=1; num<record; num++ ) {
    printf"#record:%d\n",num;
    if ( length(f_array[num,"index"]) ) {
      printf("#f_array[%d,%s]:%s\n",num,"index",f_array[num,"index"]);

      if ( f_and_or(num, f_array[num,"filtering_and_or"]) == 0 ) { # or

	printf"#ftbl or\n";

	f_func_start(num, f_array[num,"index"]);

	if ( f_array[num,"dst"] == "on" ) {
	  f_new_entry(num);
	  printf"  #ftbl dst:%s\n",f_array[num,"dst"];

	  f_no(num, f_array[num,"index"]);
	  f_direct(num, f_array[num,  "filtering_direction"]);
	  f_dst_ip(num, f_array[num,  "filtering_dst_ipaddress"],
		   f_array[num,  "filtering_dst_subnetmask"]);
	  f_proto(num, f_array[num, "filtering_protocol"],
		  f_array[num, "filtering_appoint_protocol"]);
	  f_dst_port(num, f_array[num,"filtering_dst_range"], f_array[num, "filtering_dst_port"]);
	  f_tcp_flag(num, f_array[num,"filtering_tcp_flag_urg"], f_array[num,"filtering_tcp_flag_ack"],
		     f_array[num,"filtering_tcp_flag_psh"], f_array[num,"filtering_tcp_flag_rst"],
		     f_array[num,"filtering_tcp_flag_syn_fin"]);

# logonʤ餯֤
	  if ( f_array[num, "filtering_log"] == "on" ) {
	    f_output_entry(num);
	    f_log(num, f_array[num,"filtering_log"]);
	    printf"\n";
	  }

	  f_output_entry(num);
	  f_action(num, f_array[num,  "filtering_action"]);
#	  f_newline(num);
	  printf"\n";

# forward
#	  if ( f_array[num, "filtering_direction"] == "in" ) {
#	    printf"  # forward\n";
#	    gsub("INPUT", "FORWARD", entry[num]);
#
#	    if ( f_array[num, "filtering_log"] == "on" ) {
#	      f_output_entry(num);
#	      f_log(num, f_array[num,"filtering_log"]);
#	      printf"\n";
#	    }
#
#	    f_output_entry(num);
#	    f_action(num, f_array[num, "filtering_action"]);
#	    printf"\n";
#
#	  }
#	  if ( f_array[num, "filtering_direction"] == "out" ) {
#	    printf"  # forward\n";
#	    gsub("OUTPUT", "FORWARD", entry[num]);
#
#	    if ( f_array[num, "filtering_log"] == "on" ) {
#	      f_output_entry(num);
#	      f_log(num, f_array[num,"filtering_log"]);
#	      printf"\n";
#	    }
#
#	    f_output_entry(num);
#	    f_action(num, f_array[num, "filtering_action"]);
#	    printf"\n";
#
#	  }

	}
	if ( f_array[num,"src"] == "on" ) {
	  f_new_entry(num);
	  printf"  #ftbl src:%s\n",f_array[num,"src"];

	  f_no(num, f_array[num,"index"]);
	  f_direct(num, f_array[num,  "filtering_direction"]);
	  f_src_ip(num, f_array[num,  "filtering_src_ipaddress"],
		   f_array[num,  "filtering_src_subnetmask"]);
	  f_proto(num, f_array[num, "filtering_protocol"],
		  f_array[num, "filtering_appoint_protocol"]);
	  f_src_port(num, f_array[num,"filtering_src_range"], f_array[num, "filtering_src_port"]);
	  f_tcp_flag(num, f_array[num,"filtering_tcp_flag_urg"], f_array[num,"filtering_tcp_flag_ack"],
		     f_array[num,"filtering_tcp_flag_psh"], f_array[num,"filtering_tcp_flag_rst"],
		     f_array[num,"filtering_tcp_flag_syn_fin"]);

# logonʤ餯֤
	  if ( f_array[num, "filtering_log"] == "on" ) {
	    f_output_entry(num);
	    f_log(num, f_array[num,"filtering_log"]);
	    printf"\n";
	  }

	  f_output_entry(num);
	  f_action(num, f_array[num,  "filtering_action"]);
	  printf"\n";

# forward
#	  if ( f_array[num, "filtering_direction"] == "in" ) {
#	    printf"  # forward\n";
#	    gsub("INPUT", "FORWARD", entry[num]);
#
#	    if ( f_array[num, "filtering_log"] == "on" ) {
#	      f_output_entry(num);
#	      f_log(num, f_array[num,"filtering_log"]);
#	      printf"\n";
#	    }
#
#	    f_output_entry(num);
#	    f_action(num, f_array[num, "filtering_action"]);
#	    printf"\n";
#
#	  }
#	  if ( f_array[num, "filtering_direction"] == "out" ) {
#	    printf"  # forward\n";
#	    gsub("OUTPUT", "FORWARD", entry[num]);
#
#	    if ( f_array[num, "filtering_log"] == "on" ) {
#	      f_output_entry(num);
#	      f_log(num, f_array[num,"filtering_log"]);
#	      printf"\n";
#	    }
#
#	    f_output_entry(num);
#	    f_action(num, f_array[num, "filtering_action"]);
#	    printf"\n";
#
#	  }
	}

# dst/src nothing
	if ( f_array[num,"src"] != "on" && f_array[num,"dst"] != "on" ) {
	  f_new_entry(num);
	  printf"  #ftbl nothing src:%s dst:%s\n",f_array[num,"src"], f_array[num,"dst"];

	  f_no(num, f_array[num,"index"]);
	  f_direct(num, f_array[num,  "filtering_direction"]);
	  f_proto(num, f_array[num, "filtering_protocol"],
		  f_array[num, "filtering_appoint_protocol"]);
	  f_tcp_flag(num, f_array[num,"filtering_tcp_flag_urg"], f_array[num,"filtering_tcp_flag_ack"],
		     f_array[num,"filtering_tcp_flag_psh"], f_array[num,"filtering_tcp_flag_rst"],
		     f_array[num,"filtering_tcp_flag_syn_fin"]);

# logonʤ餯֤
	  if ( f_array[num, "filtering_log"] == "on" ) {
	    f_output_entry(num);
	    f_log(num, f_array[num,"filtering_log"]);
	    printf"\n";
	  }

	  f_output_entry(num);
	  f_action(num, f_array[num,  "filtering_action"]);
	  printf"\n";

# forward
#	  if ( f_array[num, "filtering_direction"] == "in" ) {
#	    printf"  # forward\n";
#	    gsub("INPUT", "FORWARD", entry[num]);
#
#	    if ( f_array[num, "filtering_log"] == "on" ) {
#	      f_output_entry(num);
#	      f_log(num, f_array[num,"filtering_log"]);
#	      printf"\n";
#	    }
#
#	    f_output_entry(num);
#	    f_action(num, f_array[num, "filtering_action"]);
#	    printf"\n";
#
#	  }
#	  if ( f_array[num, "filtering_direction"] == "out" ) {
#	    printf"  # forward\n";
#	    gsub("OUTPUT", "FORWARD", entry[num]);
#
#	    if ( f_array[num, "filtering_log"] == "on" ) {
#	      f_output_entry(num);
#	      f_log(num, f_array[num,"filtering_log"]);
#	      printf"\n";
#	    }
#
#	    f_output_entry(num);
#	    f_action(num, f_array[num, "filtering_action"]);
#	    printf"\n";
#
#	  }
	}

	f_func_end();
      }
      else {						# and

	printf"#ftbl and\n";

	f_func_start(num, f_array[num,"index"]);

	f_new_entry(num);
	f_no(num, f_array[num,"index"]);
	f_direct(num, f_array[num,  "filtering_direction"]);

	f_dst_ip(num, f_array[num,  "filtering_dst_ipaddress"],
		 f_array[num,  "filtering_dst_subnetmask"]);
	f_src_ip(num, f_array[num,  "filtering_src_ipaddress"],
		 f_array[num,  "filtering_src_subnetmask"]);
	f_proto(num, f_array[num, "filtering_protocol"],
		f_array[num, "filtering_appoint_protocol"]);
	f_dst_port(num, f_array[num,"filtering_dst_range"], f_array[num, "filtering_dst_port"]);

	f_src_port(num, f_array[num,"filtering_src_range"], f_array[num, "filtering_src_port"]);
	f_tcp_flag(num, f_array[num,"filtering_tcp_flag_urg"], f_array[num,"filtering_tcp_flag_ack"],
		   f_array[num,"filtering_tcp_flag_psh"], f_array[num,"filtering_tcp_flag_rst"],
		   f_array[num,"filtering_tcp_flag_syn_fin"]);

# logonʤ餯֤
	if ( f_array[num, "filtering_log"] == "on" ) {
	  f_output_entry(num);
	  f_log(num, f_array[num,"filtering_log"]);
	  printf"\n";
	}

	f_output_entry(num);
	f_action(num, f_array[num,  "filtering_action"]);
	printf"\n";

# forward
#	if ( f_array[num, "filtering_direction"] == "in" ) {
#	  printf"  # forward\n";
#	  gsub("INPUT", "FORWARD", entry[num]);
#
#	  if ( f_array[num, "filtering_log"] == "on" ) {
#	    f_output_entry(num);
#	    f_log(num, f_array[num,"filtering_log"]);
#	    printf"\n";
#	  }
#
#	  f_output_entry(num);
#	  f_action(num, f_array[num, "filtering_action"]);
#	  printf"\n";
#	}
#	if ( f_array[num, "filtering_direction"] == "out" ) {
#	  printf"  # forward\n";
#	  gsub("OUTPUT", "FORWARD", entry[num]);
#
#	  if ( f_array[num, "filtering_log"] == "on" ) {
#	    f_output_entry(num);
#	    f_log(num, f_array[num,"filtering_log"]);
#	    printf"\n";
#	  }
#
#	  f_output_entry(num);
#	  f_action(num, f_array[num, "filtering_action"]);
#	  printf"\n";
#	}

	f_func_end();
      }
    }
  }
}
