#!/bin/sh
#
# autoup.txt$B$NGSB>@)8f(B
#
# $1: cgi/serv/ppp
# $2: lock/check/unlock/init
#
# $B%m%C%/85%U%!%$%k$O!"(Bautouplockf
# $B%m%C%/;~$O!"(B(type).autouplockf
# $B%m%C%/BT$A;~$O!"(B(type).autouplockf.(num)

EXECLOCK=/tmp/autoupexec.lock
ALOCKDIR=/tmp
ALOCKF=autouplockf
count=0
RETVAL=0
trap 'rm -f ${EXECLOCK}; echo "unlock";exit ${RETVAL}' 0 1 2 3 9 15

CMDBAT=`basename $0`
case $CMDBAT in
	autouplockf_sub.bat)
		EXECLOCK=/tmp/autoupexec.lock
		ALOCKDIR=/tmp
		ALOCKF=autouplockf
		;;
	hostslockf_sub.bat)
		EXECLOCK=/tmp/hostsexec.lock
		ALOCKDIR=/tmp
		ALOCKF=hostslockf
		;;
	*)
		exit 1
		;;
esac

_type=$1
_ope=$2

init_file()
{
	[ ! -f ${ALOCKF} ] && touch ${ALOCKF}
	return 0
}

lock_file()
{
	mv ${ALOCKF} ${_type}.${ALOCKF} > /dev/null 2>&1
	if [ $? = 0 ]; then
		return 0
	fi

	_lockf=`ls -1 *.${ALOCKF} 2> /dev/null`
	if [ $? = 0 ]; then
		if [ "X${_lockf%%.${ALOCKF}}" = "X$_type" ]; then
			return 3
		fi
	fi

	_lockf=`ls -1 ${_type}.${ALOCKF}.* 2> /dev/null`
	if [ $? = 0 ]; then
		return 3
	fi

	_wait1file=`ls -1 *.${ALOCKF}.1 2> /dev/null`
	_wait2file=`ls -1 *.${ALOCKF}.2 2> /dev/null`
	if [ -f "$_wait2file" ]; then
		_nextwaitnum=3
	elif [ -f "$_wait1file" ]; then
		_nextwaitnum=2
	else
		_nextwaitnum=1
	fi

	if [ $_nextwaitnum = 3 ]; then
	# $B%m%C%/%U%!%$%k$N0[>o(B(3$B0J>e$OB8:_$7$J$$$O$:(B)
		return 1
	else
		touch ${_type}.${ALOCKF}.${_nextwaitnum}
		return 2
	fi
}

check_file()
{
	_lockf=`ls -1 ${_type}.${ALOCKF} 2> /dev/null`
	if [ $? = 0 ]; then
		return 0
	else
		return 2
	fi
}

unlock_file()
{
	# $B%m%C%/%U%!%$%k$^$?$O%m%C%/BT$A%U%!%$%k$,M-$k$+(B
	_lockf=`ls -1 *.${ALOCKF} 2> /dev/null`
	_tmp1=$?
	_lockf=`ls -1 *.${ALOCKF}.* 2> /dev/null`
	_tmp2=$?
	[ $_tmp1 != 0 -a $_tmp2 != 0 ] && return 2

	#$B<+J,$N%m%C%/$+(B
	if [ -f "${_type}.${ALOCKF}" ]; then
		# *.1$B$,M-$k$+(B
		_wait1file=`ls -1 *.${ALOCKF}.1 2> /dev/null`
		_wait2file=`ls -1 *.${ALOCKF}.2 2> /dev/null`
		if [ -f "$_wait1file" ]; then
			#$B<+J,$N%m%C%/$r:o=|(B
			rm -f "${_type}.${ALOCKF}"
			# *.1$B$r%m%C%/%U%!%$%k$K(B
			mv $_wait1file ${_wait1file%%.1}

			# *.2$B$,M-$l$P!"(B*.1$B$K(B
			if [ -f "$_wait2file" ]; then
				mv $_wait2file ${_wait2file%%.2}.1
			fi
		elif [ -f "$_wait2file" ]; then
			rm -f "${_type}.${ALOCKF}"
			# *.1$B$,L5$$$+$D(B*.2$B$,M-$k$+(B
			# *.2$B$r%m%C%/%U%!%$%k$K(B
			mv $_wait2file ${_wait2file%%.2}
		else
			# $B%m%C%/$N2r=|(B
			mv ${_type}.${ALOCKF} ${ALOCKF}
			RETVAL=0
		fi
	else
		#$B<+J,$N%m%C%/$G$O$J$$(B
		_lockf=`ls -1 ${_type}.${ALOCKF}.* 2> /dev/null`
		if [ $? != 0 ]; then
			RETVAL=3
		else
			rm -f $_lockf
			_num=${_lockf##${_type}.${ALOCKF}.}
			if [ "X$_num" = "X1" ]; then
				_wait2file=`ls -1 *.${ALOCKF}.2 2> /dev/null`
				if [ $? = 0 ]; then
					mv $_wait2file ${_wait2file%%.2}.1
				fi
			fi
			RETVAL=4
		fi
	fi
	return $RETVAL
}

####################
[ "$_type" = "cgi" -o "$_type" = "serv" -o "$_type" = "ppp" ] || (echo "unknown type"; exit 1)
[ "$_ope" = "lock" -o "$_ope" = "check" -o "$_ope" = "unlock" -o "$_ope" = "init" ] || (echo "unknown operation" ; exit 1)

#$B%G%#%l%/%H%jJQ99(B
cd ${ALOCKDIR}
#$B<B9T%m%C%/(B
until ln -s . ${EXECLOCK}; do
	sleep 1
	count=$(( $count + 1 ))
	if [ $count -ge 2 ]; then
		exit 1
	fi
done

case $_ope in
	lock)
		lock_file
		RETVAL=$?
		;;
	check)
		check_file
		RETVAL=$?
		;;
	unlock)
		unlock_file
		RETVAL=$?
		;;
	init)
		init_file
		RETVAL=$?
		;;
	*)
		exit 1
		;;
esac

exit $RETVAL

