#!/bin/sh
#

#CRONDBG=0
CRONDBG=1

. /etc/ibsbat/ibs.subr
. /etc/rc.conf

SCAS_SET_FILE=/home/ibsuser/public_html/Admin/Sys_setup/Router/ipaddress_of_wan/reboot

# 2006.09.27 ץƵưե饰
PROC_RESTART_FLAG=/tmp/ibsproc_restart_flag

#ʬ
pppoe_check()
{
	# 2006.04.19
	local __chkname="pppoe_check"
	local __chkproc=0
	local __lock_file="/var/lock/subsys/pppoe_check"
	local __countf=/tmp/croncount_pppoe_check
	local __limit=10
	local __output=0

	if [ -f ${__lock_file} ]; then
		logger -p kern.info -t ${__chkname} "already started. return."
		return 0
	fi

	__count=0
	[ -f "${__countf}" ] && __count=`cat ${__countf}`
	__count=$(( $__count + 1 ))
	if [ $__count -ge $__limit ]; then
		__output=1
		__count=0
	fi
	[ $__output = 1 ] && logger -p kern.info -t ${__chkname} "$__limit times checked."

	# 2006.04.16 ip_tell
	touch $__lock_file
	check_iptell_type
	local _type=$?
	# 2006.05.02 ѹκƵưå
	if [ $_type = 5 -a ! -f /tmp/addcon.result -a ! -f "${SCAS_SET_FILE}" ]; then
		logger -p kern.info -t ${__chkname} "Not found addcon result file. Do not complete addcon setup."
		sh /etc/ibsbat/addcon/addcon.bat
		#logger -p kern.info -t ${__chkname} "done."
	fi

	if [ -x /etc/ibsbat/pppoe.bat ]; then
		/bin/sh /etc/ibsbat/pppoe.bat session_check
	fi
	rm -f $__lock_file
	echo $__count > $__countf
}

# 2005.03.17
# ϥեμ
#  OK    :0
#  顼:1
ibsexe_get_startfile_path()
{
	__slist="/home/ibsuser/app/exe/ibsproc_start"

	if [ ! -f "${__slist}" ]; then
		return 1
	fi

	IBSEXE_STARTFILE_PATH=`cat ${__slist}`
	if [ -z "${IBSEXE_STARTFILE_PATH}" ]; then
		return 1
	fi
	if [ ! -f ${IBSEXE_STARTFILE_PATH} ]; then
		return 1
	fi
	return 0
}

# 2006.04.04 sumi
#  For DEBUG S4
# V3
WINFO_AUTOUP=${TOP}/tmp/autoup_conn
WINFO_HOSTS=${TOP}/tmp/voip_conn
DEBUG_ADDCON_INFO=/tmp/debug_addcon_info
send_signal_up()
{
	local __chkname=addcon_info
	_add_rc=0
	echo "Send signal"
	#_pid=`ps ax|grep ibsserv|grep abscore|awk '{printf"%s",$1}'`
	if [ -f /var/log/ibs/ibsproc_service.pid ]; then
		_pid=`cat /var/log/ibs/ibsproc_service.pid`
		__sig="SIGHUP"
		if [ "X$_pid" != "X" ]; then
			kill -${__sig} $_pid
			logger -p kern.info -t $__chkname "send signal ${__sig} service pid."
			__add_rc=0
		else
			__add_rc=1
		fi
	else
		logger -p kern.info -t $__chkname "service pid nod found."
		__add_rc=1
	fi
	return $__add_rc
}
addcon_info()
{
	__svcompf=/tmp/Web_state.txt
	[ -f $__svcompf ] || return 0
	[ -f /tmp/addcon.result ] || return 0
	[ -f ${DEBUG_ADDCON_INFO} ] && return 0

	__svcomp=`cat $__svcompf`
	[ "X$__svcomp" = "Xserv=2" ] || return 0

	touch ${WINFO_HOSTS}
	chown ibsuser:ibsuser ${WINFO_HOSTS}
	#unlockθ夬ɤ
	send_signal_up
	if [ $? = 0 ]; then
		touch ${DEBUG_ADDCON_INFO}
	fi
	return 0
}

# S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/
# 2005.02.24
#ӥץδƻ
# 2006.09.28
# SIPץå
#  SIPΥץå1Ĥޤ6İʳϡ顼꥿
ibsexe_sip_check()
{
	local __chkname="ibsexe_sip_check"
	# LAN¦
	local _scnt=0
	local __sip_pid=`ps ax|grep ibssip|grep -v grep|awk '{printf"%s ",$1}'`
	for i in $__sip_pid; do
		_scnt=$(( $_scnt + 1 ))
	done
	if [ $_scnt != 1 -o $_scnt != 6 ]; then
		logger -p kern.info -t $__chkname "ibsip process down detected."
		return 1
	fi

	# WAN¦
	_scnt=0
	__sip_pid=`ps ax|grep ibsipsip|grep -v grep|awk '{printf"%s ",$1}'`
	for i in $__sip_pid; do
		_scnt=$(( $_scnt + 1 ))
	done
	if [ $_scnt != 1 -o $_scnt != 6 ]; then
		logger -p kern.info -t $__chkname "ibsipsip process down detected."
		return 1
	fi
	return 0
}
ibsexe_check()
{
	local __chkname="ibsexe_check"
	local __chkproc=0
	__list="/home/ibsuser/app/exe/ibsproc_list"
	__execchk=/var/run/ibsexe_check
	#  # 2005.04.11
	#  __dummyexechk=/var/run/ibsexe_check_dummy


	# ϥեΥå
	ibsexe_get_startfile_path
	if [ $? != 0 ]; then
		return 0
	#else
	# # 2005.04.11 procmngǤΥեޤǤλ
	# if [ ! -f $__dummyexechk ]; then
	#      touch $__dummyexechk
	#      return 0
	# fi
	fi

	if [ -f ${__execchk} ]; then
		logger -p kern.info -t $__chkname "already start ibsexe_check"
		return 0
	fi

	# 2006.04.04 sumi S4 DEBUG
	addcon_info

	if [ -f ${__list} ]; then
		touch ${__execchk}
		for p in `cat ${__list}`; do
			if [ ! -f ${p} ]; then
				__chkproc=1
			else
				__exe_pid=`cat ${p}`
				if [ "X$__exe_pid" = "X" -o ! -d "/proc/$__exe_pid" ]; then
					logger -p kern.info -t $__chkname "pid is null or proc not exist(`basename ${p}`)"
					__chkproc=1
				fi
			fi
		done
		# 2006.09.28
#		if [ "X$__chkproc" = "X0" ]; then
#			ibsexe_sip_check
#			if [ $? != 0 ]; then
#				__chkproc=1
#			fi
#		fi

		if [ "X${__chkproc}" = "X1" ]; then
		# ץƵư(GWޤ)
		#      # 2005.04.11 procmngǤΥեޤǤλ
		#      if [ -f $__dummyexechk ]; then
		#        rm -f $__dummyexechk
		#      fi
		# 2005.03.17 S2/S2
		# ibsreboot.batibsexe stopˤơϥեƤΤǤǤɬפʤ
			/bin/sh /etc/ibsbat/ibsreboot.bat ibsexe
			logger -p kern.info -t $__chkname "restart ibsexe"
			# 2006.09.27 ץƵưե饰
			touch ${PROC_RESTART_FLAG}
		fi
		rm -f ${__execchk}
	fi
}

# S2/S2/S2/S2/S2/S2/S2/S2/
# DHCPФΥץå
dhcpd_check()
{
	local __chkname="dhcpd_check"
	local __chkproc=0
	local __pid_f="/var/run/dhcpd.pid"
	local __rc_file="/etc/rc.d/init.d/dhcpd"
	local __lock_file="/var/lock/subsys/dhcpd"

	if [ "X${dhcpd}" != "XYES" ]; then
		return 0
	fi

	if [ ! -f "$__lock_file" ]; then
		return 0
	fi

	if [ -f "$__pid_f" ]; then
		__pid=`cat $__pid_f`
		if [ "X$__pid" = "X" -o ! -d "/proc/$__pid" ]; then
			logger -p kern.info -t $__chkname "pid is null or proc not exist"
			__chkproc=1
		fi
	else
	#ե뤬ʤΤǥץ¸ߤʤ
		logger -p kern.info -t $__chkname "pid not exist"
		__chkproc=1
	fi

	if [ "X${__chkproc}" = "X1" ]; then
		if [ -f "$__rc_file" ]; then
			#¹
			force_logrotate

			$__rc_file restart
			logger -p kern.info -t $__chkname "restart"
		else
			logger -p kern.info -t $__chkname "file not found"
		fi
	fi
	return 0
}

# S2/S2/S2/S2/S2/S2/S2/S2/
# ApacheФΥץå
httpd_check()
{
	local __chkname="httpd_check"
	local __chkproc=0
	local __pid_f="/usr/local/apache/logs/httpd.pid"
	local __rc_file="/etc/rc.d/init.d/httpd"
	local __lock_file="/var/lock/subsys/httpd"

	if [ ! -f "$__lock_file" ]; then
		return 0
	fi

	if [ -f "$__pid_f" ]; then
		__pid=`cat $__pid_f`
		if [ "X$__pid" = "X" -o ! -d "/proc/$__pid" ]; then
			logger -p kern.info -t $__chkname "pid is null or proc not exist"
			__chkproc=1
		fi
	else
		#ե뤬ʤΤǥץ¸ߤʤ
		logger -p kern.info -t $__chkname "pid not exist"
		__chkproc=1
	fi

	if [ "X${__chkproc}" = "X1" ]; then
		if [ -f "$__rc_file" ]; then
			$__rc_file restart
			logger -p kern.info -t $__chkname "restart"
		else
			logger -p kern.info -t $__chkname "file not found"
		fi
	fi
	return 0
}

# S2/S2/S2/S2/S2/S2/S2/S2/
# PostgreSQLФΥץå
pgsql_check()
{
	local __chkname="pgsql_check"
	local __chkproc=0
	local __pid_f="/usr/local/pgsql/data/postmaster.pid"
	local __rc_file="/etc/rc.d/init.d/pgsql"
	local __lock_file="/var/lock/subsys/pgsql"
	local __execchk=/var/run/pgsql_check
	local __rstr_bat=/etc/ibsbat/pgsql_restore_nohup.bat
	local __nohup_done=/tmp/pgsql_restore_nohup_done

	if [ ! -f "$__nohup_done" ]; then
		return 0
	fi

	if [ -f ${__execchk} ]; then
		logger -p kern.info -t $__chkname "already start"
		return 0
	fi

	touch ${__execchk}
	if [ -f "$__pid_f" ]; then
		__pid=`cat $__pid_f`
		if [ "X$__pid" = "X" -o ! -d "/proc/$__pid" ]; then
			logger -p kern.info -t $__chkname "pid is null or proc not exist"
			__chkproc=1
		fi
	else
		#ե뤬ʤΤǥץ¸ߤʤ
		logger -p kern.info -t $__chkname "pid not exist"
		__chkproc=1
	fi

	if [ "X${__chkproc}" = "X1" ]; then
		if [ -f "$__rc_file" ]; then
			led_info_inter

			# 2006.05.04 reindex
			[ -f "$__lock_file" ] && rm -f $__lock_file
			if [ -f "$__rstr_bat" ]; then
				/bin/sh $__rstr_bat reindex
			fi

			$__rc_file restart
			logger -p kern.info -t $__chkname "restart"
			# FLASH񤭹߽ư
			if [ -f "$__rstr_bat" ]; then
				/bin/sh $__rstr_bat flashd
			fi
			# 롼ΥСϿ
			if [ -f /etc/ibsbat/ibsregist_ver.bat ]; then
				/bin/sh /etc/ibsbat/ibsregist_ver.bat
			fi

			# ӥκƵưɬפ
			#if [ -x /etc/ibsbat/ibsexereboot.bat ]; then
			#  /bin/sh /etc/ibsbat/ibsexereboot.bat
			#  # 2004.09.13
			#  if [ $? != 0 ]; then
			#    led_alarm_on
			#  fi
			#fi
			led_info_off

		else
			logger -p kern.info -t $__chkname "file not found"
		fi
	fi
	rm -f ${__execchk}
	return 0
}

# S2/S2/S2/S2/S2/S2/S2/S2/
force_logrotate()
{
	if [ -f /etc/logrotate.conf ]; then
		# apacheθ˼¹Ԥ뤳
		/usr/sbin/logrotate -f /etc/logrotate.conf
		logger -p kern.info -t force_logrotate "rotated log"
	fi
}

####################
# S3
# 2005.11.17
_filelist1="/var/log/messages /var/log/fw.log /var/log/me.log"
_filelist2="/var/log/httpd/error_log /var/log/httpd/access_log /var/log/httpd/ssl_engine_log"
_filelist3="/var/log/last /var/log/cron /var/log/secure /var/log/wtmp /var/log/maillog /var/log/spooler /var/log/boot.log"
_filelist="$_filelist1 $_filelist2 $_filelist3"

_filelist_not_log1="/var/log/dmesg /var/log/ibscron.out /var/log/ksyms.0 /var/log/ksyms.1"
_filelist_not_log2="/var/log/httpd/httpd.pid /var/log/httpd/request_log /var/log/httpd/ssl_scache.dir /var/log/httpd.ssl_scache.pag"
_filelist_not_log="$_filelist_not_log1 $_filelist_not_log2"

diskfull_check()
{
	local __chkname=diskfull_check
	local _avail=`df /var | grep -v Filesystem |awk '{printf"%s\n",$4}'`
	if [ $_avail -ge 1 ]; then
		return 0
	fi

	#ǥեå;ʬʥե뤬̵å
	_overfile=`find /var/log ! \( -type d -name ibs -prune \) -type f`
	for i in $_overfile; do
		_overno=0

		#եΥå
		for j in $_filelist; do
			if [ "X$i" = "X$j" -o "X$i" = "X${j}.1" -o "X$i" = "X${j}.1.gz" -o "X$i" = "X${j}.2.gz" ]; then
				_overno=1
			fi
		done

		for j in $_filelist_not_log; do
			if [ "X$i" = "X$j" ]; then
				_overno=1
			fi
		done

		if [ "${i%%.*}" = "/var/log/httpd/ssl_mutex" ]; then
			#logger -p kern.info -t logrotate_sizecheck "$i is match ssl_mutex.*"
			_overno=1
		fi

		if [ $_overno = 0 ]; then
		#_overblock=`ls -s $i | awk '{printf"%s\n",$1}'`
		#if [ $_overblock -ge 0 ]; then
			_notusedfile="$_notusedfile $i"
			#echo "" > $i
			rm -f $i > /dev/null 2>&1
			#/bin/kill -HUP `cat /var/run/syslogd.pid 2> /dev/null` 2> /dev/null
			#logger -p kern.info -t logrotate_sizecheck "$i is not used file. Null writed."
		#fi
		fi
	done

	# 2006.01.11
	if [ -f /var/run/pppd.tdb ]; then
		# 2006.04.23
		# 100k --> 100k
		#    _kblock_pppd=`ls -s /var/run/pppd.tdb | awk '{printf"%s\n",$1}'`
		[ -f /var/run/pppd.tdb ] && _kblock_pppd=`ls -l /var/run/pppd.tdb | awk '{printf"%s\n",$5}'` || _kblock_pppd=0
		_kblock_pppd=$(( $_kblock_pppd / 1024 ))
		if [ $_kblock_pppd -ge 100 ]; then
			logger -p kern.info -t $__chkname "removed pppd.tdb"
			rm -f /var/run/pppd.tdb > /dev/null 2>&1
		fi
	fi

	/bin/kill -HUP `cat /var/run/syslogd.pid 2> /dev/null` 2> /dev/null
	logger -p kern.info -t $__chkname "Not used file removed.:$_notusedfile"

	#DHCPκƵư(ɬ?)
	#/etc/rc.d/init.d/dhcpd restart

	return 1
}

logrotate_sizecheck()
{
	diskfull_check

	local __chkname=logrotate_sizecheck
	local _kblock=0
	for i in $_filelist1; do
		# 2006.04.23
		#_kblock=`ls -s $i | awk '{printf"%s\n",$1}'`
		[ -f "${i}" ] && _kblock=`ls -l $i | awk '{printf"%s\n",$5}'` || _kblock=0
		_kblock=$(( $_kblock / 1024 ))
		#logger -p kern.info -t logrotate_sizecheck "check $i:$_kblock"

		# ˥ơλĳå
		if [ -f ${i} -a -f ${i}.1 -a -f ${i}.1.gz ]; then
			#ơ󤬴λƤʤ
			echo "" > ${i}.1
			kill -HUP `cat /var/run/syslogd.pid 2> /dev/null` 2> /dev/null
			logger -p kern.info -t $__chkname "${i} rotation error occur!"
		fi
		# 300KۤƤ綯ơ
		# 2006.03.28 sumi
		if [ "X$_kblock" != "X" -a $_kblock -ge 300 ]; then
			logger -p kern.info -t $__chkname "size 300k over!! ${_kblock}:${i}"
			return 1
		fi
	done

	for i in $_filelist2; do
		# 2006.04.23 110k
		#_kblock=`ls -s $i | awk '{printf"%s\n",$1}'`
		[ -f "${i}" ] && _kblock=`ls -l $i | awk '{printf"%s\n",$5}'` || _kblock=0
		_kblock=$(( $_kblock / 1024 ))
		#logger -p kern.info -t logrotate_sizecheck "check $i:$_kblock"
		# ˥ơλĳå
		if [ -f ${i} -a -f ${i}.1 -a -f ${i}.1.gz ]; then
			#ơ󤬴λƤʤ
			echo "" > ${i}.1
			kill -HUP `cat /var/run/syslogd.pid 2> /dev/null` 2> /dev/null
			logger -p kern.info -t $__chkname "${i} rotation error occur!"
		fi
		# 110KۤƤ綯ơ
		# 2006.03.28 sumi
		if [ "X$_kblock" != "X" -a $_kblock -ge 110 ]; then
			logger -p kern.info -t $__chkname "size 110k over!! ${_kblock}:${i}"
			return 1
		fi
	done

	for i in $_filelist3; do
		# 2006.04.23
		#_kblock=`ls -s $i | awk '{printf"%s\n",$1}'`
		[ -f "${i}" ] && _kblock=`ls -l $i | awk '{printf"%s\n",$5}'` || _kblock=0
		_kblock=$(( $_kblock / 1024 ))
		#logger -p kern.info -t logrotate_sizecheck "check $i:$_kblock"
		# ˥ơλĳå
		if [ -f ${i} -a -f ${i}.1 -a -f ${i}.1.gz ]; then
			#ơ󤬴λƤʤ
			echo "" > ${i}.1
			kill -HUP `cat /var/run/syslogd.pid 2> /dev/null` 2> /dev/null
			logger -p kern.info -t $__chkname "${i} rotation error occur!"
		fi
		# 20KۤƤ綯ơ
		# 2006.03.28 sumi
		if [ "X$_kblock" != "X" -a $_kblock -ge 20 ]; then
			logger -p kern.info -t $__chkname "size 20k over!! ${_kblock}:${i}"
			return 1
		fi
	done

	return 0
}

copy_log()
{
	_done=/tmp/copy_log_done
	_wday=`date +%w`
	_hmin=`date +%H%M`
	# Sun AM4:30¹
	if [ -n "$_wday" -a -n "$_hmin" -a $_wday = 0 -a $_hmin -ge 430 -a $_hmin -lt 440 ]; then
		if [ ! -f "${_done}" ]; then
			logger -p kern.info -t copy_log "Coping log to FLASH. weekday:$_wday hourmin:$_hmin"
			/etc/ibsbat/syslog_fw_sub.bat save
			touch ${_done}
		fi
	# 2006.09.27 ץƵưϡ¸
	elif [ -f "${PROC_RESTART_FLAG}" ]; then
		/etc/ibsbat/syslog_fw_sub.bat save
		rm -f ${PROC_RESTART_FLAG}
	else
		[ -f ${_done} ] && rm -f ${_done}
	fi
}

logrotate_min()
{
	local _count=0
	[ -f /tmp/croncount ] && _count0=`cat /tmp/croncount`
	local _count0=$(( $_count0 + 1 ))
	if [ $_count0 -ge 10000 ]; then
		_count0=0
	fi
	_count=$(( $_count0 % 10 ))
	#logger -p kern.info -t logrotate_min "_count0:$_count0  _count:$_count"
	case $_count in
		0)
			/usr/sbin/logrotate /etc/logrotate.conf > /dev/null 2>&1
			;;
		*)
			#ե륵ǧꥵ۾Ǥlogrotate¹Ԥ
			logrotate_sizecheck
			if [ $? != 0 ]; then
				/usr/sbin/logrotate /etc/logrotate.conf > /dev/null 2>&1
			fi
			;;
	esac
	copy_log
	echo $_count0 > /tmp/croncount
}

#2006.02.02
#For analog check
anapo_ibsreboot_check()
{
	local __chkname=anapo_ibsreboot_check
	_serv_exec_comp_file=/tmp/Web_state.txt
	_serv_exec_reboot_count=0
	_serv_exec_reboot_count_file=/tmp/serv_exec_reboot_count
	if [ -f /tmp/NORBT ]; then
		return
	fi
	if [ -f $_serv_exec_comp_file ]; then
		_serv_exec_comp=`cat $_serv_exec_comp_file`
	else
		_serv_exec_comp=0
	fi
	if [ "X$_serv_exec_comp" = "Xserv=2" ]; then
		if [ ! -f  $_serv_exec_reboot_count_file ]; then
			logger -p kern.info -t $__chkname "ibsserv start complete"
			echo "$_serv_exec_reboot_count" > $_serv_exec_reboot_count_file
		else
			_serv_exec_reboot_count=`cat $_serv_exec_reboot_count_file`
			_serv_exec_reboot_count=$(( $_serv_exec_reboot_count + 1 ))
			echo "$_serv_exec_reboot_count" > $_serv_exec_reboot_count_file
		fi

		if [ $_serv_exec_reboot_count -ge 3 ]; then
			logger -p kern.info -t $__chkname "restart system"
			sh /etc/ibsbat/ibsuserreboot.bat
		fi
	fi
}

# S4 2006.04.13
dhcpcd_check()
{
	local __chkname="dhcpcd_check"
	local __chkproc=0
	local __pid_f="/var/run/dhcpcd-eth0.pid"
	local __lock_file="/var/lock/subsys/dhcpcd_check"
	local __countf=/tmp/croncount_dhcpcd_check
	local __limit=10
	local __output=0

	# 2006.05.14
	#wanstate
	check_wanstate_type
	local _type=$?
	[ $_type = 6 ] || return 0

	# 2006.05.02
	if [ -f "${SCAS_SET_FILE}" ]; then
		logger -p kern.info -t ${__chkname} "System is not reboot. Do not dhcpcd check."
		return 0
	fi
	if [ -f ${__lock_file} ]; then
		logger -p kern.info -t ${__chkname} "already started. return."
		return 0
	fi

	local __count=0
	[ -f "${__countf}" ] && __count=`cat ${__countf}`
	__count=$(( $__count + 1 ))
	if [ $__count -ge $__limit ]; then
		__output=1
		__count=0
	fi
	[ $__output = 1 ] && logger -p kern.info -t ${__chkname} "$__limit times checked."

	# 2006.04.19
	#  if [ $_type = 6 -a ! -f $__pid_f -a ! -f /tmp/addcon.result ]; then
	if [ $_type = 6 -a ! -f /tmp/addcon.result ]; then
		logger -p kern.info -t ${__chkname} "Not found addcon result file. Do not complete addcon setup. WAN type is $_type"
		touch $__lock_file
		# 2006.05.06
		#sh /etc/ibsbat/addcon/addcon.bat
		/etc/ibsbat/wancfg.bat ibscron
		rm -f $__lock_file
	else
		[ $__output = 1 ] && logger -p kern.info -t $__chkname "Do not need setup. WAN type is $_type"
	fi
	echo $__count > $__countf
}

# S5 2006.08.11
west_ip_check()
{
	local __chkname="west_ip_check"
	local __chkproc=0
	local __lock_file="/var/lock/subsys/west_ip_check"
	local __countf=/tmp/croncount_west_ip_check
	local __wancfgs=/tmp/west_ip_wancfg_done
	local __limit=10
	local __output=0

	# wancfgλƤʤ
	[ -f $__wancfgs ] || return 0

	#wanstate
	check_wanstate_type
	local _type=$?
	[ $_type = 7 ] || return 0

	if [ -f ${__lock_file} ]; then
		logger -p kern.info -t ${__chkname} "already started. return."
		return 0
	fi
	touch $__lock_file

	local __count=0
	[ -f "${__countf}" ] && __count=`cat ${__countf}`
	__count=$(( $__count + 1 ))
	if [ $__count -ge $__limit ]; then
		__output=1
		__count=0
	fi
	[ $__output = 1 ] && logger -p kern.info -t ${__chkname} "$__limit times checked."

	if [ ! -f /tmp/addcon.result ]; then
		logger -p kern.info -t ${__chkname} "Not found addcon result file. Do not complete addcon setup. WAN type is $_type"
		/etc/ibsbat/wancfg.bat ibscron
	fi
	echo $__count > $__countf
	rm -f $__lock_file
}

# S3 2005.11.17
# 졢ƥӥưǤʤȤɤ
logrotate_min

pppoe_check

# 2005.03.09
#  դΥ⥸塼뤬λޤǼ¹Ԥʤ
#exit 0

# 2005.03.09
#  ưλƤʤʤ¹Ԥʤ
if [ ! -f /var/run/start_ibs ]; then
	exit 0
fi
#  åȥʤ¹Ԥʤ
if [ -f /var/run/stop_ibs ]; then
	exit 0
fi

pgsql_check
#ӥ
ibsexe_check

httpd_check
dhcpd_check

#2006.02.02
#anapo_ibsreboot_check

# 2006.04.13
dhcpcd_check
# 2006.08.11
west_ip_check

exit 0
