#!/bin/sh
#
# 2004.03.01
#
# local file(/etc/ibsbat/Router/mail/mail.txt)
#  mail_server
#  mail_address
#  pop_before_smtp
#  mail_account
#  mail_account_pass

CMDBAT=`basename $0`
LOCKFILE=/var/log/ibs/ibsmail.lock
USERTOP=/home/ibsuser
IBSMAIL_FILE=/etc/ibsbat/Router/mail/mail.txt
IMTOP=${USERTOP}/.im
PASSF=${IMTOP}/password
IMCONFIG=/etc/ibsbat/imconfig
IMAWK=/etc/ibsbat/ibsmail.awk
IMCRON=/etc/ibsbat/ibsmail.cron

_smtpserver=""
_mailaddress=""
_username=""
_userpass=""
_popbefore=""
_popserver=""

_lockcount=0
until ln -s $0 ${LOCKFILE} 2>&-; do
	if [ "$_lockcount" -gt 20 ]; then
		rm -f ${LOCKFILE}
		break
	fi
	sleep 1
	_lockcount=`expr $_lockcount + 1`
done
trap  "rm -f ${LOCKFILE}" EXIT


ibsmail_syslog()
{
	logger -p kern.info -t $CMDBAT "$1"
}

if [ ! -f ${IBSMAIL_FILE} ]; then
	ibsmail_syslog "${IBSMAIL_FILE} not found."
	exit 1
fi

. ${IBSMAIL_FILE}

if [ "X$mail_server" = "X" ]; then
	ibsmail_syslog "mail_server is not defined."
	exit 1
else
	_smtpserver=${mail_server}
fi

if [ "X$mail_address" = "X" ]; then
	ibsmail_syslog "mail_address is not defined."
	exit 1
else
	_mailaddress=${mail_address}
fi

if [ "X$pop_before_smtp" = "Xon" ]; then
	_popbefore=on
else
	_popbefore=
fi
if [ "X$receive_mail_server" != "X" ]; then
	_popserver=${receive_mail_server}
else
	_popserver=
fi
if [ "X$mail_account" != "X" ]; then
	_username=${mail_account}
fi
if [ "X$mail_account_pass" != "X" ]; then
	_userpass=${mail_account_pass}
fi

if [ ! -d ${IMTOP} ]; then
	mkdir ${IMTOP}
	chown ibsuser:ibsuser ${IMTOP}
fi
if [ ! -d ${IMTOP}/queue ]; then
	mkdir ${IMTOP}/queue
	chown ibsuser:ibsuser ${IMTOP}/queue
fi
if [ ! -d ${USERTOP}/Mail ]; then
	mkdir ${USERTOP}/Mail
	chown ibsuser:ibsuser ${USERTOP}/Mail
fi

if [ "X$pop_before_smtp" = "Xon" ]; then
	touch ${IMTOP}/popbefore
	echo "pop/POP  $_popserver  $_username   $_userpass" > "${PASSF}"
	chown ibsuser:ibsuser ${PASSF}
	chmod 600 ${PASSF}
fi

cat ${IMCONFIG} |\
	awk -v smtp=$_smtpserver \
	-v username=$_username \
	-v userpass=$_userpass \
	-v mailaddress=$_mailaddress \
	-v popserver=$_popserver \
	-f ${IMAWK} > "${IMTOP}"/Config

chown ibsuser:ibsuser ${IMTOP}/Config

crontab -u ibsuser -l |grep ibsmailcron
if [ $? != 0 ]; then
	crontab -u ibsuser "${IMCRON}"
fi
exit 0
