#!/bin/sh
#

PATH=/bin:/usr/bin:/usr/local/bin:/sbin:/usr/sbin
CMDBAT=`basename $0`
LOCKFILE=/var/log/ibs/ibsmail.lock
USERTOP=/home/ibsuser
IMTOP=${USERTOP}/.im
MAILDIR=${USERTOP}/Mail
POPBEFORE=${IMTOP}/popbefore
LOGF=/home/ibsuser/.im/log
IMPUT=/usr/local/bin/imput
IMGET=/usr/local/bin/imget
IMQUEOPT="--UidMsgId=X7000 --Log=${LOGF}"
IMPUTOPT="--UidMsgId=X7000 --Log=${LOGF}"
STATUSOPT="-bp"

IMCONFIG=${IMTOP}/Config

ln -s $0 ${LOCKFILE} > /dev/null 2>&1
if [ $? != 0 ]; then
	return 0
fi
trap  "rm -f ${LOCKFILE}" EXIT


ibsmailcron_syslog()
{
	logger -p kern.info -t $CMDBAT $1
}

header_check()
{
	_file=$1
	_line1=ng
	_line2=ng
	_line3=ng
	_line4=ng

	cat "$_file" | awk 'NR == 1{if ( /^From:/ ) exit 0; else exit 1; }'
	RETVAL=$?
	if [ "$RETVAL" = 0 ]; then
		#return 1
		_line1=ok
	fi

	cat "$_file" | awk 'NR == 2{if ( /^To:/ ) exit 0; else exit 1; }'
	RETVAL=$?
	if [ "$RETVAL" = 0 ]; then
		#return 2
		_line2=ok
	fi

	cat "$_file" | awk 'NR == 3{if ( /^Subject:/ ) exit 0; else exit 1; }'
	RETVAL=$?
	if [ "$RETVAL" = 0 ]; then
		#return 3
		_line3=ok
	fi

	cat "$_file" | awk 'NR == 4{if ( /^$/ ) exit 0; else exit 1; }'
	RETVAL=$?
	if [ "$RETVAL" = 0 ]; then
		_line4=ok
	fi

	if [ "X$_line1" = "Xok" -a "X$_line2" = "Xok" -a "X$_line3" = "Xok" -a "X$_line4" = "Xok" ]; then
		return 0
	else
		return 2
	fi
}

header_check2()
{
	_file=$1
	_line1=ng
	_line2=ng
	_line3=ng

	cat "$_file" | awk 'NR == 1{if ( /^To:/ ) exit 0; else exit 1; }'
	RETVAL=$?
	if [ "$RETVAL" = 0 ]; then
		_line1=ok
	fi

	cat "$_file" | awk 'NR == 2{if ( /^Subject:/ ) exit 0; else exit 1; }'
	RETVAL=$?
	if [ "$RETVAL" = 0 ]; then
		_line2=ok
	fi

	cat "$_file" | awk 'NR == 3{if ( /^$/ ) exit 0; else exit 1; }'
	RETVAL=$?
	if [ "$RETVAL" = 0 ]; then
		_line3=ok
	fi

	if [ "X$_line1" = "Xok" -a "X$_line2" = "Xok" -a "X$_line3" = "Xok" ]; then
		return 0
	else
		return 1
	fi
}


# $B%a!<%k$,B8:_%U%i%0(B
_ibsmailcron_exist=0

if [ ! -f "${IMCONFIG}" ]; then
	exit 1
else
	. ${IMCONFIG}
fi
if [ ! -d "${IMTOP}/queue" ]; then
	exit 1
fi
if [ ! -d "${MAILDIR}" ]; then
	exit 1
fi

for i in ${MAILDIR}/*; do
	if [ -f "$i" ]; then
		header_check2 "$i"
		HRETVAL=$?
		if [ "X$HRETVAL" = "X0" ]; then
			CASEVAL=addfrom
		elif [ "X$HRETVAL" = "X1" ]; then
			header_check "$i"
			HRETVAL=$?
			if [ "X$HRETVAL" = "X0" ]; then
				CASEVAL=ok
			else
				CASEVAL=ng
			fi
		else
			CASEVAL=ng
		fi

		case $CASEVAL in
			addfrom)
				echo "From: ${User}@${FromDomain}" > /tmp/ibsmail.txt
				cat ${i} >> /tmp/ibsmail.txt
				mv -f /tmp/ibsmail.txt ${i}
				${IMPUT} -odq ${IMQUEOPT} $i
				if [ $? = 0 ]; then
					rm -f $i
					_ibsmailcron_exist=1
				fi
				;;
			ok)
				${IMPUT} -odq ${IMQUEOPT} $i
				if [ $? = 0 ]; then
					rm -f $i
					_ibsmailcron_exist=1
				fi
				;;
			*)
				#echo  "`date '+%Y/%m/%d %H:%M:%S'` file format error" >> ${LOGF}
				ibsmailcron_syslog  "`date '+%Y/%m/%d %H:%M:%S'` file format error"
				rm -f $i
		esac
	fi
done

if [ "X$_ibsmailcron_exist" = "X1" ]; then
	if [ -f "${POPBEFORE}" ]; then
		${IMGET} --mode=check
	fi

	${IMPUT} -q ${IMPUTOPT}
fi

exit 0
