#!/bin/sh
#
# for ibsuser
#
#
CMDBAT=`basename $0`
BACKDIR=/var/data/backup
LAST_SAVE=/var/data/ibsback_inter.last
START_EXEC=/var/data/ibsback_inter.start
LAST_SAVE_SYM=${LAST_SAVE}.sym

ibssave_inter_syslog()
{
  logger -p kern.info -t $CMDBAT $1
}

exec_check()
{
  ln -s ${LAST_SAVE} ${LAST_SAVE_SYM}
  if [ $? != 0 ]; then
    return 1
  fi
  return 0
}

ibssave_inter_syslog "Backup start."
if [ ! -d "${BACKDIR}" ]; then
  mkdir ${BACKDIR}
fi

exec_check
if [ $? != 0 ]; then
  ibssave_inter_syslog "Backup process is executing. abort process."
  exit 1
fi

cd /var/data
touch ${START_EXEC}
ls -l ${START_EXEC} ${LAST_SAVE}
if [ -f "${LAST_SAVE}" ]; then
  for i in `find base/ibsdatabase -type f -newer ${LAST_SAVE} ! \( -name 'PG_VERSION' -o -name 'pg_*' \)`
  do
    if [ -f "${i}" ]; then
      _tbl=`basename ${i}`
      echo "org:$i  basename:$_tbl"
      pg_dump -t $_tbl ibsdatabase | gzip -c -9 > ${BACKDIR}/${_tbl}
    fi
  done
fi

mv -f ${START_EXEC} ${LAST_SAVE}
rm -f ${LAST_SAVE_SYM}
ibssave_inter_syslog "Backup done."
