#!/bin/sh
#
# ibs version check

TOP=
V_RAMDISK=${TOP}/etc/ibsbat/ver_ramdisk
V_RTETC=${TOP}/etc/ibsbat/ver_etc
V_RT=${TOP}/etc/ibsbat/ver_to_pgsql
V_RTBRWS=${TOP}/home/ibsuser/public_html/Admin/Sys_setup/Router/ver
IBSEXE_DIR=${TOP}/home/ibsuser/app/exe

# 2006.03.24 S4
PSQL=/usr/local/pgsql/bin/psql
DBNAME="ibsdatabase"

showver_system()
{
  _kern=`uname -a`
  _ram=`cat ${V_RAMDISK}`
cat <<EOF
kernel:$_kern <br>
ram:$_ram
EOF
}

showver_router()
{
#  if [ -f $V_RTETC ]; then
#    _ver=`cat $V_RTETC`
  if [ -f $V_RT ]; then
    _ver=`cat $V_RT`
  else
    _ver="None"
  fi
cat <<EOF
$_ver
EOF
}
showver_web()
{
  if [ -f $V_RTBRWS ]; then
    _ver=`cat $V_RTBRWS`
  else
    _ver="None"
  fi
cat <<EOF
web:$_ver
EOF
}

showver_ibsexe()
{
#  if [ -f ${IBSEXE_DIR}/ibsexe_ver.txt ]; then
#    cat ${IBSEXE_DIR}/ibsexe_ver.txt | awk '{printf"%s %s %s   %s   size:%s <br>\n",$6,$7,$8,$9,$5}'
#  fi

  ver_serv=`su - ibsuser -c "(cd ${IBSEXE_DIR}/service; ./ibsserv -v)" | grep IBS`
  ver_q931=`su - ibsuser -c "(cd ${IBSEXE_DIR}/q931dep; ./ibsq931 -v)" | grep ibsq931dep`
cat <<EOF
$ver_serv <br>
$ver_q931
EOF

}
showver_ipkt()
{
#  echo "None"
  ver_ipkt=`head -1 /home/ibskt/ipkt/s_ipkt_rom.s`
cat <<EOF
$ver_ipkt
EOF
}

showver_ibsgw()
{
#  echo "None"
  ver_main=`head -1 /home/ibskt/gw/x7000gw.main`
  ver_h8=`head -1 /home/ibskt/gw/x7000gw.h8`
cat <<EOF
main :$ver_main <br>
sub  :$ver_h8
EOF
}

   _type=$1

  case $_type in
  ibsexe)
     showver_ibsexe
     ;;
  router)
     showver_router
     ;;
  web)
     showver_web
     ;;
  ipkt)
     showver_ipkt
     ;;
  ibsgw)
     showver_ibsgw
     ;;
  system)
     showver_system
     ;;
  rtrelease)
     echo `date +%Y%m%d-%H%M` > ${V_RAMDISK}
     echo `date +%Y%m%d-%H%M` > ${V_RTETC}
     ;;
  # 2006.03.24 S4
  pgdata)
     _psql_str_from="from tbl_bd_ver limit 1;"
     _psql_str_id="select dbver_id ${_psql_str_from}"
     _psql_str_com="select dbver_comment ${_psql_str_from}"

     _dbid=`echo ${_psql_str_id}   | su - ibsuser -c "${PSQL} -t ${DBNAME}"`
     if [ $? != 0 ]; then
       _dbid="(null)"
     fi
     _dbcom=`echo ${_psql_str_com} | su - ibsuser -c "${PSQL} -t ${DBNAME}"`
     if [ $? != 0 ]; then
       _dbcom="(null)"
     fi

     echo "Ver:${_dbid}  Comment:${_dbcom}"
     ;;
  *)
     ;;
  esac
