#!/bin/sh
#
# ipkt_clock.bat YY MM DD hh mm
# args:
#  $BF|IU>pJs(B
#  $1:     YY: 00 - 37  (year)
#  $2:     MM: 01 - 12  (month)
#  $3:     DD: 01 - 31  (day)
#  $4:     hh: 00 - 23  (hour)
#  $5:     mm: 00 - 59  (min)
#
#
#  date$B%U%)!<%^%C%H(B: MMDDhhmm[YY]
#

CMDBAT=`basename $0`
#LOCKFILE=/var/lock/${CMDBAT}.lock
LOCKFILE=/var/log/ibs/${CMDBAT}.lock

sudo_date()
{
  sudo /bin/date $1 > /dev/null 2>&1
  sudo /sbin/hwclock --systohc --utc > /dev/null 2>&1
}

ipkt_clock_syslog()
{
  logger -p kern.info -t $CMDBAT $1
}

RETVAL=0
_YY=$1
_MM=$2
_DD=$3
_hh=$4
_mm=$5

if [ -z "$_YY" -o -z "$_MM" -o -z "$_DD" -o -z "$_hh" -o -z "$_mm" ]; then
  ipkt_clock_syslog "Error: args is too few. args1:$_YY args2:$_MM args3:$_DD args4:$_hh args5:$_mm"
  exit 1
fi

ln -s $0 ${LOCKFILE} > /dev/null 2>&1
if [ $? != 0 ]; then
  ipkt_clock_syslog "Other process executing."
  exit 1
fi
trap "rm -f ${LOCKFILE}" EXIT

####################
case $_YY in
[0-9][0-9])
  if [ $_YY -ge 00 -a $_YY -le 37 ]; then
    RETVAL=0
  else
    RETVAL=1
  fi
  ;;
*)
  RETVAL=1
  ;;
esac

if [ $RETVAL != 0 ]; then
  ipkt_clock_syslog "Error: args1 is invalid ($_YY)"
  exit 1
fi

####################
case $_MM in
[0-9][0-9])
  if [ $_MM -ge 01 -a $_MM -le 12 ]; then
    RETVAL=0
  else
    RETVAL=1
  fi
  ;;
*)
  RETVAL=1
  ;;
esac

if [ $RETVAL != 0 ]; then
  ipkt_clock_syslog "Error: args2 is invalid ($_MM)"
  exit 1
fi

####################
case $_DD in
[0-9][0-9])
  if [ $_DD -ge 01 -a $_DD -le 31 ]; then
    RETVAL=0
  else
    RETVAL=1
  fi
  ;;
*)
  RETVAL=1
  ;;
esac

if [ $RETVAL != 0 ]; then
  ipkt_clock_syslog "Error: args3 is invalid ($_DD)"
  exit 1
fi

####################
case $_hh in
[0-9][0-9])
  if [ $_hh -ge 00 -a $_hh -le 23 ]; then
    RETVAL=0
  else
    RETVAL=1
  fi
  ;;
*)
  RETVAL=1
  ;;
esac

if [ $RETVAL != 0 ]; then
  ipkt_clock_syslog "Error: args4 is invalid ($_hh)"
  exit 1
fi

####################
case $_mm in
[0-9][0-9])
  if [ $_mm -ge 00 -a $_mm -le 59 ]; then
    RETVAL=0
  else
    RETVAL=1
  fi
  ;;
*)
  RETVAL=1
  ;;
esac

if [ $RETVAL != 0 ]; then
  ipkt_clock_syslog "Error: args5 is invalid ($_mm)"
  exit 1
fi

_date="${_MM}${_DD}${_hh}${_mm}${_YY}"
#echo "date:$_date"
sudo_date $_date
exit 0
