#!/bin/sh
#
# usage:
#  mkrwfs.sh [directory]
#
dir=$1

case $dir in
/*)
   # dir is absolute directory.
   #absodir=$dir
   ;;
*)
   # dir is relative directory.
   absodir=`/bin/pwd`/$dir
   ;;
esac

if [ -d $dir ]; then
   # Backup files and directories in old directory.
   /usr/bin/tar czPf /tmp/mkrwfs.tmp.tgz $dir

   /sbin/mount_mfs -s 4096 dummy $absodir
   /bin/chmod 755 $dir

   # Restore th files and directories.
   /usr/bin/tar xzPf /tmp/mkrwfs.tmp.tgz
   rm -f /tmp/mkrwfs.tmp.tgz
else
    echo "$absodir: cannot mount to MFS. (not found)"
fi
