#!/bin/sh
#
# Ϣ
#  /etc/rc.d/init.d/pgsql
#  /etc/ibsbat/pg_dump.bat
#  /etc/ibsbat/target_app.bat
#  /usr/bin/flashd
#
# ưν
#

[ "X${X7DBG}" = "Xon" ] && set -x

. /etc/ibsbat/ibs.subr
. /etc/rc.conf

DEBUG=0

if [ "X${DEBUG}" = "X1" ]; then
	TOP=/export/release/SRC
	FTOP=/tmp
else
	TOP=""
	FTOP=""
fi

CMDBAT=`basename $0`

# 2004.08.20 add
PGSQL_BACKUP_FILE_PATH_TOP=/home/ibsuser/app
PGSQL_BACKUP_FILE_PATH=${PGSQL_BACKUP_FILE_PATH_TOP}/exe/IbsRooterUsePass.txt

PGSQL_RTOP=${TOP}/etc/ibsbat/pgsql
PGSQL_BACKUP_TBL_LIST=${PGSQL_RTOP}/backup_tbl_list

PGSQL_FTOP=${FTOP}/mnt/usr/BACKUP
PGSQL_BK_PG_PREFIX=PGDUMPto.
PGSQL_BK_DONE_PREFIX=pg_dump_done.
PGSQL_BK_PREFIX=cfile.

DB_TOP=/usr/local/pgsql/data
DB_DIR=${DB_TOP}/base

PGSQL_BK_TBL=${DB_TOP}/backup_tbl
PGSQL_BK_TBL2=${PGSQL_FTOP}/backup_tbl

DB_NAME=ibsdatabase
BK_NAME=ibsdataBAK

# 2006.05.05
#FLASHD=${PGSQL_FTOP}/flashd
FLASHD=/etc/rc.d/init.d/flashd

PG_CTL=/usr/local/pgsql/bin/pg_ctl
PG_VCUM=/usr/local/pgsql/bin/vacuumdb

PG_LOG=/tmp/pgsql_restore.log

[ -f "${PG_LOG}" ] && cp /dev/null ${PG_LOG}

# 2006.04.20
pg_syslog()
{
	logger -p kern.info -t $CMDBAT "$1"
	#initlog -n pg_restore -f kern -p info -s "$1"
	#if [ -t 1 ]; then
	echo "$1"
	echo "$1" >> ${PG_LOG}
	#fi
}

# 2006.04.29
# pgsql_data.tar.gzΥårc.localư
check_pgsql_data()
{
	PGSQL_NG=0
	PGSQL_BAK_NG=0

	## 2006.04.23
	if [ -f "${LAST_PGDATA}" ]; then
		pg_path=`cat ${LAST_PGDATA}`
		pg_syslog "pg_path:$pg_path"

		[ -f ${LAST_PGSTAT} ] && pg_stat=`cat ${LAST_PGSTAT}` || pg_stat=0
		case $pg_path in
			/mnt/IBS)
				if [ "X$pg_stat" = "XOK" ]; then
					last_path=/mnt/IBS
					bak_path=/mnt/usr
				else
					last_path=/mnt/usr
					bak_path=/mnt/IBS
				fi
				;;
			/mnt/usr)
				if [ "X$pg_stat" = "XOK" ]; then
					last_path=/mnt/usr
					bak_path=/mnt/IBS
				else
					last_path=/mnt/IBS
					bak_path=/mnt/usr
				fi
				;;
			*)
				last_path=/mnt/IBS
				bak_path=/mnt/usr
				;;
		esac
	else
		last_path=/mnt/IBS
		bak_path=/mnt/usr
	fi

	TAR_PGSQL=${last_path}/pgsql_data.tar.gz
	MD5_PGSQL=${last_path}/md5.pgsql
	TAR_PGSQL_BAK=${bak_path}/pgsql_data.tar.gz
	MD5_PGSQL_BAK=${bak_path}/md5.pgsql

	pg_syslog "TAR_PGSQL:${TAR_PGSQL}  MD5_PGSQL:${MD5_PGSQL}"
	pg_syslog "TAR_PGSQL_BAK:${TAR_PGSQL_BAK}  MD5_PGSQL_BAK:${MD5_PGSQL_BAK}"

	if [ -f ${TAR_PGSQL} ]; then
		tar tzf ${TAR_PGSQL} > /dev/null 2>&1
		if [ $? != 0 ]; then
			pg_syslog "PostgreSQL DB(${TAR_PGSQL}) is NG (not archive file)"
			PGSQL_NG=1
		else
			pg_syslog "PostgreSQL DB(${TAR_PGSQL}) is OK (archive file)"
		fi

		if [ "X${PGSQL_NG}" = "X0" -a -f ${MD5_PGSQL} ]; then
			#(cd ${DATA_DIR}; cat ${MD5_PGSQL} | md5sum -c )
			(cd ${last_path}; cat ${MD5_PGSQL} | md5sum -c )
			if [ $? = 0 ]; then
				_decomp_pgsql=${TAR_PGSQL}
				pg_syslog "PostgreSQL DB(${TAR_PGSQL}) is md5 OK"
			else
				pg_syslog "PostgreSQL DB(${TAR_PGSQL}) is md5 NG"
				PGSQL_NG=1
			fi
		elif [ "X${PGSQL_NG}" = "X0" ]; then
			_decomp_pgsql=${TAR_PGSQL}
		fi
	fi

	if [ "X${PGSQL_NG}" != "X0" ]; then
		tar tzf ${TAR_PGSQL_BAK} > /dev/null 2>&1
		if [ $? != 0 ]; then
			pg_syslog "Error:PostgreSQL Backup DB(${TAR_PGSQL_BAK}) is NG (not archive file)"
			PGSQL_BAK_NG=1
		else
			pg_syslog "PostgreSQL Backup DB(${TAR_PGSQL_BAK}) is OK (archive file)"
		fi

		if [ "X${PGSQL_BAK_NG}" = "X0" -a -f ${MD5_PGSQL_BAK} ]; then
			#(cd ${COMP_DIR}; cat ${MD5_PGSQL_BAK} | md5sum -c )
			(cd ${bak_path}; cat ${MD5_PGSQL_BAK} | md5sum -c )
			if [ $? = 0 ]; then
				_decomp_pgsql=${TAR_PGSQL_BAK}
				pg_syslog "PostgreSQL Backup DB(${TAR_PGSQL_BAK}) is md5 OK"
			else
				pg_syslog "PostgreSQL Backup DB(${TAR_PGSQL}) is md5 NG"
				PGSQL_BAK_NG=1
			fi
		elif [ "X${PGSQL_BAK_NG}" = "X0" ]; then
			pg_syslog "Warn:PostgreSQL ${MD5_PGSQL_BAK} is not found."
			_decomp_pgsql=${TAR_PGSQL_BAK}
		fi
	fi

	if [ -z "$_decomp_pgsql" ]; then
		pg_syslog "Error:PostgreSQL DB is error. ALARM ON!!"
		led_alarm_on
	else
		pg_syslog "PostgreSQL DB use ${_decomp_pgsql}"
	fi


	pg_syslog "decompress ${_decomp_pgsql} to /var"
	cat ${_decomp_pgsql} | (cd /var;tar xzpf -)
	if [ ! -f "${LAST_PGSTAT}" -o ! -f "${LAST_PGDATA}" ]; then
		local _dirs=${_decomp_pgsql%%pgsql_data.tar.gz}
		echo "$_dirs" > ${LAST_PGDATA}
		echo "OK" > ${LAST_PGSTAT}
		pg_syslog "Not found ${LAST_PGSTAT} or ${LAST_PGDATA}. created.(${_dirs})"
	fi

}


# 2004.08.20
# backup_list check
backup_tbl_check()
{
	if [ ! -f /etc/ibsbat/step1.5 ]; then
		pg_syslog "This system router is not step1.5"
		return 0
	fi

	if [ -f "${PGSQL_BACKUP_FILE_PATH}" ]; then
		pg_syslog "Found ${PGSQL_BACKUP_FILE_PATH}"
		. ${PGSQL_BACKUP_FILE_PATH}
	else
		pg_syslog "Not found ${PGSQL_BACKUP_FILE_PATH}"
	fi

	if [ "X${backup_tbl}" != "X" ]; then
		PGSQL_BK_TBL2=${PGSQL_BACKUP_FILE_PATH_TOP}/${backup_tbl}
	else
		pg_syslog "backup_tbl is not define. default setting."
		PGSQL_BK_TBL2=${PGSQL_BACKUP_FILE_PATH_TOP}/exe/backup_tbl_15
	fi

	if [ "X${backup_tbl_list}" != "X" ]; then
		PGSQL_BACKUP_TBL_LIST=${PGSQL_BACKUP_FILE_PATH_TOP}/${backup_tbl_list}
	else
		pg_syslog "backup_tbl_list is not define. default setting."
		PGSQL_BACKUP_TBL_LIST=${PGSQL_BACKUP_FILE_PATH_TOP}/exe/backup_tbl_list_15
	fi

	#ơ֥copy
	if [ -f ${PGSQL_BK_TBL} -a -f ${PGSQL_BK_TBL2} ]; then
		pg_syslog "Copy ${PGSQL_BK_TBL2} to ${PGSQL_BK_TBL}"
		cp -p ${PGSQL_BK_TBL2} ${PGSQL_BK_TBL}
	else
		pg_syslog "file not found. PGSQL_BK_TBL:${PGSQL_BK_TBL}  PGSQL_BK_TBL2:${PGSQL_BK_TBL2}"
	fi
}

#ưΤݽ
pgsql_prestart()
{
	pg_syslog $"Starting postgre: "
	if [ -f /usr/local/pgsql/data/postmaster.pid ]; then
		rm -f /usr/local/pgsql/data/postmaster.pid
	fi
	rm -f /tmp/.s.PGSQL*
}

#
# (1)Postgreٵư
# (2)ХååDB(ibsdataBAK)
# (3)ХååDB˥ơ֥
# (4)Postgre
# (5)ХååоݤΥơ֥ե򥳥ԡ
pgsql_create_bak()
{
	su - ibsuser -c "${PG_CTL} -w -o \"-S\" start"
	su - ibsuser -c "/usr/local/pgsql/bin/createdb ibsdataBAK"
	RETVAL=$?
	if [ ${RETVAL} != 0 ]; then
		pg_syslog "createdb error"
		return 0
	fi

	#ơ֥
	if [ ! -f ${PGSQL_BK_TBL} -a -f ${PGSQL_BK_TBL2} ]; then
		cp -p ${PGSQL_BK_TBL2} ${PGSQL_BK_TBL}
	fi
	su - ibsuser -c "cat ${PGSQL_BK_TBL} | /usr/local/pgsql/bin/psql ibsdataBAK"

	#touch /tmp/pgsql_nosave
	su - ibsuser -c "pg_ctl stop"
	#/etc/rc.d/init.d/pgsql stop
	RETVAL=$?

	if [ $RETVAL = 0 ]; then
		pgsql_copyfile
		#su - ibsuser -c "pg_ctl -w -o \"-S\" start"
	fi
}

pgsql_copyfile()
{
	[ -d ${DB_DIR}/${BK_NAME} ] || return 1

	for i in `cat ${PGSQL_BACKUP_TBL_LIST}`; do
		for j in ${DB_DIR}/${DB_NAME}/${i}; do
			#pg_syslog ${j}
			[ -f ${j} ] && cp -p ${j} ${DB_DIR}/${BK_NAME}
		done
	done
}

## S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/S2
# 2005.02.22
pgsql_dbsave_restore()
{
	_dump_f=${PGSQL_FTOP}/dbsave.gz

	if [ -f $_dump_f ]; then
		# 2006.04.04 sumi S4
		pg_syslog  "testing ${_dump_f}..."
		gzip -t ${_dump_f} > /dev/null 2>&1
		if [ $? != 0 ]; then
			pg_syslog "  error."
		else
			pg_syslog "  success."
			pg_syslog "dbsave file exist. restore start."
			gunzip -c $_dump_f | su - ibsuser -c "psql ${DB_NAME}" > /dev/null 2>&1
		fi
	else
		pg_syslog "dbsave file not found. Not execute dbsave restore."
	fi
}
## S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/S2


#
# ¸ιեΥꥹȥ
pgsql_bk_restore()
{
	su - ibsuser -c "pg_ctl -w -o \"-S\" start"

	## S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/S2
	# 2005.02.22
	pgsql_dbsave_restore
	## S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/S2


	# ʣpg_dumpä硢Υե
	_doneno=0000000000
	for _pg_dump_done in ${PGSQL_FTOP}/pg_dump_done.*; do
		if [ ! -f $_pg_dump_done ]; then
			continue
		fi
		_doneno1=`basename ${_pg_dump_done}`
		_doneno1=${_doneno1##pg_dump_done.}
		if [ $_doneno1 -gt $_doneno ]; then
			_doneno=$_doneno1
		fi
	done

	#Ǹpg_dumpեȿ
	_dump_f=${PGSQL_FTOP}/${PGSQL_BK_PG_PREFIX}${_doneno}
	if [ -f $_dump_f ]; then
		pg_syslog "pg_dump file exist. restore start."
		cat $_dump_f | su - ibsuser -c "psql ${DB_NAME}" > /dev/null 2>&1
	fi

	#for _dump_f in ${PGSQL_FTOP}/${PGSQL_BK_PG_PREFIX}*; do
	#	if [ -f "$_dump_f" ]; then
	#		pg_syslog "pg_dump file exist. restore start."
	#		cat $_dump_f | su - ibsuser "psql ${DB_NAME}" > /dev/null 2>&1
	#	fi
	#done

	for _cfile in ${PGSQL_FTOP}/${PGSQL_BK_PREFIX}*; do
		if [ ! -f $_cfile ]; then
			continue
		fi
		_f=`basename ${_cfile}`
		_cno=${_f##cfile.}
		# pg_dumpκǸcfileϡȿǤ
		if [ $_cno -gt $_doneno ]; then
			if [ -f "$_cfile" ]; then
				cat $_cfile | su - ibsuser -c "psql ${DB_NAME}" > /dev/null 2>&1
			fi
		fi
	done

	####################
	# ܥ󲡲DBμȯ
	if [ -f /etc/ibsbat/init_pushd/init_pushd_psql.bat ]; then
		/bin/sh /etc/ibsbat/init_pushd/init_pushd_psql.bat
	fi

	rm -f /tmp/pgsql_nosave
	
	#2004.05.24 target_app.batǤinfoߤ椹뤿
	touch /tmp/pgsql_bk_restore_execute
	# ¸뤿
	/etc/rc.d/init.d/pgsql stop
	local _init_pgsql=$?
	if [ "X$_init_pgsql" = 0 ]; then
		#ǤСFLASHιեϺ
		rm -f ${PGSQL_FTOP}/${PGSQL_BK_DONE_PREFIX}*
		rm -f ${PGSQL_FTOP}/${PGSQL_BK_PG_PREFIX}*
		rm -f ${PGSQL_FTOP}/${PGSQL_BK_PREFIX}*
	fi

	#2004.05.24 target_app.batǤinfoߤ椹뤿
	rm -f /tmp/pgsql_bk_restore_execute
}

# FLASH񤭹ߥץεư
start_flashd()
{
	if [ -x ${FLASHD} ]; then
		${FLASHD} start
	fi
}

# 2006.05.04 reindex
pg_reindex()
{
	# ǰΤ
	su - ibsuser -c "pg_ctl stop"
	pg_syslog "reindex start."
	echo "reindex table pg_attribute force;" | su - ibsuser -c "postgres -P -O ibsdatabase"
	pg_syslog "reindex done."
}

##########
_spec=$1
echo "${CMDBAT}: executing ${_spec}..."
case $_spec in
	boot)
		# 2006.04.29
		check_pgsql_data

		pgsql_prestart
		# 2004.08.20
		backup_tbl_check

		pgsql_bk_restore
		pgsql_create_bak

		#%%3100
		# 2006.04.20 move from
		if [ -f /etc/rc.d/init.d/pgsql ]; then
			/etc/rc.d/init.d/pgsql start
			start_flashd
		fi
		touch /tmp/pgsql_restore_nohup_done
		;;
	create_bak)
		pgsql_create_bak
		;;
	copy_file)
		pgsql_copyfile
		;;
	bk_restore)
		pgsql_bk_restore
		;;
	flashd)
		start_flashd
		;;
	backup_check)
		backup_tbl_check
		;;
	# 2006.04.29
	check)
		check_pgsql_data
		;;
	# 2006.05.04
	reindex)
		pg_reindex
		;;
	*)
		;;
esac
exit $RETVAL
