#!/bin/sh
#
# $1: start/stop/restart/conf/rmconf
# start/stop˥ȥֹꤹ
# $2: intaface
#
# 2004.02.25
#

#DEBUG=1
[ "X${X7DBG}" = "Xon" ] && set -x

#
# pppoe[0-4].confͤӤŤк
#
PPPOE_BAT_VERSION=2004032701
CMDBAT=`basename $0`

RETVAL=0
AWK=awk
AWK_S=/etc/ibsbat/pppoe.awk
WEB_FILE=/etc/ibsbat/Router/ipaddress_of_wan/pppoe_table.txt
WEB_WAN_STATE_FILE=/etc/ibsbat/Router/ipaddress_of_wan/wan_state.txt
# 2005.03.01 S2
ECAS_FILTER_FILE=/etc/ibsbat/Router/ipaddress_of_wan/ecas_base.txt
ECAS_IPTABLES_FILE=/etc/ibsbat/pppoe_iptables.sh

# 2005.04.09
FTBL_MANGLE_AWK=/etc/ibsbat/filter/ftbl_mangle.awk

IP_TEL=/etc/ibsbat/Router/ipaddress_of_wan/ip_tell.txt
PPP_TOP=/etc/ppp
PAPSECRET=${PPP_TOP}/pap-secrets
CHAPSECRET=${PPP_TOP}/chap-secrets

PPPOE_AUTOSTART_EXIST=/var/run/pppoe_autostart_exist
PPPOE_DISCON_MANUAL_PREFIX=/var/run/pppoe_discon_manual

NODE_LOG=/tmp/node_active_log
NKF=/usr/bin/nkf

FWMARK_VOIP=0x20

CONF_LIST="0 1 2 3 4"

pppoe_bat_syslog()
{
	logger -p kern.info -t $CMDBAT "$1"
# logger -p local1.info -t $CMDBAT "$1"
}
pppoe_bat_syslog_local1()
{
	logger -p local1.info -t $CMDBAT "$1"
	#echo "`date +%Y-%m-%d,%H:%M` $1" | ${NKF} -s >> ${NODE_LOG}
	#chown ibsuser:ibsuser ${NODE_LOG}
	#chmod 644 ${NODE_LOG}
	
}
pppoe_bat_syslog_x7dbg()
{
	[ "X${X7DBG}" != "Xon" ] && return
	logger -p kern.info -t $CMDBAT "$1"
}

# From here S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/
# 2005.02.24
pppoe_send_start_signal()
{
	#if [ -f /var/log/ibs/ibsserv.pid ]; then
	# _pid=`cat /var/log/ibs/ibsserv.pid`
	# V3 
	if [ -f /var/log/ibs/ibsproc_service.pid ]; then
		_pid=`cat /var/log/ibs/ibsproc_service.pid`
	else
		_pid=`ps ax|grep ibsserv|grep abscore|awk '{printf"%s",$1}'`
	fi
	if [ "X$_pid" != "X" ]; then
		logger -p kern.info -t $CMDBAT "Send start signal:ip_tell entry:${ip_tell}"
		# 2006.04.27
		kill -SIGHUP $_pid
		sleep 1
		kill -SIGUSR1 $_pid
		sleep 2
	fi
}
# To here S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/

pppoe_send_stop_signal()
{
	#if [ -f /var/log/ibs/ibsserv.pid ]; then
	# _pid=`cat /var/log/ibs/ibsserv.pid`
	# V3 
	if [ -f /var/log/ibs/ibsproc_service.pid ]; then
		_pid=`cat /var/log/ibs/ibsproc_service.pid`
	else
		_pid=`ps ax|grep ibsserv|grep abscore|awk '{printf"%s",$1}'`
	fi
	if [ "X$_pid" != "X" ]; then
		logger -p kern.info -t $CMDBAT "Send stop signal:ip_tell entry:${ip_tell}"
		kill -SIGUSR2 $_pid
		#kill -12 $_pid
		sleep 2
	fi
}

pppoeconf_version_check()
{
	_pppifno=$1
	_pppifname=ppp${_pppifno}
	_pppconf=pppoe${_pppifno}.conf

	if [ ! -f "${_pppconf}" ]; then
		return 1    # error
	fi

	pppoe_conf_version=`cat ${_pppconf} |grep "PPPOE_CONF_VERSION="`
	if [ $? = 0 ]; then
		eval $pppoe_conf_version
		if [ "${PPPOE_CONF_VERSION}" -lt "${PPPOE_BAT_VERSION}" ]; then
			return 1   # error
		fi
	else
		return 1 # error
	fi

	return 0  # ok
}

pppoe_stop()
{
	_pppifno=$1
	_pppifname=ppp${_pppifno}
	_pppconf=pppoe${_pppifno}.conf

	# 2006.04.09
	pppoe_bat_syslog "pppoe stop $_pppifname. call from ${PPID}"

	#ǥʥ
	if [ -f ${IP_TEL} ] ; then
		. ${IP_TEL}

		if [ "X$_pppifno" = "X$ip_tell" ]; then
			pppoe_send_stop_signal
		fi
	fi

	if [ -f ${PPP_TOP}/${_pppconf} ];then
		if [ -n "${DEBUG}" ]; then
			echo "adsl-stop ${PPP_TOP}/${_pppconf}"
		else
			adsl-stop ${PPP_TOP}/${_pppconf}
			RETVAL=$?
			_pppentno=`expr ${_pppifno} + 1`
			# 2005.11.26 ip-down.localǽϤ
			#pppoe_bat_syslog_local1 "ISP ץХȥ:${_pppentno}"
		fi
		return $RETVAL
	else
		return 21
	fi
}

pppoe_start()
{
	_pppifno=$1
	_pppifname=ppp${_pppifno}
	_pppconf=pppoe${_pppifno}.conf

	if [ -f ${PPP_TOP}/${_pppconf} ];then

		_pppentno=`expr ${_pppifno} + 1`
		pppoe_bat_syslog "conf:$_pppconf start."
		#sh /etc/ibsbat/iptables2.sh ${_pppifname} ${IPADDR} ${NETMASK} all
		#sh /etc/ibsbat/iptables2.sh ppp+ ${IPADDR} ${NETMASK} all

		if [ -n "${DEBUG}" ]; then
			echo "adsl-start ${PPP_TOP}/${_pppconf}"
		else
			if [ -f ${PPP_TOP}/${_pppconf} ]; then
				adsl-start ${PPP_TOP}/${_pppconf}
				SRETVAL=$?
				if [ "${RETVAL}" != 0 ]; then
					#pppoe_bat_syslog_local1 "pppoe${_pppifno} start:failure"
					pppoe_bat_syslog_local1 "System## ISP ץХȥ:${_pppentno}"
					return ${RETVAL}
				fi

				while [ true ]; do
					adsl-status ${PPP_TOP}/${_pppconf} > /dev/null 2>&1
					RETVAL=$?
					if [ "${RETVAL}" = 0 ]; then
					#RETVAL=$?
					#pppoe_bat_syslog_local1 "pppoe${_pppifno} start:success"
					# 2006.01.25 ip-up.localǽ
					#pppoe_bat_syslog_local1 "ISP³ ץХȥ:${_pppentno}"
						touch /var/lock/subsys/adsl
						break
					fi
					if [ "${RETVAL}" != 0 ]; then
					#RETVAL=$?
					#pppoe_bat_syslog_local1 "pppoe${_pppifno} start:failure"
						pppoe_bat_syslog_local1 "System## ISP ץХȥ:${_pppentno}"
						break
					fi
				done

				if [ "X$SRETVAL" = "X0" -a "X$RETVAL" = "X0" ]; then
					return 0
				elif [ "X$SRETVAL" = "X0" -a "X$RETVAL" != "X0" ]; then
					return 41
				else
					return 21
				fi
			fi
		fi
	fi
}

pppoe_allstart()
{
	_iptables_first=0

	#for i in $CONF_LIST; do
	#	if [ -f pppoe$i.conf ]; then
	#		if [ "_iptables_first" = "0" ]; then
	#			sh iptables2.sh 
	#		else
	#			sh iptables2.sh
	#		fi
	#	fi
	#done

	if [ -f /etc/sysconfig/network-scripts/ifcfg-eth1 ]; then
		. /etc/sysconfig/network-scripts/ifcfg-eth1
	fi
	#sh /etc/ibsbat/iptables2.sh ppp0 ${IPADDR} ${NETMASK} all
	#sh /etc/ibsbat/iptables2.sh ppp+ ${IPADDR} ${NETMASK} all

	for i in $CONF_LIST; do
		if [ -f ${PPP_TOP}/pppoe$i.conf ];then

			pppoe_start $i
			RETVAL=$?
		fi
	done
}

pppoe_allstop()
{
	for i in $CONF_LIST; do
		if [ -f ${PPP_TOP}/pppoe$i.conf ];then
			pppoe_stop $i
		fi
	done
}

named_start()
{
	_namedb=/var/namedb
	if [ ! -d $_namedb  ]; then
		mkdir $_namedb
	fi
	chown named:named $_namedb

	cp -p /etc/ibsbat/namedb/127        $_namedb
	cp -p /etc/ibsbat/namedb/localhost  $_namedb
	cp -p /etc/ibsbat/namedb/root.cache $_namedb

	#grep 
	#cat /etc/ibsbat/namedb/named.conf | awk -e '
}

pppoe_status()
{
	_pppifno=$1
	_pppconf=pppoe${_pppifno}.conf

	if [ -f ${PPP_TOP}/${_pppconf} ];then

		if [ -n "${DEBUG}" ]; then
			echo "adsl-status ${PPP_TOP}/${_pppconf}"
		else
			if [ -f ${PPP_TOP}/${_pppconf} ]; then
				adsl-status ${PPP_TOP}/${_pppconf}

				RETVAL=$?
			else
				RETVAL=1
			fi
		fi
	fi
}

# S2/S2/S2/S2/S2/S2/
# 2005.03.01
wan_eth0_boot()
{
	_ibsfunc=wan_eth0_boot
	pppoe_bat_syslog "$_ibsfunc: start"
	if [ -f ${WEB_WAN_STATE_FILE} ]; then
		. ${WEB_WAN_STATE_FILE}
	fi

	# 2005.03.12
	# Ƥ(ե)
	if [ -f "${ECAS_IPTABLES_FILE}" ]; then
		/bin/sh ${ECAS_IPTABLES_FILE} -D
		rm -f ${ECAS_IPTABLES_FILE}
	fi

	if [ "X$ip" = "Xoff" -o "X$ip" = "Xdhcp" ]; then
		# 2005.03.01 IPξõ
		ip addr flush dev eth0
		#if [ -f "${ECAS_IPTABLES_FILE}" ]; then
		#	/bin/sh ${ECAS_IPTABLES_FILE}
		#	rm -f ${ECAS_IPTABLES_FILE}
		#fi
		return 0
	fi
	# 2006.04.09
	if [ "X$ip" = "Xscas_west_dhcp" ]; then
		pppoe_bat_syslog "$_ibsfunc:ip is ${ip}. Do not setup eth0."
		return 0
	fi

	# 2006.04.16
	unset DEVICE IPADDR  NETMASK BROADCAST

	if [ -f /etc/sysconfig/network-scripts/ifcfg-eth0 ]; then
		. /etc/sysconfig/network-scripts/ifcfg-eth0
		pppoe_bat_syslog "$_ibsfunc: read from ifcfg-eth0 ${DEVICE}:${IPADDR}:${NETMASK}:${BROADCAST}:"
		# Ǥϡޤͭˤʤ
		# 2006.04.09
		if [ -n "${IPADDR}" -a -n "${NETMASK}" -a -n "${BROADCAST}" ]; then
			pppoe_bat_syslog "$_ibsfunc:/sbin/ifconfig ${DEVICE} ${IPADDR} netmask ${NETMASK} broadcast ${BROADCAST} down"
			/sbin/ifconfig ${DEVICE} ${IPADDR} netmask ${NETMASK} broadcast ${BROADCAST} down
		fi

		#echo "${IPADDR}   ibswan" >> /etc/hosts
		# Ǹ˥󥿥եͭ
		pppoe_bat_syslog "$_ibsfunc: starting interface up"
		/sbin/ifconfig ${DEVICE} up

		# 2006.08.10
		# IP⡼
		if [ "X$ip" = "Xscas_west_ip" ]; then
			pppoe_bat_syslog "$_ibsfunc: west_ip rs retry counter reset to 30."
			# 2006.08.11 LAN¦IPv6RAػߤFLUSH
			sysctl -w net.ipv6.conf.eth1.accept_ra=0
			ip -f inet6 addr flush dev eth1

			/sbin/ifconfig ${DEVICE} down
			sysctl -w net.ipv6.conf.eth0.router_solicitations=100
			sysctl -w net.ipv6.conf.default.router_solicitations=100
			sysctl -w net.ipv6.conf.all.router_solicitations=100
			/sbin/ifconfig ${DEVICE} up
			ip link set eth0 allmulti on
			pppoe_bat_syslog "$_ibsfunc: west_ip allmulti on."
		fi

		#2006.04.06 sumi
		#  boot2_2Ǽ¹Ԥ뤿ᡢ
		#if [ "${GATEWAYDEV}" = "${DEVICE}" ]; then
		#   ip route add default dev ${DEVICE}
		#fi

		# 롼ƥ󥰥ơ֥ϡ󥿥եUPƤ¹Ԥ
		if [ -f ${IP_TEL} ] ; then
			. ${IP_TEL}

			pppoe_bat_syslog "$_ibsfunc: ${ip_tell} ${ip_tell_default_gw}"
			if [ ! -z "${ip_tell_default_gw}" -a "X${ip_tell}" = "Xecas" ]; then
				_rt_table_ecas=2
				ip rule del fwmark $FWMARK_VOIP table ${_rt_table_ecas}
				ip rule add fwmark $FWMARK_VOIP table ${_rt_table_ecas}

				# 2005.04.08
				ip route flush table ${_rt_table_ecas}

				# ǥե
				ip route del default table ${_rt_table_ecas}
				ip route add default via ${ip_tell_default_gw} table ${_rt_table_ecas}

				# 2005.04.08
				if [ "X${NETWORK}" = "X" ]; then
					_wan_network=`ipcalc -n ${IPADDR} ${NETMASK}`
					if [ $? = 0 -a ! -z ${_wan_network} ]; then
						eval $_wan_network
					fi
				fi
				_wan_prefix=`ipcalc -p ${IPADDR} ${NETMASK}`
				if [ $? = 0 -a ! -z ${_wan_prefix} ]; then
					eval $_wan_prefix
				fi
				if [ "X${PREFIX}" != "X" -a "X${NETWORK}" != "X" ]; then
					ip route add ${NETWORK}/${PREFIX} via ${IPADDR} table ${_rt_table_ecas}
				fi

				# 2005.03.12
				# ȤꤢꤷpppoeΥȥ˥ǥեȤСǺ
				route add default gw ${ip_tell_default_gw}

				# 2005.03.12
				ip route flush cache

			fi
		fi

	fi

}

# S2/S2/S2/S2/S2/S2/
# 2005.03.01
# 2005.04.08 ̤
wan_eth0_boot2()
{
	_ibsfunc=wan_eth0_boot2
	pppoe_bat_syslog "$_ibsfunc: start"
	if [ -f ${WEB_WAN_STATE_FILE} ]; then
		. ${WEB_WAN_STATE_FILE}
	fi
	if [ "X$ip" = "Xoff" -o "X$ip" = "Xdhcp" ]; then
		# 2005.03.01 IPξõ
		ip addr flush dev eth0
		if [ -f "${ECAS_IPTABLES_FILE}" ]; then
			/bin/sh ${ECAS_IPTABLES_FILE} -D
			rm -f ${ECAS_IPTABLES_FILE}
		fi
		return 0
	fi

	# 2005.03.01 S2
	if [ "X$ip" = "Xecas" -a -f "${ECAS_FILTER_FILE}" ]; then
		grep "^filtering_src_port=" "${ECAS_FILTER_FILE}" | while read _rt_arg1 _rt_arg2; do
			eval `echo ${_rt_arg1}`
			if [ ! -z "${filtering_src_port}" ]; then
				if [ -z "$_rt_arg2" ]; then
				#echo "iptables -D OUTPUT -t mangle -p udp --sport ${filtering_src_port} -j MARK --set-mark $FWMARK_VOIP" >> ${ECAS_IPTABLES_FILE}
				#echo "iptables -D OUTPUT -t mangle -p tcp --sport ${filtering_src_port} -j MARK --set-mark $FWMARK_VOIP" >> ${ECAS_IPTABLES_FILE}
				#iptables -A OUTPUT -t mangle -p udp --sport ${filtering_src_port} -j MARK --set-mark $FWMARK_VOIP
				#iptables -A OUTPUT -t mangle -p tcp --sport ${filtering_src_port} -j MARK --set-mark $FWMARK_VOIP
					for i in $CONF_LIST; do
						echo "iptables -t mangle -D OUTPUT -o ppp$i -p udp --sport ${filtering_src_port} -j MARK --set-mark $FWMARK_VOIP" >> ${ECAS_IPTABLES_FILE}
						echo "iptables -t mangle -D OUTPUT -o ppp$i -p tcp --sport ${filtering_src_port} -j MARK --set-mark $FWMARK_VOIP" >>  ${ECAS_IPTABLES_FILE}
						iptables -t mangle -I OUTPUT -o ppp$i -p udp --sport ${filtering_src_port} -j MARK --set-mark $FWMARK_VOIP
						iptables -t mangle -I OUTPUT -o ppp$i -p tcp --sport ${filtering_src_port} -j MARK --set-mark $FWMARK_VOIP
					done
					
				else
				#echo "iptables -D OUTPUT -t mangle -p udp --sport ${filtering_src_port}:${_rt_arg2} -j MARK --set-mark $FWMARK_VOIP" >> ${ECAS_IPTABLES_FILE}
				#echo "iptables -D OUTPUT -t mangle -p tcp --sport ${filtering_src_port}:${_rt_arg2} -j MARK --set-mark $FWMARK_VOIP" >> ${ECAS_IPTABLES_FILE}
				#iptables -A OUTPUT -t mangle -p udp --sport ${filtering_src_port}:${_rt_arg2} -j MARK --set-mark $FWMARK_VOIP
				#iptables -A OUTPUT -t mangle -p tcp --sport ${filtering_src_port}:${_rt_arg2} -j MARK --set-mark $FWMARK_VOIP
					for i in $CONF_LIST; do
						echo "iptables -t mangle -D OUTPUT -o ppp$i -p udp --sport ${filtering_src_port}:${_rt_arg2} -j MARK --set-mark $FWMARK_VOIP" >> ${ECAS_IPTABLES_FILE}
						echo "iptables -t mangle -D OUTPUT -o ppp$i -p tcp --sport ${filtering_src_port}:${_rt_arg2} -j MARK --set-mark $FWMARK_VOIP" >> ${ECAS_IPTABLES_FILE}
						iptables -t mangle -I OUTPUT -o ppp$i -p udp --sport ${filtering_src_port}:${_rt_arg2} -j MARK --set-mark $FWMARK_VOIP
						iptables -t mangle -I OUTPUT -o ppp$i -p tcp --sport ${filtering_src_port}:${_rt_arg2} -j MARK --set-mark $FWMARK_VOIP
					done

				fi
			fi
		done
	fi
}

# S2/S2/S2/S2/S2/S2/
# 2005.03.12
wan_eth0_boot2_2()
{
	pppoe_bat_syslog "wan_eth0_boot2_2: start"
	if [ -f ${WEB_WAN_STATE_FILE} ]; then
		. ${WEB_WAN_STATE_FILE}
	fi
	if [ "X$ip" = "Xoff" -o "X$ip" = "Xdhcp" ]; then
		# 2005.03.01 IPξõ
		ip addr flush dev eth0
		if [ -f "${ECAS_IPTABLES_FILE}" ]; then
			#  /bin/sh ${ECAS_IPTABLES_FILE}
			# 2005.04.09 mangleѹˤꡢbat˰Ȥ褦ˤ
			/bin/sh ${ECAS_IPTABLES_FILE}  -D
			rm -f ${ECAS_IPTABLES_FILE}
		fi
		return 0
	fi

	# 2006.04.16
	unset DEVICE IPADDR  NETMASK BROADCAST

	# 2006.04.09
	#if [ -f /etc/sysconfig/network-scripts/ifcfg-eth0 ]; then
	if [ -f /etc/sysconfig/network-scripts/ifcfg-eth0 -a "X$ip" != "Xscas_west_dhcp" ]; then
		. /etc/sysconfig/network-scripts/ifcfg-eth0
		pppoe_bat_syslog "wan_eth0_boot2_2: ${DEVICE} ${IPADDR} ${NETMASK} ${BROADCAST}"
	fi
	#2006.04.06 sumi
	if [ -f /etc/sysconfig/network ]; then
		. /etc/sysconfig/network
		if [ -n "${GATEWAYDEV}"  ]; then
			ip route add default dev ${GATEWAYDEV}
		fi
	fi


	if [ -z "${IPADDR}" ]; then
		pppoe_bat_syslog "wan_eth0_boot2_2: IPADDR is null"
		return 0
	fi

	# 2005.03.01 S2
	if [ "X$ip" = "Xecas" -a -f "${ECAS_FILTER_FILE}" ]; then
		# 2006.06.29
		pppoe_bat_syslog_x7dbg "mode is ecas or ${ECAS_FILTER_FILE} is found."

		#grep "^filtering_src_port=" "${ECAS_FILTER_FILE}" | while read _rt_arg1 _rt_arg2; do
		#	eval `echo ${_rt_arg1}`
		#	if [ ! -z "${filtering_src_port}" ]; then
		#		if [ -z "$_rt_arg2" ]; then
		#			echo "iptables -t mangle -D OUTPUT -s ${IPADDR} -p udp --sport ${filtering_src_port} -j MARK --set-mark $FWMARK_VOIP" >> ${ECAS_IPTABLES_FILE}
		#			echo "iptables -t mangle -D OUTPUT -s ${IPADDR} -p tcp --sport ${filtering_src_port} -j MARK --set-mark $FWMARK_VOIP" >> ${ECAS_IPTABLES_FILE}
		#			iptables -t mangle -A OUTPUT -s ${IPADDR} -p udp --sport ${filtering_src_port} -j MARK --set-mark $FWMARK_VOIP
		#			iptables -t mangle -A OUTPUT -s ${IPADDR} -p tcp --sport ${filtering_src_port} -j MARK --set-mark $FWMARK_VOIP
		#		else
		#			echo "iptables -t mangle -D OUTPUT -s ${IPADDR} -p udp --sport ${filtering_src_port}:${_rt_arg2} -j MARK --set-mark $FWMARK_VOIP" >> ${ECAS_IPTABLES_FILE}
		#			echo "iptables -t mangle -D OUTPUT -s ${IPADDR} -p tcp --sport ${filtering_src_port}:${_rt_arg2} -j MARK --set-mark $FWMARK_VOIP" >> ${ECAS_IPTABLES_FILE}
		#			iptables -t mangle -A OUTPUT -s ${IPADDR} -p udp --sport ${filtering_src_port}:${_rt_arg2} -j MARK --set-mark $FWMARK_VOIP
		#			iptables -t mangle -A OUTPUT -s ${IPADDR} -p tcp --sport ${filtering_src_port}:${_rt_arg2} -j MARK --set-mark $FWMARK_VOIP
		#		fi
		#	fi
		#done
		cat ${ECAS_FILTER_FILE} | awk -v ecas_ip=${IPADDR} -v ecas_mark=${FWMARK_VOIP} -f ${FTBL_MANGLE_AWK} > ${ECAS_IPTABLES_FILE}
		/bin/sh ${ECAS_IPTABLES_FILE} -A
		# ϥʥ
		pppoe_send_start_signal
	# 2006.06.29 S4
	else
		pppoe_bat_syslog_x7dbg "Not ecas or ${ECAS_FILTER_FILE} is not found."
	fi
}

# S2/S2/S2/S2/S2/S2/
# 2005.02.26
wan_eth0_conf()
{
	pppoe_bat_syslog "wan_eth0_conf: start"
	if [ -f ${WEB_WAN_STATE_FILE} ]; then
		. ${WEB_WAN_STATE_FILE}
	fi

	# 2005.12.15
	# IP⡼ɤǤʤХ꥿
	if [ "X$pppoe" = "Xon" -o "X$ip" = "Xoff" ]; then
		return 0
	fi

	wan_eth0_boot

	# NAT
	pppoe_bat_syslog "wan_eth0_conf: starting nat.bat"
	/bin/sh /etc/ibsbat/nat.bat

	# FILTER
	pppoe_bat_syslog "wan_eth0_conf: starting filter.bat"
	/bin/sh /etc/ibsbat/filter.bat

	# ROUTING
	pppoe_bat_syslog "wan_eth0_conf: starting routing.bat"
	/bin/sh /etc/ibsbat/routing.bat

	#wan_eth0_boot2
	# 2005.03.12
	wan_eth0_boot2_2
}

create_conf()
{
	remove_conf

	if [ -f ${WEB_WAN_STATE_FILE} ]; then
		. ${WEB_WAN_STATE_FILE}
	fi
	# 2005.02.27 S2
	#if [ "X$wan_set_info" != "Xpppoe" ]; then
	if [ "X$pppoe" != "Xon" ]; then
		return 0
	fi
	cat $WEB_FILE | $AWK -v pppoe_conf_version="${PPPOE_BAT_VERSION}" -f $AWK_S 2>debug.txt
	cp /dev/null $PAPSECRET
	cp /dev/null $CHAPSECRET

	for i in ${PPP_TOP}/pppoe?.conf; do
		_certify=`cat ${i} |grep "^#certification"` > /dev/null 2>&1
		if [ "$_certify" = "#certification=pap" ]; then
			cat $i | awk 'BEGIN{FS="=";}/^USER/{printf"%s  * ",$2;}/#password/{printf"%s\n",$2;}'  >> $PAPSECRET;
		fi
		if [ "$_certify" = "#certification=chap" ]; then
			cat $i | awk 'BEGIN{FS="=";}/^USER/{printf"%s  * ",$2;}/#password/{printf"%s\n",$2;}'  >> $CHAPSECRET;
		fi

		#cat $i | grep "^USER=" | sed -e 's/USER=//' >> $SECRET;
		#cat $i | grep "^#password=" | sed -e 's/#password/ /' >> $SECRET;
	done
	chmod 600 ${PAPSECRET} ${CHAPSECRET}
}

remove_conf()
{

	#cat $WEB_FILE | $AWK -f $AWK_S 2>debug.txt
	cp /dev/null $PAPSECRET
	cp /dev/null $CHAPSECRET

	for i in ${PPP_TOP}/pppoe?.conf; do
		rm -f $i
	done
}

pppoe_autostart()
{
	_pppoe_autostar_done=0
	for i in $CONF_LIST; do
		if [ -f ${PPP_TOP}/pppoe$i.conf ];then

			_autostart=`grep "#auto_connection" ${PPP_TOP}/pppoe$i.conf | awk -F"=" '{printf"%s\n",$2}'`
			if [ "X$_autostart" != "Xon" ]; then
				continue
			fi

			pppoe_start $i
			_pppoe_autostart_done=done
		fi
	done

	if [ "X$_pppoe_autostart_done" = "Xdone" ]; then
		touch $PPPOE_AUTOSTART_EXIST
	fi
}

#2006.01.27 adsl-connectץδƻ
# $1: pppoe?.conf?
# եΥեޥåȤϡ
#   pid val
# pid  : pppoe?.conf-adsl.pidpid
# count: 󥯥θв
#
# pidۤʤäƤϡꥻå(ե)
pppoe_exist_check_link()
{
	if [ "X$1" = "X" ]; then
		return 1
	fi
	_entry=$1
	_count=0
	_pppoe_conf_adsl_file=/var/run/pppoe${_entry}.conf-connect-down
	if [ -f /var/run/pppoe${_entry}.conf-adsl.pid ]; then
		_adsl_connect_pid=`cat /var/run/pppoe${_entry}.conf-adsl.pid`
	else
		_adsl_connect_pid=0
		return 1
	fi

	if [ -f ${_pppoe_conf_adsl_file} ]; then
		cat ${_pppoe_conf_adsl_file} | while read _pid _count; do
			if [ "X$_pid" = "X$_adsl_connect_pid" ]; then
				_count=$(( $_count + 1 ))
				if [ $_count -ge 3 ]; then
					adsl-stop ${PPP_TOP}/pppoe$i.conf > /dev/null 2>&1
					rm -f ${_pppoe_conf_adsl_file}
				else
					echo "$_adsl_connect_pid  $_count" > ${_pppoe_conf_adsl_file}
				fi
			else
				#pidѤäƤΤǿ
				_count=0
				echo "$_adsl_connect_pid  $_count" > ${_pppoe_conf_adsl_file}
			fi
		done
	else
		#
		_count=0
		echo "$_adsl_connect_pid  $_count" > ${_pppoe_conf_adsl_file}
	fi
	return 0
}

pppoe_exist_check()
{
	_pppoe_connection_ng=0
	# ̵Х꥿
	[ -f $PPPOE_AUTOSTART_EXIST ] || return 0

	for i in $CONF_LIST; do
		if [ -f ${PPP_TOP}/pppoe$i.conf ];then

			_autostart=`grep "#auto_connection" ${PPP_TOP}/pppoe$i.conf | awk -F"=" '{printf"%s\n",$2}'`
			if [ "X$_autostart" != "Xon" ]; then
				continue
			fi

			if [ -f /var/run/pppoe${i}.conf-adsl.pid ]; then
				eval _adsl_${i}_pid=`cat /var/run/pppoe${i}.conf-adsl.pid`
				_file_pid=`eval echo \$\{_adsl_${i}\}`
				_now_pid=`ps ax|grep adsl-connect|grep pppoe${i}.conf|grep -v grep| awk '{printf"%s\n",$1}'`

				eval _pppd_${i}_pid=`cat /var/run/pppoe${i}.conf-adsl.pid.pppd`
				_file_pid=`eval echo \$\{_pppd_${i}\}`
				_now_pid=`ps ax|grep pppd|grep ppp${i}|grep -v grep| awk '{printf"%s\n",$1}'`
			else
				pppoe_bat_syslog "session start:entry pppoe${i}"
				pppoe_start $i
			fi

			# 2006.01.09 For V3 alarmϡư³åǼ¹Ԥ
			adsl-status ${PPP_TOP}/pppoe$i.conf > /dev/null 2>&1
			if [ $? != 0 ]; then
				_pppoe_connection_ng=1
				# 2006.01.25 󥯥åˤ󤷤Ƥϡץλ
				#  ν˥¹ԤƤꡢʥȯԤƤ
				#adsl-stop ${PPP_TOP}/pppoe$i.conf > /dev/null 2>&1
				# 2006.01.27 ʣΥ󥯥åѹ
				#pppoe_exist_check_link $i
			fi
		fi
	done

	# 2006.01.09 For V3 alarmϡư³åǼ¹Ԥ
	if [ "X$_pppoe_connection_ng" = "X1" ]; then
		alarm_led_update 2
	else
		# 2006.01.12 ԻˤϡΤޤ
		if [ -f /tmp/fwupdate_ng_exec_oldver ]; then
			alarm_led_update 2
		else
			alarm_led_update 0
		fi
	fi
}

# 2006.01.09 For V3
alarm_led_update()
{
	_led_type=$1
	LED_PROC_LIST="/proc/ibs/ibsled/alarm /proc/ibsled/alarm /proc/alarm"

	# LED on : voip
	for led in ${LED_PROC_LIST}; do
		if [ -f "${led}" ]; then
			echo "$_led_type" > "${led}"
			break
		fi
	done
}


####################
# main
####################

_args=$1
_ifname=$2

if [ -f /etc/sysconfig/network-scripts/ifcfg-eth1 ]; then
	. /etc/sysconfig/network-scripts/ifcfg-eth1
fi

pppoe_bat_syslog "args:$_args"
case $_args in
	start)
		pppoeconf_version_check $_ifname
		if [ $? != 0 ]; then
			create_conf
		fi
		pppoe_start $_ifname
		RETVAL=$?
		;;
	stop)
		pppoe_stop $_ifname
		RETVAL=$?
		# 2006.01.09 For V3 alarmϡư³åǼ¹Ԥ
		#if [ "X$RETVAL" != "X0" ]; then
		#	touch ${PPPOE_DISCON_MANUAL_PREFIX}.ppp$_ifname
		#fi
		;;
	restart)
		pppoe_stop $_ifname
		create_conf
		pppoe_start $_ifname
		RETVAL=$?
		;;
	# 2005.03.01 S2 confbootʬ
	boot)
		pppoe_bat_syslog "$_args: start."
		# S2/S2/S2/S2/S2/S2/S2/S2/
		# 2005.02.26
		wan_eth0_boot
		RETVALeth0=$?
		
		create_conf
		RETVAL=$?
		pppoe_bat_syslog "$_args: done."
		;;
	# 2005.03.01 ֡Ȼnat/filter/routingθ˺Ƽ¹
	boot2)
		#wan_eth0_boot2
		# 2005.03.12
		wan_eth0_boot2_2
		;;
	#conf|boot)
	conf)
		pppoe_bat_syslog "$_args: start."
		# S2/S2/S2/S2/S2/S2/S2/S2/
		# 2005.02.26
		wan_eth0_conf
		RETVALeth0=$?
		
		create_conf
		RETVAL=$?
		pppoe_bat_syslog "$_args: done."
		;;
	rmconf)
		remove_conf $_ifname
		RETVAL=$?
		;;
	status)
		pppoe_status $_ifname
		RETVAL=$?
		;;
	autostart)
		pppoe_autostart
		RETVAL=$?
		;;
	namedconf)
		named_start
		RETVAL=$?
		;;
	session_check)
		pppoe_exist_check
		;;
	# From here S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/
	# 2005.02.24
	voip_start_signal)
		pppoe_send_start_signal
		;;
	voip_stop_signal)
		pppoe_send_stop_signal
		;;
	# To here S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/
	*)
		;;
esac

exit $RETVAL
