#!/bin/sh
#
# 롼ƥ
#
# $1: default
#
# $1:static
# $2:ppp0/ppp1.... (ȥ̾)
#
# $1:conf
#
# $1:boot
#

[ "X${X7DBG}" = "Xon" ] && set -x

CMDBAT=`basename $0`
ROUTING_BAT_VERSION=2004032801

#DBG_LOCAL=1
if [ -z "${DBG_LOCAL}" ]; then
	RTWEBTOP=/etc/ibsbat/Router
	RTWEBDIR=${RTWEBTOP}/routing
	RTDIR=/etc/ibsbat/routing
	VARDIR=/var/run
else
	RTWEBTOP=/home/ibsuser/work/routing
	RTWEBDIR=${RTWEBTOP}
	RTDIR=${RTWEBTOP}
	VARDIR=${RTWEBTOP}
fi

DEFTBL=${RTWEBDIR}/default_route.txt
POLTBL=${RTWEBDIR}/policy_table.txt
RIPTBL=${RTWEBDIR}/rip.txt
STATTBL=${RTWEBDIR}/static_table.txt

WANSTATE=${RTWEBTOP}/ipaddress_of_wan/wan_state.txt

STATAWK=${RTDIR}/static.awk
POLICYAWK=${RTDIR}/policy.awk
RTCONF=${RTDIR}/router.conf
POLCONF=${RTDIR}/policy.conf
STATCONF=${RTDIR}/static-routes
POLICYCONF=${RTDIR}/policy-routes
DEFRTBAT=${RTDIR}/default_route.bat

N_TO_REAL_PREFIX=${VARDIR}/ntoreal.

LANIF=eth1
WANIF=eth0



RIP_SYSCONFIG=/etc/sysconfig/routed

routing_syslog()
{
	logger -p kern.info -t $CMDBAT $1
}
routing_syslog_debug()
{
	logger -p kern.debug -t $CMDBAT $1
}

create_conf()
{
	cat ${STATTBL} |awk -f ${STATAWK} > ${RTCONF}
	cat ${POLTBL}  |awk -f ${POLICYAWK} > ${POLCONF}
}

default_route_set()
{
	if [ -f "$DEFRTBAT" ]; then
		/bin/sh $DEFRTBAT
	fi
}

static_route_alladd()
{
	[ ! -f "${STATCONF}" ] && return 0
	[ -f "${WANSTATE}" ] && . ${WANSTATE}
	cat "${STATCONF}"| while read device args; do
		case $wan_set_info in
			dhcp)
				if [ "$device" = "dhcp" ]; then
					/sbin/ip address show ${WANIF} |grep inet > /dev/null 2>&1
					if [ $? = 0 ]; then
						/sbin/route add -$args
					fi
				fi
				;;
			pppoe)
				if [ -f "${N_TO_REAL_PREFIX}${device}" ]; then
					_real_if=`cat ${N_TO_REAL_PREFIX}${device}`
					if [ ! -z "$_real_if" ]; then
						/sbin/route add -$args
					fi
				fi
				;;
			manual)
				if [ "$device" = "${WANIF}" ]; then
#        /sbin/route add -$args
# 2004.06.17
					/sbin/route add -$args dev ${device}
				fi
				;;
			*)
				;;
		esac

		if [ "$device" = "any" ]; then
			/sbin/route add -$args
		fi
	done
}

# S2 2005.02.27
static_route_alladd_S2()
{
	[ ! -f "${STATCONF}" ] && return 0
	[ -f "${WANSTATE}" ] && . ${WANSTATE}
	cat "${STATCONF}"| while read device args; do
		if [ "X${pppoe}" = "Xon" ]; then
			if [ -f "${N_TO_REAL_PREFIX}${device}" ]; then
				_real_if=`cat ${N_TO_REAL_PREFIX}${device}`
				if [ ! -z "$_real_if" ]; then
					/sbin/route add -$args
				fi
			fi
		fi

		if [ "X${ip}" = "Xnormal" ]; then
			if [ "$device" = "${WANIF}" ]; then
				/sbin/route add -$args dev ${device}
			fi
		fi

		if [ "X${ip}" = "Xdhcp" ]; then
			if [ "$device" = "dhcp" ]; then
				/sbin/ip address show ${WANIF} |grep inet > /dev/null 2>&1
				if [ $? = 0 ]; then
					/sbin/route add -$args
				fi
			fi
		fi

		if [ "$device" = "any" ]; then
			/sbin/route add -$args
		fi
	done
}

static_route_alldel()
{
	[ ! -f "${STATCONF}" ] && return 0
	cat "${STATCONF}"| while read device args; do
		routing_syslog_debug "static_route_alldel:$device:$args"
# 2004.06.17
#    if [ "$device" = "dhcp" ]; then
#      /sbin/route delete ${WANIF} -$args
		if [ "$device" = "dhcp" -o "$device" = "eth0" ]; then
			/sbin/route delete -$args dev ${WANIF}
		elif [ "$device" = "any" ]; then
			/sbin/route delete -$args
		else
#      /sbin/route delete ${device} -$args
			/sbin/route delete -$args dev ${device}
		fi
	done
}

static_route_add()
{
	if [ ! -f "${STATCONF}" ]; then
		return 0
	fi

	_ifname=$1

	grep "^$_ifname" "${STATCONF}" | while read device args; do
		/sbin/route add -$args
	done
	grep "^any " "${STATCONF}" | while read ignore args ; do
		/sbin/route add -$args
	done
}

static_route_del()
{
	if [ ! -f "${STATCONF}" ]; then
		return 0
	fi

	_ifname=$1

	grep "^$_ifname" "${STATCONF}" | while read device args; do
		/sbin/route delete -$args
	done
# 2005.11.26 I/FΰפΤΤߺ
#  grep "^any " "${STATCONF}" | while read ignore args ; do
#        /sbin/route delete -$args
#  done
}

static_route_conf()
{
	[ -f "${RTCONF}" ] && . ${RTCONF} || return 1

	cp /dev/null ${STATCONF}

	_entno=0
	while [ ${_entno} -le 15 ]; do

		_entry=ENTRY_${_entno}

		_static_route=`eval echo \$\{${_entry}_STATIC_ROUTE\}`
		_dst_mask=`eval echo \$\{${_entry}_STATIC_MASK\}`
		_dst_ip=`eval echo \$\{${_entry}_STATIC_IP\}`
		_wan_entry=`eval echo \$\{${_entry}_STATIC_ROUTE_ENTRY_NAME\}`
		_gw_ip=`eval echo \$\{${_entry}_STATIC_GW_IP\}`
		_hop=`eval echo \$\{${_entry}_STATIC_HOP\}`

		[ -z "$_hop" -o "X$_hop" = "X0" ] && _hop="" || _hop="metric $_hop"

		if [ ! -z "$_dst_ip" ]; then
			case $_static_route in
				ip)
					if [ "X$_dst_mask" = "X32" ]; then
						echo "any host $_dst_ip gw $_gw_ip $_hop" >> ${STATCONF}
					else
						echo "any net  $_dst_ip/$_dst_mask gw $_gw_ip $_hop" >> ${STATCONF}
					fi
					;;
				provider)
					if [ ! -z $_wan_entry ]; then
						case $_wan_entry in
							wan)
								if [ "X$_dst_mask" = "X32" ]; then
									echo "${WANIF} host $_dst_ip $_hop $_real_if" >> ${STATCONF}
								else
									echo "${WANIF} net  $_dst_ip/$_dst_mask $_hop $_real_if" >> ${STATCONF}
								fi
								;;
							dhcp)
								if [ "X$_dst_mask" = "X32" ]; then
									echo "dhcp host $_dst_ip $_hop $_real_if" >> ${STATCONF}
								else
									echo "dhcp net  $_dst_ip/$_dst_mask $_hop $_real_if" >> ${STATCONF}
								fi
								;;
							*)
								if [ -f "${N_TO_REAL_PREFIX}ppp${_wan_entry}" ]; then
									_real_if=`cat ${N_TO_REAL_PREFIX}ppp${_wan_entry}`
									if [ "X$_dst_mask" = "X32" ]; then
										echo "ppp${_wan_entry} host $_dst_ip $_hop $_real_if" >> ${STATCONF}
									else
										echo "ppp${_wan_entry} net  $_dst_ip/$_dst_mask $_hop $_real_if" >> ${STATCONF}
									fi
								fi
								;;
						esac
					fi
					;;
				lan)
					if [ -z "$_static_route" -o -z "$_dst_mask" ]; then
						:
					else
						if [ ! -z "$_gw_ip" ]; then
							if [ "X$_dst_mask" = "X32" ]; then
								echo "${LANIF} host $_dst_ip gw $_gw_ip $_hop" >> ${STATCONF}
							else
								echo "${LANIF} net  $_dst_ip/$_dst_mask gw $_gw_ip $_hop" >> ${STATCONF}
							fi
						else
							if [ "X$_dst_mask" = "X32" ]; then
								echo "${LANIF} host $_dst_ip $_hop ${LANIF}" >> ${STATCONF}
							else
								echo "${LANIF} net  $_dst_ip/$_dst_mask $_hop ${LANIF}" >> ${STATCONF}
							fi
						fi
					fi
					;;
				*)
					;;
			esac
		fi
		_entno=`expr ${_entno} + 1`
	done
}

#
# ex.)
# iptables -A PREROUTING -i eth1 -t mangle -p tcp --dport 80 -j MARK --set-mark 2
# iptables -A PREROUTING -i eth1 -t mangle -p udp --dport 80 -j MARK --set-mark 2
#
# ip route add 0/0 dev ppp0 table 1
# ip rule add from 192.168.1.12 table 1
#
policy_route_conf()
{
	for _pppno in 0 1 2 3 4; do
	#ˤpppoeѤΥȥ򡢺
	# _entno: 0/1/2/3/4
		for _batch_f in ${POLICYCONF}.set.${_pppno}.*; do
			[ -f "${_batch_f}" ] && rm -f "${_batch_f}"
		done
	done
	for _route in ip wan; do
	#ˤip/wanѤΥȥ򡢺
		for _batch_f in ${POLICYCONF}.set.${_route}.*; do
			[ -f "${_batch_f}" ] && rm -f "${_batch_f}"
		done
	done

	[ -f "${RTCONF}" ] && . ${RTCONF} || return 1
	[ -f "${POLCONF}" ] && . ${POLCONF} || return 1


	routing_syslog_debug "policy route conf start"
	cp /dev/null ${POLICYCONF}
	echo "#!/bin/sh" >> ${POLICYCONF}
	echo "# auto generate" >> ${POLICYCONF}
	echo "RETVAL=0" >> ${POLICYCONF}
	echo "case \$1 in"  >> ${POLICYCONF}
	echo "add)"  >> ${POLICYCONF}
	echo "  IPROUTEOPT=add"  >> ${POLICYCONF}
	echo "  IPTABLESOPT=-A"  >> ${POLICYCONF}
	echo "  ;;"  >> ${POLICYCONF}
	echo "del)"  >> ${POLICYCONF}
	echo "  IPROUTEOPT=del"  >> ${POLICYCONF}
	echo "  IPTABLESOPT=-D"  >> ${POLICYCONF}
	echo "  ;;"  >> ${POLICYCONF}
	echo "*)"  >> ${POLICYCONF}
	echo "  RETVAL=1" >> ${POLICYCONF}
	echo "  ;;"  >> ${POLICYCONF}
	echo "esac"  >> ${POLICYCONF}
	echo "if [ \"X\$RETVAL\" = \"X1\" ]; then exit 0; fi" >> ${POLICYCONF}

	_entno=0
	_shell_head=0
	while [ ${_entno} -le 15 ]; do

		_entry=ENTRY_POLICY_${_entno}
		_tblno=`expr $_entno + 1`
		_tblno=`expr $_tblno \* 10`

		_pol_rule_opt=""
		_pol_dst_ip=`eval echo \$\{${_entry}_POLICY_DST_IP\}`
		_pol_src_ip=`eval echo \$\{${_entry}_POLICY_SRC_IP\}`
		_pol_port=`eval echo \$\{${_entry}_POLICY_PORT\}`
		_pol_route=`eval echo \$\{${_entry}_POLICY_ROUTE\}`
		_pol_route_entry_name=`eval echo \$\{${_entry}_POLICY_ROUTE_ENTRY_NAME\}`
		_pol_gw_ip=`eval echo \$\{${_entry}_POLICY_GW_IP\}`
		_pol_hop=`eval echo \$\{${_entry}_POLICY_HOP\}`

		routing_syslog_debug "policy: $_pol_route"

		if [ "X$_pol_src_ip" != "X" ]; then
			_pol_rule_opt="from $_pol_src_ip"
		fi
		if [ "X$_pol_dst_ip" != "X" ]; then
			_pol_rule_opt="$_pol_rule_opt to $_pol_src_ip"
		fi

		case $_pol_route in
			ip)
				_pol_opt_tcp=""
				_pol_opt_udp=""
				_pol_opt_src=""
				_pol_opt_dst=""

				if [ "X$_pol_port" != "X" ]; then
					_pol_opt_tcp="-p tcp --dport $_pol_port"
					_pol_opt_udp="-p udp --dport $_pol_port"
				fi
				if [ "X$_pol_src_ip" != "X" ]; then
					_pol_opt_src="-s $_pol_src_ip"
				fi
				if [ "X$_pol_dst_ip" != "X" ]; then
					_pol_opt_dst="-d $_pol_dst_ip"
				fi

				_pol_tbl=${_tblno}
				_pol_mark=0x${_tblno}
				_add_iptables_cmd="iptables -A PREROUTING -t mangle -i eth1"
				_del_iptables_cmd="iptables -D PREROUTING -t mangle -i eth1"


				#Хå
				# ե̾: ${POLICYCONF}.set.0.0
				# $1: idle/start/stop
				# $2: real ifname
				_batch_f=${POLICYCONF}.set.${_pol_route}.${_entno}
				echo "#!/bin/sh" > ${_batch_f}
				echo "# \$1:add/del" >> ${_batch_f}
				echo "#" >> ${_batch_f}

				echo "case \$1 in" >> ${_batch_f}
				echo "add)"       >> ${_batch_f}
				if [ "X$_pol_port" != "X" ]; then
	     #MARK
					echo "  ${_add_iptables_cmd} ${_pol_opt_src} ${_pol_opt_dst} ${_pol_opt_tcp} -j MARK --set-mark ${_pol_mark}" >> ${_batch_f}
					echo "  ${_add_iptables_cmd} ${_pol_opt_src} ${_pol_opt_dst} ${_pol_opt_udp} -j MARK --set-mark ${_pol_mark}" >> ${_batch_f}

				else
					echo "${_add_iptables_cmd} ${_pol_opt_src} ${_pol_opt_dst} -j MARK --set-mark ${_pol_mark}" >> ${_batch_f}
				fi

				echo "  ip rule add fwmark ${_pol_mark} pref ${_pol_tbl} table ${_pol_tbl}" >> ${_batch_f}
				echo "  ip route add default via $_pol_gw_ip table ${_pol_tbl}" >> ${_batch_f}
				echo "  ;;"				>> ${_batch_f}
				echo "del)"				>> ${_batch_f}
				if [ "X$_pol_port" != "X" ]; then
	     #MARK
					echo "  ${_del_iptables_cmd} ${_pol_opt_src} ${_pol_opt_dst} ${_pol_opt_tcp} -j MARK --set-mark ${_pol_mark}" >> ${_batch_f}
					echo "  ${_del_iptables_cmd} ${_pol_opt_src} ${_pol_opt_dst} ${_pol_opt_udp} -j MARK --set-mark ${_pol_mark}" >> ${_batch_f}

				else
					echo "${_del_iptables_cmd} ${_pol_opt_src} ${_pol_opt_dst} -j MARK --set-mark ${_pol_mark}" >> ${_batch_f}
				fi

				echo "  ip rule del fwmark ${_pol_mark} pref ${_pol_tbl} table ${_pol_tbl}" >> ${_batch_f}
				echo "  ip route del default via $_pol_gw_ip table ${_pol_tbl}" >> ${_batch_f}
				echo "  ;;"				>> ${_batch_f}

				echo "esac"				>> ${_batch_f}
				echo "ip route flush cache"		>> ${_batch_f}

				;;
			provider)
				case $_pol_route_entry_name in
					wan|dhcp)
						_pol_opt_tcp=""
						_pol_opt_udp=""
						_pol_opt_src=""
						_pol_opt_dst=""

						if [ "X$_pol_port" != "X" ]; then
							_pol_opt_tcp="-p tcp --dport $_pol_port"
							_pol_opt_udp="-p udp --dport $_pol_port"
						fi
						if [ "X$_pol_src_ip" != "X" ]; then
							_pol_opt_src="-s $_pol_src_ip"
						fi
						if [ "X$_pol_dst_ip" != "X" ]; then
							_pol_opt_dst="-d $_pol_dst_ip"
						fi

						_pol_tbl=${_tblno}
						_pol_mark=0x${_tblno}
						_add_iptables_cmd="iptables -A PREROUTING -t mangle -i eth1"
						_del_iptables_cmd="iptables -D PREROUTING -t mangle -i eth1"


						#Хå
						# ե̾: ${POLICYCONF}.set.0.0
						# $1: idle/start/stop
						# $2: real ifname
						_batch_f=${POLICYCONF}.set.${_pol_route_entry_name}.${_entno}
						echo "#!/bin/sh" > ${_batch_f}
						echo "# \$1:add/del" >> ${_batch_f}
						echo "#" >> ${_batch_f}

						echo "case \$1 in" >> ${_batch_f}
						echo "add)"       >> ${_batch_f}
						if [ "X$_pol_port" != "X" ]; then
							#MARK
							echo "  ${_add_iptables_cmd} ${_pol_opt_src} ${_pol_opt_dst} ${_pol_opt_tcp} -j MARK --set-mark ${_pol_mark}" >> ${_batch_f}
							echo "  ${_add_iptables_cmd} ${_pol_opt_src} ${_pol_opt_dst} ${_pol_opt_udp} -j MARK --set-mark ${_pol_mark}" >> ${_batch_f}

						else
							echo "${_add_iptables_cmd} ${_pol_opt_src} ${_pol_opt_dst} -j MARK --set-mark ${_pol_mark}" >> ${_batch_f}
						fi

						echo "  ip rule add fwmark ${_pol_mark} pref ${_pol_tbl} table ${_pol_tbl}" >> ${_batch_f}
						echo "  ip route add default dev ${WANIF} table ${_pol_tbl}" >> ${_batch_f}
						echo "  ;;"				>> ${_batch_f}
						echo "del)"				>> ${_batch_f}
						if [ "X$_pol_port" != "X" ]; then
							#MARK
							echo "  ${_del_iptables_cmd} ${_pol_opt_src} ${_pol_opt_dst} ${_pol_opt_tcp} -j MARK --set-mark ${_pol_mark}" >> ${_batch_f}
							echo "  ${_del_iptables_cmd} ${_pol_opt_src} ${_pol_opt_dst} ${_pol_opt_udp} -j MARK --set-mark ${_pol_mark}" >> ${_batch_f}

						else
							echo "${_del_iptables_cmd} ${_pol_opt_src} ${_pol_opt_dst} -j MARK --set-mark ${_pol_mark}" >> ${_batch_f}
						fi

						echo "  ip rule del fwmark ${_pol_mark} pref ${_pol_tbl} table ${_pol_tbl}" >> ${_batch_f}
						echo "  ip route del default via $_pol_gw_ip table ${_pol_tbl}" >> ${_batch_f}
						echo "  ;;"				>> ${_batch_f}

						echo "esac"				>> ${_batch_f}
						echo "ip route flush cache"		>> ${_batch_f}

						;;
					0|1|2|3|4)
						_pol_opt_tcp=""
						_pol_opt_udp=""
						_pol_opt_src=""
						_pol_opt_dst=""

						if [ "X$_pol_port" != "X" ]; then
							_pol_opt_tcp="-p tcp --dport $_pol_port"
							_pol_opt_udp="-p udp --dport $_pol_port"
						fi
						if [ "X$_pol_src_ip" != "X" ]; then
							_pol_opt_src="-s $_pol_src_ip"
						fi
						if [ "X$_pol_dst_ip" != "X" ]; then
							_pol_opt_dst="-d $_pol_dst_ip"
						fi

						_pol_tbl=${_tblno}
						_pol_mark=0x${_tblno}
						_add_iptables_cmd="iptables -A PREROUTING -t mangle -i eth1"
						_del_iptables_cmd="iptables -D PREROUTING -t mangle -i eth1"


	   #Хå
	   # ե̾: ${POLICYCONF}.set.0.0
	   # $1: idle/start/stop
	   # $2: real ifname
						_batch_f=${POLICYCONF}.set.${_pol_route_entry_name}.${_entno}
						echo "#!/bin/sh" > ${_batch_f}
						echo "# \$1:idle/start/stop" >> ${_batch_f}
						echo "# \$2:real ifname" >> ${_batch_f}

						echo "case \$1 in" >> ${_batch_f}
						echo "idle)"       >> ${_batch_f}

						if [ "X$_pol_port" != "X" ]; then
	     #MARK
							echo "  ${_add_iptables_cmd} ${_pol_opt_src} ${_pol_opt_dst} ${_pol_opt_tcp} -j MARK --set-mark ${_pol_mark}" >> ${_batch_f}
							echo "  ${_add_iptables_cmd} ${_pol_opt_src} ${_pol_opt_dst} ${_pol_opt_udp} -j MARK --set-mark ${_pol_mark}" >> ${_batch_f}

						else
							echo "${_add_iptables_cmd} ${_pol_opt_src} ${_pol_opt_dst} -j MARK --set-mark ${_pol_mark}" >> ${_batch_f}
						fi
						echo "  ip rule add fwmark ${_pol_mark} unreachable pref ${_pol_tbl} table ${_pol_tbl}" >> ${_batch_f}
						echo "  ;;"				>> ${_batch_f}
						echo "stop)"				>> ${_batch_f}
	           #Ǥ
						echo "  ip rule del fwmark ${_pol_mark} pref ${_pol_tbl} table ${_pol_tbl}" >> ${_batch_f}
						echo "  ip rule add fwmark ${_pol_mark} unreachable pref ${_pol_tbl} table ${_pol_tbl}" >> ${_batch_f}
						echo "  ip route del default dev \$2 table ${_pol_tbl}" >> ${_batch_f}
						echo "  ;;"				>> ${_batch_f}
						echo "start)"			>> ${_batch_f}
	           #Ǥ
						echo "  ip rule del fwmark ${_pol_mark} unreachable pref ${_pol_tbl} table ${_pol_tbl}" >> ${_batch_f}
						echo "  ip rule add fwmark ${_pol_mark} pref ${_pol_tbl} table ${_pol_tbl}" >> ${_batch_f}
						echo "  ip route add default dev \$2 table ${_pol_tbl}" >> ${_batch_f}
						echo "  ;;"				>> ${_batch_f}
						echo "esac"				>> ${_batch_f}
						echo "ip route flush cache"		>> ${_batch_f}

						;;
				esac
				;;
			*)
				;;
		esac

		_entno=`expr ${_entno} + 1`
	done
}

#
# Τߵư
#
policy_route_init()
{
	for i in 0 1 2 3 4; do
		for _batch_f in ${POLICYCONF}.set.${i}.*; do
			if [ -f "$_batch_f" ]; then
				/bin/sh "$_batch_f" idle
			fi
		done
	done
}

policy_route_add()
{
	for _batch_f in ${POLICYCONF}.set.ip.*; do
		if [ -f "$_batch_f" ]; then
			/bin/sh "$_batch_f" add
		fi
	done
	for _batch_f in ${POLICYCONF}.set.wan.*; do
		if [ -f "$_batch_f" ]; then
			/bin/sh "$_batch_f" add
		fi
	done
}
policy_route_del()
{
	for _batch_f in ${POLICYCONF}.set.ip.*; do
		if [ -f "$_batch_f" ]; then
			/bin/sh "$_batch_f" del
		fi
	done
	for _batch_f in ${POLICYCONF}.set.wan.*; do
		if [ -f "$_batch_f" ]; then
			/bin/sh "$_batch_f" del
		fi
	done
}

#
# $1: entry ifname
# $2: real ifname
policy_route_add_ppp()
{
	for _batch_f in ${POLICYCONF}.set.${1#ppp}.*; do
		if [ -f "$_batch_f" ]; then
			/bin/sh "$_batch_f" start ${2}
		fi
	done
}
#
# $1: entry ifname
# $2: real ifname
policy_route_del_ppp()
{
	for _batch_f in ${POLICYCONF}.set.${1#ppp}.*; do
		if [ -f "$_batch_f" ]; then
			/bin/sh "$_batch_f" stop ${2}
		fi
	done
}

rip_info()
{
	[ -f ${RIPTBL} ] && . ${RIPTBL} || return 0
	if [ "X$dynamic_route" = "Xon" ]; then
		if [ "X$routing_info" = "Xon" ]; then
			#_routed_opt="-s"
			_routed_opt="-g -s"
		else
			_routed_opt="-q"
		fi

		if [ -f /var/lock/subsys/routed ]; then
			/etc/rc.d/init.d/routed stop
			/usr/sbin/routed $_routed_opt
		else
			iptables -I OUTPUT -o ppp+ -p udp --dport 520 -j DROP
			/usr/sbin/routed $_routed_opt
		fi
		touch /var/lock/subsys/routed
		routing_syslog "routed start"
	else
		if [ -f /var/lock/subsys/routed ]; then
			/etc/rc.d/init.d/routed stop
			iptables -D OUTPUT -o ppp+ -p udp --dport 520 -j DROP
			routing_syslog "routed stop"
		fi
	fi
}

routing_syslog "_spec:$_spec"
_spec=$1
case $_spec in
	default)
		;;
	static_add)
		static_route_conf
		static_route_add $2
		;;
	static_del)
		static_route_del $2
		;;
	conf)
		create_conf
		static_route_conf
		policy_route_conf
		;;
	boot)
		create_conf
		default_route_set
		static_route_conf
		static_route_add ${LANIF}
		# 2005.02.27 S2ѹ
		#2004.06.17
		#  static_route_alladd
		static_route_alladd_S2
		policy_route_conf
		policy_route_init
		policy_route_add
		rip_info
		;;
	policy_conf)
		# for debug
		policy_route_conf
		;;
	policy_add)
		policy_route_add
		;;
	policy_del)
		policy_route_del
		;;
	policy_add_ppp)
		# PPPoE
		# $2: entry ifname
		# $3: real ifname
		policy_route_add_ppp $2 $3
		;;
	policy_del_ppp)
		# PPPoE
		# $2: entry ifname
		# $3: real ifname
		policy_route_del_ppp $2 $3
		;;
	*)
		policy_route_del
		static_route_alldel
		create_conf
		default_route_set
		static_route_conf

		# 2005.02.27 S2ѹ
		#static_route_alladd
		static_route_alladd_S2

		policy_route_conf
		policy_route_add
		rip_info
		;;
esac

exit 0
