#!/bin/sh
#
#

[ "X${X7DBG}" = "Xon" ] && set -x

CMDBAT=$0
ROUTING_BAT_VERSION=2004032801
LOG_DEBUG="logger -p kern.debug -t $CMDBAT "
LOG_INFO="logger -p kern.info -t $CMDBAT "

. /etc/sysconfig/network-scripts/network-functions

#DBG_LOCAL=1
if [ -z "${DBG_LOCAL}" ]; then
	RTWEBDIR=/etc/ibsbat/Router/routing
	RTDIR=/etc/ibsbat/routing
else
	RTWEBDIR=/home/ibsuser/work/routing
	RTDIR=/home/ibsuser/work/routing
fi

DEFTBL=${RTWEBDIR}/default_route.txt
POLTBL=${RTWEBDIR}/policy_table.txt
RIPTBL=${RTWEBDIR}/rip.txt
STATTBL=${RTWEBDIR}/static_table.txt


LANIF=eth1
WANIF=eth0


syslog_info()
{
	if [ "X$1" = "X1" ]; then
		${LOG_INFO} "default route change"
	fi
}

delete_default()
{
	if check_default_route ; then
		/sbin/ip route del default
	fi
}


if [ -f "${DEFTBL}" ]; then
	. ${DEFTBL}
else
	exit 1
fi

case $default_route in
	provider)
		${LOG_DEBUG} "default_route:$default_route"
		;;
	wan)
		gw_ip=""
		gw_dev=${WANIF}

		${LOG_DEBUG} "default_route:$default_route gw_dev:$gw_dev"

		if [ -z "${DBG_LOCAL}" ]; then
			delete_default
			route add default $gw_dev
			syslog_info
		else
			echo "route add default $gw_dev"
		fi
		;;
	dhcp)
		gw_ip=""
		gw_dev=${WANIF}

		${LOG_DEBUG} "default_route:$default_route gw_dev:$gw_dev"

		if [ -z "${DBG_LOCAL}" ]; then
			delete_default
			route add default $gw_dev
			syslog_info
		else
			echo "route add default $gw_dev"
		fi
		;;
	ip)
		gw_ip=$default_route_ipaddress
		hop=$default_route_hop
		gw_dev=""

		${LOG_DEBUG} "default_route:$default_route gw_ip:$gw_ip"

		if [ -z "$hop" ]; then
			if [ -z "${DBG_LOCAL}" ]; then
				delete_default
				route add default gw $gw_ip
				syslog_info
			else
				echo "route add default gw $gw_ip"
			fi
		else
			if [ -z "${DBG_LOCAL}" ]; then
				delete_default
				route add default gw $gw_ip metric $hop
				syslog_info
			else
				echo "route add default gw $gw_ip metric $hop"
			fi
		fi
		;;
	*)
		;;
esac

