#!/bin/sh
#
# SIPФΥۥ̾IPɥ쥹ΥڥϿ
#  IPɥ쥹ϰϥåϻ˹Ԥȡ
#
#  $1: add/del/alldel
#  $2: ipaddress (xxx.xxx.xxx.xxxʸ)
#  $3: hostname
#
# 2004.03.13
#
TOP=
HOSTS=${TOP}/etc/hosts
HOSTS_TMP=${TOP}/etc/hosts.sip
HOSTS_LOCK=${TOP}/etc/hosts.ibs-soho.lock
HOSTS_LOCK_SYM=${TOP}/etc/hosts.ibs-soho.lock.sym
HOSTS_SIP_KEY="#ibs-soho sip server"
SPEC=$1
IP=$2
HN=$3
OKCODE=0
ERRCODE=1
RM="rm -f"
MOVE="mv -f"
RETRY=0

LOCK_SLEEP=1
LOCK_TOUT=20

umask 022

trap_init()
{
 trap "rm -f ${HOSTS_TMP};rm -f ${HOSTS_LOCK_SYM};exit 1"   1 2 3 9 15
}

lock()
{
  until ln -s ${HOSTS_LOCK} ${HOSTS_LOCK_SYM} 2>&- ; do
   if [ "$RETRY" -gt "${LOCK_TOUT}" ] ; then
      ${RM} ${HOSTS_LOCK_SYM}
      return ${ERRCODE}
   fi
   RETRY=`expr $RETRY + 1`
   sleep ${LOCK_SLEEP}
  done
  return ${OKCODE}
}

unlock()
{
  #echo "wait..."
  #sleep 2
  ${RM} ${HOSTS_LOCK_SYM}
  #echo "done."
}

move_host()
{
  ${MOVE} ${HOSTS_TMP} ${HOSTS}
#  chmod 644 ${HOSTS}
}

check_entry()
{
  cat ${HOSTS} | \
	awk -v _ip="${IP}" -v _host="${HN}" \
	'{ if ( $1 != _ip && $2 != _host ) { printf"%s %s\n",$1,$2} }' > ${HOSTS_TMP}
  RETVAL=$?
  return $RETVAL
}

check_ip()
{
  IP=`echo ${IP} | awk -F"." '{printf"%d.%d.%d.%d",$1,$2,$3,$4}'`
  RETVAL=$?
#  echo $_ip
  return $RETVAL
}


sip_alldel()
{
  check_ip
  check_entry

  cat ${HOSTS} | grep -v "${HOSTS_SIP_KEY}" > ${HOSTS_TMP}
  move_host
}

sip_add()
{
  check_ip
  check_entry

  echo "${IP} ${HN}  ${HOSTS_SIP_KEY}" >> ${HOSTS_TMP}
  move_host
}
sip_del()
{
  check_ip
  check_entry
  move_host
}
####################
trap_init
lock
if [ $? != 0 ]; then
   exit $?
fi

RETVAL=0

case ${SPEC} in
alldel)
  echo "alldel"
  sip_alldel
  ;;
add)
  echo "add"
  if [ -z "$2" -o -z "$3" ]; then
    exit ${ERRCODE}
  fi
  sip_add
  ;;
del)
  echo "del"
  if [ -z "$2" -o -z "$3" ]; then
    exit ${ERRCODE}
  fi
  sip_del
  ;;
*)
  RETVAL=${ERRCODE}
  ;;
esac

unlock
exit $RETVAL