#!/bin/sh
#
# $B%?!<%2%C%HMQ(B
#  savelist_app$B$NFbMF$rJ]B8(B

. /etc/ibsbat/ibs.subr
. /etc/ibsbat/ibsflash.conf

#TAR=/usr/local/bin/tar
#TAROPT_W="--block-compress -c -z -b 128 -f"

#LIST0=/etc/ibsbat/savelist1
#LIST1=/etc/ibsbat/savelist2
#LIST2=/etc/ibsbat/savelist_app

#DDOPT="bs=64k"
#DEST=/dev/flash9

#ARCH=`uname -m`
#if [ "X${ARCH}" != "Xppcibs" ];then
#    exit 0
#fi

target_app_syslog()
{
	echo "${1}"
	logger -p kern.info -t target_app "${1}"
}

# 2005.04.08 tar$B%U%!%$%k$N%A%'%C%/(B
target_app_check_pgsql()
{
	PGSQL_NG=0

	if [ -f ${TAR_PGSQL} ]; then
		tar tzf ${TAR_PGSQL} > /dev/null 2>&1
		if [ $? != 0 ]; then
			echo                "appchk:PostgreSQL DB(${TAR_PGSQL}) is NG (not archive file)"
			logger -p kern.info "appchk:PostgreSQL DB(${TAR_PGSQL}) is NG (not archive file)"
			PGSQL_NG=1
		else
			echo                "appchk:PostgreSQL DB(${TAR_PGSQL}) is OK (archive file)"
			logger -p kern.info "appchk:PostgreSQL DB(${TAR_PGSQL}) is OK (archive file)"
		fi
		
		if [ "X${PGSQL_NG}" = "X0" -a -f ${MD5_PGSQL} ]; then
			(cd ${DATA_DIR}; cat ${MD5_PGSQL} | md5sum -c )
			if [ $? = 0 ]; then
				_decomp_pgsql=${TAR_PGSQL}
				echo                "appchk:PostgreSQL DB(${TAR_PGSQL}) is md5 OK"
				logger -p kern.info "appchk:PostgreSQL DB(${TAR_PGSQL}) is md5 OK"
			else
				echo                "appchk:PostgreSQL DB(${TAR_PGSQL}) is md5 NG"
				logger -p kern.info "appchk:PostgreSQL DB(${TAR_PGSQL}) is md5 NG"
				PGSQL_NG=1
			fi
		elif [ "X${PGSQL_NG}" = "X0" ]; then
			_decomp_pgsql=${TAR_PGSQL}
		fi
	else
		PGSQL_NG=1
	fi
	
	if [ "X${PGSQL_NG}" = "X0" ]; then
		return 0
	else
		return 1
	fi
}

# 2006.04.04
# pgsql$B$,Dd;_$7$F$$$k$3$H(B
save_dbsave()
{
	#  2006.04.04 sumi dbsave Try.
	__dbsave_rc=1
	target_app_syslog  "Trying dbsve..."
	if [ -x /etc/ibsbat/pgsql/dbsave.bat ]; then
		/etc/ibsbat/pgsql/dbsave.bat
		__dbsave_rc=$?
		if [ $__dbsave_rc = 0 ]; then
			target_app_syslog  "done."

			target_app_syslog "removing ${PGSQL_BK_DONE_PREFIX} ${PGSQL_BK_PG_PREFIX} ${PGSQL_BK_PREFIX}"
			#$B@.8y$G$"$l$P!"(BFLASH$B$N99?7%U%!%$%k$O:o=|(B
			rm -f ${PGSQL_FTOP}/${PGSQL_BK_DONE_PREFIX}*
			rm -f ${PGSQL_FTOP}/${PGSQL_BK_PG_PREFIX}*
			rm -f ${PGSQL_FTOP}/${PGSQL_BK_PREFIX}*

			#$B0JA0$N;D$j(B
			rm -f /mnt/usr/BACKUP/pgdump/*
			rm -fr /mnt/usr/BACKUP/pgdump

		else
			target_app_syslog "error."
		fi
	fi
	return $__dbsave_rc
}

last_pgdata()
{
	local _pgdata_rc=0
	[ -f ${LAST_PGSTAT} ] && pg_stat=`cat ${LAST_PGSTAT}` || pg_stat=0
	echo "100" > ${LAST_PGSTAT}
	[ -f ${LAST_PGDATA} ] && last_path=`cat ${LAST_PGDATA}` || last_path=/mnt/IBS
	#[ -f "${last_path}" ] && pg_path=`cat ${last_path}`
	target_app_syslog "100: $pg_stat $last_path"

	case ${last_path} in
		/mnt/IBS)
			[ "X$pg_stat" = "XOK" ] && next_path=/mnt/usr || next_path=/mnt/IBS
			;;
		/mnt/usr)
			[ "X$pg_stat" = "XOK" ] && next_path=/mnt/IBS || next_path=/mnt/usr
			;;
		*)
			next_path=/mnt/IBS
			;;
	esac

	TAR_PGSQL=${next_path}/pgsql_data.tar.gz
	MD5_PGSQL=${next_path}/md5.pgsql
	target_app_syslog "TAR_PGSQL:${TAR_PGSQL}  MD5_PGSQL:${MD5_PGSQL}"
	
	tar czf /tmp/pgsql_data.tar.gz -C /var `cat ${IBSFLASH_DATA_LIST_LINUX}` > /dev/null 2>&1
	(cd /tmp; md5sum pgsql_data.tar.gz > md5.pgsql)
	echo "200" > ${LAST_PGSTAT}
	target_app_syslog "200"

	# 2006.05.02
	flash_sizecheck /tmp/pgsql_data.tar.gz ${next_path}
	if [ $? = 0 ]; then
		target_app_syslog "Copying /tmp to ${TAR_PGSQL}"
		cp /tmp/pgsql_data.tar.gz ${TAR_PGSQL}
		cp /tmp/md5.pgsql ${MD5_PGSQL}
		#md5sum ${TAR_PGSQL} > ${MD5_PGSQL}

		(cd ${next_path}; cat ${MD5_PGSQL} | md5sum -c )
		_pgdata_rc=0
	else
		#target_app_syslog "Trying dbsave."
		#save_dbsave
		_pgdata_rc=$?
	fi
	if [ "$_pgdata_rc" != 0 ]; then
		target_app_syslog "pgsql_data save failure!!"
	else
		target_app_syslog "pgsql_data save success!!"
	fi

	[ -f ${LAST_PGDATA} ] && mv ${LAST_PGDATA} ${LAST_PGDATA}.old
	echo "${next_path}" > ${LAST_PGDATA}
	echo "OK" > ${LAST_PGSTAT}
	rm -f /tmp/pgsql_data.tar.gz
	rm -f /tmp/md5.pgsql
	target_app_syslog "done."
}

# 2006.05.02
# $1: $B%3%T!<$9$k(Bpgsql_data.tar.gz$B$N%Q%9(B
# $2: $B%3%T!<@h$N%^%&%s%H%]%$%s%H(B
flash_sizecheck()
{
	local _tmp_path=$1
	local _tmp_size=0
	local _fl_mnt=$2
	local _fl_avail=0
	local _fl_pgsize=0
	if [ -n "$_tmp_path" -a -f "$_tmp_path" ]; then
		_tmp_size=`ls -l $_tmp_path | awk '{printf"%s\n",$5}'`
		target_app_syslog "$_tmp_path size is $_tmp_size"
	fi
	if [ -n "$_fl_mnt" ]; then
		_fl_avail=`df $_fl_mnt | sed -n '2p' | awk '{printf"%s\n",$4}'`
	fi
	if [ -n "$_tmp_size" -a -n "$_fl_avail" -a "X$_tmp_size" != "X0" -a "X$_fl_avail" != "X0" ]; then
		_fl_pgsize=`ls -l ${_fl_mnt}/pgsql_data.tar.gz | awk '{printf"%s\n",$5}'`
		_fl_avail=$(( $_fl_avail * 1000 + $_fl_pgsize ))
		if [ $_tmp_size -lt $_fl_avail ]; then
			target_app_syslog "$_fl_mnt is enough space."
			return 0
		else
			target_app_syslog "$_fl_mnt is not enough space."
			return 1
		fi
	else
		target_app_syslog "$_tmp_path or $_fl_mnt is illegal."
		return 1
	fi
}

##############################
if ! check_ppcibs ; then
	exit 0
fi

# for NetBSD
if ostype_is_netbsd ; then
	cd /
	${TAR} ${TAROPT_W} - `cat ${IBSFLASH_APP_LIST}` | dd of=${IBSFLASH_APP_DEST} ${IBSFLASH_APP_DDOPT}
fi

# for Linux
if ostype_is_linux ; then


	# 2004.05.24 pgsql_restore.bat$B$+$i$N8F=P;~$O@)8f$7$J$$(B
	if [ ! -f /tmp/pgsql_bk_restore_execute ]; then
		led_info_inter
	fi
	flash_rw_mount
	flash_rw_mount_usr

	# 2006.04.04 sumi
	__args=$1
	if [ -n "$__args" -a "$__args" = "dbsave" ]; then
		save_dbsave
	else
		# 2006.04.23
		if [ -f "${LAST_PGDATA}" ]; then
			last_pgdata
		else
			local _pgdata_rc=0

			# 2005.04.08 tar$B%U%!%$%k$N%A%'%C%/(B
			target_app_check_pgsql
			if [ $? = 0 -a -f "${TAR_PGSQL}" ]; then
				target_app_syslog "Moving ${TAR_PGSQL} to ${TAR_PGSQL_BAK}... "
				mv ${TAR_PGSQL} ${TAR_PGSQL_BAK}
			#  mv ${MD5_PGSQL} ${MD5_PGSQL_BAK}
				target_app_syslog "done."
			fi

			if [ -f "${MD5_PGSQL}" ]; then
				cat ${MD5_PGSQL} | awk -v pgpath=${TAR_PGSQL_BAK} '{printf"%s  %s\n",$1,pgpath}' > ${MD5_PGSQL_BAK}
			fi
			if [ -f "${TAR_PGSQL}.bak" ]; then rm -f ${TAR_PGSQL}.bak; fi

			# 2006.04.17
			target_app_syslog "Archiving ${TAR_PGSQL}... "
			#tar czf ${TAR_PGSQL} -C /var `cat ${IBSFLASH_DATA_LIST_LINUX}` > /dev/null 2>&1
			tar czf /tmp/pgsql_tmp.tar.gz -C /var `cat ${IBSFLASH_DATA_LIST_LINUX}` > /dev/null 2>&1
			target_app_syslog "done."

			flash_sizecheck /tmp/pgsql_tmp.tar.gz ${TAR_PGSQL%/pgsql_datar.tar.gz}
			if [ $? = 0 ]; then
				target_app_syslog "Copying /tmp to ${TAR_PGSQL}"
				cp /tmp/pgsql_tmp.tar.gz ${TAR_PGSQL}
				md5sum ${TAR_PGSQL} > ${MD5_PGSQL}
				target_app_syslog "done."
				_pgdata_rc=0
			else
				#target_app_syslog "Trying dbsave."
				#save_dbsave
				_pgdata_rc=$?
			fi
			if [ "$_pgdata_rc" != 0 ]; then
				target_app_syslog "pgsql_data save failure!!"
			else
				target_app_syslog "pgsql_data save success!!"
			fi
			rm -fr /tmp/pgsql_tmp.tar.gz
		# 2006.04.23 $B$3$3$^$G(B
		fi

		target_app_syslog "removing ${PGSQL_BK_DONE_PREFIX} ${PGSQL_BK_PG_PREFIX} ${PGSQL_BK_PREFIX}"
		#$B@.8y$G$"$l$P!"(BFLASH$B$N99?7%U%!%$%k$O:o=|(B
		rm -f ${PGSQL_FTOP}/${PGSQL_BK_DONE_PREFIX}*
		rm -f ${PGSQL_FTOP}/${PGSQL_BK_PG_PREFIX}*
		rm -f ${PGSQL_FTOP}/${PGSQL_BK_PREFIX}*

		# S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/S2/
		# 2005.02.22
		rm -f ${PGSQL_FTOP}/dbsave.gz

		#$B0JA0$N;D$j(B
		rm -f /mnt/usr/BACKUP/pgdump/*
		rm -fr /mnt/usr/BACKUP/pgdump
	fi
	# 2006.04.04 sumi $B$3$3$^$G(B

	sync
	flash_ro_mount_usr
	flash_ro_mount
	# 2004.05.24 pgsql_restore.bat$B$+$i$N8F=P;~$O@)8f$7$J$$(B
	if [ ! -f /tmp/pgsql_bk_restore_execute ]; then
		led_info_off
	fi
fi
