#!/bin/sh
#
# upload.bat
# args:
#   $1: type
#   $2: file
#   $3: debug    /tmp$B$K%5%$%:(B0$B$N%U%!%$%k$r:n$k(B
# 
#

. /etc/ibsbat/ibs.subr
. /etc/ibsbat/ibsflash.conf

CMDBAT=`basename $0`
RETVAL=0
TMPDIR=/tmp
UP_LIST=/tmp/file.lst

GWMAIN=x7000gw.main
GWH8=x7000gw.h8

upload_syslog()
{
	logger -p kern.info -t $CMDBAT $1
}

#
# $1: start/stop
upload_ftpd()
{
	case $1 in
		stop)
			mv /etc/inetd.conf /etc/inetd.conf.upload
			cp /etc/ibsbat/upload/inetd.conf.noftp /etc/inetd.conf
			/etc/rc.d/init.d/inet restart > /dev/null 2>&1
			_psline=`ps ax|grep ftpd |grep -v grep | awk '{printf"%s ",$1}'`
			if [ "X$_psline" != "X" ]; then
				for _pid in $_psline; do
					kill -9 $_pid
				done
				sleep 1
			fi
			;;
		start)
			mv /etc/inetd.conf.upload /etc/inetd.conf
			_ftpent=`grep "^ftp" /etc/inetd.conf`
			if [ "X$_ftpent" = "X" ]; then
				echo "ftp	stream	tcp	nowait	root	/usr/sbin/tcpd	ftpd" >> /etc/inetd.conf
			fi
			/etc/rc.d/init.d/inet restart > /dev/null 2>&1
			;;
		*)
			;;
	esac
}

# IBSEXE
#

#
# create tar(ibsexe.tar.gz) to cram
#  $1: file(ibsexe.tar.gz)
upload_ibsexe_mkcram()
{
	_sfile=$1
	_cramdir=/tmp/ibsexecram
	_cramdir2nd=/ibsexecram
	if [ ! -d $_cramdir ]; then
		mkdir $_cramdir
	fi

	tar xzpf $_sfile -C ${_cramdir}
	if [ $? = 0 ]; then
		if [ ! -d ${_cramdir}/exe ]; then
			upload_syslog "ibsexe mkcram: not found exe directory"
			rm -fr $_cramdir
			return 1
		fi

		(cd /tmp; mkcramfs ibsexecram/exe ${TAR_IBSEXE_UP} )
		if [ $? = 0 ]; then
			upload_syslog "ibsexe mkcram: create ok $_cramdir to ${TAR_IBSEXE_UP}"
			rm -fr $_cramdir
      # /tmp/ibsexe.tar.gz$B$N:o=|(B
			rm -f $_sfile
			return 0
		else
			upload_syslog "ibsexe mkcram: create ng $_cramdir to ${TAR_IBSEXE_UP}"
			rm -fr $_cramdir
		fi
	else
		upload_syslog "ibsexe mkcram: copy error. Try other temp."
		rm -fr $_cramdir
	fi

	mkdir $_cramdir2nd > /dev/null 2>&1
	mount -t tmpfs tmpfs $_cramdir2nd
	tar xzpf $_file -C ${_cramdir2nd}
	if [ $? != 0 ]; then
		upload_syslog "ibsexe mkcram: filesystem create error."
		umount $_cramdir2nd
		rm -fr $_cramdir2nd
		return 1
	else
		(cd /; mkcramfs ibsexecram/exe ${TAR_IBSEXE_UP})
		if [ $? = 0 ]; then
			upload_syslog "ibsexe mkcram: create ok $_cramdir2nd to ${TAR_IBSEXE_UP}"
			umount $_cramdir2nd
			rm -fr $_cramdir2nd
       # /tmp/ibsexe.tar.gz$B$N:o=|(B
			rm -f $_sfile
			return 0
		else
			upload_syslog "ibsexe mkcram: create ng $_cramdir2nd to ${TAR_IBSEXE_UP}"
			umount $_cramdir2nd
			rm -fr $_cramdir2nd
			return 1
		fi
	fi
}

upload_ibsexe_tar()
{
	_file=$1
	grep ibsserv ${UP_LIST} > /dev/null 2>&1
	if [ $? = 0 ]; then
		upload_ibsexe_mkcram $_file
		if [ $? = 0 ]; then
			upload_syslog "IBSEXE : copy done. tar to ${TAR_IBSEXE_UP}"
			return 0
		else
			upload_syslog "IBSEXE : copy error. tar to ${TAR_IBSEXE_UP}"
			return 1
		fi
	else
		upload_syslog "IBSEXE : not include ibsserv"
		return 1
	fi
}

upload_ibsexe_tar2()
{
	_file=$1
	grep ibsexe.tar.gz ${UP_LIST} > /dev/null 2>&1
	if [ $? = 0 ]; then
		tar xzpf $_file ibsexe.tar.gz
		upload_ibsexe_mkcram ibsexe.tar.gz
		if [ $? = 0 ]; then
			upload_syslog "IBSEXE : copy done. tar2 to ${TAR_IBSEXE_UP}"
			rm -f ibsexe.tar.gz
			return 0
		else
			upload_syslog "IBSEXE : copy error. tar2 to ${TAR_IBSEXE_UP}"
			rm -f ibsexe.tar.gz
			return 1
		fi
	else
		upload_syslog "IBSEXE : not include ibs.tar.gz"
		return 1
	fi
}

#
# $1: archive file
#
upload_ibsexe()
{
	_file=$1
	_up_type=""
	_up_fileok=ng
	_up_done_exe=ng
	_up_done_pg=ng

	chmod 444 $_file
	tar tzpf $_file > ${UP_LIST} 2>&1
	if [ $? = 0 ]; then
		upload_syslog "IBSEXE:archive file"
		_up_type=tar
	else
		upload_syslog "IBSEXE:not archive file"
		_up_type=cram
	fi

	grep exe.cramfs ${UP_LIST} > /dev/null 2>&1
	if [ $? = 0 ]; then
		_up_type=cram
	fi

	if [ "X$_up_type" = "Xtar" ]; then
		upload_ibsexe_tar $_file
		if [ $? = 0 ]; then
			_up_done_exe=ok
		else
			_up_done_exe=ng
		fi

		if [ "X$_up_done_exe" != "Xok" ]; then
			upload_ibsexe_tar2 $_file
			if [ $? = 0 ]; then
				_up_done_exe=ok
			else
				_up_done_exe=ng
			fi
		fi
	fi

	if [ "X$_up_type" = "Xcram" ]; then
		tar xzpf $_file > /dev/null 2>&1
		if [ -f MD5 -a -f exe.cramfs ]; then
			grep exe.cramfs MD5 | md5sum -c > /dev/null 2>&1
			if [ $? = 0 ]; then
				_up_fileok=ok
				upload_syslog "IBSEXE: check sum ok."
			else
				_up_fileok=ng
				upload_syslog "IBSEXE: check sum ng."
			fi

			if [ "X$_up_fileok" = "Xok" ]; then
				cp exe.cramfs ${TAR_IBSEXE_UP}
				if [ $? = 0 ]; then
					_up_done_exe=ok
					rm -f exe.cramfs
					upload_syslog "IBSEXE: copy done. cram to ${TAR_IBSEXE_UP}"
				else
					_up_done_exe=ng
					rm -f exe.cramfs
					upload_syslog "IBSEXE: copy error. cram to ${TAR_IBSEXE_UP}"
				fi
			fi
		fi
	fi

	_up_done_pg=ok
  # $B%U%!%$%k$,4^$^$l$F$$$l$P!"=hM}(B
	tar xzpf $_file pgsql_data.tar.gz MD5 > /dev/null 2>&1
	if [ "X$_up_done_exe" = "Xok" -a -f MD5 -a -f pgsql_data.tar.gz ]; then
		grep pgsql_data MD5 | md5sum -c > /dev/null 2>&1
		if [ $? = 0 ]; then
			_up_fileok=ok
			upload_syslog "PGSQL: check sum ok."
		else
			_up_fileok=ng
			upload_syslog "PGSQL: check sum ng."
		fi

		if [ "X$_up_fileok" = "Xok" ]; then
			cp pgsql_data.tar.gz ${TAR_PGSQL_UP}
			if [ $? = 0 ]; then
				_up_done_pg=ok
				upload_syslog "PGSQL: copy done. cram to ${TAR_PGSQL_UP}"
			else
				_up_done_pg=ng
				upload_syslog "PGSQL: copy error. cram to ${TAR_PGSQL_UP}"
			fi
		else
			upload_syslog "PGSQL: copy error. cram to ${TAR_PGSQL_UP}"
			_up_done_pg=ng
		fi

		if [ "X$_up_done_pg" = "Xok" ]; then
			rm -f pgsql_data.tar.gz
		else
			rm -f ${TAR_IBSEXE_UP}
			rm -f ${TAR_PGSQL_UP}
			rm -f pgsql_data.tar.gz
		fi
	fi

	if [ "X$_up_done_exe" = "Xok" -a "X$_up_done_pg" = "Xok" ]; then
		return 0
	else
		return 1
	fi
}

ibsexe_update()
{
	if [ ! -f ${TAR_IBSEXE_UP} ]; then
		upload_syslog "Not found ${TAR_IBSEXE_UP}"
		return 1
	fi

  # $B%W%m%;%9Dd;_(B
	if [ -x /etc/rc.d/init.d/ibsexe ]; then
		/etc/rc.d/init.d/ibsexe stop
	fi

	sleep 2
	_count=0
	until ibsexe_umount 2>&- ; do
		if [ "$_count" -gt 10 ]; then
			upload_syslog "Unmount error ${TAR_IBSEXE} timeout."
			rm -f ${TAR_IBSEXE_UP}
			return 1
		fi
		upload_syslog "Unmount error ${TAR_IBSEXE} retry.($_count)"
		_count=`expr $_count + 1`
		sleep1 
	done

	mv ${TAR_IBSEXE_UP} ${TAR_IBSEXE}
	if [ -f ${TAR_PGSQL_UP} ]; then
		mv ${TAR_PGSQL_UP} ${TAR_PGSQL}
		touch /tmp/pgsql_nosave
	fi
	ibsexe_mount
	if [ $? != 0 ]; then
		upload_syslog "Mount error ${TAR_IBSEXE}"
		return 1
	fi

#  if [ -x /etc/ibsbat/ibsexereboot.bat ]; then
#    /bin/sh /etc/ibsbat/ibsexereboot.bat
#  fi
	return 0
}

#
# ROUTER
#
# check file
# $1: file (tar format)
upload_router_check_file()
{
	_sfile=$1
#  return 1		# $BL$%5%]!<%H$N$?$a(B

	[ ! -f "$_sfile" ] && return 1

	tar tzpf $_sfile > ${UP_LIST} 2>&1
	if [ $? != 0 ]; then
		upload_syslog "RT: format error."
		return 1
	fi

  #2005.12.20
	grep module.ver ${UP_LIST} 2>&1
	if [ $? != 0 ]; then
		upload_syslog "RT: module.ver not found"
		return 1
	fi

	grep ibssysupdate.bat ${UP_LIST} > /dev/null 2>&1
	if [ $? = 0 ]; then
		upload_syslog "RT: ibssysupdate.bat is found."
		return 2
	fi

	grep ipl.bin ${UP_LIST} > /dev/null 2>&1
	if [ $? != 0 ]; then
		upload_syslog "RT: ipl not found"
		return 1
	fi

	grep vmlinux ${UP_LIST} > /dev/null 2>&1
	if [ $? != 0 ]; then
		upload_syslog "RT: kernel not found"
		return 1
	fi

	return 0
}

# ipl.bin
# vmlinux.image
# ramdisk.image
# etc.tar.gz
# usr.cramfs
# home.tar.gz
upload_router()
{
	_file=$1
	if [ "X$_debug" = "Xdebug" ]; then
		touch /tmp/${_debugf}_to_etc.tar.gz
		return 0
	fi

	upload_router_check_file $_file
	RETVAL=$?

	case $RETVAL in
		2)
			tar xzpf $_file ibssysupdate.bat > /dev/null 2>&1
			/bin/sh ibssysupdate.bat $_file
			rm -f $_file
			return 0
			;;
		1)
			return 1
			;;
		*)
			return 1
			;;
	esac


	tar xzpf $_file > /dev/null 2>&1
	if [ $? != 0 ]; then
		upload_syslog "IBSRT:not archive file"
		return 1
	fi
	if [ -f MD5 ]; then #md5 file
		if [ -f "etc.tar.gz" -a -f "vmlinux8241_ram.image" -a -f "ramdisk8241.image" ]; then # file
			grep etc.tar.gz MD5 | md5sum -c
			ETCVAL=$?
			grep vmlinux8241_ram.image MD5 | md5sum -c
			VMVAL=$?
			grep ramdisk8241.image MD5 | md5sum -c
			RAMVAL=$?
			if [ "X$ETCVAL" = "X0" -a "X$VMVAL" = "X0" -a "X$RAMVAL" = "X0" ]; then  # sum
				cp etc.tar.gz ${TAR_ETC}
				if [ $? = 0 ]; then
					upload_syslog "Copy to ${TAR_ETC} OK"
				else
					upload_syslog "Copy to ${TAR_ETC} NG"
				fi
				dd if=vmlinux8241_ram.image of=/dev/mtdblockkernel
				if [ $? = 0 ]; then
					upload_syslog "Copy to KERNEL OK"
				else
					upload_syslog "Copy to KERNEL NG"
				fi
				dd if=ramdisk8241.image of=/dev/mtdblockramdisk
				if [ $? = 0 ]; then
					upload_syslog "Copy to RAMDISK OK"
				else
					upload_syslog "Copy to RAMDISK NG"
				fi
			else #sum
				upload_syslog "IBSRT:check sum error"
			fi   #sum
		else  #file
			upload_syslog "IBSRT:check sum error"
			return 1
		fi #file
	else #md5 file
		upload_syslog "IBSRT: md5 file not found"
		return 1
	fi #md5 file
}

# GW
#  check S format
#  $1: file
#
# 2$B9TL\$H(B10$B9TL\$N@hF,J8;z$,(BS$B$G$"$k$3$H(B
#
upload_gw_simple_check_sf()
{
	_sfile=$1
	[ -f "$_sfile" ] || return 1

	_line2=`awk '{ if ( NR == 2 ) {print}}' $_sfile`
	_line10=`awk '{ if ( NR == 10 ) {print}}' $_sfile`

	_ok2=`echo $_line2 | grep "^S"`
	_ok10=`echo $_line10 | grep "^S"`

	if [ "X$_ok2" != "X" -a "X$_ok10" != "X" ]; then
		return 0
	else
		return 1
	fi
}
#
# mkcram
#  $1: gw main file
#  $2: gw h8 file
upload_gw_mkcram()
{
	_gwfile=$1
	_gw8file=$2
	_cramdir=/tmp/gwcram
	_cramdir2nd=/gwcram

	[ ! -f "$_gwfile" -o ! -f "$_gw8file" ] && return 1

	if [ ! -d $_cramdir ]; then
		mkdir $_cramdir
	fi

	cp $_gwfile $_cramdir/${GWMAIN}
	cp $_gw8file $_cramdir/${GWH8}
	if [ $? = 0 ]; then
		(cd /tmp; mkcramfs gwcram ${TAR_GW_COMP_UP} )
		if [ $? = 0 ]; then
			upload_syslog "gw mkcram: create ok $_cramdir to ${TAR_GW_COMP_UP}"
			rm -fr $_cramdir
			return 0
		else
			upload_syslog "gw mkcram: create ng $_cramdir to ${TAR_GW_COMP_UP}"
			rm -fr $_cramdir
		fi
	else
		upload_syslog "gw mkcram: copy error. Try other temp."
		rm -fr $_cramdir
	fi

	mkdir $_cramdir2nd > /dev/null 2>&1
	mount -t tmpfs tmpfs $_cramdir2nd
	cp $_gwfile $_cramdir2nd/${GWMAIN}
	cp $_gw8file $_cramdir2nd/${GWH8}
	if [ $? != 0 ]; then
		upload_syslog "gw mkcram: filesystem create error."
		umount $_cramdir2nd
		rm -fr $_cramdir2nd
		return 1
	else
		(cd /; mkcramfs gwcram ${TAR_GW_COMP_UP})
		if [ $? = 0 ]; then
			upload_syslog "gw mkcram: create ok $_cramdir2nd to ${TAR_GW_COMP_UP}"
			umount $_cramdir2nd
			rm -fr $_cramdir2nd
			return 0
		else
			upload_syslog "gw mkcram: create ng $_cramdir2nd to ${TAR_GW_COMP_UP}"
			umount $_cramdir2nd
			rm -fr $_cramdir2nd
			return 1
		fi
	fi
}

#
# $1: archive file
#
upload_gwmain()
{
	_file=$1
	_up_type=""
	_up_fileok=ng
	_up_done=ng

	chmod 444 $_file
	tar tzpf $_file > /dev/null 2>&1
	if [ $? = 0 ]; then
		upload_syslog "GW:archive file"
		_up_type=tar
	else
		upload_syslog "GW:not archive file"
		_up_type=sf
	fi

  # S format
	if [ "X$_up_type" = "Xsf" ]; then
		upload_gw_simple_check_sf $_file
		if [ $? != 0 ]; then
			_up_fileok=ng
		else
			_up_fileok=ok
		fi

		if [ "X$_up_fileok" = "Xok" ]; then
			upload_gw_mkcram $_file  /home/ibskt/${GWH8}
			if [ $? = 0 ]; then
				_up_done=ok
				rm -f $_file
				upload_syslog "GW: copy done. sf to ${TAR_GW_COMP_UP}"
				return 0
			fi
		fi
	fi

	upload_syslog "GW: file type cannot support."
	return 1
}

#
# $1: archive file
#
upload_gwh8()
{
	_up_type=""
	_up_fileok=ng
	_up_done=ng

	chmod 444 $_file
	tar tzpf $_file > /dev/null 2>&1
	if [ $? = 0 ]; then
		upload_syslog "GW:archive file"
		_up_type=tar
	else
		upload_syslog "GW:not archive file"
		_up_type=sf
	fi

  # S format
	if [ "X$_up_type" = "Xsf" ]; then
		upload_gw_simple_check_sf $_file
		if [ $? != 0 ]; then
			_up_fileok=ng
		else
			_up_fileok=ok
		fi

		if [ "X$_up_fileok" = "Xok" ]; then
			upload_gw_mkcram /home/ibskt/${GWMAIN} $_file
			if [ $? = 0 ]; then
				_up_done=ok
				rm -f $_file
				upload_syslog "GW: copy done. sf to ${TAR_GW_COMP_UP}"
				return 0
			fi
		fi
	fi

	upload_syslog "GW: file type cannot support."
	return 1
}


#
# IPKT
#
#  check S format
#  $1: file
#
# 2$B9TL\$H(B10$B9TL\$N@hF,J8;z$,(BS$B$G$"$k$3$H(B
#
upload_ipkt_simple_check_sf()
{
	_sfile=$1
	[ -f "$_sfile" ] || return 1

	_line2=`awk '{ if ( NR == 2 ) {print}}' $_sfile`
	_line10=`awk '{ if ( NR == 10 ) {print}}' $_sfile`

	_ok2=`echo $_line2 | grep "^S"`
	_ok10=`echo $_line10 | grep "^S"`

	if [ "X$_ok2" != "X" -a "X$_ok10" != "X" ]; then
		return 0
	else
		return 1
	fi
}
#
# mkcram
#  $1: file
upload_ipkt_mkcram()
{
	_sfile=$1
	_cramdir=/tmp/ipktcram
	_cramdir2nd=/ipktcram
	if [ ! -d $_cramdir ]; then
		mkdir $_cramdir
	fi

	cp $_sfile $_cramdir/s_ipkt_rom.s
	if [ $? = 0 ]; then
		(cd /tmp; mkcramfs ipktcram ${TAR_IPKT_COMP_UP} )
		if [ $? = 0 ]; then
			upload_syslog "ipkt mkcram: create ok $_cramdir to ${TAR_IPKT_COMP_UP}"
			rm -fr $_cramdir
			return 0
		else
			upload_syslog "ipkt mkcram: create ng $_cramdir to ${TAR_IPKT_COMP_UP}"
			rm -fr $_cramdir
		fi
	else
		upload_syslog "ipkt mkcram: copy error. Try other temp."
		rm -fr $_cramdir
	fi

	mkdir $_cramdir2nd > /dev/null 2>&1
	mount -t tmpfs tmpfs $_cramdir2nd
	cp $_sfile $_cramdir2nd/s_ipkt_rom.s
	if [ $? != 0 ]; then
		upload_syslog "ipkt mkcram: filesystem create error."
		umount $_cramdir2nd
		rm -fr $_cramdir2nd
		return 1
	else
		(cd /; mkcramfs ipktcram ${TAR_IPKT_COMP_UP})
		if [ $? = 0 ]; then
			upload_syslog "ipkt mkcram: create ok $_cramdir2nd to ${TAR_IPKT_COMP_UP}"
			umount $_cramdir2nd
			rm -fr $_cramdir2nd
			return 0
		else
			upload_syslog "ipkt mkcram: create ng $_cramdir2nd to ${TAR_IPKT_COMP_UP}"
			umount $_cramdir2nd
			rm -fr $_cramdir2nd
			return 1
		fi
	fi
}

#
# $1: upload file
#
upload_ipkt()
{
	_file=$1
	_up_type=""
	_up_fileok=ng
	_up_done=ng

	chmod 444 $_file
	tar tzpf $_file > /dev/null 2>&1
	if [ $? = 0 ]; then
		upload_syslog "IPKT:archive file"
		_up_type=tar
	else
		upload_syslog "IPKT:not archive file"
		_up_type=sf
	fi

  # S format
	if [ "X$_up_type" = "Xsf" ]; then
		upload_ipkt_simple_check_sf $_file
		if [ $? != 0 ]; then
			_up_fileok=ng
		else
			_up_fileok=ok
		fi

		if [ "X$_up_fileok" = "Xok" ]; then
			upload_ipkt_mkcram $_file
			if [ $? = 0 ]; then
				_up_done=ok
				rm -f $_file
				upload_syslog "IPKT: copy done. sf to ${TAR_IPKT_COMP_UP}"
				return 0
			fi
		fi
	fi

	if [ "X$_up_type" = "Xtar" ]; then
		tar xzpf $_file > /dev/null 2>&1
		if [ -f MD5 -a -f s_ipkt_rom.s ]; then
			cat MD5 | md5sum -c
			if [ $? = 0 ]; then
				_up_fileok=ok
				upload_syslog "IPKT:check sum ok"
			else
				_up_fileok=ng
				upload_syslog "IPKT:check sum error"
			fi

			if [ "X$_up_fileok" = "Xok" ]; then
				upload_ipkt_mkcram s_ipkt_rom.s
				if [ $? = 0 ]; then
					_up_done=ok
					rm -f $_file
					upload_syslog "IPKT: copy done. tar sf to ${TAR_IPKT_COMP_UP}"
					return 0
				fi
			fi
		fi

		if [ -f MD5 -a -f ipkt.cramfs ]; then
			cat MD5 | md5sum -c
			if [ $? = 0 ]; then
				_up_fileok=ok
				upload_syslog "IPKT: check cram sum ok"
			else
				_up_fileok=ng
				upload_syslog "IPKT: check cram sum ng"
			fi

			if [ "X$_up_fileok" = "Xok" ]; then
				cp ipkt.cramfs ${TAR_IPKT_COMP_UP}
				if [ $? = 0 ]; then
					_up_done=ok
					rm -f $_file
					upload_syslog "IPKT: copy done. tar cram to ${TAR_IPKT_COMP_UP}"
					return 0
				fi
			fi
		fi
	fi

	upload_syslog "IPKT: file type is illegal."
	return 1
}

# S2/S2/S2
# 2005.03.22
upload_false()
{
	rm -f /var/run/exeupload
	touch /var/run/exeupload_false
}

####################
if ! check_ppcibs ; then
	exit 0
fi

# for NetBSD
if ostype_is_netbsd ; then
	exit 0
fi

# S2/S2/S2
# 2005.03.09 lock
touch /var/run/exeupload

# for Linux
if ostype_is_linux ; then
	led_update_on
	cd /tmp

	_type=$1
	_file=$2

	if [ "X$3" = "Xdebug" ]; then
		_debug=$3
		_debugf=`basename $_file`
	fi

	if [ ! -f /etc/jffs2 ]; then
		upload_syslog "Filesystem is not jffs2"
    # 2005.03.22
		upload_false
		exit 15
	fi

  # $B$3$3$G!"%U%!%$%k$N@09g@-$r%A%'%C%/$9$k(B
	tar tzf $_file >/dev/null 2>&1
	RETVAL=$?
	if [ $RETVAL -ne 0 ]; then
		upload_syslog "File not archive file"
#    exit 15
	fi

	flash_rw_mount
	flash_rw_mount_usr

	_reboot=0
	case $_type in
		ibsexe)
    # 2005.11.08 For V3
#    if [ -f /etc/thisver ]; then
			upload_router $_file > /tmp/router_up.log 2>&1
			if [ $? != 0 ]; then
				RETVAL=15
			else
				RETVAL=0
			fi
#    else
#      upload_ibsexe $_file
#      if [ $? != 0 ]; then
#        RETVAL=15
#      else
#        RETVAL=0
#      fi
#    fi

#     ibsexe_update
#     if [ $? = 0 ]; then
#       _reboot=1
#     fi
			;;
		router)
			upload_router $_file > /tmp/router_up.log 2>&1
			if [ $? != 0 ]; then
				RETVAL=15
			else
				RETVAL=0
			fi
#     if [ "X$RETVAL" = "X0" ]; then
#       _reboot=1
#     fi
			;;
		gwmain)
			upload_ftpd stop
			upload_gwmain $_file
			if [ $? != 0 ]; then
				RETVAL=15
			else
				gw_umount
				mv ${TAR_GW_COMP_UP} ${TAR_GW_COMP}
				gw_mount
				RETVAL=0
			fi
			upload_ftpd start
			;;
		gwh8)
			upload_ftpd stop
			upload_gwh8 $_file
			if [ $? != 0 ]; then
				RETVAL=15
			else
				gw_umount
				mv ${TAR_GW_COMP_UP} ${TAR_GW_COMP}
				gw_mount
				RETVAL=0
			fi
			upload_ftpd start
			;;
		ipkt)
			upload_ftpd stop
			upload_ipkt $_file
			if [ $? != 0 ]; then
				RETVAL=15
			else
				ipkt_umount
				mv ${TAR_IPKT_COMP_UP} ${TAR_IPKT_COMP}
				ipkt_mount
				RETVAL=0
			fi
			upload_ftpd start
			;;
#  web)
#     if [ "X$_debug" = "Xdebug" ]; then
#       touch /tmp/${_debugf}_to_home.tar.gz
#     else
#       cp $_file ${TAR_HOME}
#     fi
#     ;;
#  system)
#     if [ "X$_debug" = "Xdebug" ]; then
#       touch /tmp/${_debugf}_to_sytem
#     fi
#     ;;
#  all)
#     if [ "X$_debug" = "Xdebug" ]; then
#       touch /tmp/${_debugf}_to_all
#     fi
#     ;;
		*)
			;;
	esac

	sync
	flash_ro_mount_usr
	flash_ro_mount
#  sh /etc/ibsbat/mkram.bat after
	led_update_off
	if [ "X$_reboot" = "X1" ]; then
		init 6
	fi
fi

# S2/S2/S2
# 2005.03.22
if [ "X$RETVAL" != "X0" ]; then
	upload_false
fi

# S2/S2/S2
# 2005.03.09 lock
rm -f /var/run/exeupload

exit ${RETVAL}
