#!/bin/sh
#
UPNPD=/usr/sbin/upnpd
IPTABLES=/sbin/iptables
WEB_UPNP_CONF=/etc/ibsbat/Router/upnp/upnp.txt

_lock_file=/var/lock/subsys/upnpd
_real_ifname_prefix=/var/run/ntoreal.

_spec=$1
#2006.01.29 ifname
_pppoe_ifname=$2

LANIF=eth1
RETVAL=0

start_reaim()
{
	_ifname=$1

	${IPTABLES} -t nat -A PREROUTING -i "${LANIF}" -p tcp --dport 1863 -j REDIRECT --to-ports 1863
	${IPTABLES} -A INPUT -i "${LANIF}" -p tcp --dport 1863 -j ACCEPT
	${IPTABLES} -A INPUT -i $_ifname -p tcp --dport 1864 -j ACCEPT
}
stop_reaim()
{
	_ifname=$1

	${IPTABLES} -t nat -D PREROUTING -i "${LANIF}" -p tcp --dport 1863 -j REDIRECT --to-ports 1863
	${IPTABLES} -D INPUT -i "${LANIF}" -p tcp --dport 1863 -j ACCEPT
	${IPTABLES} -D INPUT -i $_ifname -p tcp --dport 1864 -j ACCEPT
}

start_upnpd()
{
	_ifname=$1

	_multi=`netstat -nr|grep 239.0.0.0`
	if [ -z "$_multi" ]; then
		route add -net 239.0.0.0 netmask 255.0.0.0 dev eth1
	fi
	if [ -x "${UPNPD}" ]; then
		${UPNPD} "${_ifname}" eth1
		touch $_lock_file
		#start_reaim "${_ifname}"
	fi
}

stop_upnpd()
{
	if [ -f $_lock_file ]; then
		#stop_reaim "${_ifname}"

		_pid=`ps ax|grep upnpd|grep -v grep|head -1|awk '{printf"%d",$1}'`

		if [ ! -z "$_pid" ]; then
			kill -SIGKILL $_pid
		else
			rm -f $_lock_file
		fi
	fi
}

case $_spec in
	start)
	#ppp0|ppp1|ppp2|ppp3|ppp4)
		# entry interface no
		if [ -f "${WEB_UPNP_CONF}" ]; then
			. "${WEB_UPNP_CONF}"
		fi
		#if [ "X$_spec" = "Xppp$upnp_set_number" ]; then
		if [ "X$_pppoe_ifname" = "Xppp$upnp_set_number" ]; then
			stop_upnpd
			#if [ -f "${_real_ifname_prefix}${_spec}" ]; then
			# _real_ifname=`cat ${_real_ifname_prefix}${_spec}`
			if [ -f "${_real_ifname_prefix}${_pppoe_ifname}" ]; then
				_real_ifname=`cat ${_real_ifname_prefix}${_pppoe_ifname}`
				start_upnpd $_real_ifname
			fi
		fi
		;;
	stop)
		# entry interface no
		if [ -f "${WEB_UPNP_CONF}" ]; then
			. "${WEB_UPNP_CONF}"
		fi
		if [ "X$_pppoe_ifname" = "Xppp$upnp_set_number" ]; then
			stop_upnpd
		fi
		;;
	boot|conf)
		;;
	# 2006.06.08 For debug
	manual)
		if [ -n "$2" ]; then
			start_upnpd $2
		fi
		;;
	*)
		if [ -f "${WEB_UPNP_CONF}" ]; then
			. "${WEB_UPNP_CONF}"
		fi
		if [ "X$_spec" = "Xppp$upnp_set_number" ]; then
			stop_upnpd
			if [ -f "${_real_ifname_prefix}${_spec}" ]; then
				_real_ifname=`cat ${_real_ifname_prefix}${_spec}`
				start_upnpd $_real_ifname
			fi
		fi
		;;
esac
exit $RETVAL
