# 2006/09/21
use Time::Local;
sub check_date_and_time
{
my($year) = $_[0];
my($month) = $_[1];
my($date) = $_[2];
my($hour) = $_[3];
my($minute) = $_[4];
my($second) = $_[5];
unless( ($year =~ /^\d+$/) && ($month =~ /^\d+$/) && ($date =~ /^\d+$/) && ($hour =~ /^\d+$/) && ($minute =~ /^\d+$/) && ($second =~ /^\d+$/) ){
return "error";
}
$year = sprintf("%d", $year);
$month = sprintf("%d", $month);
$date = sprintf("%d", $date);
$hour = sprintf("%d", $hour);
$minute = sprintf("%d", $minute);
$second = sprintf("%d", $second);
unless( ($year =~ /^\d{4}$/) && (2000 <= $year) && (2037 >= $year) ){
return "error";
}
unless( ($month =~ /^\d{1,2}$/) && (1 <= $month) && (12 >= $month) ){
return "error";
}
unless( ($date =~ /^\d{1,2}$/) && (1 <= $date) && (31 >= $date) ){
return "error";
}
unless( ($hour =~ /^\d{1,2}$/) && (0 <= $hour) && (23 >= $hour) ){
return "error";
}
unless( ($minute =~ /^\d{1,2}$/) && (0 <= $minute) && (59 >= $minute) ){
return "error";
}
unless( ($second =~ /^\d{1,2}$/) && (0 <= $second) && (59 >= $second) ){
return "error";
}
return &check_date($year, $month, $date);
}
sub check_date
{
my($year) = $_[0];
my($month) = $_[1];
my($date) = $_[2];
eval{
timelocal(0, 0, 0, $date, ($month - 1), ($year - 1900));
};
if($@){
return "error";
}
if(12 == $month){
$month = 0;
}
my($time) = timelocal(0, 0, 0, 1, $month, ($year - 1900));
$time -= (60 * 60 * 24);
my(@date_and_time) = localtime($time);
unless( ($date =~ /./) && ($date_and_time[3] =~ /./) ){
return "error";
}
if($date > $date_and_time[3]){
return "error";
}
else{
return "success";
}
}
sub check_ntp_server
{
my($ntp_server) = $_[0];
if($ntp_server =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/){
return &check_ipaddress_ipv4($ntp_server);
}
else{
if($ntp_server =~ /^[\da-zA-Z\-\.]+$/){
return &check_host_address($ntp_server);
}
else{
return "error";
}
}
}
sub check_hour_minute
{
my($hour) = $_[0];
my($minute) = $_[1];
if( ($hour =~ /^\d{2}$/) && ($minute =~ /^\d{2}$/) ){
$hour = sprintf("%d", $hour);
$minute = sprintf("%d", $minute);
if( (0 <= $hour) && (23 >= $hour) && (0 <= $minute) && (59 >= $minute) ){
return "success";
}
else{
return "error";
}
}
else{
return "error";
}
}
sub get_date_and_time
{
my(%return_hash);
my($tmp) = `/bin/date '+%Y %D %T'`;
if($tmp =~ /^(\d+)\s(\d+)\/(\d+)\/(?:\d+)\s(\d+):(\d+):(\d+)$/){
%return_hash = (
"return" => "success",
"year" => $1,
"month" => $2,
"date" => $3,
"hour" => $4,
"minute" => $5,
"second" => $6
);
return %return_hash;
}
else{
my($alert_message) = $RETURN_CODE{"11"};
%return_hash = (
"return" => "error",
"error_contents" => "date_command",
"alert_message" => "utƎv" . $alert_message
);
return %return_hash;
}
}
sub get_ntp_server_data
{
my($when) = $_[0];
my($backup);
my($ntp) = "off";
my($ntp_server) = "";
my($ntp_schedule) = "40";
my($ntp_hour) = "00";
my($ntp_minute) = "00";
my(%return_hash);
my($crond_file_path) = "$ROUTER_DATA/date_and_time/crond_file.txt";
my($rc_conf_path) = "/etc/rc.conf";
my($ntp_conf_path) = "/etc/ntp.conf";
if("error" eq &lock_file("CROND_FILE_LOCK", $crond_file_path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "crond_file_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &lock_file("RC_CONF_LOCK", $rc_conf_path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "rc_conf_lock",
"alert_message" => $alert_message
);
close(CROND_FILE_LOCK);
return %return_hash;
}
if("error" eq &lock_file("NTP_CONF_LOCK", $ntp_conf_path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "ntp_conf_lock",
"alert_message" => $alert_message
);
close(CROND_FILE_LOCK);
close(RC_CONF_LOCK);
return %return_hash;
}
if("error" eq &open_file("CROND_FILE_PATH", "$crond_file_path$backup", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "crond_file_open",
"alert_message" => $alert_message
);
close(CROND_FILE_LOCK);
close(RC_CONF_LOCK);
close(NTP_CONF_LOCK);
return %return_hash;
}
my(@tmp_cron) = <CROND_FILE_PATH>;
close(CROND_FILE_PATH);
foreach(@tmp_cron){
if(/^\s*(\#?)\s*(\d+)\s+(\d+)\s+([\*\+\d\@]+)\s([\*\+\d\@]+)\s+([\*\+\d\@]+)\s+\/home\/ibsuser\/public_html\/Admin\/Sys_setup\/Router\/date_and_time\/ntpdate.pl/){
my($comment) = $1;
$ntp_minute = $2;
$ntp_hour = $3;
my($ntp_date) = $4;
my($ntp_month) = $5;
my($ntp_day) = $6;
if($comment =~ /./){
$ntp = "off";
}
else{
$ntp = "on";
}
$ntp_schedule = &get_schedule($ntp_date, $ntp_month, $ntp_day);
$ntp_minute = sprintf("%02d", $ntp_minute);
$ntp_hour = sprintf("%02d", $ntp_hour);
last;
}
}
if("error" eq &open_file("RC_CONF_PATH", "$rc_conf_path$backup", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "rc_conf_open",
"alert_message" => $alert_message
);
close(CROND_FILE_LOCK);
close(RC_CONF_LOCK);
close(NTP_CONF_LOCK);
return %return_hash;
}
my(@tmp_rc) = <RC_CONF_PATH>;
close(RC_CONF_PATH);
foreach(@tmp_rc){
if(/^\s*(?:ntpd=)(\S+)\s+(?:ntpd_flags="")\s+(?:\#ibs-soho)/){
if("YES" eq $1){
$ntp = "on";
}
else{
}
last;
}
}
if("error" eq &open_file("NTP_CONF_PATH", "$ntp_conf_path$backup", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "ntp_conf_open",
"alert_message" => $alert_message
);
close(CROND_FILE_LOCK);
close(RC_CONF_LOCK);
close(NTP_CONF_LOCK);
return %return_hash;
}
my(@tmp_ntp) = <NTP_CONF_PATH>;
close(NTP_CONF_PATH);
foreach(@tmp_ntp){
if(/^\s*(?:server)\s+(\S+)\s+(?:\#ibs-soho)/){
$ntp_server = $1;
last;
}
}
if("no_ntp_server" eq $ntp_server){
$ntp_server = "";
}
%return_hash = (
"return" => "success",
"ntp" => $ntp,
"ntp_server" => $ntp_server,
"ntp_schedule" => $ntp_schedule,
"ntp_hour" => $ntp_hour,
"ntp_minute" => $ntp_minute
);
close(CROND_FILE_LOCK);
close(RC_CONF_LOCK);
close(NTP_CONF_LOCK);
return %return_hash;
}
sub get_schedule
{
my($ntp_date) = $_[0];
my($ntp_month) = $_[1];
my($ntp_day) = $_[2];
my($ntp_schedule);
if( ("+" eq $ntp_date) && ("+" eq $ntp_month) && ("+" eq $ntp_day) ){
$ntp_schedule = 36;
return $ntp_schedule;
}
if( ("@" eq $ntp_date) && ("@" eq $ntp_month) && ("@" eq $ntp_day) ){
$ntp_schedule = 40;
return $ntp_schedule;
}
if("*" ne $ntp_date){
$ntp_schedule = $ntp_date + 7;
}
elsif("*" ne $ntp_day){
if("0" eq $ntp_day){
$ntp_schedule = ($ntp_day + 1);
}
elsif("7" eq $ntp_day){
$ntp_schedule = ($ntp_day - 6);
}
else{
$ntp_schedule = ($ntp_day + 1);
}
}
else{
$ntp_schedule = 0;
}
return $ntp_schedule;
}
sub set_date_and_time
{
my($year) = sprintf("%02d", $_[0]);
my($month) = sprintf("%02d", $_[1]);
my($date) = sprintf("%02d", $_[2]);
my($hour) = sprintf("%02d", $_[3]);
my($minute) = sprintf("%02d", $_[4]);
my($second) = sprintf("%02d", $_[5]);
my(%return_hash);
my($id_org) = $<;
$< = 0;
if(system("/bin/date $month$date$hour$minute$year.$second >/dev/null 2>&1")){
my($alert_message) = $RETURN_CODE{"10"};
%return_hash = (
"return" => "error",
"error_contents" => "date_command",
"alert_message" => "utƎv" . $alert_message
);
}
else{
if(system("/sbin/hwclock --systohc --utc >/dev/null 2>&1")){
sleep(5);
if(system("/sbin/hwclock --systohc --utc >/dev/null 2>&1")){
my($alert_message) = $RETURN_CODE{"10"};
%return_hash = (
"return" => "error",
"error_contents" => "hwclock_command",
"alert_message" => "uhwclockv" . $alert_message
);
}
else{
%return_hash = (
"return" => "suucess"
);
}
}
else{
%return_hash = (
"return" => "suucess"
);
}
}
$< = $id_org;
return %return_hash;
}
sub set_ntp_server_data
{
my($set_info) = $_[0];
my($ntp_server) = $_[1];
my($schedule) = $_[2];
my($hour) = sprintf("%d", $_[3]);
my($minute)= sprintf("%d", $_[4]);
my(%return_kill_process);
my(%return_set_crond);
my(%return_set_ntpd);
my($ntp_access_result);
my(%return_hash);
unless($ntp_server =~ /./){
$ntp_server = "no_ntp_server";
}
my($ntpd_pid) = &get_process_id("ntpd");
if($ntpd_pid =~ /\d+/){
my($id_org) = $<;
$< = 0;
if(system("/etc/rc.d/init.d/ntpd stop >/dev/null 2>&1")){
my($alert_message) = $RETURN_CODE{"18"};
%return_hash = (
"return" => "error",
"error_contents" => "ntpd_stop",
"alert_message" => "uNTPCv" . $alert_message
);
$< = $id_org;
return %return_hash;
}
$< = $id_org;
}
if("ntp" eq $set_info){
if("error" eq &ntp_access_test($ntp_server)){
$ntp_access_result = "error";
}
else{
$ntp_access_result = "success";
}
}
my($month) = "*";
my($date) = "*";
my($day) = "*";
if(40 == $schedule){
$month = "@";
$date = "@";
$day = "@";
$minute = "00";
$hour = "00";
}
if(36 == $schedule){
$month = "+";
$date = "+";
$day = "+";
$minute = "00";
$hour = "00";
if("ntp" eq $set_info){
if("success" eq $ntp_access_result){
my($id_org) = $<;
$< = 0;
if(system("/usr/sbin/ntpdate -b $ntp_server >/dev/null 2>&1")){
my($alert_message) = $RETURN_CODE{"21"};
%return_hash = (
"return" => "error",
"error_contents" => "ntpdate_command",
"alert_message" => "uNTPT[ov" . $alert_message
);
$< = $id_org;
return %return_hash;
}
else{
if(system("/sbin/hwclock --systohc --utc >/dev/null 2>&1")){
my($alert_message) = $RETURN_CODE{"10"};
%return_hash = (
"return" => "error",
"error_contents" => "hwclock_command",
"alert_message" => "uhwclockv" . $alert_message
);
$< = $id_org;
return %return_hash;
}
}
}
}
}
SWITCH:{
if(0 == $schedule){last SWITCH;}
if(1 == $schedule){$day = 0; last SWITCH;}
if(2 == $schedule){$day = 1; last SWITCH;}
if(3 == $schedule){$day = 2; last SWITCH;}
if(4 == $schedule){$day = 3; last SWITCH;}
if(5 == $schedule){$day = 4; last SWITCH;}
if(6 == $schedule){$day = 5; last SWITCH;}
if(7 == $schedule){$day = 6; last SWITCH;}
if(8 == $schedule){$date = 1; last SWITCH;}
if(9 == $schedule){$date = 2; last SWITCH;}
if(10 == $schedule){$date = 3; last SWITCH;}
if(11 == $schedule){$date = 4; last SWITCH;}
if(12 == $schedule){$date = 5; last SWITCH;}
if(13 == $schedule){$date = 6; last SWITCH;}
if(14 == $schedule){$date = 7; last SWITCH;}
if(15 == $schedule){$date = 8; last SWITCH;}
if(16 == $schedule){$date = 9; last SWITCH;}
if(17 == $schedule){$date = 10; last SWITCH;}
if(18 == $schedule){$date = 11; last SWITCH;}
if(19 == $schedule){$date = 12; last SWITCH;}
if(20 == $schedule){$date = 13; last SWITCH;}
if(21 == $schedule){$date = 14; last SWITCH;}
if(22 == $schedule){$date = 15; last SWITCH;}
if(23 == $schedule){$date = 16; last SWITCH;}
if(24 == $schedule){$date = 17; last SWITCH;}
if(25 == $schedule){$date = 18; last SWITCH;}
if(26 == $schedule){$date = 19; last SWITCH;}
if(27 == $schedule){$date = 20; last SWITCH;}
if(28 == $schedule){$date = 21; last SWITCH;}
if(29 == $schedule){$date = 22; last SWITCH;}
if(30 == $schedule){$date = 23; last SWITCH;}
if(31 == $schedule){$date = 24; last SWITCH;}
if(32 == $schedule){$date = 25; last SWITCH;}
if(33 == $schedule){$date = 26; last SWITCH;}
if(34 == $schedule){$date = 27; last SWITCH;}
if(35 == $schedule){$date = 28; last SWITCH;}
}
if("manual" eq $set_info){
%return_set_crond = &set_crond("manual", $ntp_server, $minute, $hour, $date, $month, $day);
}
else{
%return_set_crond = &set_crond("ntp", $ntp_server, $minute, $hour, $date, $month, $day);
}
if("error" eq $return_set_crond{"return"}){
%return_hash = (
"return" => "error",
"error_contents" => $return_set_crond{"error_contents"},
"alert_message" => $return_set_crond{"alert_message"}
);
return %return_hash;
}
if( (40 == $schedule) && ("ntp" eq $set_info) ){
%return_set_ntpd = &set_ntpd("on", $ntp_server, $ntp_access_result);
}
else{
%return_set_ntpd = &set_ntpd("off", $ntp_server);
}
if("error" eq $return_set_ntpd{"return"}){
%return_hash = (
"return" => "error",
"error_contents" => $return_set_ntpd{"error_contents"},
"alert_message" => $return_set_ntpd{"alert_message"}
);
return %return_hash;
}
if("ntp" eq $set_info){
if("success" eq $ntp_access_result){
%return_hash = (
"return" => "success"
);
return %return_hash;
}
else{
%return_hash = (
"return" => "ntp_access_error"
);
return %return_hash;
}
}
else{
%return_hash = (
"return" => "success"
);
return %return_hash;
}
}
sub set_crond
{
my($regulation) = $_[0];
my($ntp_server) = $_[1];
my($minute) = $_[2];
my($hour) = $_[3];
my($date) = $_[4];
my($month) = $_[5];
my($day) = $_[6];
my($ntpd_flag);
my($no_auto_flag);
my($ntpdate_flag) = "off";
my(%return_hash);
if( ("@" eq $date) && ("@" eq $month) && ("@" eq $day) ){
$ntpd_flag = "on";
}
else{
$ntpd_flag = "off";
}
if( ("+" eq $date) && ("+" eq $month) && ("+" eq $day) ){
$no_auto_flag = "on";
}
else{
$no_auto_flag = "off";
}
my($path) = "$ROUTER_DATA/date_and_time/crond_file.txt";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "crond_file_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("PATH", "$path", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "crond_file_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "crond_file_tmp_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
# 2006/09/21
my($interval_ps_chk) = "off";
foreach(@tmp){
if(/^\s*(\#?)\s*(?:\d+)\s+(?:\d+)\s+(?:[\*\d\+\@]+)\s+(?:[\*\d\+\@]+)\s+(?:[\*\d\+\@]+)\s+(?:\/home\/ibsuser\/public_html\/Admin\/Sys_setup\/Router\/date_and_time\/ntpdate.pl)/){
$ntpdate_flag = "on";
if( ("manual" eq $regulation) || ("on" eq $ntpd_flag) || ("on" eq $no_auto_flag) ){
$_ = "\#$minute\t$hour\t$date\t$month\t$day\t$ROUTER/date_and_time/ntpdate.pl >/dev/null 2>&1\n";
}
else{
$_ = "$minute\t$hour\t$date\t$month\t$day\t$ROUTER/date_and_time/ntpdate.pl >/dev/null 2>&1\n";
}
}
# 2006/09/21
elsif(/(?:interval_ps\.bat)/){
$interval_ps_chk = "on";
}
else{
}
print TMP;
}
# 2006/09/21
if("off" eq $interval_ps_chk){
print TMP "50\t3\t*\t*\t*\t/bin/sh /etc/ibsbat/interval_ps.bat > /dev/null 2>&1\n";
}
close(TMP);
if("off" eq $ntpdate_flag){
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w+")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "crond_file_tmp_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
if( ("manual" eq $regulation) || ("on" eq $ntpd_flag) || ("on" eq $no_auto_flag) ){
print TMP "\#$minute\t$hour\t$date\t$month\t$day\t$ROUTER/date_and_time/ntpdate.pl >/dev/null 2>&1\n";
}
else{
print TMP "$minute\t$hour\t$date\t$month\t$day\t$ROUTER/date_and_time/ntpdate.pl >/dev/null 2>&1\n";
}
close(TMP);
}
rename("$path", "$path.ibs-soho.backup");
rename("$path.ibs-soho.tmp", "$path");
my($id_org) = $<;
$< = 0;
if(system("/usr/bin/crontab -u root $path >/dev/null 2>&1")){
my($alert_message) = $RETURN_CODE{10};
%return_hash = (
"return" => "error",
"error_contents" => "crontab_set_command",
"alert_message" => "uv" . $alert_message
);
$< = $id_org;
close(LOCK);
return %return_hash;
}
if(system("/etc/rc.d/init.d/crond restart >/dev/null 2>&1")){
my($alert_message) = $RETURN_CODE{"19"};
%return_hash = (
"return" => "error",
"error_contents" => "cron_reboot_command",
"alert_message" => "uv" . $alert_message
);
$< = $id_org;
close(LOCK);
return %return_hash;
}
$< = $id_org;
%return_hash = (
"return" => "success"
);
close(LOCK);
return %return_hash;
}
sub set_ntpd
{
my($set_info) = $_[0];
my($ntp_server) = $_[1];
my($ntp_access_result) = $_[2];
my($ntp_server_flag) = "off";
my(%return_hash);
my($ntp_conf_path) = "/etc/ntp.conf";
my($rc_conf_path) = "/etc/rc.conf";
if("error" eq &lock_file("NTP_CONF_LOCK", $ntp_conf_path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "ntp_conf_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &lock_file("RC_CONF_LOCK", $rc_conf_path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "rc_conf_lock",
"alert_message" => $alert_message
);
close(NTP_CONF_LOCK);
return %return_hash;
}
if("error" eq &open_file("NTP_CONF_PATH", "$ntp_conf_path", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "ntp_conf_open",
"alert_message" => $alert_message
);
close(NTP_CONF_LOCK);
close(RC_CONF_LOCK);
return %return_hash;
}
my(@tmp_ntp) = <NTP_CONF_PATH>;
close(NTP_CONF_PATH);
if("error" eq &open_file("RC_CONF_PATH", "$rc_conf_path", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "rc_conf_file_open",
"alert_message" => $alert_message
);
close(NTP_CONF_LOCK);
close(RC_CONF_LOCK);
return %return_hash;
}
my(@tmp_rc) = <RC_CONF_PATH>;
close(RC_CONF_PATH);
if("error" eq &open_file("NTP_CONF_TMP", "$ntp_conf_path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "ntp_conf_tmp_file_open",
"alert_message" => $alert_message
);
close(NTP_CONF_LOCK);
close(RC_CONF_LOCK);
return %return_hash;
}
foreach(@tmp_ntp){
if(/^\s*(?:server)\s+(\S*)\s*(?:\#ibs-soho)$/){
$ntp_server_flag = "on";
$_ = "server\t$ntp_server\t\#ibs-soho\n";
}
print NTP_CONF_TMP;
}
close(NTP_CONF_TMP);
if("off" eq $ntp_server_flag){
if("error" eq &open_file("NTP_CONF_TMP", "$ntp_conf_path.ibs-soho.tmp", "w+")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "ntp_conf_tmp_file_open",
"alert_message" => $alert_message
);
close(NTP_CONF_LOCK);
close(RC_CONF_LOCK);
return %return_hash;
}
else{
print NTP_CONF_TMP "server\t$ntp_server\t\#ibs-soho\n";
close(NTP_CONF_TMP);
}
}
if("error" eq &open_file("RC_CONF_TMP", "$rc_conf_path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "rc_conf_tmp_file_open",
"alert_message" => $alert_message
);
close(NTP_CONF_LOCK);
close(RC_CONF_LOCK);
return %return_hash;
}
foreach(@tmp_rc){
chomp;
if(/^\s*(?:ntpd=)(\S*)/){
if("off" eq $set_info){
$_ = "ntpd=NO\tntpd_flags=\"\"\t\#ibs-soho";
}
else{
$_ = "ntpd=YES\tntpd_flags=\"\"\t\#ibs-soho";
}
}
print RC_CONF_TMP "$_\n";
}
close(RC_CONF_TMP);
if("on" eq $set_info){
if("success" eq $ntp_access_result){
my($id_org) = $<;
$< = 0;
if(system("/usr/sbin/ntpdate -b $ntp_server >/dev/null 2>&1")){
my($alert_message) = $RETURN_CODE{"21"};
%return_hash = (
"return" => "error",
"error_contents" => "ntpdate_command",
"alert_message" => "uNTPSv" . $alert_message
);
close(NTP_CONF_LOCK);
close(RC_CONF_LOCK);
$< = $id_org;
return %return_hash;
}
else{
if(system("/sbin/hwclock --systohc --utc >/dev/null 2>&1")){
my($alert_message) = $RETURN_CODE{"10"};
%return_hash = (
"return" => "error",
"error_contents" => "hwclock_command",
"alert_message" => "uhwclockv" . $alert_message
);
close(NTP_CONF_LOCK);
close(RC_CONF_LOCK);
$< = $id_org;
return %return_hash;
}
}
$< = $id_org;
}
}
if("on" eq $set_info){
rename("$rc_conf_path", "$rc_conf_path.ibs-soho.backup.backup");
rename("$rc_conf_path.ibs-soho.tmp", "$rc_conf_path");
my($id_org) = $<;
$< = 0;
if(system("/etc/rc.d/init.d/ntpd start >/dev/null 2>&1")){
my($alert_message) = $RETURN_CODE{"17"};
%return_hash = (
"return" => "error",
"error_contents" => "ntpd_start",
"alert_message" => "uNTPCv" . $alert_message
);
rename("$rc_conf_path.ibs-soho.backup.backup", "$rc_conf_path");
close(NTP_CONF_LOCK);
close(RC_CONF_LOCK);
$< = $id_org;
return %return_hash;
}
else{
rename("$rc_conf_path.ibs-soho.backup.backup", "$rc_conf_path.ibs-soho.backup");
$< = $id_org;
}
}
if("on" eq $set_info){
rename("$ntp_conf_path", "$ntp_conf_path.ibs-soho.backup");
rename("$ntp_conf_path.ibs-soho.tmp", "$ntp_conf_path");
}
else{
rename("$ntp_conf_path", "$ntp_conf_path.ibs-soho.backup");
rename("$rc_conf_path", "$rc_conf_path.ibs-soho.backup");
rename("$ntp_conf_path.ibs-soho.tmp", "$ntp_conf_path");
rename("$rc_conf_path.ibs-soho.tmp", "$rc_conf_path");
}
%return_hash = (
"return" => "success"
);
close(NTP_CONF_LOCK);
close(RC_CONF_LOCK);
return %return_hash;
}
sub ntp_access_test
{
if(system("/usr/sbin/ntpdate -q $_[0] >/dev/null 2>&1")){
return "error";
}
else{
return "success";
}
}
1;
