# 2004/11/25
sub check_domain
{
my($domain) = $_[0];
unless($DOMAIN_NAME_LEN >= length($domain)){
return "error";
}
if( !($domain =~ /^[a-zA-Z\d\-\.]+$/) ){
return "error";
}
if("error" eq &check_ascii($domain)){
return "error";
}
else{
return "success";
}
}
sub check_host
{
my($host_name) = $_[0];
unless($HOST_NAME_LEN >= length($host_name)){
return "error";
}
if( !($host_name =~ /^[a-zA-Z]/) ){
return "error";
}
if( !($host_name =~ /[a-zA-Z\d]$/) ){
return "error";
}
if( !($host_name =~ /^[a-zA-Z\d\.\-]+$/) ){
return "error";
}
if("error" eq &check_ascii($host_name)){
return "error";
}
my($path) = "./reserve_host";
my(@reserve_host) = `/bin/cat $path`;
foreach(@reserve_host){
chomp;
if($_ eq $host_name){
return "error";
}
}
return "success";
}
sub get_dns
{
my($when) = $_[0];
my($backup);
my($refer_dns);
my($provider_entry);
my($primary_dns);
my($secondary_dns);
my(%return_hash);
my($path) = "$ROUTER_DATA/dns/dns.txt";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "dns_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("PATH", "$path$backup", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "dns_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
foreach(@tmp){
if(/^\s*(?:refer_dns=)(\S*)/){
$refer_dns = $1;
}
elsif(/^\s*(?:provider_entry=)(\S*)/){
$provider_entry = $1;
}
elsif(/^\s*(?:primary_dns=)(\S*)/){
$primary_dns = $1;
}
elsif(/^\s*(?:secondary_dns=)(\S*)/){
$secondary_dns = $1;
}
else{
}
}
%return_hash = (
"return" => "success",
"refer_dns" => $refer_dns,
"provider_entry" => $provider_entry,
"primary_dns" => $primary_dns,
"secondary_dns" => $secondary_dns
);
close(LOCK);
return %return_hash;
}
sub get_dns_table
{
my($when) = $_[0];
my($backup);
my($index);
my(@dns_table_number);
my(@dns_table_domain);
my(@dns_table_appoint);
my(@dns_table_dns_server);
my(@dns_table_domain_routing);
my(%return_hash);
my($path) = "$ROUTER_DATA/dns/dns_table.txt";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "dns_table_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("PATH", "$path$backup", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "dns_table_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
foreach(@tmp){
if(/^\s*(?:index=)(\S*)/){
$index = $1;
}
elsif(/^\s*(?:dns_table_number=)(\S*)/){
$dns_table_number[$index] = $1;
}
elsif(/^\s*(?:dns_table_domain=)(\S*)/){
$dns_table_domain[$index] = $1;
}
elsif(/^\s*(?:dns_table_appoint=)(\S*)/){
$dns_table_appoint[$index] = $1;
}
elsif(/^\s*(?:dns_table_dns_server=)(\S*)/){
$dns_table_dns_server[$index] = $1;
}
elsif(/^\s*(?:dns_table_domain_routing=)(\S*)/){
$dns_table_domain_routing[$index] = $1;
}
else{
}
}
%return_hash = (
"return" => "success",
"dns_table_number" => join("\#IBS-SOHO\#", @dns_table_number),
"dns_table_domain" => join("\#IBS-SOHO\#", @dns_table_domain),
"dns_table_appoint" => join("\#IBS-SOHO\#", @dns_table_appoint),
"dns_table_dns_server" => join("\#IBS-SOHO\#", @dns_table_dns_server),
"dns_table_domain_routing" => join("\#IBS-SOHO\#", @dns_table_domain_routing)
);
close(LOCK);
return %return_hash;
}
sub get_host_table
{
my($when) = $_[0];
my($backup);
my($index);
my(@host_table_number);
my(@host_table_host);
my(@host_table_ipaddress);
my(%return_hash);
my($path) = "$ROUTER_DATA/dns/host_table.txt";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "host_table_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("PATH", "$path$backup", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "host_table_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
foreach(@tmp){
if(/^\s*(?:index=)(\S*)/){
$index = $1;
}
elsif(/^\s*(?:host_table_number=)(\S*)/){
$host_table_number[$index] = $1;
}
elsif(/^\s*(?:host_table_host=)(\S*)/){
$host_table_host[$index] = $1;
}
elsif(/^\s*(?:host_table_ipaddress=)(\S*)/){
$host_table_ipaddress[$index] = $1;
}
else{
}
}
%return_hash = (
"return" => "success",
"host_table_number" => join("\#IBS-SOHO\#", @host_table_number),
"host_table_host" => join("\#IBS-SOHO\#", @host_table_host),
"host_table_ipaddress" => join("\#IBS-SOHO\#", @host_table_ipaddress)
);
close(LOCK);
return %return_hash;
}
sub set_dns
{
my($refer_dns) = $_[0];
my($provider_entry) = $_[1];
my($primary_dns) = $_[2];
my($secondary_dns) = $_[3];
my($pppoe) = $_[4];
my($refer_dns_flag) = "off";
my($provider_entry_flag) = "off";
my($primary_dns_flag) = "off";
my($secondary_dns_flag) = "off";
my(%return_hash);
my($path) = "$ROUTER_DATA/dns/dns.txt";
unless($pppoe =~ /./){
$pppoe = "off";
}
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "dns_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("PATH", "$path", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "dns_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "dns_tmp_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
foreach(@tmp){
chomp;
if(/^\s*refer_dns=/){
$refer_dns_flag = "on";
$_ = "refer_dns=$refer_dns";
}
elsif(/^\s*provider_entry=/){
$provider_entry_flag = "on";
$_ = "provider_entry=$provider_entry";
}
elsif(/^\s*primary_dns=/){
$primary_dns_flag = "on";
if("off" eq $pppoe){
$_ = "primary_dns=$primary_dns";
}
}
elsif(/^\s*secondary_dns=/){
$secondary_dns_flag = "on";
if("off" eq $pppoe){
$_ ="secondary_dns=$secondary_dns";
}
}
else{
next;
}
print TMP "$_\n";
}
if("off" eq $refer_dns_flag){
print TMP "refer_dns=$refer_dns\n";
}
if("off" eq $provider_entry_flag){
print TMP "provider_entry=$provider_entry\n";
}
if("off" eq $primary_dns_flag){
if("on" eq $pppoe){
print TMP "primary_dns=\n";
}
else{
print TMP "primary_dns=$primary_dns\n";
}
}
if("off" eq $secondary_dns_flag){
if("on" eq $pppoe){
print TMP "secondary_dns=\n";
}
else{
print TMP "secondary_dns=$secondary_dns\n";
}
}
close(TMP);
rename("$path", "$path.ibs-soho.backup");
rename("$path.ibs-soho.tmp", "$path");
%return_hash = (
"return" => "success"
);
close(LOCK);
return %return_hash;
}
sub set_dns_table
{
my(@dns_table_number) = split(/\#IBS-SOHO\#/, $_[0]);
my(@dns_table_domain) = split(/\#IBS-SOHO\#/, $_[1]);
my(@dns_table_appoint) = split(/\#IBS-SOHO\#/, $_[2]);
my(@dns_table_dns_server) = split(/\#IBS-SOHO\#/, $_[3]);
my(@dns_table_domain_routing) = split(/\#IBS-SOHO\#/, $_[4]);
my(%return_hash);
my($path) = "$ROUTER_DATA/dns/dns_table.txt";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "dns_table_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "dns_table_tmp_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my($loop_cnt);
for($loop_cnt = 0; $loop_cnt < $MAX_DNS_ROUTING_ENTRY; $loop_cnt++){
if("on" eq $dns_table_number[$loop_cnt]){
print TMP "index=$loop_cnt\n";
print TMP "dns_table_number=$dns_table_number[$loop_cnt]\n";
print TMP "dns_table_domain=$dns_table_domain[$loop_cnt]\n";
print TMP "dns_table_appoint=$dns_table_appoint[$loop_cnt]\n";
print TMP "dns_table_dns_server=$dns_table_dns_server[$loop_cnt]\n";
print TMP "dns_table_domain_routing=$dns_table_domain_routing[$loop_cnt]\n";
print TMP "\n";
}
}
close(TMP);
rename("$path", "$path.ibs-soho.backup");
rename("$path.ibs-soho.tmp", "$path");
%return_hash = (
"return" => "success"
);
close(LOCK);
return %return_hash;
}
sub set_host_table
{
my(@host_table_number) = split(/\#IBS-SOHO\#/, $_[0]);
my(@host_table_host) = split(/\#IBS-SOHO\#/, $_[1]);
my(@host_table_ipaddress) = split(/\#IBS-SOHO\#/, $_[2]);
my(%return_hash);
my($path) = "$ROUTER_DATA/dns/host_table.txt";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "host_table_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "host_table_tmp_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my($loop_cnt);
for($loop_cnt = 0; $loop_cnt < $MAX_HOST_TABLE_ENTRY; $loop_cnt++){
if("on" eq $host_table_number[$loop_cnt]){
print TMP "index=$loop_cnt\n";
print TMP "host_table_number=$host_table_number[$loop_cnt]\n";
print TMP "host_table_host=$host_table_host[$loop_cnt]\n";
print TMP "host_table_ipaddress=$host_table_ipaddress[$loop_cnt]\n";
print TMP "\n";
}
}
close(TMP);
rename("$path", "$path.ibs-soho.backup");
rename("$path.ibs-soho.tmp", "$path");
%return_hash = (
"return" => "success"
);
close(LOCK);
return %return_hash;
}
1;
