# 2006/01/26
sub check_service_access_hosts
{
my($hosts) = $_[0];
my($foreach_tmp);
my($ipaddress);
my($subnetmask);
my(@split_hosts) = split(/\s+/, $hosts);
foreach $foreach_tmp (@split_hosts){
if($foreach_tmp =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/){
$ipaddress = $foreach_tmp;
if("success" eq &check_ipaddress_ipv4($ipaddress)){
next;
}
}
elsif($foreach_tmp =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)\/(\d+)$/){
$ipaddress = sprintf("%d.%d.%d.%d", $1, $2, $3, $4);
$subnetmask = sprintf("%d", $5);
if("success" eq &check_subnetmask($subnetmask)){
if("success" eq &check_network_address($ipaddress, $subnetmask)){
next;
}
}
}
else{
return "error";
}
return "error";
}
return "success";
}
sub get_service_access
{
my($when) = $_[0];
my($service) = $_[1];
my($service_access_lan);
my($service_access_wan);
my($service_access_ip);
my($allow_hosts);
my($backup);
my(@split_allow_hosts);
my(%return_hash);
if("ftpd" eq $service){
$service_access_lan = "on";
$service_access_wan = "off";
$service_access_ip = "off";
$allow_hosts = "";
}
elsif("telnetd" eq $service){
}
else{
}
my($path) = "/etc/hosts.allow";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "hosts_allow_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
unless(-e "$path$backup"){
%return_hash = (
"return" => "success",
"service_access_lan" => $service_access_lan,
"service_access_wan" => $service_access_wan,
"service_access_ip" => $service_access_ip,
"service_hosts" => $allow_hosts
);
close(LOCK);
return %return_hash;
}
if("error" eq &open_file("PATH", "$path$backup", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "hosts_allow_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
foreach(@tmp){
chomp;
if($_ =~ /^\s*(\#?)\s*$service:\s+.*\s*\#ibs-soho-lan/){
if(!($1 =~ /./)){
$service_access_lan = "on";
}
else{
$service_access_lan = "off";
}
}
elsif($_ =~ /^\s*(\#?)\s*$service:\s+.*\s*\#ibs-soho-wan/){
if(!($1 =~ /./)){
$service_access_wan = "on";
}
else{
$service_access_wan = "off";
}
}
elsif($_ =~ /^\s*(\#?)\s*$service:\s+(.*)\s*\#ibs-soho-ip/){
my($tmp) = $1;
$allow_hosts = $2;
if( !($tmp =~ /./) ){
$service_access_ip = "on";
}
else{
$service_access_ip = "off";
}
}
else{
}
}
if($allow_hosts =~ /./){
@split_allow_hosts = split(/,/, $allow_hosts);
foreach(@split_allow_hosts){
s/^\s*//;
s/\s*$//;
if($_ =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)\/([\d\.]+)/){
$_ = sprintf("%d.%d.%d.%d/%s", $1, $2, $3, $4, &change_subnetmask($5));
}
}
$allow_hosts = join(" ", @split_allow_hosts);
}
%return_hash = (
"return" => "success",
"service_access_lan" => $service_access_lan,
"service_access_wan" => $service_access_wan,
"service_access_ip" => $service_access_ip,
"service_hosts" => $allow_hosts
);
close(LOCK);
return %return_hash;
}
sub set_service_access
{
my($service) = $_[0];
my($service_access_lan) = $_[1];
my($service_access_wan) = $_[2];
my($service_access_ip) = $_[3];
my($allow_hosts) = $_[4];
my($get_info) = $_[5];
my($lan_interface_name);
my($wan_interface_name);
my($set_to_lan);
my($set_to_wan);
my($set_to_hosts);
my($when) = "now";
my($wan_state_manual);
my($wan_state_dhcp);
my($wan_state_pppoe);
my(%return_hash);
unless($get_info =~ /./){
$get_info = "command";
}
my(%return_get_interface_name) = &get_interface_name();
if("error" eq $return_get_interface_name{"return"}){
%return_hash = (
"return" => "error",
"error_contents" => $return_get_interface_name{"error_contents"},
"alert_message" => $return_get_interface_name{"alert_message"}
);
return %return_hash;
}
else{
$lan_interface_name = $return_get_interface_name{"lan_interface_name"};
$wan_interface_name = $return_get_interface_name{"wan_interface_name"};
}
my($path) = "/etc/hosts.allow";
{
my(%return_get_ipaddress_of_lan);
if("command" eq $get_info){
%return_get_ipaddress_of_lan = &get_ipaddress_by_command($lan_interface_name);
}
else{
%return_get_ipaddress_of_lan = &get_ipaddress_by_file("now", $lan_interface_name);
}
if("error" eq $return_get_ipaddress_of_lan{"return"}){
%return_hash = (
"return" => "error",
"error_contents" => $return_get_ipaddress_of_lan{"error_contents"},
"alert_message" => $return_get_ipaddress_of_lan{"alert_message"}
);
return %return_hash;
}
else{
my($ipaddress_of_lan) = $return_get_ipaddress_of_lan{"ipaddress_ipv4"};
my($subnetmask_of_lan) = $return_get_ipaddress_of_lan{"subnetmask"};
if("command" eq $get_info){
$subnetmask_of_lan = &change_hexa_to_decimal($subnetmask_of_lan);
}
my($network_address_of_lan) = &get_network_address($ipaddress_of_lan, $subnetmask_of_lan);
$set_to_lan = sprintf("%s/%s", $network_address_of_lan, $subnetmask_of_lan);
}
}
my(@split_allow_hosts) = split(/\s+/, $allow_hosts);
foreach(@split_allow_hosts){
if($_ =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)\/(\d+)/){
$_ = sprintf("%d.%d.%d.%d/%s", $1, $2, $3, $4, &change_subnetmask($5));
}
}
$set_to_hosts = join(",", @split_allow_hosts);
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "hosts_allow_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("PATH", "$path", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "hosts_allow_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "hosts_allow_tmp_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my($lan_write_flag) = "off";
my($telnetd_flag) = "off";
foreach(@tmp){
chomp;
if($_ =~ /^\s*(\#)\s*(?:ibsnew)\s*$service:\s+(\S*)\s*\#ibs-soho-lan/){
$_ = sprintf("\#ibsnew $service: %s\t\#ibs-soho-lan", $set_to_lan);
$lan_write_flag = "on";
}
if($_ =~ /^\s*(\#?)\s*$service:\s+(\S*)\s*\#ibs-soho-lan/){
$_ = "$1$service: $2\t\#ibs-soho-lan\t\#ibsold";
}
if($_ =~ /^\s*(\#)\s*(?:ibsnew)\s*in\.telnetd:\s+(\S*)\s*\#ibs-soho-lan/){
$telnetd_flag = "on";
if("on" eq $TELNETD){
$_ = sprintf("\#ibsnew in.telnetd: %s\t\#ibs-soho-lan", $set_to_lan);
}
else{
next;
}
}
if($_ =~ /^\s*(\#?)\s*in\.telnetd:\s+(\S*)\s*\#ibs-soho-lan/){
my($tmp) = "in.telnetd";
if("on" eq $TELNETD){
$_ = "$1$tmp: $2\t\#ibs-soho-lan\t\#ibsold";
}
else{
next;
}
}
if($_ =~ /^\s*(\#?)\s*$service:\s+\S*\s*\#ibs-soho-wan$/){
if("on" eq $service_access_wan){
$_ = sprintf("$service: %s\t\#ibs-soho-wan", $set_to_wan);
}
else{
$_ = sprintf("\#$service: %s\t\#ibs-soho-wan", $set_to_wan);
}
}
if($_ =~ /^\s*(\#?)\s*$service:\s+\S*\s*\#ibs-soho-ip$/){
if("on" eq $service_access_ip){
$_ = sprintf("$service: %s\t\#ibs-soho-ip", $set_to_hosts);
}
else{
$_ = sprintf("#$service: %s\t\#ibs-soho-ip", $set_to_hosts);
}
}
print TMP "$_\n";
}
close(TMP);
if(("off" eq $lan_write_flag) || ("off" eq $telnetd_flag)){
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "hosts_allow_tmp_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
foreach(@tmp){
chomp;
if($_ =~ /^\s*(\#?)\s*$service:\s+(\S*)\s*\#ibs-soho-lan/){
if("off" eq $lan_write_flag){
my($tmp) = $_;
print TMP "\#ibsnew $service: $set_to_lan\t\#ibs-soho-lan\n";
$_ = $tmp;
}
}
if($_ =~ /^\s*(\#?)\s*in\.telnetd:\s+(\S*)\s*\#ibs-soho-lan/){
if("off" eq $telnetd_flag){
my($tmp) = $_;
if("on" eq $TELNETD){
print TMP "\#ibsnew in.telnetd: $set_to_lan\t\#ibs-soho-lan\n";
$_ = $tmp;
}
else{
next;
}
}
}
print TMP "$_\n";
}
close(TMP);
}
rename("$path", "$path.ibs-soho.backup");
rename("$path.ibs-soho.tmp", "$path");
%return_hash = (
"return" => "success"
);
close(LOCK);
return %return_hash;
}
1;
