# 2006/04/15
sub check_httpd_access_hosts
{
my($hosts) = $_[0];
my($foreach_tmp);
my($ipaddress);
my($subnetmask);
my(@split_hosts) = split(/\s+/, $hosts);
foreach $foreach_tmp (@split_hosts){
if($foreach_tmp =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/){
$ipaddress = $foreach_tmp;
if("success" eq &check_ipaddress_ipv4($ipaddress)){
next;
}
}
elsif($foreach_tmp =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)\/(\d+)$/){
$ipaddress = sprintf("%d.%d.%d.%d", $1, $2, $3, $4);
$subnetmask = sprintf("%d", $5);
if("success" eq &check_subnetmask($subnetmask)){
if("success" eq &check_network_address($ipaddress, $subnetmask)){
next;
}
}
}
else{
return "error";
}
return "error";
}
return "success";
}
sub get_service_access_of_httpd
{
my($when) = $_[0];
my($httpd_access_lan) = "on";
my($httpd_access_wan) = "off";
my($httpd_access_ip) = "off";
my($allow_hosts) = "";
my(@tmp);
my($path);
my($backup);
my(@split_allow_hosts);
my(%return_hash);
$path = "/usr/local/apache/conf/access.conf";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "access_onf_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
unless(-e "$path$backup"){
%return_hash = (
"return" => "success",
"httpd_access_lan" => $httpd_access_lan,
"httpd_access_wan" => $httpd_access_wan,
"httpd_access_ip" => $httpd_access_ip,
"allow_hosts" => $allow_hosts
);
close(LOCK);
return %return_hash;
}
if("error" eq &open_file("PATH", "$path$backup", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "access_conf_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
@tmp = <PATH>;
close(PATH);
foreach(@tmp){
chomp;
if($_ =~ /^\s*(\#?)\s*(?:allow from)\s+(\S*)\s*(?:\#ibs-soho-lan)/){
if($1 =~ /./){
$httpd_access_lan = "off";
}
else{
$httpd_access_lan = "on";
}
}
elsif($_ =~ /^\s*(\#?)\s*(?:allow from)\s+(\S*)\s*(?:\#ibs-soho-wan)/){
if($1 =~ /./){
$httpd_access_wan = "off";
}
else{
$httpd_access_wan = "on";
}
}
elsif($_ =~ /^\s*(\#?)\s*(?:allow from)\s+(.*)\s*(?:\#ibs-soho-ip)/){
my($tmp) = $1;
$allow_hosts = $2;
if($tmp =~ /./){
$httpd_access_ip = "off";
}
else{
$httpd_access_ip = "on";
}
}
else{
}
}
if($allow_hosts =~ /./){
@split_allow_hosts = split(/\s+/, $allow_hosts);
foreach(@split_allow_hosts){
s/^\s+//;
s/\s+$//;
}
$allow_hosts = join(" ", @split_allow_hosts);
}
%return_hash = (
"return" => "success",
"httpd_access_lan" => $httpd_access_lan,
"httpd_access_wan" => $httpd_access_wan,
"httpd_access_ip" => $httpd_access_ip,
"allow_hosts" => $allow_hosts
);
close(LOCK);
return %return_hash;
}
sub set_service_access_of_httpd
{
my($httpd_access_lan) = $_[0];
my($httpd_access_wan) = $_[1];
my($httpd_access_ip) = $_[2];
my($allow_hosts) = $_[3];
my($reboot) = $_[4];
my($get_info) = $_[5];
my(%return_hash);
my($lan_interface_name);
my($wan_interface_name);
my($wan_state_manual);
my($wan_state_dhcp);
my($wan_state_pppoe);
my($set_to_lan);
my($set_to_wan);
my($set_to_hosts);
my($when) = "now";
unless($reboot =~ /./){
$reboot = "on";
}
unless($get_info =~ /./){
$get_info = "command";
}
my(%return_get_interface_name) = &get_interface_name();
if("error" eq $return_get_interface_name{"return"}){
%return_hash = (
"return" => "error",
"error_contents" => $return_get_interface_name{"error_contents"},
"alert_message" => $return_get_interface_name{"alert_message"}
);
return %return_hash;
}
else{
$lan_interface_name = $return_get_interface_name{"lan_interface_name"};
$wan_interface_name = $return_get_interface_name{"wan_interface_name"};
}
my($path) = "/usr/local/apache/conf/access.conf";
my($restart_path) = "/usr/local/apache/bin/apachectl";
{
my(%return_get_ipaddress_of_lan);
if("command" eq $get_info){
%return_get_ipaddress_of_lan = &get_ipaddress_by_command($lan_interface_name);
}
elsif("file" eq $get_info){
%return_get_ipaddress_of_lan = &get_ipaddress_by_file("now", $lan_interface_name);
}
if("error" eq $return_get_ipaddress_of_lan{"return"}){
%return_hash = (
"return" => "error",
"error_contents" => $return_get_ipaddress_of_lan{"error_contemts"},
"alert_message" => $return_get_ipaddress_of_lan{"alert_message"}
);
return %return_hash;
}
else{
my($ipaddress_of_lan) = $return_get_ipaddress_of_lan{"ipaddress_ipv4"};
my($subnetmask_of_lan) = $return_get_ipaddress_of_lan{"subnetmask"};
if("command" eq $get_info){
$subnetmask_of_lan = &change_hexa_to_decimal($subnetmask_of_lan);
}
my($network_address_of_lan) = &get_network_address($ipaddress_of_lan, $subnetmask_of_lan);
$subnetmask_of_lan = &change_subnetmask($subnetmask_of_lan);
$set_to_lan = sprintf("%s/%s", $network_address_of_lan, $subnetmask_of_lan);
}
}
my(@split_allow_hosts) = split(/\s+/, $allow_hosts);
$set_to_hosts = join(" ", @split_allow_hosts);
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "access_conf_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("PATH", "$path", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "access_conf_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "access_conf_tmp_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my($lan_write_flag) = "off";
foreach(@tmp){
chomp;
if($_ =~ /^\s*(\#)\s*(?:ibsnew)\s*(?:allow from)\s+(\S*)\s*(?:\#ibs-soho-lan)/){
$_ = sprintf("\#ibsnew allow from %s\t\#ibs-soho-lan", $set_to_lan);
$lan_write_flag = "on";
}
elsif($_ =~ /^\s*(?:allow from)\s*(\S*)\s*(?:\#ibs-soho-lan)/){
$_ = sprintf("allow from $1\t\#ibs-soho-lan\t\#ibsold", $set_to_lan);
}
elsif($_ =~ /^\s*(\#?)\s*(?:allow from)\s+(.*)\s*(?:\#ibs-soho-ip)$/){
if("on" eq $httpd_access_ip){
$_ = sprintf("allow from %s\t\#ibs-soho-ip", $set_to_hosts);
}
else{
$_ = sprintf("#allow from %s\t\#ibs-soho-ip", $set_to_hosts);
}
}
print TMP "$_\n";
}
close(TMP);
if("off" eq $lan_write_flag){
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "access_conf_tmp_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
foreach(@tmp){
chomp;
if($_ =~ /^\s*(\#?)\s*(?:allow from)\s+(\S*)\s*(?:\#ibs-soho-lan)/){
my($tmp) = $_;
print TMP "\#ibsnew allow from $set_to_lan\t\#ibs-soho-lan\n";
$_ = $tmp;
}
print TMP "$_\n";
}
close(TMP);
}
rename("$path", "$path.ibs-soho.backup");
rename("$path.ibs-soho.tmp", "$path");
if("on" eq $reboot){
my($id_org) = $<;
$< = 0;
if(system("$restart_path graceful >/dev/null 2>&1 &")){
my($alert_message) = $RETURN_CODE{"19"};
%return_hash = (
"return" => "error",
"error_contents" => "restart_command",
"alert_message" => "uWEBT[ov" . $alert_message
);
close(LOCK);
$< = $id_org;
return %return_hash;
}
else{
%return_hash = (
"return" => "success"
);
close(LOCK);
$< = $id_org;
return %return_hash;
}
}
else{
%return_hash = (
"return" => "success"
);
close(LOCK);
return %return_hash;
}
}
1;
