# 2006/04/24
use Socket;
sub check_gw_ipaddress
{
my($address_type) = $_[0];
my($ipaddress) = $_[1];
my($gw_ipaddress) = $_[2];
my($subnetmask) = $_[3];
my($check_ipaddress);
my($check_gw_ipaddress);
if("ipv4" eq $address_type){
if($ipaddress eq $gw_ipaddress){
return "error";
}
my(@split_ipaddress) = split(/\./, $ipaddress);
my(@split_gw_ipaddress) = split(/\./, $gw_ipaddress);
foreach(@split_ipaddress){
$_ = unpack("B8", pack("c*", $_));
}
my($bit_ipaddress) = join("", @split_ipaddress);
foreach(@split_gw_ipaddress){
$_ = unpack("B8", pack("c*", $_));
}
my($bit_gw_ipaddress) = join("", @split_gw_ipaddress);
if($bit_ipaddress =~ /^([01]{$subnetmask})/){
$check_ipaddress = $1;
}
if($bit_gw_ipaddress =~ /^([01]{$subnetmask})/){
$check_gw_ipaddress = $1;
}
if($check_ipaddress eq $check_gw_ipaddress){
return "success";
}
else{
return "error";
}
}
}
sub check_quota_ipaddress
{
my($quota_ipaddress1) = $_[0];
my($quota_ipaddress2) = $_[1];
my($ipaddress) = $_[2];
my($gw_ipaddress) = $_[3];
my($dhcp_server_notice_gateway) = $_[4];
my($subnetmask) = $_[5];
my($check_ipaddress);
my($check_quota_ipaddress1);
my($check_quota_ipaddress2);
my(@split_ipaddress) = split(/\./, $ipaddress);
my(@split_quota_ipaddress1) = split(/\./, $quota_ipaddress1);
my(@split_quota_ipaddress2) = split(/\./, $quota_ipaddress2);
my($loop_cnt);
my($square_cnt);
my($static_num);
for($loop_cnt = 3, $square_cnt = 0; $loop_cnt >= 0; $loop_cnt--, $square_cnt++){
$static_num += (2 ** ($square_cnt * 8)) * ($split_quota_ipaddress2[$loop_cnt] - $split_quota_ipaddress1[$loop_cnt]);
}
unless( ($MIN_DHCP_RANGE <= $static_num) && ($MAX_DHCP_RANGE >= $static_num) ){
return "error";
}
my(@all_ipaddress);
my(%return_get_all_ipaddress) = &get_all_ipaddress($quota_ipaddress1, $quota_ipaddress2);
if("error" eq $return_get_all_ipaddress{"return"}){
return "error";
}
else{
@all_ipaddress = split(/\#IBS-SOHO\#/, $return_get_all_ipaddress{"ipaddress"});
}
foreach(@all_ipaddress){
chomp;
if($_ eq $ipaddress){
return "error";
}
elsif($_ eq $gw_ipaddress){
return "error";
}
elsif($_ eq $dhcp_server_notice_gateway){
return "error";
}
else{
}
}
foreach(@split_ipaddress){
$_ = unpack("B8", pack("c*", $_));
}
my($bit_ipaddress) = join("", @split_ipaddress);
foreach(@split_quota_ipaddress1){
$_ = unpack("B8", pack("c*", $_));
}
my($bit_quota_ipaddress1) = join("", @split_quota_ipaddress1);
foreach(@split_quota_ipaddress2){
$_ = unpack("B8", pack("c*", $_));
}
my($bit_quota_ipaddress2) = join("", @split_quota_ipaddress2);
if($bit_ipaddress =~ /^([01]{$subnetmask})/){
$check_ipaddress = $1;
}
if($bit_quota_ipaddress1 =~ /^([01]{$subnetmask})/){
$check_quota_ipaddress1 = $1;
}
if($bit_quota_ipaddress2 =~ /^([01]{$subnetmask})/){
$check_quota_ipaddress2 = $1;
}
if( ($check_ipaddress eq $check_quota_ipaddress1) && ($check_ipaddress eq $check_quota_ipaddress2) ){
return "success";
}
else{
return "error";
}
}
sub check_lease_time
{
my($lease_time) = $_[0];
unless($lease_time =~ /^\d+$/){
return "error";
}
unless($lease_time eq sprintf("%d", $lease_time)){
return "error";
}
if( ($MIN_LEASE_TIME <= $lease_time) && ($MAX_LEASE_TIME >= $lease_time) ){
return "success";
}
else{
return "error";
}
}
sub check_mac_address
{
my($mac_address) = $_[0];
if($mac_address =~ /^[\da-fA-F]{2}:[\da-fA-F]{2}:[\da-fA-F]{2}:[\da-fA-F]{2}:[\da-fA-F]{2}:[\da-fA-F]{2}$/){
return "success";
}
else{
return "error";
}
}
sub check_host_name
{
my($host_name) = $_[0];
unless($HOST_NAME_LEN >= length($host_name)){
return "error";
}
if( !($host_name =~ /^[a-zA-Z]/) ){
return "error";
}
if( !($host_name =~ /[a-zA-Z\d]$/) ){
return "error";
}
if( !($host_name =~ /^[a-zA-Z\d\-\.]+$/) ){
return "error";
}
if("success" eq &check_ascii($host_name)){
return "success";
}
else{
return "error";
}
}
sub get_reboot_request
{
my($reboot_request);
my(%return_hash);
my($path) = "$ROUTER/ipaddress_of_lan/reboot_request.txt";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "reboot_request_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("PATH", "$path", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "reboot_request_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
foreach(@tmp){
if($_ =~ /^\s*(?:reboot_request=)(\S+)/){
if("YES" eq $1){
$reboot_request = "yes";
}
else{
$reboot_request = "no";
}
last;
}
}
%return_hash = (
"return" => "success",
"reboot_request" => $reboot_request
);
close(LOCK);
return %return_hash;
}
sub get_gw_error
{
my($gw_error);
my(%return_hash);
my($path) = "$ROUTER/ipaddress_of_lan/gw_error.txt";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "ge_error_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("PATH", "$path", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "gw_error_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
foreach(@tmp){
if($_ =~ /^\s*(?:gw_error=)(\S+)/){
if("ON" eq $1){
$gw_error = "on";
}
else{
$gw_error = "off";
}
last;
}
}
%return_hash = (
"return" => "success",
"gw_error" => $gw_error
);
close(LOCK);
return %return_hash;
}
sub get_gw
{
my($backup);
my($gw_ipaddress);
my(%return_hash);
if("before" eq $_[0]){
$backup = ".ibs-soho.backup";
}
my($path) = "/etc/hosts";
my($return_lockf) = &lockf("hosts");
if("error0" eq $return_lockf){
%return_hash = (
"return" => "error",
"error_contents" => "hosts_lock",
"alert_message" => $ERROR_L0
);
return %return_hash;
}
elsif("error1" eq $return_lockf){
%return_hash = (
"return" => "error",
"error_contents" => "hosts_lock",
"alert_message" => $ERROR_L1
);
return %return_hash;
}
elsif("error2" eq $return_lockf){
%return_hash = (
"return" => "error",
"error_contents" => "hosts_lock",
"alert_message" => $ERROR_L2
);
return %return_hash;
}
else{
}
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "hosts_lock",
"alert_message" => $alert_message
);
&unlockf("hosts");
return %return_hash;
}
if("error" eq &open_file("PATH", "$path", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "hosts_open",
"alert_message" => $alert_message
);
&unlockf("hosts");
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
foreach(@tmp){
if($_ =~ /^\s*(?:\#ibsnew)\s+(\S+)\s+(?:ibsgw)/){
$gw_ipaddress = $1;
last;
}
}
unless($gw_ipaddress =~ /./){
foreach(@tmp){
if($_ =~ /^\s*(\S+)\s+(?:ibsgw)/){
$gw_ipaddress = $1;
last;
}
}
}
unless($gw_ipaddress =~ /./){
$gw_ipaddress = "192.168.1.2";
}
my($return_unlockf) = &unlockf("hosts");
if("success" eq $return_unlockf){
%return_hash = (
"return" => "success",
"gw_ipaddress" => $gw_ipaddress
);
}
else{
%return_hash = (
"return" => "error",
"error_contents" => "hosts_unlock",
"alert_message" => $ERROR_U1
);
}
close(LOCK);
return %return_hash;
}
sub get_dhcp_server_state
{
my($when) = $_[0];
my($interface_name) = $_[1];
my($backup);
my($dhcp_server_state);
my(%return_hash);
my($path) = "/etc/rc.conf";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "rc_conf_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("PATH", "$path$backup", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "rc_conf_open",
"alert_message" => $alert_message
);
close (LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
foreach(@tmp){
if($_ =~ /^\s*(?:dhcpd=)(\S+)\s+dhcpd_flags="(?:-q)\s+(\S*)(?:,?)(\S*)"\s+(\#ibs-soho)/){
if( ("YES" eq $1) && ( ($interface_name eq $2) || ($interface_name eq $3) ) ){
$dhcp_server_state = "start";
}
else{
$dhcp_server_state = "stop";
}
last;
}
}
%return_hash = (
"return" => "success",
"dhcp_server_state" => $dhcp_server_state
);
close (LOCK);
return %return_hash;
}
sub get_dhcp_server
{
my($when) = $_[0];
my($backup);
my($quota_ipaddress1);
my($quota_ipaddress2);
my($subnetmask);
my($notice_gateway);
my($lease_time);
my($notice_dns);
my($notice_dns_auto);
my($primary_dns);
my($secondary_dns);
my($primary_wins);
my($secondary_wins);
my(%return_hash);
my($path) = "/etc/dhcpd.conf";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "dhcpd_conf_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("PATH", "$path$backup", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "dhcpd_conf_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
foreach(@tmp){
if($_ =~ /^\s*(?:\#ibs-soho-domain-name-servers)\s+(?:\#)(\S+)/){
if("ip" eq $1){
$notice_dns = "ip";
}
elsif("proxy" eq $1){
$notice_dns = "proxy";
}
elsif("auto" eq $1){
$notice_dns = "auto";
}
elsif("no" eq $1){
$notice_dns = "no";
}
else{
my($alert_message) = $RETURN_CODE{"11"};
%return_hash = (
"return" => "error",
"error_ontents" => "no_dns",
"alert_message" => "uDNSv" . $alert_message
);
close(LOCK);
return %return_hash;
}
}
if($_ =~ /^\s*(\#?)\s*(?:option)\s+(?:domain-name-servers)\s*([\d\.]*)(?:,?)\s*([\d\.]*);\s+(?:\#ibs-soho-domain-name-servers-ip)/){
$primary_dns = $2;
$secondary_dns = $3;
}
if($_ =~ /^\s*(\#?)\s*(?:option)\s+(?:domain-name-servers)\s*([\d\.\s\,]*);\s+(?:\#ibs-soho-domain-name-servers-auto)\s*(?:\#?)(\S*)/){
if($3 =~ /^pppoe(\d+)/){
$notice_dns_auto = "pppoe$1";
}
}
if($_ =~ /^\s*(\#?)\s*(?:default-lease-time)\s+([\d\-]+);/){
$lease_time = $2;
if("-1" eq $lease_time){
$lease_time = "0";
}
else{
$lease_time /= (60 * 60);
}
}
if($_ =~ /^\s*(\#?)\s*(?:option)\s+(?:routers)\s*([\d\.]*);/){
$notice_gateway = $2;
}
if($_ =~ /^\s*(\#?)\s*(?:range)\s+([\d\.]+)\s+([\d\.]+);/){
$quota_ipaddress1 = $2;
$quota_ipaddress2 = $3;
}
if($_ =~ /^\s*(\#?)\s*(?:option)\s+(?:netbios-name-servers)\s+([\d\.]*)(?:,?)\s*([\d\.]*);/){
$primary_wins = $2;
$secondary_wins = $3;
}
}
%return_hash = (
"retrn" => "sucess",
"quota_ipaddress1" => $quota_ipaddress1,
"quota_ipaddress2" => $quota_ipaddress2,
"notice_gateway" => $notice_gateway,
"lease_time" => $lease_time,
"notice_dns" => $notice_dns,
"notice_dns_auto" => $notice_dns_auto,
"primary_dns" => $primary_dns,
"secondary_dns" => $secondary_dns,
"primary_wins" => $primary_wins,
"secondary_wins" => $secondary_wins
);
close(LOCK);
return %return_hash;
}
sub get_static_dhcp
{
my($when) = $_[0];
my(@number);
my(@ipaddress);
my(@mac_address);
my(@host_name);
my($backup);
my(%return_hash);
my($path) = "/etc/dhcpd.conf";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "dhcpd_conf_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("PATH", "$path$backup", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "dhcpd_conf_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
my($set_number);
foreach(@tmp){
if($_ =~ /^\s*(?:host)\s+(\S*)\s*\{\s+\#(?:ibs-soho-static-no\.)(\d+)/){
$set_number = $2;
$number[$set_number] = "on";
}
if($_ =~ /^\s*(\#?)\s*hardware\s+ethernet\s*(\S*);/){
$mac_address[$set_number] = $2;
}
if($_ =~ /^\s*(\#?)\s*fixed-address\s*(\S*);/){
$ipaddress[$set_number] = $2;
}
if($_ =~ /^\s*(\#?)\s*(?:option)\s+(?:host-name)\s*"(\S*)";/){
$host_name[$set_number] = $2;
}
}
%return_hash = (
"return" => "success",
"number" => join("\#IBS-SOHO\#", @number),
"ipaddress" => join("\#IBS-SOHO\#", @ipaddress),
"host_name" => join("\#IBS-SOHO\#", @host_name),
"mac_address" => join("\#IBS-SOHO\#", @mac_address)
);
close(LOCK);
return %return_hash;
}
sub set_reboot_request
{
my($reboot_request) = $_[0];
my(%return_hash);
my($path) = "$ROUTER/ipaddress_of_lan/reboot_request.txt";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "reboot_request_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "tmp_file_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
if("yes" eq $reboot_request){
print TMP "reboot_request=YES\n";
}
else{
print TMP "reboot_request=NO\n";
}
close(TMP);
rename("$path.ibs-soho.tmp", "$path");
%return_hash = (
"return" => "success"
);
close(LOCK);
return %return_hash;
}
sub set_gw_error
{
my($gw_error) = $_[0];
my(%return_hash);
my($path) = "$ROUTER/ipaddress_of_lan/gw_error.txt";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "gw_error_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "tmp_file_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
if("on" eq $gw_error){
print TMP "gw_error=ON\n";
}
else{
print TMP "gw_error=OFF\n";
}
close(TMP);
rename("$path.ibs-soho.tmp", "$path");
%return_hash = (
"return" => "success"
);
close(LOCK);
return %return_hash;
}
sub set_gw
{
my($gw_ipaddress) = $_[0];
my($ipaddress) = $_[1];
my($subnetmask) = $_[2];
my($write_flag) = "off";
my(%return_hash);
my($path) = "/etc/hosts";
my($return_lockf) = &lockf("hosts");
if("error0" eq $return_lockf){
%return_hash = (
"return" => "error",
"error_contents" => "hosts_lock",
"alert_message" => $ERROR_L0
);
return %return_hash;
}
elsif("error1" eq $return_lockf){
%return_hash = (
"return" => "error",
"error_contents" => "hosts_lock",
"alert_message" => $ERROR_L1
);
return %return_hash;
}
elsif("error2" eq $return_lockf){
%return_hash = (
"return" => "error",
"error_contents" => "hosts_lock",
"alert_message" => $ERROR_L2
);
return %return_hash;
}
else{
}
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "hosts_lock",
"alert_message" => $alert_message
);
&unlockf("hosts");
return %return_hash;
}
if("error" eq &open_file("PATH", "$path", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "hosts_open",
"alert_message" => $alert_message
);
&unlockf("hosts");
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "hosts_tmp_open",
"alert_message" => $alert_message
);
&unlockf("hosts");
close(LOCK);
return %return_hash;
}
foreach(@tmp){
chomp;
if("manual" eq $LAN_MODE){
if($_ =~ /^\s*(\#)\s*(?:ibsnew)\s*([\d\.]+)\s*(?:ibsgw)\s*$/){
$write_flag = "on";
$_ = "\#ibsnew $gw_ipaddress\tibsgw";
}
if($_ =~ /^\s*([\d\.]+)\s*(?:ibsgw)/){
$_ = "$1\tibsgw\t#ibsold";
}
print TMP "$_\n";
}
elsif("auto" eq $LAN_MODE){
if($_ =~ /^\s*([\d\.]+)\s*(?:ibsgw)/){
$write_flag = "on";
$_ = "$gw_ipaddress\tibsgw";
}
print TMP "$_\n";
}
else{
}
}
close(TMP);
if("manual" eq $LAN_MODE){
if("off" eq $write_flag){
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "hosts_tmp_open",
"alert_message" => $alert_message
);
&unlockf("hosts");
close(LOCK);
return %return_hash;
}
foreach(@tmp){
chomp;
if($_ =~ /^\s*([\d\.]+)\s*(?:ibsgw)\s*(?:\#ibsold)/){
my($tmp) = $_;
$write_flag = "on";
print TMP "\#ibsnew $gw_ipaddress ibsgw\n";
$_ = $tmp;
}
print TMP "$_\n";
}
close(TMP);
}
}
if("off" eq $write_flag){
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w+")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "hosts_tmp_open",
"alert_message" => $alert_message
);
&unlockf("hosts");
close(LOCK);
return %return_hash;
}
print TMP "$gw_ipaddress\tibsgw\n";
close(TMP);
}
rename("$path", "$path.ibs-soho.backup");
rename("$path.ibs-soho.tmp", "$path");
my($ip1);
my($ip2);
my($ip3);
my($ip4);
my($ntmk);
my($defgw1);
my($defgw2);
my($defgw3);
my($defgw4);
my($user) = "ibsgw";
my($pass) = "ibsgw";
my($host) = "ibsgw";
if($gw_ipaddress =~ /^([\d]+)\.([\d]+)\.([\d]+)\.([\d]+)$/){
$ip1 = $1;
$ip2 = $2;
$ip3 = $3;
$ip4 = $4;
}
$ntmk = $subnetmask;
if($ipaddress =~ /^([\d]+)\.([\d]+)\.([\d]+)\.([\d]+)$/){
$defgw1 = $1;
$defgw2 = $2;
$defgw3 = $3;
$defgw4 = $4;
}
my($send_data) = "ip1=$ip1&1p2=$ip2&ip3=$ip3&ip4=$ip4&ntmk=$ntmk&defgw1=$defgw1&defgw2=$defgw2&defgw3=$defgw3&defgw4=$defgw4&submit=ݒ&USER=$user&PASS=$pass&";
my($send_data_len) = length($send_data) + 8;
if ( !socket(SOCKET, PF_INET, SOCK_STREAM, getprotobyname('tcp')) ) {
my($alert_message) = $RETURN_CODE{"204"};
%return_hash = (
"return" => "error",
"error_contents" => "socket",
"alert_message" => $alert_message
);
&unlockf("hosts");
close(LOCK);
return %return_hash;
}
my($port) = 80;
if ( !connect(SOCKET, sockaddr_in($port, inet_aton($host))) ){
my($alert_message) = $RETURN_CODE{"205"};
%return_hash = (
"return" => "error",
"error_contents" => "connect",
"alert_message" => $alert_message
);
close(SOCKET);
close(LOCK);
&unlockf("hosts");
return %return_hash;
}
select(SOCKET);
$| = 1;
select(STDOUT);
print SOCKET "POST /tlan2 HTTP/1.0\r\n";
print SOCKET "Content-Length: $send_data_len\r\n";
print SOCKET "\r\n";
print SOCKET "$send_data";
eval{
local $SIG{ALRM} = sub{die "timeout"};
alarm 10;
while(<SOCKET>){
m/^\r\n$/;
last;
}
alarm 0;
};
alarm 0;
if($@){
if($@ =~ /timeout/){
my($alert_message) = $RETURN_CODE{"205"};
%return_hash = (
"return" => "error",
"error_contents" => "timeout",
"alert_message" => $alert_message
);
&unlockf("hosts");
close(LOCK);
return %return_hash;
}
}
my($set_gw_error_flag) = "on";
while(<SOCKET>){
if($_ =~ /set_gw_ipaddr_error/){
$set_gw_error_flag = "on";
last;
}
elsif($_ =~ /ok/i){
$set_gw_error_flag = "off";
last;
}
else{
}
}
if("on" eq $set_gw_error_flag){
my($alert_message) = $RETURN_CODE{"206"};
%return_hash = (
"return" => "error",
"error_contents" => "set_gw_ipaddress",
"alert_message" => $alert_message
);
&unlockf("hosts");
close(LOCK);
return %return_hash;
}
my($return_unlockf) = &unlockf("hosts");
if("success" eq $return_unlockf){
%return_hash = (
"return" => "success"
);
}
else{
%return_hash = (
"return" => "error",
"error_contents" => "hosts_unlock",
"alert_message" => $ERROR_U1
);
}
close(LOCK);
return %return_hash;
}
sub set_ipaddress_to_file
{
my($interface_name) = $_[0];
my($address_type) = $_[1];
my($ipaddress) = $_[2];
my($subnetmask);
my($path);
my($broadcast);
my($ipv4_write_flag) = "off";
my($subnetmask_write_flag) = "off";
my($broadcast_write_flag) = "off";
my(%return_hash);
if("ipv4" eq $address_type){
$subnetmask = $_[3];
}
if("linux" eq $OS){
$broadcast = &get_broadcast($ipaddress, $subnetmask);
}
if($subnetmask =~ /./){
$subnetmask = &change_subnetmask($subnetmask);
}
if($interface_name =~ /./){
if("netbsd" eq $OS){
}
else{
$path = sprintf("/etc/sysconfig/network-scripts/ifcfg-%s", $interface_name);
}
}
else{
my($alert_message) = $RETURN_CODE{"100"};
%return_hash = (
"return" => "error",
"error_contents" => "no_interface_name",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "ifconfig_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("PATH", "$path", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "ifconfig_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "ifconfig_tmp_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
foreach(@tmp){
if("netbsd" eq $OS){
}
else{
if($_ =~ /^\s*(\#?)\s*(?:IPADDR=)/){
if("ipv4" eq $address_type){
$ipv4_write_flag = "on";
$_ = "IPADDR=$ipaddress\n";
}
}
elsif($_ =~ /^\s*(\#?)\s*(?:NETMASK=)/){
if("ipv4" eq $address_type){
$subnetmask_write_flag = "on";
$_ = "NETMASK=$subnetmask\n";
}
}
elsif($_ =~ /^\s*(\#?)\s*(?:BROADCAST=)/){
if("ipv4" eq $address_type){
$broadcast_write_flag = "on";
$_ = "BROADCAST=$broadcast\n";
}
}
else{
}
}
print TMP;
}
close(TMP);
if(
("ipv4" eq $address_type) &&
( ("off" eq $ipv4_write_flag) || ( ("linux" eq $OS) && ( ("off" eq $subnetmask_write_flag) || ("off" eq $broadcast_write_flag) ) ) )
){
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w+")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "ifconfig_tmp_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
if("netbsd" eq $OS){
}
else{
if("off" eq $ipv4_write_flag){
print TMP "IPADDR=$ipaddress\n";
}
if("off" eq $subnetmask_write_flag){
print TMP "NETMASK=$subnetmask\n";
}
if("off" eq $broadcast_write_flag){
print TMP "BROADCAST=$broadcast\n";
}
}
close(TMP);
}
rename("$path", "$path.ibs-soho.backup");
rename("$path.ibs-soho.tmp", "$path");
%return_hash = (
"return" => "success"
);
close(LOCK);
return %return_hash;
}
sub set_dhcp_server
{
my($quota_ipaddress1) = $_[0];
my($quota_ipaddress2) = $_[1];
my($notice_gateway) = $_[2];
my($lease_time) = $_[3];
my($notice_dns) = $_[4];
my($notice_dns_auto) = $_[5];
my($primary_dns) = $_[6];
my($secondary_dns) = $_[7];
my($primary_wins) = $_[8];
my($secondary_wins) = $_[9];
my($interface_name) = $_[10];
my($ipaddress_of_lan);
my($subnetmask_of_lan);
my($network_address_of_lan);
my($routers_flag) = "off";
my($range_flag) = "off";
my($wins_flag) = "off";
my(%return_hash);
my($path) = "/etc/dhcpd.conf";
$lease_time *= (60 * 60);
my(%return_get_ipaddress_by_file) = &get_ipaddress_by_file("now", $interface_name);
if("error" eq $return_get_ipaddress_by_file{"return"}){
%return_hash = (
"return" => "error",
"error_contents" => $return_get_ipaddress_by_file{"error_contents"},
"alert_message" => $return_get_ipaddress_by_file{"alert_message"}
);
return %return_hash;
}
else{
$ipaddress_of_lan = $return_get_ipaddress_by_file{"ipaddress_ipv4"};
$subnetmask_of_lan = $return_get_ipaddress_by_file{"subnetmask"};
}
$network_address_of_lan = &get_network_address($ipaddress_of_lan, $subnetmask_of_lan);
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "dhcpd_conf_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("PATH", "$path", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "dhcpd_conf_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "dhcpd_conf_tmp_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
foreach(@tmp){
if($_ =~ /^\s*(\#?)\s*(?:ibs-soho-domain-name-servers)\s+(?:\#)(\S*)/){
if("auto" eq $notice_dns){
$_ = "\#ibs-soho-domain-name-servers\t\#$notice_dns\t$notice_dns_auto\n";
}
else{
$_ = "\#ibs-soho-domain-name-servers\t\#$notice_dns\n";
}
}
if($_ =~ /^\s*(\#?)\s*(?:option)\s+(?:domain-name-servers)\s*([\d\.]*)(?:,?)\s*([\d\.]*);\s+(?:\#ibs-soho-domain-name-servers-ip)/){
my($write_dns);
if(($primary_dns =~ /./) && ($secondary_dns =~ /./)){
$write_dns = "$primary_dns, $secondary_dns";
}
else{
$write_dns = "$primary_dns";
}
if("ip" eq $notice_dns){
$_ = "option domain-name-servers\t$write_dns;\t\#ibs-soho-domain-name-servers-ip\n";
}
else{
$_ = "\#option domain-name-servers\t$write_dns;\t\#ibs-soho-domain-name-servers-ip\n";
}
}
if($_ =~ /^\s*(\#?)\s*(?:option)\s+(?:domain-name-servers)\s*([\d\.\s\,]*);\s+(?:\#ibs-soho-domain-name-servers-auto)/){
if("auto" eq $notice_dns){
$_ = "\#option domain-name-servers\t;\t\#ibs-soho-domain-name-servers-auto\t\#$notice_dns_auto\n";
}
else{
$_ = "\#option domain-name-servers\t;\t\#ibs-soho-domain-name-servers-auto\n";
}
}
if($_ =~ /^\s*(\#?)\s*(?:option)\s+(?:domain-name-servers)\s*([\d\.]*);\s+(?:\#ibs-soho-domain-name-servers-proxy)/){
if("proxy" eq $notice_dns){
$_ = "option domain-name-servers\t$ipaddress_of_lan;\t\#ibs-soho-domain-name-servers-proxy\n";
}
else{
$_ = "\#option domain-name-servers\t$ipaddress_of_lan;\t\#ibs-soho-domain-name-servers-proxy\n";
}
}
if($lease_time =~ /^0$/){
$lease_time = -1;
}
if($_ =~ /^\s*(\#?)\s*(?:default-lease-time)\s+([\d-]*);/){
$_ = "default-lease-time\t$lease_time;\n";
}
if($_ =~ /^\s*(\#?)\s*(?:max-lease-time)\s+([\d-]*);/){
$_ = "max-lease-time\t$lease_time;\n";
}
if($_ =~ /^\s*(\#?)\s*(?:subnet)\s+([\d\.]+)\s+(?:netmask)\s+([\d\.]+)\s*\{/){
$_ = "subnet $network_address_of_lan netmask $subnetmask_of_lan\{\n";
}
if($_ =~ /^\s*(\#?)\s*(?:option)\s+(?:routers)\s*([\d\.]*);/){
$routers_flag = "on";
if($notice_gateway =~ /./){
$_ = "\toption routers\t$notice_gateway;\n";
}
else{
$_ = "\t\#option routers;\n";
}
}
if($_ =~ /^\s*(\#?)\s*(?:range)\s+([\d\.]*)\s*([\d\.]*);/){
$range_flag = "on";
$_ = "\trange $quota_ipaddress1 $quota_ipaddress2;\n";
}
if($_ =~ /^\s*(\#?)\s*(?:option)\s+(?:netbios-name-servers)\s*([\d\.]*)(?:,?)\s*([\d\.]*);/){
$wins_flag = "on";
my($write_wins);
if(($primary_wins =~ /./) || ($secondary_wins =~ /./)){
if(($primary_wins =~ /./) && ($secondary_wins =~ /./)){
$write_wins = "$primary_wins, $secondary_wins";
}
else{
$write_wins = $primary_wins;
}
$_ = "\toption netbios-name-servers\t$write_wins;\n";
}
else{
$_ = "\t\#option netbios-name-servers;\n";
}
}
print TMP;
}
close(TMP);
if(("off" eq $routers_flag) || ("off" eq $range_flag) || ("off" eq $wins_flag)){
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "dhcpd_conf_tmp_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
foreach(@tmp){
if($_ =~ /^\s*(\#?)\s*(?:subnet)\s+([\d\.]+)\s+(?:netmask)\s+([\d\.]+)\s*\{/){
print TMP;
if("off" eq $routers_flag){
if($notice_gateway =~ /./){
print TMP "\toption routers\t$notice_gateway;\n";
}
else{
print TMP "\t\#option routers;\n";
}
}
if("off" eq $range_flag){
print TMP "\trange $quota_ipaddress1 $quota_ipaddress2;\n";
}
if("off" eq $wins_flag){
my($write_wins);
if( ($primary_wins =~ /./) || ($secondary_wins =~ /./) ){
if( ($primary_wins =~ /./) && ($secondary_wins =~ /./) ){
$write_wins = "$primary_wins, $secondary_wins";
}
else{
$write_wins = $primary_wins;
}
print TMP "\toption netbios-name-servers\t$write_wins;\n";
}
else{
print TMP "\t\#option netbios-name-servers;\n";
}
}
next;
}
print TMP;
}
close(TMP);
}
rename("$path", "$path.ibs-soho.backup");
rename("$path.ibs-soho.tmp", "$path");
%return_hash = (
"return" => "success"
);
close(LOCK);
return %return_hash;
}
sub set_static_dhcp
{
my(@number) = split(/\#IBS-SOHO\#/, $_[0]);
my(@ipaddress) = split(/\#IBS-SOHO\#/, $_[1]);
my(@mac_address) = split(/\#IBS-SOHO\#/, $_[2]);
my(@host_name) = split(/\#IBS-SOHO\#/, $_[3]);
my($static_flag) = "off";
my(%return_hash);
my($path) = "/etc/dhcpd.conf";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "dhcpd_conf_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("PATH", "$path", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "dhcpd_conf_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "dhcpd_conf_tmp_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
foreach(@tmp){
if($_ =~ /^\s*(?:\#?)\s*(?:host)\s+(?:\S+)\s*\{\s+(?:\#ibs-soho-static-no\.)(\d+)/){
my($loop_cnt);
$static_flag = "on";
for($loop_cnt = 0; $loop_cnt < $MAX_DHCP_TABLE_ENTRY; $loop_cnt++){
if("on" eq $number[$loop_cnt]){
if($host_name[$loop_cnt] =~ /./){
print TMP "\thost $host_name[$loop_cnt]\{\t\#ibs-soho-static-no.$loop_cnt\n";
print TMP "\t\thardware ethernet $mac_address[$loop_cnt];\n";
print TMP "\t\tfixed-address $ipaddress[$loop_cnt];\n";
print TMP "\t\toption host-name\t\"$host_name[$loop_cnt]\";\n";
print TMP "\t}\n";
print TMP "\n";
}
else{
print TMP "\thost host$loop_cnt\{\t\#ibs-soho-static-no.$loop_cnt\n";
print TMP "\t\thardware ethernet $mac_address[$loop_cnt];\n";
print TMP "\t\tfixed-address $ipaddress[$loop_cnt];\n";
print TMP "\t\t\#option host-name\"\";\n";
print TMP "\t}\n";
print TMP "\n";
}
}
}
print TMP "}\n";
last;
}
print TMP;
}
close(TMP);
if("off" eq $static_flag){
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "dhcpd_conf_tmp_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
foreach(@tmp){
if($_ =~ /^}$/){
my($loop_cnt);
for($loop_cnt = 0; $loop_cnt < $MAX_DHCP_TABLE_ENTRY; $loop_cnt++){
if("on" eq $number[$loop_cnt]){
if($host_name[$loop_cnt] =~ /./){
print TMP "\thost $host_name[$loop_cnt]\{\t\#ibs-soho-static-no.$loop_cnt\n";
print TMP "\t\thardware ethernet $mac_address[$loop_cnt];\n";
print TMP "\t\tfixed-address $ipaddress[$loop_cnt];\n";
print TMP "\t\toption host-name\t\"$host_name[$loop_cnt]\";\n";
print TMP "\t}\n";
print TMP "\n";
}
else{
print TMP "\thost host$loop_cnt\{\t\#ibs-soho-static-no.$loop_cnt\n";
print TMP "\t\thardware ethernet $mac_address[$loop_cnt];\n";
print TMP "\t\tfixed-address $ipaddress[$loop_cnt];\n";
print TMP "\t\t\#option host-name\"\";\n";
print TMP "\t}\n";
print TMP "\n";
}
}
}
print TMP "}\n";
last;
}
print TMP;
}
close(TMP);
}
rename("$path", "$path.ibs-soho.backup");
rename("$path.ibs-soho.tmp", "$path");
%return_hash = (
"return" => "success"
);
close(LOCK);
return %return_hash;
}
sub set_dhcp_server_state
{
my($dhcp_server_state) = $_[0];
my($interface_name) = $_[1];
my($dhcp_server_flag) = "off";
my(%return_hash);
my($path) = "/etc/rc.conf";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "rc_conf_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("PATH", "$path", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "rc_conf_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "rc_conf_tmp_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
foreach(@tmp){
if(/^\s*(?:dhcpd=)(\S*)\s+(?:dhcpd_flags="-q)\s*(\S*)"\s+(?:\#ibs-soho)/){
$dhcp_server_flag = "on";
if("on" eq $dhcp_server_state){
$_ = "dhcpd=YES\tdhcpd_flags=\"-q $interface_name\"\t\#ibs-soho\n";
}
else{
$_ = "dhcpd=NO\tdhcpd_flags=\"-q $interface_name\"\t\#ibs-soho\n";
}
}
print TMP;
}
close(TMP);
if("off" eq $dhcp_server_flag){
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w+")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "rc_conf_tmp_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
if("on" eq $dhcp_server_state){
print TMP "dhcpd=YES\tdhcpd_flags=\"-q $interface_name\"\t\#ibs-soho\n";
}
else{
print TMP "dhcpd=NO\tdhcpd_flags=\"-q $interface_name\"\t\#ibs-soho\n";
}
close(TMP);
}
rename("$path", "$path.ibs-soho.backup");
rename("$path.ibs-soho.tmp", "$path");
%return_hash = (
"return" => "success"
);
close(LOCK);
return %return_hash;
}
sub set_httpd_access_of_lan
{
my($ipaddress) = $_[0];
my($subnetmask) = $_[1];
my($write_flag) = "off";
my(%return_hash);
my($subnetmask_tmp) = &change_subnetmask($subnetmask);
my($network_address) = &get_network_address($ipaddress, $subnetmask_tmp);
my($path) = "/usr/local/apache/conf/access.conf";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "access_conf_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("PATH", "$path", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "access_conf_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "access_conf_tmp_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
foreach(@tmp){
chomp;
if($_ =~ /^\s*(\#)\s*(?:ibsnew)\s*(?:allow from)\s+(\S*)\s+(?:\#ibs-soho-lan)/){
$_ = "\#ibsnew allow from $network_address/$subnetmask\t\#ibs-soho-lan";
$write_flag = "on";
}
if($_ =~ /^\s*(?:allow from)\s*(\S*)\s*(?:\#ibs-soho-lan)/){
$_ = "allow from $1\t#ibs-soho-lan\t#ibsold";
}
print TMP "$_\n";
}
close(TMP);
if("off" eq $write_flag){
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "access_conf_tmp_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
foreach(@tmp){
chomp;
if($_ =~ /^\s*(\#?)\s*(?:allow from)\s+(\S*)\s*(?:\#ibs-soho-lan)/){
my($tmp) = $_;
print TMP "\#ibsnew allow from $network_address/$subnetmask\t\#ibs-soho-lan\n";
$_ = $tmp;
}
print TMP "$_\n";
}
close(TMP);
}
rename("$path", "$path.ibs-soho.backup");
rename("$path.ibs-soho.tmp", "$path");
%return_hash = (
"return" => "success"
);
close(LOCK);
return %return_hash;
}
sub set_hosts_of_lan
{
my($ipaddress) = $_[0];
my($write_flag) = "off";
my(%return_hash);
my($path) = "/etc/hosts";
my($return_lockf) = &lockf("hosts");
if("error0" eq $return_lockf){
%return_hash = (
"return" => "error",
"error_contents" => "hosts_lock",
"alert_message" => $ERROR_L0
);
return %return_hash;
}
elsif("error1" eq $return_lockf){
%return_hash = (
"return" => "error",
"error_contents" => "hosts_lock",
"alert_message" => $ERROR_L1
);
return %return_hash;
}
elsif("error2" eq $return_lockf){
%return_hash = (
"return" => "error",
"error_contents" => "hosts_lock",
"alert_message" => $ERROR_L2
);
return %return_hash;
}
else{
}
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "hosts_lock",
"alert_message" => $alert_message
);
&unlockf("hosts");
return %return_hash;
}
if("error" eq &open_file("PATH", "$path", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "hosts_open",
"alert_message" => $alert_message
);
&unlockf("hosts");
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "hosts_tmp_open",
"alert_message" => $alert_message
);
&unlockf("hosts");
close(LOCK);
return %return_hash;
}
foreach(@tmp){
chomp;
if($_ =~ /^\s*(\#)\s*(?:ibsnew)\s*([\d\.]+)\s*(?:ibs-soho)\s*$/){
$write_flag = "on";
$_ = "\#ibsnew $ipaddress\tibs-soho";
}
if($_ =~ /^\s*([\d\.]+)\s*(?:ibs-soho)/){
$_ = "$1\tibs-soho\t#ibsold";
}
print TMP "$_\n";
}
close(TMP);
if("off" eq $write_flag){
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "hosts_tmp_open",
"alert_message" => $alert_message
);
&unlockf("hosts");
close(LOCK);
return %return_hash;
}
foreach(@tmp){
chomp;
if($_ =~ /^\s*([\d\.]+)\s*(?:ibs-soho)\s*(?:\#ibsold)/){
my($tmp) = $_;
$write_flag = "on";
print TMP "\#ibsnew $ipaddress ibs-soho\n";
$_ = $tmp;
}
print TMP "$_\n";
}
close(TMP);
}
if("off" eq $write_flag){
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w+")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "hosts_tmp_open",
"alert_message" => $alert_message
);
&unlockf("hosts");
close(LOCK);
return %return_hash;
}
print TMP "$ipaddress\tibs-soho\n";
close(TMP);
}
rename("$path", "$path.ibs-soho.backup");
rename("$path.ibs-soho.tmp", "$path");
my($return_unlockf) = &unlockf("hosts");
if("success" eq $return_unlockf){
%return_hash = (
"return" => "success"
);
}
else{
%return_hash = (
"return" => "error",
"error_contents" => "hosts_unlock",
"alert_message" => $ERROR_U1
);
}
close(LOCK);
return %return_hash;
}
sub set_service_access_of_lan
{
my($service) = $_[0];
my($ipaddress) = $_[1];
my($subnetmask) = $_[2];
my($write_flag) = "off";
my($telnetd_flag) = "off";
my(%return_hash);
my($path) = "/etc/hosts.allow";
$subnetmask = &change_subnetmask($subnetmask);
my($network_address) = &get_network_address($ipaddress, $subnetmask);
my($set) = sprintf("%s/%s", $network_address, $subnetmask);
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "hosts_allow_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("PATH", "$path", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "hosts_allow_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "hosts_allow_tmp_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
foreach(@tmp){
chomp;
if($_ =~ /^\s*(\#)\s*(?:ibsnew)\s*$service:\s+(\S*)\s*\#ibs-soho-lan/){
$_ = "\#ibsnew $service: $set\t\#ibs-soho-lan";
$write_flag = "on";
}
if($_ =~ /^\s*(\#?)\s*$service:\s+(\S*)\s*\#ibs-soho-lan/){
$_ = "$1$service: $2\t\#ibs-soho-lan\t\#ibsold";
}
if($_ =~ /^\s*(\#)\s*(?:ibsnew)\s*in\.telnetd:\s+(\S*)\s*\#ibs-soho-lan/){
$telnetd_flag = "on";
if("on" eq $TELNETD){
$_ = "\#ibsnew in.telnetd: $set\t\#ibs-soho-lan";
}
else{
next;
}
}
if($_ =~ /^\s*(\#?)\s*in\.telnetd:\s+(\S*)\s*\#ibs-soho-lan/){
my($tmp) = "in.telnetd";
if("on" eq $TELNETD){
$_ = "$1$tmp: $2\t\#ibs-soho-lan\t\#ibsold";
}
else{
next;
}
}
print TMP "$_\n";
}
close(TMP);
if( ("off" eq $write_flag) || ("off" eq $telnetd_flag) ){
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "hosts_allow_tmp_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
}
foreach(@tmp){
chomp;
if($_ =~ /^\s*(\#?)\s*$service:\s+(\S*)\s*\#ibs-soho-lan/){
if("off" eq $write_flag){
my($tmp) = $_;
print TMP "\#ibsnew $service: $set\t\#ibs-soho-lan\n";
$_ = $tmp;
}
}
if($_ =~ /^\s*(\#?)\s*in\.telnetd:\s+(\S*)\s*\#ibs-soho-lan/){
if("off" eq $telnetd_flag){
my($tmp) = $_;
if("on" eq $TELNETD){
print TMP "\#ibsnew in.telnetd: $set\t\#ibs-soho-lan\n";
$_ = $tmp;
}
else{
next;
}
}
}
print TMP "$_\n";
}
close(TMP);
rename("$path", "$path.ibs-soho.backup");
rename("$path.ibs-soho.tmp", "$path");
%return_hash = (
"return" => "success"
);
close(LOCK);
return %return_hash;
}
sub set_autoup_lan
{
my($ipaddress) = $_[0];
my($autoup);
my(%return_hash);
my($lanip);
my($old_lanip);
my($path) = "$ROUTER_DATA/ipaddress_of_wan/autoup.txt";
my(@tmp) = `/bin/cat $path`;
foreach(@tmp){
chomp;
if($_ =~ /^\s*\#\s*(\S+)\s*$/){
$autoup = $1;
}
elsif($_ =~ /^\s*([\d\.]+)\s*(?:ibs-autoup)\s*$/){
$lanip = $1;
}
elsif($_ =~ /^\s*([\d\.]+)\s*(?:ibs-autoup)\s*(?:\#ibsold)\s*$/){
$old_lanip = $1;
}
else{
next;
}
}
if("lan" ne $autoup){
%return_hash = (
"return" => "success"
);
return %return_hash;
}
my($return_lockf) = &lockf("autoup");
if("error0" eq $return_lockf){
%return_hash = (
"return" => "error",
"error_contents" => "autoup_lock",
"alert_message" => $ERROR_L0
);
return %return_hash;
}
elsif("error1" eq $return_lockf){
%return_hash = (
"return" => "error",
"error_contents" => "autoup_lock",
"alert_message" => $ERROR_L1
);
return %return_hash;
}
elsif("error2" eq $return_lockf){
%return_hash = (
"return" => "error",
"error_contents" => "autoup_lock",
"alert_message" => $ERROR_L2
);
return %return_hash;
}
else{
}
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "autoup_lock",
"alert_message" => $alert_message
);
&unlockf("autoup");
return %return_hash;
}
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "autoup_tmp_open",
"alert_message" => $alert_message
);
&unlockf("autoup");
close(LOCK);
return %return_hash;
}
print TMP "#$autoup\n";
if($lanip =~ /./){
print TMP "$lanip\tibs-autoup\t\#ibsold\n";
}
else{
print TMP "$old_lanip\tibs-autoup\t\#ibsold\n";
}
print TMP "#ibsnew\t$ipaddress\tibs-autoup\n";
close(TMP);
rename("$path", "$path.ibs-soho.backup");
rename("$path.ibs-soho.tmp", "$path");
my($return_unlockf) = &unlockf("autoup");
if("success" eq $return_unlockf){
%return_hash = (
"return" => "success"
);
}
else{
%return_hash = (
"return" => "error",
"error_contents" => "autoup_unlock",
"alert_message" => $ERROR_U1
);
}
close(LOCK);
return %return_hash;
}
1;
