# 2005/02/22
use Socket;
sub check_mac_mac_addr
{
my($mac_addr) = $_[0];
unless(12 == length($mac_addr)){
return "error";
}
if($mac_addr =~ /^([\da-fA-F]+)$/){
return "success";
}
else{
return "error";
}
}
sub get_now_mac_wan
{
my($now_mac_wan);
my($flash_mac_wan);
my(%return_hash);
my(@tmp) = `/sbin/ifconfig eth0`;
foreach(@tmp){
if(/(?:HWaddr)\s+([\da-fA-F:]+)/){
$now_mac_wan = $1;
last;
}
}
if($now_mac_wan =~ /./){
$_ = $now_mac_wan;
s/([a-f])/\U$1/gi;
s/:/\-/g;
$now_mac_wan = $_;
}
else{
my($alert_message) = $RETURN_CODE{"11"};
%return_hash = (
"return" => "error",
"error_contents" => "no_now_mac_wan",
"alert_message" => "uMACAhXv" . $alert_message
);
return %return_hash;
}
@tmp = `/sbin/flashenv -p`;
foreach(@tmp){
if(/(?:ethaddr=)([\da-fA-F:]+)/){
$flash_mac_wan = $1;
last;
}
}
if($flash_mac_wan =~ /./){
$_ = $flash_mac_wan;
s/([a-f])/\U$1/gi;
s/:/\-/g;
$flash_mac_wan = $_;
%return_hash = (
"return" => "success",
"now_mac_wan" => $now_mac_wan,
"flash_mac_wan" => $flash_mac_wan
);
return %return_hash;
}
else{
my($alert_message) = $RETURN_CODE{"11"};
%return_hash = (
"return" => "error",
"error_contents" => "no_flash_mac_wan",
"alert_message" => "uMACAhXv" . $alert_message
);
return %return_hash;
}
}
sub get_now_mac_lan
{
my($now_mac_lan);
my($flash_mac_lan);
my(%return_hash);
my(@tmp) = `/sbin/ifconfig eth1`;
foreach(@tmp){
if(/(?:HWaddr)\s+([\da-fA-F:]+)/){
$now_mac_lan = $1;
last;
}
}
if($now_mac_lan =~ /./){
$_ = $now_mac_lan;
s/([a-f])/\U$1/gi;
s/:/\-/g;
$now_mac_lan = $_;
}
else{
my($alert_message) = $RETURN_CODE{"11"};
%return_hash = (
"return" => "error",
"error_contents" => "no_now_mac_lan",
"alert_message" => "uMACAhXv" . $alert_message
);
return %return_hash;
}
@tmp = `/sbin/flashenv -p`;
foreach(@tmp){
if(/(?:eth1addr=)([\da-fA-F:]+)/){
$flash_mac_lan = $1;
last;
}
}
if($flash_mac_lan =~ /./){
$_ = $flash_mac_lan;
s/([a-f])/\U$1/gi;
s/:/\-/g;
$flash_mac_lan = $_;
%return_hash = (
"return" => "success",
"now_mac_lan" => $now_mac_lan,
"flash_mac_lan" => $flash_mac_lan
);
return %return_hash;
}
else{
my($alert_message) = $RETURN_CODE{"11"};
%return_hash = (
"return" => "error",
"error_contents" => "no_flash_mac_lan",
"alert_message" => "uMACAhXv" . $alert_message
);
return %return_hash;
}
}
sub get_now_mac_gw
{
my($now_mac_gw);
my($flash_mac_gw);
my($host) = "ibsgw";
my(%return_hash);
if (!socket(SOCKET, PF_INET, SOCK_STREAM, getprotobyname('tcp'))) {
my($alert_message) = $RETURN_CODE{"204"};
%return_hash = (
"return" => "error",
"error_contents" => "socket",
"alert_message" => $alert_message
);
return %return_hash;
}
my($port) = 80;
if (!connect(SOCKET, sockaddr_in($port, inet_aton($host)))){
my($alert_message) = $RETURN_CODE{"205"};
%return_hash = (
"return" => "error",
"error_contents" => "connect",
"alert_message" => $alert_message
);
close(SOCKET);
return %return_hash;
}
select(SOCKET);
$| = 1;
select(STDOUT);
print SOCKET "GET /tmac3 HTTP/1.0\r\n";
print SOCKET "\r\n";
eval{
local $SIG{ALRM} = sub{die "timeout"};
alarm 10;
while(<SOCKET>){
m/^\r\n$/;
last;
}
alarm 0;
};
alarm 0;
if($@){
if($@ =~ /timeout/){
my($alert_message) = $RETURN_CODE{"205"};
%return_hash = (
"return" => "error",
"error_contents" => "timeout",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
}
my($mac0) = "00-20-c1";
my($mac4);
my($mac5);
my($mac6);
while(<SOCKET>){
if(/([\da-fA-F]{2}.[\da-fA-F]{2}.[\da-fA-F]{2}.[\da-fA-F]{2}.[\da-fA-F]{2}.[\da-fA-F]{2})/){
$flash_mac_gw = $1;
}
elsif(/(?:mac4).+(?:value=)"([\da-fA-F]+)"/){
$mac4 = $1;
}
elsif(/(?:mac5).+(?:value=)"([\da-fA-F]+)"/){
$mac5 = $1;
}
else{
}
}
if( ($mac4 =~ /./) && ($mac5 =~ /./) ){
if($mac5 =~ /([\da-fA-F]{2})([\da-fA-F]{2})/){
my($tmp1) = $1;
my($tmp2) = $2;
$mac5 = $tmp1;
$mac6 = $tmp2;
$now_mac_gw = $mac0."-".$mac4."-".$mac5."-".$mac6;
}
}
if($flash_mac_gw =~ /./){
$_ = $flash_mac_gw;
s/([a-f])/\U$1/gi;
$flash_mac_gw = $_;
}
else{
my($alert_message) = $RETURN_CODE{"208"};
%return_hash = (
"return" => "error",
"error_contents" => "no_flash_mac_gw",
"alert_message" => $alert_message
);
return %return_hash;
}
if($now_mac_gw =~ /./){
$_ = $now_mac_gw;
s/([a-f])/\U$1/gi;
$now_mac_gw = $_;
%return_hash = (
"return" => "success",
"now_mac_gw" => $now_mac_gw,
"flash_mac_gw" => $flash_mac_gw
);
return %return_hash;
}
else{
my($alert_message) = $RETURN_CODE{"208"};
%return_hash = (
"return" => "error",
"error_contents" => "no_now_mac_gw",
"alert_message" => $alert_message
);
return %return_hash;
}
}
sub get_mac_addr
{
my($mac_addr) = $_[0];
my($mac_addr_wan);
my($mac_addr_lan);
my($mac_addr_gw);
my(@split_mac_addr);
my(@split_mac_addr_10);
my(@split_mac_addr_lan_10);
my(@split_mac_addr_gw_10);
my(@split_mac_addr_16);
my(@split_mac_addr_lan_16);
my(@split_mac_addr_gw_16);
my($loop_cnt);
my($ok_cnt);
my(%return_hash);
if($mac_addr =~ /^([\da-fA-F]{2})([\da-fA-F]{2})([\da-fA-F]{2})([\da-fA-F]{2})([\da-fA-F]{2})([\da-fA-F]{2})$/){
$split_mac_addr[0] = $1;
$split_mac_addr[1] = $2;
$split_mac_addr[2] = $3;
$split_mac_addr[3] = $4;
$split_mac_addr[4] = $5;
$split_mac_addr[5] = $6;
for($loop_cnt = 0; $loop_cnt < 6; $loop_cnt++){
$split_mac_addr_10[$loop_cnt] = hex($split_mac_addr[$loop_cnt]);
}
for($loop_cnt = 5; $loop_cnt >= 0; $loop_cnt--){
if(255 == $split_mac_addr_10[$loop_cnt]){
$split_mac_addr_lan_10[$loop_cnt] = 0;
}
else{
$split_mac_addr_lan_10[$loop_cnt] = $split_mac_addr_10[$loop_cnt] + 1;
$ok_cnt = $loop_cnt;
last;
}
}
if($ok_cnt =~ /./){
for($loop_cnt = 0; $loop_cnt < $ok_cnt; $loop_cnt++){
$split_mac_addr_lan_10[$loop_cnt] = $split_mac_addr_10[$loop_cnt];
}
}
$ok_cnt = "";
for($loop_cnt = 5; $loop_cnt >= 0; $loop_cnt--){
if(255 == $split_mac_addr_lan_10[$loop_cnt]){
$split_mac_addr_gw_10[$loop_cnt] = 0;
}
else{
$split_mac_addr_gw_10[$loop_cnt] = $split_mac_addr_lan_10[$loop_cnt] + 1;
$ok_cnt = $loop_cnt;
last;
}
}
if($ok_cnt =~ /./){
for($loop_cnt = 0; $loop_cnt < $ok_cnt; $loop_cnt++){
$split_mac_addr_gw_10[$loop_cnt] = $split_mac_addr_lan_10[$loop_cnt];
}
}
for($loop_cnt = 0; $loop_cnt < 6; $loop_cnt++){
$split_mac_addr_16[$loop_cnt] = sprintf("%02X", $split_mac_addr_10[$loop_cnt]);
$split_mac_addr_lan_16[$loop_cnt] = sprintf("%02X", $split_mac_addr_lan_10[$loop_cnt]);
$split_mac_addr_gw_16[$loop_cnt] = sprintf("%02X", $split_mac_addr_gw_10[$loop_cnt]);
}
%return_hash = (
"return" => "success",
"mac_addr_wan" => join("", @split_mac_addr_16),
"mac_addr_lan" => join("", @split_mac_addr_lan_16),
"mac_addr_gw" => join("", @split_mac_addr_gw_16)
);
return %return_hash;
}
}
sub set_mac_addr
{
my($mac_addr_wan) = $_[0];
my($mac_addr_lan) = $_[1];
my(@split_mac_addr_wan);
my(@split_mac_addr_lan);
my(%return_hash);
if($mac_addr_wan =~ /^(.{2})(.{2})(.{2})(.{2})(.{2})(.{2})/){
$split_mac_addr_wan[0] = $1;
$split_mac_addr_wan[1] = $2;
$split_mac_addr_wan[2] = $3;
$split_mac_addr_wan[3] = $4;
$split_mac_addr_wan[4] = $5;
$split_mac_addr_wan[5] = $6;
}
if($mac_addr_lan =~ /^(.{2})(.{2})(.{2})(.{2})(.{2})(.{2})/){
$split_mac_addr_lan[0] = $1;
$split_mac_addr_lan[1] = $2;
$split_mac_addr_lan[2] = $3;
$split_mac_addr_lan[3] = $4;
$split_mac_addr_lan[4] = $5;
$split_mac_addr_lan[5] = $6;
}
$mac_addr_wan = join(":", @split_mac_addr_wan);
$mac_addr_lan = join(":", @split_mac_addr_lan);
my($id_org) = $<;
$< = 0;
my($system_return) = system("/sbin/flashenv -w $mac_addr_wan -l $mac_addr_lan >/dev/null 2>&1");
if(0 != $system_return){
$system_return = $system_return >> 8;
if(10 <= $system_return){
%return_hash = (
"return" => "error",
"error_contents" => "flashenv",
"alert_message" => "uMACAhXv" . $RETURN_CODE{$system_return}
);
$< = $id_org;
close(LOCK);
return %return_hash;
}
}
%return_hash = (
"return" => "success"
);
$< = $id_org;
close(LOCK);
return %return_hash;
}
sub set_mac_addr_gw
{
my($mac_addr_gw) = $_[0];
my($user_name) = "ibsgw";
my($user_pass) = "ibsgw";
my($host) = "ibsgw";
my($mac1);
my($mac2);
my($mac3);
my($mac4);
my($mac5);
my(%return_hash);
if($mac_addr_gw =~ /([\da-fA-F]{2})([\da-fA-F]{2})([\da-fA-F]{2})([\da-fA-F]{2})([\da-fA-F]{4})/){
$mac1 = $1;
$mac2 = $2;
$mac3 = $3;
$mac4 = $4;
$mac5 = $5;
}
my($send_data) = "mac1=$mac1&mac2=$mac2&mac3=$mac3&mac4=$mac4&mac5=$mac5&B1=&USER=$user_name&PASS=$user_pass&";
my($send_data_len) = length($send_data) + 12;
if (!socket(SOCKET, PF_INET, SOCK_STREAM, getprotobyname('tcp'))) {
my($alert_message) = $RETURN_CODE{"204"};
%return_hash = (
"return" => "error",
"error_contents" => "socket",
"alert_message" => $alert_message
);
return %return_hash;
}
my($port) = 80;
if (!connect(SOCKET, sockaddr_in($port, inet_aton($host)))){
my($alert_message) = $RETURN_CODE{"205"};
%return_hash = (
"return" => "error",
"error_contents" => "connect",
"alert_message" => $alert_message
);
close(SOCKET);
return %return_hash;
}
select(SOCKET);
$| = 1;
select(STDOUT);
print SOCKET "POST /tmac2 HTTP/1.0\r\n";
print SOCKET "Content-Length: $send_data_len\r\n";
print SOCKET "\r\n";
print SOCKET "$send_data";
eval{
local $SIG{ALRM} = sub{die "timeout"};
alarm 10;
while(<SOCKET>){
m/^\r\n$/;
last;
}
alarm 0;
};
alarm 0;
if($@){
if($@ =~ /timeout/){
my($alert_message) = $RETURN_CODE{"205"};
%return_hash = (
"return" => "error",
"error_contents" => "timeout",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
}
my($set_gw_error_flag) = "on";
while(<SOCKET>){
if($_ =~ /set_gw_macaddr_error/){
$set_gw_error_flag = "on";
last;
}
elsif($_ =~ /ok/i){
$set_gw_error_flag = "off";
last;
}
}
if("on" eq $set_gw_error_flag){
my($alert_message) = $RETURN_CODE{"207"};
%return_hash = (
"return" => "error",
"error_contents" => "set_gw_macaddress",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
else{
%return_hash = (
"return" => "success"
);
close(LOCK);
return %return_hash;
}
}
1;
