# 2005/02/17
sub check_string
{
my($string) = $_[0];
my($string_len) = length($string);
unless((0 < $string_len) && (32 >= $string_len)){
return "error";
}
if($string =~ /[\<\>\[\]\{\}\(\)\"]/){
return "error";
}
if("error" eq &check_ascii($string, "on")){
return "error";
}
else{
return "success";
}
}
sub check_mail_server
{
my($mail_server) = $_[0];
if($mail_server =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/){
return &check_ipaddress_ipv4($mail_server);
}
else{
if($mail_server =~ /^[a-zA-Z\d\.\-]+$/){
return &check_host_address($mail_server);
}
else{
return "error";
}
}
}
sub check_mailaddress
{
my($mailaddress) = $_[0];
unless($mailaddress =~ /^[a-zA-Z0-9\.\-_]+@[a-zA-Z0-9\-_]+[\.][a-zA-Z0-9\.\-_]*$/){
return "error";
}
my($total_length) = length($mailaddress);
if(128 >= $total_length){
return "success";
}
else{
return "error";
}
}
sub get_mail
{
my($when) = $_[0];
my($backup);
my($mail_server);
my($mailaddress);
my($pop_before_smtp);
my($receive_mail_server);
my($mail_account);
my($mail_account_pass);
my(%return_hash);
my($path) = "$ROUTER_DATA/mail/mail.txt";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "mail_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("PATH", "$path$backup", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "mail_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
foreach(@tmp){
if(/^\s*(?:mail_server=)(\S*)/){
$mail_server = $1;
}
elsif(/^\s*(?:mail_address=)(\S*)/){
$mailaddress = $1;
}
elsif(/^\s*(?:pop_before_smtp=)(\S*)/){
$pop_before_smtp = $1;
}
elsif(/^\s*(?:receive_mail_server=)(\S*)/){
$receive_mail_server = $1;
}
elsif(/^\s*(?:mail_account=)(\S*)/){
$mail_account = $1;
}
elsif(/^\s*(?:mail_account_pass=)(\S*)/){
$mail_account_pass = $1;
}
else{
}
}
%return_hash = (
"return" => "success",
"mail_server" => $mail_server,
"mailaddress" => $mailaddress,
"pop_before_smtp" => $pop_before_smtp,
"receive_mail_server" => $receive_mail_server,
"mail_account" => $mail_account,
"mail_account_pass" => $mail_account_pass
);
close(LOCK);
return %return_hash;
}
sub get_mail_work
{
my($mail_func);
my($mail_server);
my($mailaddress);
my($pop_before_smtp);
my($receive_mail_server);
my($mail_account);
my($mail_account_pass);
my(%return_hash);
my($path) = "$ROUTER_DATA/mail/work.txt";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "mail_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("PATH", "$path", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "mail_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
foreach(@tmp){
if(/^\s*(?:mail_func=)(\S*)/){
$mail_func = $1;
}
elsif(/^\s*(?:mail_server=)(\S*)/){
$mail_server = $1;
}
elsif(/^\s*(?:mail_address=)(\S*)/){
$mailaddress = $1;
}
elsif(/^\s*(?:pop_before_smtp=)(\S*)/){
$pop_before_smtp = $1;
}
elsif(/^\s*(?:receive_mail_server=)(\S*)/){
$receive_mail_server = $1;
}
elsif(/^\s*(?:mail_account=)(\S*)/){
$mail_account = $1;
}
elsif(/^\s*(?:mail_account_pass=)(\S*)/){
$mail_account_pass = $1;
}
else{
}
}
%return_hash = (
"return" => "success",
"mail_func" => $mail_func,
"mail_server" => $mail_server,
"mailaddress" => $mailaddress,
"pop_before_smtp" => $pop_before_smtp,
"receive_mail_server" => $receive_mail_server,
"mail_account" => $mail_account,
"mail_account_pass" => $mail_account_pass
);
close(LOCK);
return %return_hash;
}
sub set_mail
{
my($mail_func) = $_[0];
my($mail_server) = $_[1];
my($mailaddress) = $_[2];
my($pop_before_smtp) = $_[3];
my($receive_mail_server) = $_[4];
my($mail_account) = $_[5];
my($mail_account_pass) = $_[6];
my(%return_hash);
my($path) = "$ROUTER_DATA/mail/mail.txt";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "mail_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "mail_tmp_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
if("on" eq $mail_func){
print TMP "mail_server=$mail_server\n";
print TMP "mail_address=$mailaddress\n";
print TMP "pop_before_smtp=$pop_before_smtp\n";
print TMP "receive_mail_server=$receive_mail_server\n";
print TMP "mail_account=$mail_account\n";
print TMP "mail_account_pass=$mail_account_pass\n";
print TMP "\n";
}
else{
print TMP "mail_server=\n";
print TMP "mail_address=\n";
print TMP "pop_before_smtp=off\n";
print TMP "receive_mail_server=\n";
print TMP "mail_account=\n";
print TMP "mail_account_pass=\n";
print TMP "\n";
}
close(TMP);
rename("$path", "$path.ibs-soho.backup");
rename("$path.ibs-soho.tmp", "$path");
%return_hash = (
"return" => "success"
);
close(LOCK);
return %return_hash;
}
sub set_mail_work
{
my($mail_func) = $_[0];
my($mail_server) = $_[1];
my($mailaddress) = $_[2];
my($pop_before_smtp) = $_[3];
my($receive_mail_server) = $_[4];
my($mail_account) = $_[5];
my($mail_account_pass) = $_[6];
my(%return_hash);
my($path) = "$ROUTER_DATA/mail/work.txt";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "mail_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "mail_tmp_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
print TMP "mail_func=$mail_func\n";
print TMP "mail_server=$mail_server\n";
print TMP "mail_address=$mailaddress\n";
print TMP "pop_before_smtp=$pop_before_smtp\n";
print TMP "receive_mail_server=$receive_mail_server\n";
print TMP "mail_account=$mail_account\n";
print TMP "mail_account_pass=$mail_account_pass\n";
print TMP "\n";
close(TMP);
rename("$path", "$path.ibs-soho.backup");
rename("$path.ibs-soho.tmp", "$path");
%return_hash = (
"return" => "success"
);
close(LOCK);
return %return_hash;
}
1;
