# 2005/01/18
sub get_nat
{
my($when) = $_[0];
my($backup);
my(@nat_type);
my(@nat_out_ipaddress1);
my(@nat_out_ipaddress2);
my(@nat_in_ipaddress);
my(@nat_in_ipaddress_ip);
my($ip_nat_type);
my($ip_nat_out_ipaddress1);
my($ip_nat_out_ipaddress2);
my($ip_nat_in_ipaddress);
my($ip_nat_in_ipaddress_ip);
my($dhcp_nat_type);
my($dhcp_nat_in_ipaddress);
my($dhcp_nat_in_ipaddress_ip);
my(%return_hash);
my($path) = "$ROUTER_DATA/nat/nat.txt";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "nat_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("PATH", "$path$backup", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "nat_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
foreach(@tmp){
if(/^\s*(?:nat_type=)(\S*)/){
push(@nat_type, $1);
}
elsif(/^\s*(?:nat_out_ipaddress1=)(\S*)/){
push(@nat_out_ipaddress1, $1);
}
elsif(/^\s*(?:nat_out_ipaddress2=)(\S*)/){
push(@nat_out_ipaddress2, $1);
}
elsif(/^\s*(?:nat_in_ipaddress=)(\S*)/){
push(@nat_in_ipaddress, $1);
}
elsif(/^\s*(?:nat_in_ipaddress_ip=)(.*)/){
push(@nat_in_ipaddress_ip, $1);
}
elsif(/^\s*(?:ip_nat_type=)(\S*)/){
$ip_nat_type = $1;
}
elsif(/^\s*(?:ip_nat_out_ipaddress1=)(\S*)/){
$ip_nat_out_ipaddress1 = $1;
}
elsif(/^\s*(?:ip_nat_out_ipaddress2=)(\S*)/){
$ip_nat_out_ipaddress2 = $1;
}
elsif(/^\s*(?:ip_nat_in_ipaddress=)(\S*)/){
$ip_nat_in_ipaddress = $1;
}
elsif(/^\s*(?:ip_nat_in_ipaddress_ip=)(.*)/){
$ip_nat_in_ipaddress_ip = $1;
}
elsif(/^\s*(?:dhcp_nat_type=)(\S*)/){
$dhcp_nat_type = $1;
}
elsif(/^\s*(?:dhcp_nat_in_ipaddress=)(\S*)/){
$dhcp_nat_in_ipaddress = $1;
}
elsif(/^\s*(?:dhcp_nat_in_ipaddress_ip=)(.*)/){
$dhcp_nat_in_ipaddress_ip = $1;
}
else{
next;
}
}
%return_hash = (
"return" => "success",
"nat_type" => join("\#IBS-SOHO\#", @nat_type),
"nat_out_ipaddress1" => join("\#IBS-SOHO\#", @nat_out_ipaddress1),
"nat_out_ipaddress2" => join("\#IBS-SOHO\#", @nat_out_ipaddress2),
"nat_in_ipaddress" => join("\#IBS-SOHO\#", @nat_in_ipaddress),
"nat_in_ipaddress_ip" => join("\#IBS-SOHO\#", @nat_in_ipaddress_ip),
"ip_nat_type" => $ip_nat_type,
"ip_nat_out_ipaddress1" => $ip_nat_out_ipaddress1,
"ip_nat_out_ipaddress2" => $ip_nat_out_ipaddress2,
"ip_nat_in_ipaddress" => $ip_nat_in_ipaddress,
"ip_nat_in_ipaddress_ip" => $ip_nat_in_ipaddress_ip,
"dhcp_nat_type" => $dhcp_nat_type,
"dhcp_nat_in_ipaddress" => $dhcp_nat_in_ipaddress,
"dhcp_nat_in_ipaddress_ip" => $dhcp_nat_in_ipaddress_ip
);
close(LOCK);
return %return_hash;
}
sub get_nat_table
{
my($when) = $_[0];
my($backup);
my($index);
my(@nat_table_number);
my(@nat_table_global_ip);
my(@nat_table_local_ip);
my(%return_hash);
my($path) = "$ROUTER_DATA/nat/nat_table.txt";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "nat_table_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("PATH", "$path$backup", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "nat_table_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
foreach(@tmp){
if(/^\s*(?:index=)(\S*)/){
$index = $1;
}
elsif(/^\s*(?:nat_table_number=)(\S*)/){
$nat_table_number[$index] = $1;
}
elsif(/^\s*(?:nat_table_global_ip=)(\S*)/){
$nat_table_global_ip[$index] = $1;
}
elsif(/^\s*(?:nat_table_local_ip=)(\S*)/){
$nat_table_local_ip[$index] = $1;
}
else{
next;
}
}
%return_hash = (
"return" => "success",
"nat_table_number" => join("\#IBS-SOHO\#", @nat_table_number),
"nat_table_global_ip" => join("\#IBS-SOHO\#", @nat_table_global_ip),
"nat_table_local_ip" => join("\#IBS-SOHO\#", @nat_table_local_ip)
);
close(LOCK);
return %return_hash;
}
sub get_natp_table
{
my($when) = $_[0];
my($backup);
my($index);
my(@natp_table_number);
my(@natp_table_protocol);
my(@natp_table_port);
my(@natp_table_ipaddress);
my(%return_hash);
my($path) = "$ROUTER_DATA/nat/natp_table.txt";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "natp_table_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("PATH", "$path$backup", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "natp_table_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
foreach(@tmp){
if(/^\s*(?:index=)(\S*)/){
$index = $1;
}
elsif(/^\s*(?:natp_table_number=)(\S*)/){
$natp_table_number[$index] = $1;
}
elsif(/^\s*(?:natp_table_protocol=)(\S*)/){
$natp_table_protocol[$index] = $1;
}
elsif(/^\s*(?:natp_table_port=)(\S*)/){
$natp_table_port[$index] = $1;
}
elsif(/^\s*(?:natp_table_ipaddress=)(\S*)/){
$natp_table_ipaddress[$index] = $1;
}
else{
next;
}
}
%return_hash = (
"return" => "success",
"natp_table_number" => join("\#IBS-SOHO\#", @natp_table_number),
"natp_table_protocol" => join("\#IBS-SOHO\#", @natp_table_protocol),
"natp_table_port" => join("\#IBS-SOHO\#", @natp_table_port),
"natp_table_ipaddress" => join("\#IBS-SOHO\#", @natp_table_ipaddress)
);
close(LOCK);
return %return_hash;
}
sub get_work
{
my($index);
my(@nat_type);
my(@nat_out_ipaddress1);
my(@nat_out_ipaddress2);
my(@nat_in_ipaddress);
my(@nat_in_ipaddress_ip);
my($ip_nat_type);
my($ip_nat_out_ipaddress1);
my($ip_nat_out_ipaddress2);
my($ip_nat_in_ipaddress);
my($ip_nat_in_ipaddress_ip);
my($dhcp_nat_type);
my($dhcp_nat_in_ipaddress);
my($dhcp_nat_in_ipaddress_ip);
my(@nat_table_number);
my(@nat_table_global_ip);
my(@nat_table_local_ip);
my($new_nat_table_number);
my($new_nat_table_global_ip);
my($new_nat_table_local_ip);
my(@natp_table_number);
my(@natp_table_protocol);
my(@natp_table_port);
my(@natp_table_ipaddress);
my($new_natp_table_number);
my($new_natp_table_protocol);
my($new_natp_table_port);
my($new_natp_table_ipaddress);
my(%return_hash);
my($path) = "$ROUTER_DATA/nat/work.txt";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "work_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("PATH", "$path", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "work_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
foreach(@tmp){
if(/^\s*(?:nat_type=)(\S*)/){
push(@nat_type, $1);
}
elsif(/^\s*(?:nat_out_ipaddress1=)(\S*)/){
push(@nat_out_ipaddress1, $1);
}
elsif(/^\s*(?:nat_out_ipaddress2=)(\S*)/){
push(@nat_out_ipaddress2, $1);
}
elsif(/^\s*(?:nat_in_ipaddress=)(\S*)/){
push(@nat_in_ipaddress, $1);
}
elsif(/^\s*(?:nat_in_ipaddress_ip=)(.*)/){
push(@nat_in_ipaddress_ip, $1);
}
elsif(/^\s*(?:ip_nat_type=)(\S*)/){
$ip_nat_type = $1;
}
elsif(/^\s*(?:ip_nat_out_ipaddress1=)(\S*)/){
$ip_nat_out_ipaddress1 = $1;
}
elsif(/^\s*(?:ip_nat_out_ipaddress2=)(\S*)/){
$ip_nat_out_ipaddress2 = $1;
}
elsif(/^\s*(?:ip_nat_in_ipaddress=)(\S*)/){
$ip_nat_in_ipaddress = $1;
}
elsif(/^\s*(?:ip_nat_in_ipaddress_ip=)(.*)/){
$ip_nat_in_ipaddress_ip = $1;
}
elsif(/^\s*(?:dhcp_nat_type=)(\S*)/){
$dhcp_nat_type = $1;
}
elsif(/^\s*(?:dhcp_nat_in_ipaddress=)(\S*)/){
$dhcp_nat_in_ipaddress = $1;
}
elsif(/^\s*(?:dhcp_nat_in_ipaddress_ip=)(.*)/){
$dhcp_nat_in_ipaddress_ip = $1;
}
elsif(/^\s*(?:nat_table_index=)(\S*)/){
$index = $1;
}
elsif(/^\s*(?:nat_table_number=)(\S*)/){
$nat_table_number[$index] = $1;
}
elsif(/^\s*(?:nat_table_global_ip=)(\S*)/){
$nat_table_global_ip[$index] = $1;
}
elsif(/^\s*(?:nat_table_local_ip=)(\S*)/){
$nat_table_local_ip[$index] = $1;
}
elsif(/^\s*(?:new_nat_table_number=)(\S*)/){
$new_nat_table_number = $1;
}
elsif(/^\s*(?:new_nat_table_global_ip=)(\S*)/){
$new_nat_table_global_ip = $1;
}
elsif(/^\s*(?:new_nat_table_local_ip=)(\S*)/){
$new_nat_table_local_ip = $1;
}
elsif(/^\s*(?:natp_table_index=)(\S*)/){
$index = $1;
}
elsif(/^\s*(?:natp_table_number=)(\S*)/){
$natp_table_number[$index] = $1;
}
elsif(/^\s*(?:natp_table_protocol=)(\S*)/){
$natp_table_protocol[$index] = $1;
}
elsif(/^\s*(?:natp_table_port=)(\S*)/){
$natp_table_port[$index] = $1;
}
elsif(/^\s*(?:natp_table_ipaddress=)(\S*)/){
$natp_table_ipaddress[$index] = $1;
}
elsif(/^\s*(?:new_natp_table_number=)(\S*)/){
$new_natp_table_number = $1;
}
elsif(/^\s*(?:new_natp_table_protocol=)(\S*)/){
$new_natp_table_protocol = $1;
}
elsif(/^\s*(?:new_natp_table_port=)(\S*)/){
$new_natp_table_port = $1;
}
elsif(/^\s*(?:new_natp_table_ipaddress=)(\S*)/){
$new_natp_table_ipaddress = $1;
}
else{
next;
}
}
%return_hash = (
"return" => "success",
"nat_type" => join("\#IBS-SOHO\#", @nat_type),
"nat_out_ipaddress1" => join("\#IBS-SOHO\#", @nat_out_ipaddress1),
"nat_out_ipaddress2" => join("\#IBS-SOHO\#", @nat_out_ipaddress2),
"nat_in_ipaddress" => join("\#IBS-SOHO\#", @nat_in_ipaddress),
"nat_in_ipaddress_ip" => join("\#IBS-SOHO\#", @nat_in_ipaddress_ip),
"ip_nat_type" => $ip_nat_type,
"ip_nat_out_ipaddress1" => $ip_nat_out_ipaddress1,
"ip_nat_out_ipaddress2" => $ip_nat_out_ipaddress2,
"ip_nat_in_ipaddress" => $ip_nat_in_ipaddress,
"ip_nat_in_ipaddress_ip" => $ip_nat_in_ipaddress_ip,
"dhcp_nat_type" => $dhcp_nat_type,
"dhcp_nat_in_ipaddress" => $dhcp_nat_in_ipaddress,
"dhcp_nat_in_ipaddress_ip" => $dhcp_nat_in_ipaddress_ip,
"nat_table_number" => join("\#IBS-SOHO\#", @nat_table_number),
"nat_table_global_ip" => join("\#IBS-SOHO\#", @nat_table_global_ip),
"nat_table_local_ip" => join("\#IBS-SOHO\#", @nat_table_local_ip),
"new_nat_table_number" => $new_nat_table_number,
"new_nat_table_global_ip" => $new_nat_table_global_ip,
"new_nat_table_local_ip" => $new_nat_table_local_ip,
"natp_table_number" => join("\#IBS-SOHO\#", @natp_table_number),
"natp_table_protocol" => join("\#IBS-SOHO\#", @natp_table_protocol),
"natp_table_port" => join("\#IBS-SOHO\#", @natp_table_port),
"natp_table_ipaddress" => join("\#IBS-SOHO\#", @natp_table_ipaddress),
"new_natp_table_number" => $new_natp_table_number,
"new_natp_table_protocol" => $new_natp_table_protocol,
"new_natp_table_port" => $new_natp_table_port,
"new_natp_table_ipaddress" => $new_natp_table_ipaddress,
);
close(LOCK);
return %return_hash;
}
sub set_nat
{
my(@nat_type) = split(/\#IBS-SOHO\#/, $_[0]);
my(@nat_out_ipaddress1) = split(/\#IBS-SOHO\#/, $_[1]);
my(@nat_out_ipaddress2) = split(/\#IBS-SOHO\#/, $_[2]);
my(@nat_in_ipaddress) = split(/\#IBS-SOHO\#/, $_[3]);
my(@nat_in_ipaddress_ip) = split(/\#IBS-SOHO\#/, $_[4]);
my($ip_nat_type) = $_[5];
my($ip_nat_out_ipaddress1) = $_[6];
my($ip_nat_out_ipaddress2) = $_[7];
my($ip_nat_in_ipaddress) = $_[8];
my($ip_nat_in_ipaddress_ip) = $_[9];
my($dhcp_nat_type) = $_[10];
my($dhcp_nat_in_ipaddress) = $_[11];
my($dhcp_nat_in_ipaddress_ip) = $_[12];
my(%return_hash);
my($path) = "$ROUTER_DATA/nat/nat.txt";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "nat_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "nat_tmp_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my($loop_cnt);
for($loop_cnt = 0; $loop_cnt < $MAX_PPPOE_ENTRY; $loop_cnt++){
print TMP "name=pppoe$loop_cnt\n";
print TMP "nat_type=$nat_type[$loop_cnt]\n";
print TMP "nat_out_ipaddress1=$nat_out_ipaddress1[$loop_cnt]\n";
print TMP "nat_out_ipaddress2=$nat_out_ipaddress2[$loop_cnt]\n";
print TMP "nat_in_ipaddress=$nat_in_ipaddress[$loop_cnt]\n";
print TMP "nat_in_ipaddress_ip=$nat_in_ipaddress_ip[$loop_cnt]\n";
print TMP "\n";
}
print TMP "name=ip\n";
print TMP "ip_nat_type=$ip_nat_type\n";
print TMP "ip_nat_out_ipaddress1=$ip_nat_out_ipaddress1\n";
print TMP "ip_nat_out_ipaddress2=$ip_nat_out_ipaddress2\n";
print TMP "ip_nat_in_ipaddress=$ip_nat_in_ipaddress\n";
print TMP "ip_nat_in_ipaddress_ip=$ip_nat_in_ipaddress_ip\n";
print TMP "\n";
print TMP "name=dhcp\n";
print TMP "dhcp_nat_type=$dhcp_nat_type\n";
print TMP "dhcp_nat_in_ipaddress=$dhcp_nat_in_ipaddress\n";
print TMP "dhcp_nat_in_ipaddress_ip=$dhcp_nat_in_ipaddress_ip\n";
print TMP "\n";
close(TMP);
rename("$path", "$path.ibs-soho.backup");
rename("$path.ibs-soho.tmp", "$path");
%return_hash = (
"return" => "success"
);
close(LOCK);
return %return_hash;
}
sub set_nat_table
{
my(@nat_table_number) = split(/\#IBS-SOHO\#/, $_[0]);
my(@nat_table_global_ip) = split(/\#IBS-SOHO\#/, $_[1]);
my(@nat_table_local_ip) = split(/\#IBS-SOHO\#/, $_[2]);
my(%return_hash);
my($path) = "$ROUTER_DATA/nat/nat_table.txt";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "nat_table_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "nat_table_tmp_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my($loop_cnt);
for($loop_cnt = 0; $loop_cnt < $MAX_STATIC_NAT_TABLE_ENTRY; $loop_cnt++){
if("on" eq $nat_table_number[$loop_cnt]){
print TMP "index=$loop_cnt\n";
print TMP "nat_table_number=$nat_table_number[$loop_cnt]\n";
print TMP "nat_table_global_ip=$nat_table_global_ip[$loop_cnt]\n";
print TMP "nat_table_local_ip=$nat_table_local_ip[$loop_cnt]\n";
print TMP "\n";
}
}
close(TMP);
rename("$path", "$path.ibs-soho.backup");
rename("$path.ibs-soho.tmp", "$path");
%return_hash = (
"return" => "success"
);
close(LOCK);
return %return_hash;
}
sub set_natp_table
{
my(@natp_table_number) = split(/\#IBS-SOHO\#/, $_[0]);
my(@natp_table_protocol) = split(/\#IBS-SOHO\#/, $_[1]);
my(@natp_table_port) = split(/\#IBS-SOHO\#/, $_[2]);
my(@natp_table_ipaddress) = split(/\#IBS-SOHO\#/, $_[3]);
my(%return_hash);
my($path) = "$ROUTER_DATA/nat/natp_table.txt";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "natp_table_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "natp_table_tmp_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my($loop_cnt);
for($loop_cnt = 0; $loop_cnt < $MAX_STATIC_NAPT_TABLE_ENTRY; $loop_cnt++){
if("on" eq $natp_table_number[$loop_cnt]){
print TMP "index=$loop_cnt\n";
print TMP "natp_table_number=$natp_table_number[$loop_cnt]\n";
print TMP "natp_table_protocol=$natp_table_protocol[$loop_cnt]\n";
print TMP "natp_table_port=$natp_table_port[$loop_cnt]\n";
print TMP "natp_table_ipaddress=$natp_table_ipaddress[$loop_cnt]\n";
print TMP "\n";
}
}
close(TMP);
rename("$path", "$path.ibs-soho.backup");
rename("$path.ibs-soho.tmp", "$path");
%return_hash = (
"return" => "success"
);
close(LOCK);
return %return_hash;
}
sub set_work
{
my(@nat_type) = split(/\#IBS-SOHO\#/, $_[0]);
my(@nat_out_ipaddress1) = split(/\#IBS-SOHO\#/, $_[1]);
my(@nat_out_ipaddress2) = split(/\#IBS-SOHO\#/, $_[2]);
my(@nat_in_ipaddress) = split(/\#IBS-SOHO\#/, $_[3]);
my(@nat_in_ipaddress_ip) = split(/\#IBS-SOHO\#/, $_[4]);
my($ip_nat_type) = $_[5];
my($ip_nat_out_ipaddress1) = $_[6];
my($ip_nat_out_ipaddress2) = $_[7];
my($ip_nat_in_ipaddress) = $_[8];
my($ip_nat_in_ipaddress_ip) = $_[9];
my($dhcp_nat_type) = $_[10];
my($dhcp_nat_in_ipaddress) = $_[11];
my($dhcp_nat_in_ipaddress_ip) = $_[12];
my(@nat_table_number) = split(/\#IBS-SOHO\#/, $_[13]);
my(@nat_table_global_ip) = split(/\#IBS-SOHO\#/, $_[14]);
my(@nat_table_local_ip) = split(/\#IBS-SOHO\#/, $_[15]);
my($new_nat_table_number) = $_[16];
my($new_nat_table_global_ip) = $_[17];
my($new_nat_table_local_ip) = $_[18];
my(@natp_table_number) = split(/\#IBS-SOHO\#/, $_[19]);
my(@natp_table_protocol) = split(/\#IBS-SOHO\#/, $_[20]);
my(@natp_table_port) = split(/\#IBS-SOHO\#/, $_[21]);
my(@natp_table_ipaddress) = split(/\#IBS-SOHO\#/, $_[22]);
my($new_natp_table_number) = $_[23];
my($new_natp_table_protocol) = $_[24];
my($new_natp_table_port) = $_[25];
my($new_natp_table_ipaddress) = $_[26];
my(%return_hash);
my($path) = "$ROUTER_DATA/nat/work.txt";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "work_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "work_tmp_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my($loop_cnt);
for($loop_cnt = 0; $loop_cnt < $MAX_PPPOE_ENTRY; $loop_cnt++){
print TMP "name=pppoe$loop_cnt\n";
print TMP "nat_type=$nat_type[$loop_cnt]\n";
print TMP "nat_out_ipaddress1=$nat_out_ipaddress1[$loop_cnt]\n";
print TMP "nat_out_ipaddress2=$nat_out_ipaddress2[$loop_cnt]\n";
print TMP "nat_in_ipaddress=$nat_in_ipaddress[$loop_cnt]\n";
print TMP "nat_in_ipaddress_ip=$nat_in_ipaddress_ip[$loop_cnt]\n";
print TMP "\n";
}
print TMP "name=ip\n";
print TMP "ip_nat_type=$ip_nat_type\n";
print TMP "ip_nat_out_ipaddress1=$ip_nat_out_ipaddress1\n";
print TMP "ip_nat_out_ipaddress2=$ip_nat_out_ipaddress2\n";
print TMP "ip_nat_in_ipaddress=$ip_nat_in_ipaddress\n";
print TMP "ip_nat_in_ipaddress_ip=$ip_nat_in_ipaddress_ip\n";
print TMP "\n";
print TMP "name=dhcp\n";
print TMP "dhcp_nat_type=$dhcp_nat_type\n";
print TMP "dhcp_nat_in_ipaddress=$dhcp_nat_in_ipaddress\n";
print TMP "dhcp_nat_in_ipaddress_ip=$dhcp_nat_in_ipaddress_ip\n";
print TMP "\n";
for($loop_cnt = 0; $loop_cnt < $MAX_STATIC_NAT_TABLE_ENTRY; $loop_cnt++){
if("on" eq $nat_table_number[$loop_cnt]){
print TMP "nat_table_index=$loop_cnt\n";
print TMP "nat_table_number=$nat_table_number[$loop_cnt]\n";
print TMP "nat_table_global_ip=$nat_table_global_ip[$loop_cnt]\n";
print TMP "nat_table_local_ip=$nat_table_local_ip[$loop_cnt]\n";
print TMP "\n";
}
}
print TMP "new_nat_table_number=$new_nat_table_number\n";
print TMP "new_nat_table_global_ip=$new_nat_table_global_ip\n";
print TMP "new_nat_table_local_ip=$new_nat_table_local_ip\n";
print TMP "\n";
for($loop_cnt = 0; $loop_cnt < $MAX_STATIC_NAPT_TABLE_ENTRY; $loop_cnt++){
if("on" eq $natp_table_number[$loop_cnt]){
print TMP "natp_table_index=$loop_cnt\n";
print TMP "natp_table_number=$natp_table_number[$loop_cnt]\n";
print TMP "natp_table_protocol=$natp_table_protocol[$loop_cnt]\n";
print TMP "natp_table_port=$natp_table_port[$loop_cnt]\n";
print TMP "natp_table_ipaddress=$natp_table_ipaddress[$loop_cnt]\n";
print TMP "\n";
}
}
print TMP "new_natp_table_number=$new_natp_table_number\n";
print TMP "new_natp_table_protocol=$new_natp_table_protocol\n";
print TMP "new_natp_table_port=$new_natp_table_port\n";
print TMP "new_natp_table_ipaddress=$new_natp_table_ipaddress\n";
print TMP "\n";
close(TMP);
rename("$path", "$path.ibs-soho.backup");
rename("$path.ibs-soho.tmp", "$path");
%return_hash = (
"return" => "success"
);
close(LOCK);
return %return_hash;
}
1;
