# 2004/12/06
sub get_arp
{
my(@ipaddress);
my(@mac_address);
my(@host_name);
my(%host_data);
my($arp_total);
my(%return_hash);
my(@tmp) = `/sbin/arp -an`;
my($loop_cnt) = 0;
foreach(@tmp){
if(/^\s*(?:\?)\s+.([\d\.]+).\s+(?:at)\s+([\d:A-F]+)\s+/){
$ipaddress[$loop_cnt] = $1;
$mac_address[$loop_cnt] = $2;
$loop_cnt++;
}
}
$arp_total = $loop_cnt;
my($path) = "/etc/hosts";
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "hosts_lock",
"alert_message" => $alert_message
);
return %return_hash;
}
if("error" eq &open_file("PATH", "$path", "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "hosts_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
@tmp = <PATH>;
close(PATH);
foreach(@tmp){
if(/^\s*([\d\.]+)\s+(\S*)/){
$host_data{$1} = $2;
}
}
for($loop_cnt = 0; $loop_cnt < $arp_total; $loop_cnt++){
if($ipaddress[$loop_cnt] =~ /./){
$host_name[$loop_cnt] = $host_data{"$ipaddress[$loop_cnt]"};
$host_name[$loop_cnt] =~ s/ibs/[X7000]/ig;
}
}
%return_hash = (
"return" => "success",
"ipaddress" => join("\#IBS-SOHO\#", @ipaddress),
"mac_address" => join("\#IBS-SOHO\#", @mac_address),
"host_name" => join("\#IBS-SOHO\#", @host_name),
"arp_total" => $arp_total
);
close(LOCK);
return %return_hash;
}
sub delete_arp
{
my($ipaddress) = $_[0];
my(%return_hash);
my(@del_ipaddress);
my($del_ipaddress);
@del_ipaddress = split("\#IBS-SOHO\#", $ipaddress);
my($id_org) = $<;
$< = 0;
foreach $del_ipaddress (@del_ipaddress){
if(system("/sbin/arp -d $del_ipaddress >/dev/null 2>&1")){
my($alert_message) = $RETURN_CODE{"14"};
%return_hash = (
"return" => "error",
"error_contents" => "arp_command",
"alert_message" => "uARPe[uv" . $alert_message
);
last;
}
else{
%return_hash = (
"return" => "success"
);
}
}
$< = $id_org;
return %return_hash;
}
1;
