# 2005/04/11
sub get_dhcpd_leases
{
my($path);
my(%ipaddr);
my(%dhcpd_leases);
my(%return_hash);
if("netbsd" eq $OS){
}
else{
$path = "/var/lib/dhcp/dhcpd.leases";
}
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "dhcpd_leases_lock",
"alert_message => $alert_message"
);
return %return_hash;
}
if("error" eq &open_file("PATH", $path, "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "dhcpd_leases_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
my($set_flag) = "off";
my($repeat);
my($loop_cnt) = 0;
my($macaddr_flag) = "off";
my($host_flag) = "off";
my($abandoned_flag) = "off";
my($starts_flag) = "off";
my($ends_flag) = "off";
foreach(@tmp){
if(/^\s*(?:lease)\s*([\d\.]+)\s*(?:{)/){
my($ipaddr) = $1;
$set_flag = "on";
if($ipaddr{$ipaddr} =~ /./){
$repeat = $ipaddr{$ipaddr};
}
if($repeat =~ /./){
$dhcpd_leases{"$repeat"}{"ipaddress"} = $ipaddr;
# 2005/04/11
$dhcpd_leases{"$repeat"}{"mac_address"} = "";
$dhcpd_leases{"$repeat"}{"host"} = "";
$dhcpd_leases{"$repeat"}{"state"} = "";
$dhcpd_leases{"$repeat"}{"starts"} = "";
$dhcpd_leases{"$repeat"}{"ends"} = ""
}
else{
$ipaddr{$ipaddr} = $loop_cnt;
$dhcpd_leases{"$loop_cnt"}{"ipaddress"} = $ipaddr;
}
}
elsif(/^\s*(?:hardware)\s*(?:ethernet)\s*(\S*);/){
my($macaddr) = $1;
$macaddr_flag = "on";
if("on" eq $set_flag){
if($repeat =~ /./){
$dhcpd_leases{"$repeat"}{"mac_address"} = $macaddr;
}
else{
$dhcpd_leases{"$loop_cnt"}{"mac_address"} = $macaddr;
}
}
}
elsif(/^\s*(?:client-hostname)\s*"(\S*)";/){
my($host) = $1;
$host_flag = "on";
if("on" eq $set_flag){
if($repeat =~ /./){
$dhcpd_leases{"$repeat"}{"host"} = $host;
}
else{
$dhcpd_leases{"$loop_cnt"}{"host"} = $host;
}
}
}
elsif(/^\s*(?:abandoned;)/){
$abandoned_flag = "on";
if("on" eq $set_flag){
if($repeat =~ /./){
$dhcpd_leases{"$repeat"}{"state"} = "abandoned";
}
else{
$dhcpd_leases{"$loop_cnt"}{"state"} = "abandoned";
}
}
}
elsif(/^\s*(?:starts)\s+(?:\d+)\s+([\d\/]+)\s+([\d:]+)/){
my($starts_time) = $1 . " " . $2;
$starts_flag = "on";
if("on" eq $set_flag){
if($repeat =~ /./){
$dhcpd_leases{"$repeat"}{"starts"} = $starts_time;
}
else{
$dhcpd_leases{"$loop_cnt"}{"starts"} = $starts_time;
}
}
}
elsif(/^\s*(?:ends)\s+(?:\d+)\s+([\d\/]+)\s+([\d:]+)/){
my($ends_time) = $1 . " " . $2;
$ends_flag = "on";
if("on" eq $set_flag){
if($repeat =~ /./){
$dhcpd_leases{"$repeat"}{"ends"} = $ends_time;
}
else{
$dhcpd_leases{"$loop_cnt"}{"ends"} = $ends_time;
}
}
}
elsif(/^\s*(?:})/){
if("on" eq $macaddr_flag){
$macaddr_flag = "off";
}
if("on" eq $host_flag){
$host_flag = "off";
}
if("on" eq $abandoned_flag){
$abandoned_flag = "off";
}
if("on" eq $starts_flag){
$starts_flag = "off";
}
if("on" eq $ends_flag){
$ends_flag = "off";
}
if($repeat =~ /./){
$repeat = "";
}
else{
$loop_cnt++;
}
$set_flag = "off";
}
}
for($loop_cnt = 0; $loop_cnt < $MAX_R_DHCP; $loop_cnt++){
if($dhcpd_leases{$loop_cnt}{"ipaddress"} =~ /[\d\.]+/){
my(@tmp) = split(/\./, $dhcpd_leases{$loop_cnt}{"ipaddress"});
$tmp[0] = sprintf("%03d", $tmp[0]);
$tmp[1] = sprintf("%03d", $tmp[1]);
$tmp[2] = sprintf("%03d", $tmp[2]);
$tmp[3] = sprintf("%03d", $tmp[3]);
$dhcpd_leases{"$loop_cnt"}{"ipaddress"} = join(".", @tmp);
}
else{
last;
}
}
my($now_time);
my($date_tmp) = `/bin/date -u '+%Y %D %T'`;
if($date_tmp =~ /(\d+)\s+(\d+)\/(\d+)\/(?:\d+)\s+(\d+):(\d+):(\d+)/){
my($now_year) = $1;
my($now_month) = sprintf("%02d", $2);
my($now_date) = sprintf("%02d", $3);
my($now_hour) = sprintf("%02d", $4);
my($now_min) = sprintf("%02d", $5);
my($now_sec) = sprintf("%02d", $6);
$now_time = $now_year . $now_month . $now_date . $now_hour . $now_min . $now_sec;
}
else{
close(LOCK);
return %dhcpd_leases;
}
$loop_cnt = 0;
while(1){
if( !($dhcpd_leases{"$loop_cnt"}{"ipaddress"} =~ /./) || ("null" eq $dhcpd_leases{"$loop_cnt"}{"ipaddress"}) ){
last;
}
else{
my($lease_starts) = $dhcpd_leases{"$loop_cnt"}{"starts"};
my($starts_time);
my($leases_ends) = $dhcpd_leases{"$loop_cnt"}{"ends"};
my($ends_time);
if($lease_starts =~ /(\d+)\/(\d+)\/(\d+)\s+(\d+):(\d+):(\d+)/){
my($starts_year) = $1;
my($starts_month) = sprintf("%02d", $2);
my($starts_date) = sprintf("%02d", $3);
my($starts_hour) = sprintf("%02d", $4);
my($starts_min) = sprintf("%02d", $5);
my($starts_sec) = sprintf("%02d", $6);
$starts_time = $starts_year . $starts_month . $starts_date . $starts_hour . $starts_min . $starts_sec;
}
else{
$loop_cnt++;
$dhcpd_leases{"$loop_cnt"}{"time"} = "null";
next;
}
if($leases_ends =~ /(\d+)\/(\d+)\/(\d+)\s+(\d+):(\d+):(\d+)/){
my($ends_year) = $1;
my($ends_month) = sprintf("%02d", $2);
my($ends_date) = sprintf("%02d", $3);
my($ends_hour) = sprintf("%02d", $4);
my($ends_min) = sprintf("%02d", $5);
my($ends_sec) = sprintf("%02d", $6);
$ends_time = $ends_year . $ends_month . $ends_date . $ends_hour . $ends_min . $ends_sec;
}
else{
$loop_cnt++;
$dhcpd_leases{"$loop_cnt"}{"time"} = "null";
next;
}
if($now_time > $ends_time){
if($starts_time > $ends_time){
$dhcpd_leases{"$loop_cnt"}{"time"} = "null";
}
else{
$dhcpd_leases{"$loop_cnt"}{"time"} = "ends";
}
}
else{
$dhcpd_leases{"$loop_cnt"}{"time"} = "null";
}
$loop_cnt++;
}
}
close(LOCK);
return %dhcpd_leases;
}
sub set_dhcpd_leases
{
my($del_ipaddr) = $_[0];
my($path);
my(%return_hash);
my(@del_ipaddr) = split("\#IBS-SOHO\#", $del_ipaddr);
if("netbsd" eq $OS){
}
else{
$path = "/var/lib/dhcp/dhcpd.leases";
}
if("error" eq &lock_file("LOCK", $path)){
my($alert_message) = $RETURN_CODE{"200"};
%return_hash = (
"return" => "error",
"error_contents" => "dhcpd_leases_lock",
"alert_message => $alert_message"
);
return %return_hash;
}
if("error" eq &open_file("PATH", $path, "r")){
my($alert_message) = $RETURN_CODE{"202"};
%return_hash = (
"return" => "error",
"error_contents" => "dhcpd_leases_open",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my(@tmp) = <PATH>;
close(PATH);
if("error" eq &open_file("TMP", "$path.ibs-soho.tmp", "w")){
my($alert_message) = $RETURN_CODE{"203"};
%return_hash = (
"return" => "error",
"error_contents" => "dhcpd_leases_tmp",
"alert_message" => $alert_message
);
close(LOCK);
return %return_hash;
}
my($set_flag) = "on";
foreach(@tmp){
chomp;
my($del_flag) = "off";
if(/^\s*(?:lease)\s*([\d\.]+)\s*(?:{)/){
my($ipaddr) = $1;
foreach(@del_ipaddr){
if($_ eq $ipaddr){
$del_flag = "on";
last;
}
else{
next;
}
}
if("off" eq $del_flag){
$set_flag = "on";
}
else{
$set_flag = "off";
next;
}
}
elsif(/^\s*(?:})/){
if("off" eq $set_flag){
next;
}
else{
$set_flag = "off";
}
}
else{
if("off" eq $set_flag){
next;
}
}
print TMP "$_\n";
}
close(TMP);
%return_hash = (
"return" => "success"
);
rename "$path.ibs-soho.tmp", "$path";
close(LOCK);
return %return_hash;
}
1;
