# 2004/11/24
sub get_lan_packet_info
{
my($lan_interface_name) = $_[0];
my($lan_receive_total) = 0;
my($lan_receive_failure) = 0;
my($lan_receive_destruction) = 0;
my($lan_transmit_total) = 0;
my($lan_transmit_failure) = 0;
my($lan_transmit_destruction) = 0;
my(%return_hash);
my(@tmp) = `/sbin/ifconfig $lan_interface_name`;
foreach(@tmp){
if(/^\s*(?:RX)\s+(?:packets:)(\d+)\s+(?:errors:)(\d+)\s+(?:dropped:)(\d+)/){
$lan_receive_total = $1;
$lan_receive_failure = $2;
$lan_receive_destruction = $3;
$lan_receive_total += $lan_receive_failure + $lan_receive_destruction;
}
elsif(/^\s*(?:TX)\s+(?:packets:)(\d+)\s+(?:errors:)(\d+)\s+(?:dropped:)(\d+)/){
$lan_transmit_total = $1;
$lan_transmit_failure = $2;
$lan_transmit_destruction = $3;
$lan_transmit_total += $lan_transmit_failure + $lan_transmit_destruction;
}
else{
}
}
%return_hash = (
"return" => "success",
"lan_receive_total" => $lan_receive_total,
"lan_receive_failure" => $lan_receive_failure,
"lan_receive_destruction" => $lan_receive_destruction,
"lan_transmit_total" => $lan_transmit_total,
"lan_transmit_failure" => $lan_transmit_failure,
"lan_transmit_destruction" => $lan_transmit_destruction
);
return %return_hash;
}
sub get_wan_packet_info
{
my($wan_interface_name) = $_[0];
my($wan_receive_total) = 0;
my($wan_receive_failure) = 0;
my($wan_receive_destruction) = 0;
my($wan_transmit_total) = 0;
my($wan_transmit_failure) = 0;
my($wan_transmit_destruction) = 0;
my(%return_hash);
my(@tmp) = `/sbin/ifconfig $wan_interface_name`;
foreach(@tmp){
if(/^\s*(?:RX)\s+(?:packets:)(\d+)\s+(?:errors:)(\d+)\s+(?:dropped:)(\d+)/){
$wan_receive_total = $1;
$wan_receive_failure = $2;
$wan_receive_destruction = $3;
$wan_receive_total += $wan_receive_failure + $wan_receive_destruction;
}
elsif(/^\s*(?:TX)\s+(?:packets:)(\d+)\s+(?:errors:)(\d+)\s+(?:dropped:)(\d+)/){
$wan_transmit_total = $1;
$wan_transmit_failure = $2;
$wan_transmit_destruction = $3;
$wan_transmit_total += $wan_transmit_failure + $wan_transmit_destruction;
}
else{
}
}
%return_hash = (
"return" => "success",
"wan_receive_total" => $wan_receive_total,
"wan_receive_failure" => $wan_receive_failure,
"wan_receive_destruction" => $wan_receive_destruction,
"wan_transmit_total" => $wan_transmit_total,
"wan_transmit_failure" => $wan_transmit_failure,
"wan_transmit_destruction" => $wan_transmit_destruction
);
return %return_hash;
}
sub get_pppoe_packet_info
{
my(@pppoe_receive_total);
my(@pppoe_receive_failure);
my(@pppoe_receive_destruction);
my(@pppoe_transmit_total);
my(@pppoe_transmit_failure);
my(@pppoe_transmit_destruction);
my(%return_hash);
my($loop_cnt);
for($loop_cnt = 0; $loop_cnt < $MAX_PPPOE_ENTRY; $loop_cnt++){
$pppoe_receive_total[$loop_cnt] = 0;
$pppoe_receive_failure[$loop_cnt] = 0;
$pppoe_receive_destruction[$loop_cnt] = 0;
$pppoe_transmit_total[$loop_cnt] = 0;
$pppoe_transmit_failure[$loop_cnt] = 0;
$pppoe_transmit_destruction[$loop_cnt] = 0;
my(@tmp) = `/bin/sh /etc/ibsbat/pppoe.bat status $loop_cnt`;
foreach(@tmp){
if(/^\s*(?:RX)\s+(?:packets:)(\d+)\s+(?:errors:)(\d+)\s+(?:dropped:)(\d+)/){
$pppoe_receive_total[$loop_cnt] = $1;
$pppoe_receive_failure[$loop_cnt] = $2;
$pppoe_receive_destruction[$loop_cnt] = $3;
$pppoe_receive_total[$loop_cnt] += $pppoe_receive_failure[$loop_cnt] + $pppoe_receive_destruction[$loop_cnt];
}
elsif(/^\s*(?:TX)\s+(?:packets:)(\d+)\s+(?:errors:)(\d+)\s+(?:dropped:)(\d+)/){
$pppoe_transmit_total[$loop_cnt] = $1;
$pppoe_transmit_failure[$loop_cnt] = $2;
$pppoe_transmit_destruction[$loop_cnt] = $3;
$pppoe_transmit_total[$loop_cnt] += $pppoe_transmit_failure[$loop_cnt] + $pppoe_transmit_destruction[$loop_cnt];
}
else{
}
}
}
%return_hash = (
"return" => "success",
"pppoe_receive_total" => join("\#IBS-SOHO\#", @pppoe_receive_total),
"pppoe_receive_failure" => join("\#IBS-SOHO\#", @pppoe_receive_failure),
"pppoe_receive_destruction" => join("\#IBS-SOHO\#", @pppoe_receive_destruction),
"pppoe_transmit_total" => join("\#IBS-SOHO\#", @pppoe_transmit_total),
"pppoe_transmit_failure" => join("\#IBS-SOHO\#", @pppoe_transmit_failure),
"pppoe_transmit_destruction" => join("\#IBS-SOHO\#", @pppoe_transmit_destruction)
);
return %return_hash;
}
1;
