<?
define("FRI"," furigana like ");

function furigana_serch( $target_string )
{
	switch( $target_string['furigana_id'] )
	{	
		case 1:
			$serch_sql = " furigana ~ '^[]' ";
		break;
		case 2:
			$serch_sql = " furigana ~ '^[]' ";
		break;
		case 3:
			$serch_sql = " furigana ~ '^[]' ";
		break;
		case 4:
			$serch_sql = " furigana ~ '^[]' ";
		break;
		case 5:
			$serch_sql = " furigana ~ '^[]' ";
		break;
		case 6:
			$serch_sql = " furigana ~ '^[]' ";
		break;
		case 7:
			$serch_sql = " furigana ~ '^[]' ";
		break;
		case 8:
			$serch_sql = " furigana ~ '^[֬]' ";
		break;
				break;
		case 9:
			$serch_sql = " furigana ~ '^[]' ";
		break;
		case 10:
			$serch_sql = " furigana ~ '^[ܦ]' ";
		break;
		default:
			$serch_sql = " furigana ~ '^[!-~--߰]' ";
			break;
	}
	return $serch_sql;
}


$furigana_dic = array(		'','','','','','','','','','','',
														'','','','','',
														'','','','','',
														'','','','','','',
														'','','','','',
														'','','','','',
														'','','','','',
														'','','','','','',
														'','','','','',
														'','','',
														'A','a','B','b','C','c','D','d','E','e','F','f','G','g','H','h','I','i','J','j','K','k','L','l','M','m',
														'N','n','O','o','P','p','Q','q','R','r','S','s','T','t','U','u','V','v','W','w','X','x','Y','y','Z','z',
														'0','1','2','3','4','5','6','7','8','9',
														' ','!','"','#','$','%','&','\'','(',')','*','+',',','-','.','/',
														':',';','<','=','>','?','@',
														'[','\\',']','^','_','`',
														'{','|','}','~','','','','','',
														'','','');


function furigana_sort( $target_string, $database )
{
	$record_num = $database->da_record_num();
	if( 0 >= $record_num )
	{
		$record_num = 0;
	}
	
	for( $loop=0; $record_num > $loop; $loop++ )
	{
		$result_table[$loop] = $loop;
		$data = $database->da_record_get( $loop );
		$furigana_record[ $loop ] = $data['furigana'];
	}
	
	switch( $target_string['furigana_id'] )
	{
		case 1:
		case 2:
		case 3:
		case 4:
		case 5:
		case 6:
		case 7:
		case 8:
		case 9:
		case 10:
		case 11:
		if( 0 < $record_num )
		{
			$result_table = rquickSort( $result_table, $furigana_record, 0, $record_num - 1 );
		}
		break;
		default:
		break;
	}
	switch( $target_string['grp_id'] )
	{
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case '10':		
		if( 0 < $record_num )
		{
			$result_table = rquickSort( $result_table, $furigana_record, 0, $record_num - 1 );
		}
		break;
		default:
		break;
	}
	return $result_table;
}


/* NCbN\[g */
function rquickSort( $target_key, $target_data, $first, $last )
{
	static $i;
	static $j;
	static $x;
	$i = $first;
	$j = $last;
	$x = $target_data[ $target_key[ (int)( ( $i + $j ) / 2 ) ] ];
	while( TRUE )
	{
		while( 0 > dic_strcmp( $target_data[ $target_key[ $i ] ], $x ) ) $i++;
		while( 0 < dic_strcmp( $target_data[ $target_key[ $j ] ], $x ) ) $j--;
		if( $i >= $j ) break;
		$tmp = $target_key[ $i ];
		$target_key[ $i ] = $target_key[ $j ];
		$target_key[ $j ] = $tmp;
		$i++;
		$j--;
	}
	if( $first < $i - 1 ) 
		$target_key = rquickSort( $target_key, $target_data, $first, $i - 1 );
	if( $last  > $j + 1 ) 
		$target_key = rquickSort( $target_key, $target_data, $j + 1, $last );
	return $target_key;
}


/* r */
function dic_strcmp( $mae_str, $pos_str )
{
	global $furigana_dic;
	$mae_len = strlen( $mae_str );
	$pos_len = strlen( $pos_str );
	if( $mae_len > $pos_len )
	{
		$end_loop = $pos_len;
		$result = 1;
	}
	elseif( $mae_len < $pos_len  )
	{
		$end_loop = $mae_len;
		$result = -1;
	}
	else
	{
		$end_loop = $mae_len;
		$result = 0;
	}
	if( 0 != strcmp( $mae_str, $pos_str ) )
	{
		for( $loop=0; $end_loop > $loop; $loop++ )
		{
			if( $mae_str[$loop] != $pos_str[$loop] )
			{
				$mae_str_rank = array_search( $mae_str[$loop], $furigana_dic );
				$pos_str_rank = array_search( $pos_str[$loop], $furigana_dic );
				if( $mae_str_rank > $pos_str_rank )
				{
					return 1;
				}
				elseif( $mae_str_rank < $pos_str_rank )
				{
					return -1;
				}
			}
		}
	}
	return $result;
}


function kana_dsp( $kana_code )
{
	switch( $kana_code )
	{
		case 1:
			return "As";
		case 2:
			return "Js";
		case 3:
			return "Ts";
		case 4:
			return "^s";
		case 5:
			return "is";
		case 6:
			return "ns";
		case 7:
			return "}s";
		case 8:
			return "s";
		case 9:
			return "s";
		case 10:
			return "s";
		default:
			return "̑";
	}
}
?>